﻿#define DO_DIRECT_SQL
#define GET_ACTUAL_TP_DATA
#define GET_ACTUAL_PIVOT_DATA

#region Using
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using WMAApp.Web.Models;
using System.ServiceModel.DomainServices.Hosting;
using System.Data.EntityClient;
using System.Configuration;
using System.Text;
using System.ServiceModel.DomainServices.Server;
using System.Data.Objects;
using System.Data.Common;
using System.Data.Entity;
using WMAApp.WMASharedClasses;
using System.Data.SqlClient;
using System.Data;
#endregion Using

namespace WMAApp.Web.Services
{
   
    [EnableClientAccess()] // Enables projection of context to the client
    public class WMATestDBDomainService : WMATestDBBaseDomainService
    {
        protected override WMATestDBEntities CreateObjectContext()
        {
            byte[] connArray = new byte[256];

            EntityConnectionStringBuilder ecsb = new EntityConnectionStringBuilder();

            if (ConfigurationManager.AppSettings["Provider"] != null)
            {
                ecsb.Provider = ConfigurationManager.AppSettings["Provider"];
            }

            if (ConfigurationManager.AppSettings["ConnMetaData"] != null)
            {
                ecsb.Metadata = ConfigurationManager.AppSettings["ConnMetaData"];
            }

            if (ServiceContext.User.Identity.IsAuthenticated)
            {
                if (System.Web.HttpContext.Current.Request.Cookies["ConnString"] != null)
                {
                    UnicodeEncoding decoder = new UnicodeEncoding();

                    connArray = Convert.FromBase64String(System.Web.HttpContext.Current.Request.Cookies["ConnString"].Value);

                    ecsb.ProviderConnectionString = decoder.GetString(connArray, 0, connArray.Length);
                }
            }

            return new WMATestDBEntities(ecsb.ToString());
        }

#if GET_ACTUAL_TP_DATA
        // By default, your query is passed to the server in the URL. For complicated queries, the URL gets long enough to 
        // exceed the maximum length ( error : "The maximum URI length of 2083 was exceeded.")

        // Change the query method to use POST instead of GET, so the query is not passed on the URL, but in the POST body. 
        // To do this, use the [Query(HasSideEffects = true)] attribute. 
        //[Query(HasSideEffects = true)]
        //public IQueryable<TPData> GetTPData(decimal _dTpId, string _sUserName)
        //{           
        //    var query = (ObjectQuery<TPData>)( from tpdef in ObjectContext.TP_DEFN
        //                                       from pd in ObjectContext.PRODUCT_DATA
        //                                       join tpd in ObjectContext.TP_DATA on tpdef.TP_DEFN_SAKEY equals tpd.TP_DEFN_SAKEY                                            
        //                                       join vts in ObjectContext.VAR_TREND_SUM on
        //                                                   new
        //                                                   {
        //                                                       TestDts = tpd.TEST_DTS,
        //                                                       StandCode = tpd.STAND_CODE
        //                                                   }
        //                                                   equals new
        //                                                   {
        //                                                       TestDts = vts.DATA_DTS,
        //                                                       StandCode = vts.STAND_CODE
        //                                                   }
        //                                       where tpdef.TP_ID == _dTpId && vts.TP_TEXT == _sUserName
        //                                       && pd.TEST_DTS == tpd.TEST_DTS && pd.STAND_CODE == tpd.STAND_CODE
        //                                      orderby tpd.TEST_DTS                                               
        //                                      select new TPData()
        //                                      {
        //                                          dId = tpdef.TP_ID,
        //                                          dtTestTime = tpd.TEST_DTS,
        //                                          sStandCode = tpd.STAND_CODE,
        //                                          dTpDefnSakey = tpd.TP_DEFN_SAKEY,
        //                                          dTPQty = (decimal)tpd.TP_QTY,                                         
        //                                          sModel = pd.MODEL_CODE,
        //                                          sSerial = pd.SERIAL_CODE,
        //                                      }  );

        //    return query;
        //}  
        [Query(HasSideEffects = true)]
        public IQueryable<TPData> GetTPData(decimal _dTpId, string _sUserName)
        {
            var query = (ObjectQuery<TPData>)(from tpdef in ObjectContext.TP_DEFN
                                              from pd in ObjectContext.PRODUCT_DATA
                                              from pds in ObjectContext.PRODUCT_DATA_STAT
                                              join tpd in ObjectContext.TP_DATA on tpdef.TP_DEFN_SAKEY equals tpd.TP_DEFN_SAKEY
                                              join vts in ObjectContext.VAR_TREND_SUM on
                                                          new
                                                          {
                                                              TestDts = tpd.TEST_DTS,
                                                              StandCode = tpd.STAND_CODE
                                                          }
                                                          equals new
                                                          {
                                                              TestDts = vts.DATA_DTS,
                                                              StandCode = vts.STAND_CODE
                                                          }
                                              where tpdef.TP_ID == _dTpId && vts.TP_TEXT == _sUserName
                                              && pd.TEST_DTS == tpd.TEST_DTS && pd.STAND_CODE == tpd.STAND_CODE &&
                                              pds.TEST_DTS == tpd.TEST_DTS && pds.STAND_CODE == tpd.STAND_CODE && (pds.PRODUCT_DATA_STAT_ID == 4 || pds.PRODUCT_DATA_STAT_ID == 5)
                                              orderby tpd.TEST_DTS
                                              select new TPData()
                                              {
                                                  dId = tpdef.TP_ID,
                                                  dtTestTime = tpd.TEST_DTS,
                                                  sStandCode = tpd.STAND_CODE,
                                                  dTpDefnSakey = tpd.TP_DEFN_SAKEY,
                                                  dTPQty = (decimal)tpd.TP_QTY,
                                                  sModel = pd.MODEL_CODE,
                                                  sSerial = pd.SERIAL_CODE,
                                                  sUnits = tpdef.UNITS_TEXT.UNITS_TEXT1,
                                                  dStatus = pds.PRODUCT_DATA_STAT_ID
                                              });

            return query;
        }  

#endif

        public IQueryable<TestData> GetTestResults(DateTime _dtTestDate, string _sStandCode)
        {

        // The following are some typical scenarios that might lead to the presence of CROSS APPLY and/or OUTER APPLY operators in the output query:
        //A correlated subquery with paging.
        //An AnyElement over a correlated sub-query, or over a collection produced by navigation.
        //LINQ queries that use grouping methods that accept an element selector.
        //A query in which a CROSS APPLY or an OUTER APPLY is explicitly specified
        //A query that has a DEREF construct over a REF construct. 

            var query = (ObjectQuery<TestData>)(from pd in ObjectContext.PRODUCT_DATA
                                                from tp in ObjectContext.TP_DATA.Where( tp => tp.TEST_DTS == pd.TEST_DTS && tp.STAND_CODE == pd.STAND_CODE)
                                                from tpd in ObjectContext.TP_DEFN.Where(tpd => tpd.TP_DEFN_SAKEY == tp.TP_DEFN_SAKEY)
                                                from ut in ObjectContext.UNITS_TEXT.Where(ut => ut.UNITS_TEXT_SAKEY == tpd.UNITS_TEXT_SAKEY)
                                                from lowlimit in ObjectContext.PARAM_TP_DEFN.Where(ll => ll.TP_DEFN_SAKEY == tpd.TP_DEFN_SAKEY && ll.LIMIT_CODE == "L").DefaultIfEmpty()
                                                from highlimit in ObjectContext.PARAM_TP_DEFN.Where(hl => hl.TP_DEFN_SAKEY == tpd.TP_DEFN_SAKEY && hl.LIMIT_CODE == "H").DefaultIfEmpty()
                                                       from phase in ObjectContext.TEST_TEXT.Where(ph => ph.TEST_TEXT_SAKEY == tpd.PHASE_PHRASE_SAKEY).DefaultIfEmpty()
                                                       from step in ObjectContext.TEST_TEXT.Where(st => st.TEST_TEXT_SAKEY == tpd.STEP_PHRASE_SAKEY).DefaultIfEmpty()  
                                                //from pvh in ObjectContext.PARAM_VAL.Where(pvh => pvl.PARAM_CODE_NAME == pd.MODEL_CODE && pvh.PARAM_ID == highlimit.PARAM_ID).OrderByDescending(pvh => pvh.PARAM_VAL_REV_DTS).DefaultIfEmpty()
                                                
                                                where (pd.TEST_DTS == _dtTestDate && pd.STAND_CODE == _sStandCode)

                                                from pvl in ObjectContext.PARAM_VAL where
                                                        pd.MODEL_CODE == pvl.PARAM_CODE_NAME &&
                                                        lowlimit.PARAM_ID == pvl.PARAM_ID &&
                                                        pvl.PARAM_VAL_REV_DTS == ObjectContext.PARAM_VAL.Where(pv => 
                                                                                                    pv.PARAM_CODE_NAME == pd.MODEL_CODE &&
                                                                                                    pv.PARAM_ID == lowlimit.PARAM_ID &&
                                                                                                    pv.PARAM_VAL_REV_DTS <= pd.MAX_PARAM_VAL_REV_DTS).Max(pv => pv.PARAM_VAL_REV_DTS)
                                                from pvh in ObjectContext.PARAM_VAL
                                                where
                                                    pd.MODEL_CODE == pvh.PARAM_CODE_NAME &&
                                                    highlimit.PARAM_ID == pvh.PARAM_ID &&
                                                    pvh.PARAM_VAL_REV_DTS == ObjectContext.PARAM_VAL.Where(pv =>
                                                         pv.PARAM_CODE_NAME == pd.MODEL_CODE &&
                                                                                                           pv.PARAM_ID == highlimit.PARAM_ID &&
                                                                                                           pv.PARAM_VAL_REV_DTS <= pd.MAX_PARAM_VAL_REV_DTS).Max(pv => pv.PARAM_VAL_REV_DTS)
                                                
                                                       orderby tpd.TP_ID
                                                      
                                                       select new TestData()
                                                       {
                                                           dId = tpd.TP_ID,
                                                           sText = tpd.TP_TEXT,
                                                           //sModel = pd.MODEL_CODE,
                                                           //sSerial = pd.SERIAL_CODE,
                                                           sUnits = ut.UNITS_TEXT1,
                                                           sPhase = ((phase == null) ? "" : phase.TEST_TEXT1),
                                                           sStep = ((step == null) ? "" : step.TEST_TEXT1),
                                                           dFormattedLowLimit =  pvl.PARAM_VAL_QTY,
                                                           dFormattedHighLimit = pvh.PARAM_VAL_QTY,
                                                           dFormattedValue = (decimal)tp.TP_QTY//,
                                                           //iLowLimitId = 1, //  (int)((lvals == null) ? -1 : lvals.PARAM_ID),
                                                           //iHighLimitId = 1, //(int)((hvals == null) ? -1 : hvals.PARAM_ID),
                                                           //iPhaseId = (int)((phase == null) ? -1 : phase.TEST_TEXT_ID),
                                                           //iStepId = (int)((step == null) ? -1 : step.TEST_TEXT_ID)
                                                       });
                                                 

            return query;
        }

        // Note: These names of these XXX methods are appended with the "Query" by the compiler so you must
        // call them as XXXQuery.

        [Query(HasSideEffects = true)]
        public IQueryable<ModelDefData> GetActiveModels(int _iFamily)
        {
            var query = (ObjectQuery<ModelDefData>)(from mdc in this.ObjectContext.MODEL_CODE_DEFN
                                                    from md in this.ObjectContext.MODEL_DEFN
                                                    where mdc.MODEL_ACTIVE_FLAG == "A" &&
                                                          md.FAMILY_ID == _iFamily &&
                                                          mdc.MODEL_CODE == md.MODEL_CODE &&
                                                          md.MODEL_DEFN_REV_DTS == mdc.MODEL_CODE_DEFN_REV_DTS
                                                    orderby mdc.MODEL_CODE
                                                    select new ModelDefData()
                                                    {
                                                        dFamilyId = md.FAMILY_ID,
                                                        sModelName = mdc.MODEL_CODE,
                                                        sModelText = md.MODEL_TEXT,
                                                        sModelNameText = md.MODEL_NAME_TEXT
                                                    });

            return query;
        }

        // To support paging you will need to add ordering to the 'PRODUCT_DATA' query.
		public IQueryable<PRODUCT_DATA> GetProductDataDateFamily(DateTime _dtStartTime,
                                                                 DateTime _dtEndTime, 
                                                                 List<int> _lFamilyIds,
                                                                 List<string> _lStandIds,
                                                                 List<string> _lModels,
                                                                 List<int> _lFirstTest,
                                                                 List<int> _lTestStatus,
                                                                 List<int> _lLastTest,
                                                                 bool _bGetRejectInfo)
        {
            ObjectQuery<PRODUCT_DATA> query;
            query = (ObjectQuery<PRODUCT_DATA>)(from pd in this.ObjectContext.PRODUCT_DATA
                                                where _lFamilyIds.Contains( (int)pd.FAMILY_ID ) &&
                                                      ( _lStandIds.Count == 0 || _lStandIds.Any( sd => sd == pd.STAND_CODE ) ) &&
                                                      ( _lModels.Count == 0 || _lModels.Any( mc => mc == pd.MODEL_CODE ) ) &&
                                                      ( pd.TEST_DTS >= _dtStartTime && pd.TEST_DTS <= _dtEndTime ) &&
                                                      ( _lFirstTest.Count == 0 || _lFirstTest.Any( fid => pd.PRODUCT_DATA_STAT.Any( fpds => fpds.PRODUCT_DATA_STAT_ID == fid ) ) ) &&
                                                      _lTestStatus.Any( id => pd.PRODUCT_DATA_STAT.Any( pds => pds.PRODUCT_DATA_STAT_ID == id ) ) &&
                                                      !_lLastTest.Any( nid => pd.PRODUCT_DATA_STAT.Any( npds => npds.PRODUCT_DATA_STAT_ID == nid ) )
                                                orderby pd.TEST_DTS, pd.STAND_CODE
                                                select pd);

            if (_bGetRejectInfo)
                return query.Include("PRODUCT_DATA_REJ").Include("PRODUCT_DATA_STAT").Include("PRODUCT_DATA_STAT.PRODUCT_DATA_STAT_DESC");
            else
                return query.Include("PRODUCT_DATA_STAT").Include("PRODUCT_DATA_STAT.PRODUCT_DATA_STAT_DESC");
        }
        
        // To support paging you will need to add ordering to the 'PRODUCT_DATA' query.
        public IQueryable<PRODUCT_DATA> GetPRODUCT_DATA_W_STAT_AND_REJ(DateTime _dtStartTime, DateTime _dtEndTime)
        {
            var query = from pd in this.ObjectContext.PRODUCT_DATA.Include("PRODUCT_DATA_REJ").Include("PRODUCT_DATA_STAT").Include("PRODUCT_DATA_STAT.PRODUCT_DATA_STAT_DESC")
                        where pd.TEST_DTS >= _dtStartTime && pd.TEST_DTS <= _dtEndTime
                        orderby pd.TEST_DTS, pd.STAND_CODE
                        select pd;

            return query;
        }
        [Query(HasSideEffects = true)] 
        public IQueryable<PRODUCT_DATA> GetPRODUCT_DATA_W_STAT_AND_REJ_FOR_PARTS(List<string> _lstPartList)
        {
            // This way works for small sets but gives Oracle 04030 error for large lists of model/serial combinations
            //var query = (ObjectQuery<PRODUCT_DATA>)(from pd in this.ObjectContext.PRODUCT_DATA
            //            join pl in _lstPartList
            //            on pd.MODEL_CODE + pd.SERIAL_CODE equals pl
            //            orderby pd.TEST_DTS, pd.STAND_CODE
            //            select pd);


            var query = (ObjectQuery<PRODUCT_DATA>)(from pd in this.ObjectContext.PRODUCT_DATA
                                                    where _lstPartList.Contains( pd.MODEL_CODE + pd.SERIAL_CODE )
                                                    orderby pd.TEST_DTS, pd.STAND_CODE
                                                    select pd);
            var query2 = (ObjectQuery<PRODUCT_DATA>)(query.Include("PRODUCT_DATA_REJ").Include("PRODUCT_DATA_STAT").Include("PRODUCT_DATA_STAT.PRODUCT_DATA_STAT_DESC"));
            //Console.WriteLine(query.ToTraceString()); // what does the generated sql look like?
            return query2;

        }

        [Query(HasSideEffects = true)]
        public IQueryable<PRODUCT_DATA> GetPRODUCT_DATA_W_STAT_FOR_PARTS(List<string> _lstPartList)
        {        
            var query = (ObjectQuery<PRODUCT_DATA>)(from pd in this.ObjectContext.PRODUCT_DATA
                                                    where _lstPartList.Contains(pd.MODEL_CODE + pd.SERIAL_CODE)
                                                    orderby pd.TEST_DTS, pd.STAND_CODE
                                                    select pd);
            var query2 = (ObjectQuery<PRODUCT_DATA>)(query.Include("PRODUCT_DATA_STAT"));
            //Console.WriteLine(query.ToTraceString()); // what does the generated sql look like?
            return query2;

        }
        public IQueryable<PRODUCT_DATA> GetPDB_PRODUCT_DATA_W_STAT_AND_REJ(decimal _dPDBDefnSakey)
        {
            var query = (ObjectQuery<PRODUCT_DATA>)
                        (from pdbd in this.ObjectContext.PDB_DATA
                         join pd in this.ObjectContext.PRODUCT_DATA
                             on new { pdbd.TEST_DTS, pdbd.STAND_CODE } equals new { pd.TEST_DTS, pd.STAND_CODE }
                         where pdbd.PDB_DEFN_SAKEY == _dPDBDefnSakey
                         orderby pd.TEST_DTS, pd.STAND_CODE
                         select pd);

            return query.Include("PRODUCT_DATA_REJ").Include("PRODUCT_DATA_STAT").Include("PRODUCT_DATA_STAT.PRODUCT_DATA_STAT_DESC");
        }

        public IQueryable<PRODUCT_DATA> GetPDB_PRODUCT_DATA_W_STAT(decimal _dPDBDefnSakey)
        {
            var query = (ObjectQuery<PRODUCT_DATA>)
                        (from pdbd in this.ObjectContext.PDB_DATA
                         join pd in this.ObjectContext.PRODUCT_DATA
                             on new { pdbd.TEST_DTS, pdbd.STAND_CODE } equals new { pd.TEST_DTS, pd.STAND_CODE }
                         where pdbd.PDB_DEFN_SAKEY == _dPDBDefnSakey
                         orderby pd.TEST_DTS, pd.STAND_CODE
                         select pd);

            return query.Include("PRODUCT_DATA_STAT").Include("PRODUCT_DATA_STAT.PRODUCT_DATA_STAT_DESC");
        }

        // todo: should be able to have same name for methods and just overload them but seems like this does not get reflected in generated code so for now make new name.
        public IQueryable<PDB_DEFN> GetPDB_DEFNEx(string _sPDBDefnName, string _sPDBDefnUserName, bool _bIncludePDBData) //todo: optional args don't seem to make it to generated code???
        {
            System.Linq.IQueryable<PDB_DEFN> iqQuery;

            if (_bIncludePDBData)
            {
                iqQuery = from pdb in this.ObjectContext.PDB_DEFN.Include("PDB_DATA")
                          where pdb.NAME == _sPDBDefnName && pdb.USER_NAME == _sPDBDefnUserName
                          select pdb;
            }
            else
            {
                iqQuery = from pdb in this.ObjectContext.PDB_DEFN
                          where pdb.NAME == _sPDBDefnName && pdb.USER_NAME == _sPDBDefnUserName
                          select pdb;
            }
            return iqQuery;
        }
        public IQueryable<PDB_DEFN> GetPDB_DEFNViaSakey(decimal _dSakey, bool _bIncludePDBData) 
        {
            System.Linq.IQueryable<PDB_DEFN> iqQuery;

            if (_bIncludePDBData)
            {
                iqQuery = from pdb in this.ObjectContext.PDB_DEFN.Include("PDB_DATA")
                          where pdb.PDB_DEFN_SAKEY == _dSakey
                          select pdb;
            }
            else
            {
                iqQuery = from pdb in this.ObjectContext.PDB_DEFN
                          where pdb.PDB_DEFN_SAKEY == _dSakey
                          select pdb;
            }
            return iqQuery;
        }
      
        private string sMakeDtString( DateTime _dt) {
            return Convert.ToString(_dt);
        }

        public IQueryable<TpDefn> GetTpDefns()
        {
         /*   var query = (ObjectQuery<TpDefn>)(from vtpd in this.ObjectContext.VU_TP_DEFN_CRUST
                                                where vtpd.TP_ACTIVE_FLAG == "Y" || vtpd.TP_ACTIVE_FLAG == "C"  
                   join ut in this.ObjectContext.UNITS_TEXT
                       on vtpd.UNITS_TEXT_SAKEY equals ut.UNITS_TEXT_SAKEY                                                                                   
                   select new TpDefn() { dTpDefnSakey = vtpd.TP_DEFN_SAKEY,  dFamilyId = vtpd.FAMILY_ID, dId = vtpd.TP_ID, 
                                           sText = vtpd.TP_TEXT, sUnits = ut.UNITS_TEXT1 }
                    );//.OrderBy(x=> x.dFamilyId).ThenBy(y=> y.dId); 
            //Console.WriteLine(query.ToTraceString()); */
			var query = (ObjectQuery<TpDefn>)(from tp in this.ObjectContext.TP_DEFN
                                                where (tp.TP_ACTIVE_FLAG == "Y" || tp.TP_ACTIVE_FLAG == "C" ) &&
                                                        tp.TP_DEFN_REV_DTS == ObjectContext.TP_DEFN.Where( tp1 => tp1.TP_ID == tp.TP_ID ).Max( tp1 => tp1.TP_DEFN_REV_DTS )
                                                orderby tp.FAMILY_ID, tp.TP_ID
                                                join ut in this.ObjectContext.UNITS_TEXT
                                                on tp.UNITS_TEXT_SAKEY equals ut.UNITS_TEXT_SAKEY                                              
                                                select new TpDefn() 
                                                { 
                                                    dTpDefnSakey = tp.TP_DEFN_SAKEY,  
                                                    dFamilyId = tp.FAMILY_ID, 
                                                    dId = tp.TP_ID, 
                                                    sText = tp.TP_TEXT, 
                                                    sUnits = ut.UNITS_TEXT1 
                                                }
                    );
            return query;
        }

        [Query(HasSideEffects = true)] 
        public IQueryable<TP_DEFN> GetTEST_POINT_DEFNS(List<string> _lstTestList)
        {
         
            //var query = from tpd in this.ObjectContext.TP_DATA
            //            join tpdefn in this.ObjectContext.TP_DEFN
            //            on new { tpd.TP_DEFN_SAKEY } equals new { tpdefn.TP_DEFN_SAKEY }
            //            where _lstTestList.Contains(tpd.TEST_DTS + tpd.STAND_CODE)
            //            orderby tpdefn.TP_ID
            //            select tpdefn; //select new TpDefn{ dId = tpdefn.TP_ID, sText = tpdefn.TP_TEXT, sUnits = tpdefn.UNITS_TEXT.UNITS_TEXT1 } ;
            //Console.WriteLine(query.ToTraceString()); // what does the generated sql look like?

            ////var query4 = from x in this.ObjectContext.TP_DATA.AsEnumerable() 
            ////             Select new { x.Field<string>("TP_DEFN_SAKEY") }

            ////var query3 = (ObjectQuery<TP_DEFN>)(from tpdefn in this.ObjectContext.TP_DEFN
            ////                                    where (
            ////                                              this.ObjectContext.TP_DATA.Select( p => new {TEST_DTS, STAND_CODE }).AsEnumerable()
            ////                                              .Select(
            ////                                              from tpd2 in this.ObjectContext.TP_DATA
            ////                                              where _lstTestList.Contains(tpd2.TEST_DTS + tpd2.STAND_CODE)
            ////                                              select tpd2.TP_DEFN_SAKEY

            ////                                          ).Contains(tpdefn.TP_DEFN_SAKEY)
            ////                                    select tpdefn);

            //// var query5 = (ObjectQuery<TP_DEFN>)(from tpdefn in this.ObjectContext.TP_DEFN
            ////              where (
            ////                        from tpd2 in this.ObjectContext.TP_DATA                         
            ////                        where ( o=> _lstTestList.Contains(o.TEST_DTS + o.STAND_CODE)
            ////                        select tpd2.TP_DEFN_SAKEY 
                                
            ////                    ).Contains(tpdefn.TP_DEFN_SAKEY)
            ////               select tpdefn);

            var query2 = (ObjectQuery<TP_DEFN>)(from tpdefn in this.ObjectContext.TP_DEFN
                          where (
                                    from tpd2 in this.ObjectContext.TP_DATA                         
                                    where _lstTestList.Contains( tpd2.TEST_DTS + tpd2.STAND_CODE)
                                    select tpd2.TP_DEFN_SAKEY                                 
                                ).Contains(tpdefn.TP_DEFN_SAKEY)
                           select tpdefn);

            ////// var query7 = (ObjectQuery<TP_DEFN>)(from tpd3 in ObjectContext.TP_DATA
            //////                                     .Where ( p=> p.STAND_CODE equals "x").Intersect(
            //////                                     select tpd3.TP_DEFN_SAKEY
            //////                                     ).AsEnumerable().Intersect(_lstTestList)
            //////                                              where tpd3.TEST_DTS + tpd.STAND_CODE ).ToList().Contains()
            //////                                             );


            //////return (ObjectQuery<TP_DEFN>) query2;

            //////var query6 = (ObjectQuery<TP_DEFN>)(from tpdefn in this.ObjectContext.TP_DEFN
            //////                                    where ( p1 =>
            //////                                              from tpd in ObjectContext.TP_DATA
            //////                                              select tpd.TP_DEFN_SAKEY
            //////                                              where tpd.TEST_DTS + tpd.STAND_CODE ).ToList().Contains()
            //////                                              )
            //////                                              .select tpd.TP_DEFN_SAKEY

            //////                                          ).Contains(p1.TP_DEFN_SAKEY)
            //////                                    select tpdefn);
            return (ObjectQuery<TP_DEFN>) query2;

        }

        //[Query(HasSideEffects = true)]
        // Get TpDefns that are associated with any of the families displayed in the test list.
        public IQueryable<TpDefn> GetTpDefnsInFam(List<decimal> _lstdDistinctFamilyIds)
        {           
            var query = (ObjectQuery<TpDefn>) ( from tp in this.ObjectContext.TP_DEFN
                                                where _lstdDistinctFamilyIds.Contains(tp.FAMILY_ID) && (tp.TP_ACTIVE_FLAG == "Y" || tp.TP_ACTIVE_FLAG == "C") &&
                                                tp.TP_DEFN_REV_DTS == this.ObjectContext.TP_DEFN.Where( tp1 => tp1.TP_ID == tp.TP_ID && tp1.FAMILY_ID == tp.FAMILY_ID ).Max( tp1 => tp1.TP_DEFN_REV_DTS)
                                                join
                                                    ut in this.ObjectContext.UNITS_TEXT
                                                    on 
                                                    tp.UNITS_TEXT_SAKEY equals ut.UNITS_TEXT_SAKEY
                                                from phaseText in ObjectContext.TEST_TEXT.Where(pht => pht.TEST_TEXT_SAKEY == tp.PHASE_PHRASE_SAKEY).DefaultIfEmpty()
                                                from stepText in ObjectContext.TEST_TEXT.Where(st => st.TEST_TEXT_SAKEY == tp.STEP_PHRASE_SAKEY).DefaultIfEmpty()
                                                from paramText in ObjectContext.TEST_TEXT.Where(pt => pt.TEST_TEXT_SAKEY == tp.PARAM_PHRASE_SAKEY).DefaultIfEmpty()

                                                select new TpDefn()
                                                {
                                                    dTpDefnSakey = tp.TP_DEFN_SAKEY,
                                                    dFamilyId = tp.FAMILY_ID,
                                                    dId = tp.TP_ID,
                                                    sText = tp.TP_TEXT,
                                                    sUnits = ut.UNITS_TEXT1,
                                                    sPhaseText = ((phaseText == null) ? "" : phaseText.TEST_TEXT1),
                                                    sStepText = ((stepText == null) ? "" : stepText.TEST_TEXT1),
                                                    sParamText = ((paramText == null) ? "" : paramText.TEST_TEXT1)
                                                }
                   );
            //Console.WriteLine(query.ToTraceString());
            return query;
        
        }

#if GET_ACTUAL_PIVOT_DATA
        [Query(HasSideEffects = true)]
        public IQueryable<TPPivotGridData> GetTPPivotGridData(string _sUsername)
        {
#if USE_VAR_TREND_SUM_TEMP 
            var query = (ObjectQuery<TPPivotGridData>)(from tpdef in ObjectContext.TP_DEFN
                                                       join vtst in ObjectContext.VAR_TREND_SUM_TEMP on tpdef.TP_ID equals vtst.TP_ID
                                              join tpd in ObjectContext.TP_DATA on tpdef.TP_DEFN_SAKEY equals tpd.TP_DEFN_SAKEY
                                              join vts in ObjectContext.VAR_TREND_SUM on
                                                          new
                                                          {
                                                              TestDts = tpd.TEST_DTS,
                                                              StandCode = tpd.STAND_CODE
                                                          }
                                                          equals new
                                                          {
                                                              TestDts = vts.DATA_DTS,
                                                              StandCode = vts.LOW_PARAM_CODE // using vst.stand_code to store serial code
                                                          }
                                                       where vts.TP_TEXT == _sUsername && vtst.TP_TEXT == _sUsername
                                              orderby tpd.TEST_DTS
                                              select new TPPivotGridData()
                                              {    sModel =  vts.MODEL_CODE,
                                                   sSerial = vts.STAND_CODE, //  using vst.stand_code to store serial code
                                                  dId = tpdef.TP_ID,
                                                  dtTestTime = tpd.TEST_DTS,
                                                  sStandCode = tpd.STAND_CODE,
                                                  dTPQty = (decimal)tpd.TP_QTY
                                              });
#else
            /*var query = (ObjectQuery<TPPivotGridData>)(from tpdef in ObjectContext.TP_DEFN
                                                       join ad in ObjectContext.AUDIT_DEFN on tpdef.TP_ID equals ad.SHIFT_ID
                                                       join tpd in ObjectContext.TP_DATA on tpdef.TP_DEFN_SAKEY equals tpd.TP_DEFN_SAKEY
                                                       join vts in ObjectContext.VAR_TREND_SUM on
                                                                   new
                                                                   {
                                                                       TestDts = tpd.TEST_DTS,
                                                                       StandCode = tpd.STAND_CODE
                                                                   }
                                                                   equals new
                                                                   {
                                                                       TestDts = vts.DATA_DTS,
                                                                       StandCode = vts.LOW_PARAM_CODE // using vst.stand_code to store serial code
                                                                   }
                                                       where vts.TP_TEXT == _sUsername && ad.TABLE_NAME == _sUsername
                                                       orderby tpd.TEST_DTS
                                                       select new TPPivotGridData()
                                                       {
                                                           sModel = vts.MODEL_CODE,
                                                           sSerial = vts.STAND_CODE, //  using vst.stand_code to store serial code
                                                           dId = tpdef.TP_ID,
                                                           dtTestTime = tpd.TEST_DTS,
                                                           sStandCode = tpd.STAND_CODE,
                                                           dTPQty = (decimal)tpd.TP_QTY
                                                       });*/
            var query = (ObjectQuery<TPPivotGridData>)(from tpdef in ObjectContext.TP_DEFN
                                                       join ad in ObjectContext.AUDIT_DEFN.Where(x=>x.TABLE_NAME == _sUsername) on tpdef.TP_ID equals ad.SHIFT_ID
                                                       join tpd in ObjectContext.TP_DATA on tpdef.TP_DEFN_SAKEY equals tpd.TP_DEFN_SAKEY
                                                       join vts in ObjectContext.VAR_TREND_SUM.Where(x=>x.TP_TEXT == _sUsername) on
                                                                   new
                                                                   {
                                                                       TestDts = tpd.TEST_DTS,
                                                                       StandCode = tpd.STAND_CODE
                                                                   }
                                                                   equals new
                                                                   {
                                                                       TestDts = vts.DATA_DTS,
                                                                       StandCode = vts.LOW_PARAM_CODE // using vst.stand_code to store serial code
                                                                   }
                                                       // pivotgrid should take care of ordering the data orderby tpd.TEST_DTS
                                                       select new TPPivotGridData()
                                                       {
                                                           sModel = vts.MODEL_CODE,
                                                           sSerial = vts.STAND_CODE, //  using vst.stand_code to store serial code
                                                           dId = tpdef.TP_ID,
                                                           dtTestTime = tpd.TEST_DTS,
                                                           sStandCode = tpd.STAND_CODE,
                                                           dTPQty = (decimal)tpd.TP_QTY
                                                       });
#endif

            return query;
        }
           
#else
        // By default, your query is passed to the server in the URL. For complicated queries, the URL gets long enough to 
        // exceed the maximum length ( error : "The maximum URI length of 2083 was exceeded.")

        // Change the query method to use POST instead of GET, so the query is not passed on the URL, but in the POST body. 
        // To do this, use the [Query(HasSideEffects = true)] attribute. 
        [Query(HasSideEffects = true)]
        public IQueryable<TPPivotGridData> GetTPPivotGridData(List<string> _lstTestList, List<decimal> _lstTPIds)
        {          
            List<TDSC> lstTests = new List<TDSC>();// { udt1, udt2 };

            // reconstruct the datetime,standcode list
            string[] split;
            DateTime dt;
            foreach (string s in _lstTestList)
            {
                split = s.Split(' ');
                dt = new DateTime(Convert.ToInt32(split[0]), Convert.ToInt32(split[1]), Convert.ToInt32(split[2]),
                                  Convert.ToInt32(split[3]), Convert.ToInt32(split[4]), Convert.ToInt32( split[5]));
                lstTests.Add(new TDSC(dt, split[6]));
            }

            var query = (ObjectQuery<TPPivotGridData>)
                          (//from pd in ObjectContext.PRODUCT_DATA.Where(l => lstTests.Contains( new TDSC(l.TEST_DTS, l.STAND_CODE)))
                           from pd in ObjectContext.PRODUCT_DATA
                           //from test in lstTests
                           //where pd.TEST_DTS == test.dtTestDts &&
                           //pd.STAND_CODE == test.sStandCode
                           //from pd in ObjectContext.PRODUCT_DATA
                           //join testlist in lstTests
                           //     on 
                           //         new { dtTestDts = pd.TEST_DTS, sStandCode = pd.STAND_CODE } 
                           //         equals 
                           //         new { dtTestDts = testlist.dtTestDts, sStandCode = testlist.sStandCode }
                       

                           join tp in ObjectContext.TP_DATA on
                                 new
                                 {
                                     TestDts = pd.TEST_DTS,
                                     StandCode = pd.STAND_CODE
                                 }
                                 equals new
                                 {
                                     TestDts = tp.TEST_DTS,
                                     StandCode = tp.STAND_CODE
                                 }
                           from tpdefn in ObjectContext.TP_DEFN
                           where tpdefn.TP_ID == tp.TP_DEFN_SAKEY
                           orderby pd.TEST_DTS
                           select new TPPivotGridData()
                           {
                               dtTestTime = pd.TEST_DTS/*,
                               sStandCode = pd.STAND_CODE,
                               sText = tpdefn.TP_TEXT,
                               sModel = pd.MODEL_CODE,
                               sSerial = pd.SERIAL_CODE,
                               dId = tpdefn.TP_ID,
                               dTpDefnSakey = tp.TP_DEFN_SAKEY,
                               dTPQty = (decimal)tp.TP_QTY*/
                           });

            //var query = (ObjectQuery<TPPivotGridData>)
            //                (from tpd in ObjectContext.TP_DATA.AsEnumerable()
            //                 where tpd.TEST_DTS <= _dtStart && tpd.TEST_DTS >= _dtEnd //_lstTestList.Contains( tpd.TEST_DTS + tpd.STAND_CODE) 
            //                 from tpdefn in ObjectContext.TP_DEFN
            //                    where tpdefn.TP_ID == _lstTPIds[0] // temporary                                            
            //                 join 
            //                    tpdefn2 in ObjectContext.TP_DEFN 
            //                    on
            //                    tpd.TP_DEFN_SAKEY equals tpdefn2.TP_DEFN_SAKEY
            //                 orderby tpd.TEST_DTS                                              
            //                 select new TPPivotGridData()
            //                 {
            //                    dtTestTime = tpd.TEST_DTS,
            //                    sStandCode = tpd.STAND_CODE,
            //                    sText = tpdefn.TP_TEXT,
            //                    sModel = tpd.PRODUCT_DATA.MODEL_CODE,
            //                    sSerial = tpd.PRODUCT_DATA.SERIAL_CODE,
            //                    dId = tpdefn.TP_ID,
            //                    dTpDefnSakey = tpdefn.TP_DEFN_SAKEY,
            //                    dTPQty = (decimal)tpd.TP_QTY
            //                 }  );

            return query;
        }

#endif
        [Invoke]
        //z public IEnumerable<string> ExecuteQuery(string _sSql)
        // NOTE: Use this when expecting results.
        public IEnumerable<WMAApp.WMASharedClasses.Cxcrap> ExecuteQuery(string _sSql)
        {
            //IEnumerable<string> str = ObjectContext.ExecuteStoreQuery<IEnumerable<string>>(_sSql);
            //z var str = ObjectContext.ExecuteStoreQuery<string>(_sSql);
            //z return str.AsEnumerable();

            //var str = ObjectContext.ExecuteStoreQuery<string>(_sSql);
            // with ExecuteStoreCommand, you've bypassed Entity Framework so you'll need to use the Refresh method to keep your model in sync with your data
            var str = ObjectContext.ExecuteStoreQuery<WMAApp.WMASharedClasses.Cxcrap>(_sSql);
            //z return str.AsEnumerable();
            return str;
        }

        [Invoke]
        //z public IEnumerable<string> ExecuteQuery(string _sSql)
        // NOTE: Use this when not expecting results to be returned.
        public int iExecuteCommand(string _sSql)
        {
            int iRowsAffected = ObjectContext.ExecuteStoreCommand(_sSql);
            return iRowsAffected;
        }
#if DO_DIRECT_SQL


        /*The domain context will contain a method for each invoke operation on the domain service. Unlike domain operations, invoke operations are executed immediately. 
         * You do not call the SubmitChanges method. Invoke operations are executed asynchronously. The invoke operation returns an InvokeOperation object. 
         * You retrieve the value of the Value property to get the returned value from the service operation.

         In almost all scenarios, you should use query operations instead of invoke operations to load data. Query methods return either a single Entity object, an 
         * IQueryable<Entity> object, or an IEnumerable<Entity> object. Query methods are an integral part of the data pattern supported by DomainService on the 
         * middle-tier and by DomainContext on the client. The RIA Services framework generates entities in the client project for only those entities that are 
         * returned from query methods in a DomainService.

         Invoke operations provide an out-of-band mechanism for returning non-entity data and executing operations with side-effects. For more information about 
         * side-effects, see the HasSideEffects property. Invoke operations are usually not appropriate for query methods. Even when an invoke operation returns an entity, 
         * the entity is generated for the client project only if it is returned by a query method.
         * */

        // NOTE: Use this when expecting results.
        ////////public IEnumerable<TestData> ExecuteQueryGetTestResults(string _sSql, object[] sqlParams )
        ////////{         
        ////////    return ObjectContext.ExecuteStoreQuery<TestData>(_sSql, sqlParams).AsEnumerable();
        ////////}
        ////public IQueryable<TestData> ExecuteQueryGetTestResults(string _sSql, object[] sqlParams)
        ////{
        ////    return ObjectContext.ExecuteStoreQuery<TestData>(_sSql, sqlParams).AsQueryable();
        ////}
        [Invoke]

        //temporary debug
        public IEnumerable<TestData> ExecuteQueryGetTestResults(string _sSql, string _sTestTime, string _sStandCode)
        {
            //todo: could't get objectparameters to work correctly so I just did stupid replace show below...
            //var parameters = new ObjectParameter[] { new ObjectParameter("td", _sTestTime), new ObjectParameter("sc", _sStandCode) };
            //var parameters = new DbParameter[] { new OracleParameter("td", _sTestTime), new SqlParameter("sc", _sStandCode) };
            var parameters = new object[] { _sTestTime, _sStandCode };

            //return ObjectContext.ExecuteStoreQuery<TestData>(_sSql, new object[]{ _sTestTime, _sStandCode} ).AsEnumerable();
            //return ObjectContext.ExecuteStoreQuery<TestData>(_sSql, parameters).AsEnumerable();

            _sSql = _sSql.Replace("{0}", _sTestTime);
            _sSql = _sSql.Replace("{1}", _sStandCode);
            return ObjectContext.ExecuteStoreQuery<TestData>(_sSql).AsEnumerable();            
        }
#if crap
#else
        public LimitData Dummy()
        {
            return null;
        }

        [Invoke]
        public IEnumerable<LimitData> ExecuteQueryLimitData(string _sSql)
        {
            return ObjectContext.ExecuteStoreQuery<LimitData>(_sSql).AsEnumerable();
        }

        [Invoke]
        public IEnumerable<TPData> ExecuteQueryGetTPData(string _sSql)
        {
            try
            {
            return ObjectContext.ExecuteStoreQuery<TPData>(_sSql).AsEnumerable();
        }        
            catch( Exception Ex )
            {
                string s = Ex.Message;
                return null;
            }
        }

#endif // crap
        [Invoke]
        public IEnumerable<TPPivotGridData> ExecuteQueryGetTPPivotGridData(string _sSql)
        {
            return ObjectContext.ExecuteStoreQuery<TPPivotGridData>(_sSql).AsEnumerable();
        }
#endif // DO_DIRECT_SQL
    }
}