﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ComponentModel.DataAnnotations;

namespace WMAApp.Web.Models
{
    public partial class HistogramGroup
    {
        public string sLabel { get; set; }
        public double dCount { get; set; }

        public HistogramGroup()
        {
            sLabel = "";
            dCount = 0.0;
        }

        public HistogramGroup(int iGroupId)
            : this()
        {
            sLabel = "Group" + iGroupId;
        }

        public void vSetGroupLabel(string _sLabel)
        {
            sLabel = _sLabel;
        }
    }

    public partial class HistogramColumns
    {
        [Key]
        public string sRange { get; set; }
        public List<HistogramGroup> lsGroups { get; set; }

        public void vCreateGroups( int iGroups )
        {
            if (lsGroups.Count > 0 ) lsGroups.Clear();

            for (int i = 0; i < iGroups; i++)
            {
                lsGroups.Add(new HistogramGroup( i ));
            }
        }

        public HistogramColumns()
        {
            lsGroups = new List<HistogramGroup>();
        }

    }
}