﻿//#define RESTRICT_DOCK_DESTINATIONS

#region Using
using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Layouts;
using System.Text;
using System.Windows.Markup;
#endregion Using
// This class is used to extend the base ContentPane class to add a tooltip to the tab header.

namespace WMAApp.Controls
{
    public class ContentPaneEx : ContentPane
    {
        public ControlTemplate TabHeaderToolTipTemplate
        {
            get { return (ControlTemplate)GetValue(TabHeaderToolTipTemplateProperty); }
            set { SetValue(TabHeaderToolTipTemplateProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TabHeaderToolTipTemplate.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TabHeaderToolTipTemplateProperty =
            DependencyProperty.Register("TabHeaderToolTipTemplate", typeof(ControlTemplate), typeof(ContentPaneEx), new PropertyMetadata(null));
    
    
        public ContentPaneEx()
        {
            // Default tooltip.
            TabHeaderToolTipTemplate = BuildBasicToolTipTemplate(this);
        }

        private ControlTemplate BuildBasicToolTipTemplate(ContentPane pane)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("<ControlTemplate xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\">");
            sb.Append("<Border BorderBrush=\"Black\" BorderThickness=\"1\" Background=\"#FFF7F8FA\">");
            sb.Append("<TextBlock Text='{Binding Path=Header}'/>");
            sb.Append("</Border>");
            sb.Append("</ControlTemplate>");

            return XamlReader.Load(sb.ToString()) as ControlTemplate;
        }
#if RESTRICT_DOCK_DESTINATIONS
        protected override bool EnsureDockingAllowed(Infragistics.Controls.Layouts.Primitives.ISupportDockIndicators isdi)
        {
            // This method checks to see if I ( this pane ) can be docked to destPane
            // cast the argument to a pane.
            PaneBase pDest = isdi as PaneBase;
            
            switch (((Infragistics.Controls.Layouts.ContentPane)(this)).Content.GetType().ToString())
	        {
                case "Infragistics.Controls.Grids.XamGrid":                   
                    // Check the destination pane name.
                    if (pDest != null && pDest.Name == "tgpData")
                        return true;
                    break;
                case "Infragistics.Controls.Grids.XamDataChart":
                    // Check the destination pane name.
                    if (pDest != null && pDest.Name == "tgpCharts")
                        return true;
                    break;
                case "Infragistics.Controls.Grids.XamPivotGrid":
                    // Check the destination pane name.
                    if (pDest != null && pDest.Name == "tgpPivotGrid")
                        return true;
                    break;
                default:
                    break;
	        }
            return false;
         
        }
#endif
    }


}
