﻿#region Using
using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
#endregion Using
namespace WMAApp.Controls
{
    public class XamDataChartEx : XamDataChart
    {
        #region Private Members

        // The title for the chart.
        TextBlock m_titleText = new TextBlock();

        #endregion

        #region Dependency Properties

        public Style TitleStyle
        {
            get { return (Style)GetValue(TitleStyleProperty); }
            set { SetValue(TitleStyleProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TitleStyle.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TitleStyleProperty =
            DependencyProperty.Register("TitleStyle", typeof(Style), typeof(XamDataChartEx), new PropertyMetadata(null, new PropertyChangedCallback(OnTitleStyleChanged)));

        protected static void OnTitleStyleChanged(DependencyObject dObj, DependencyPropertyChangedEventArgs e)
        {
            XamDataChartEx chart = (dObj as XamDataChartEx);

            // Update the title.
            chart.m_titleText.Style = (Style)e.NewValue;
        }

        public string Title
        {
            get { return (string)GetValue(TitleProperty); }
            set { SetValue(TitleProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Title.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TitleProperty =
            DependencyProperty.Register("Title", typeof(string), typeof(XamDataChartEx), new PropertyMetadata("", new PropertyChangedCallback(OnTitleChanged)));

        protected static void OnTitleChanged(DependencyObject dObj, DependencyPropertyChangedEventArgs e)
        {
            XamDataChartEx chart = (dObj as XamDataChartEx);

            // Update the title.
            chart.m_titleText.Text = (string)e.NewValue;
        }

        #endregion

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();

            Grid rootLayout = VisualTreeHelper.GetChild(this, 0) as Grid;

            //m_titleText.FontSize = 24;
            m_titleText.VerticalAlignment = System.Windows.VerticalAlignment.Top;
            m_titleText.HorizontalAlignment = System.Windows.HorizontalAlignment.Center;

            // Add the title.
            rootLayout.Children.Add(m_titleText);
        }
    }
}
