﻿#define SUBMIT_IMMEDIATE
#define DO_DIRECT_SQL
#define TRAP_SUBMITCHANGES_ERRORS_DIRECTLY

#region Using
using System;
using System.Linq;
using System.Collections.Generic;

// Toolkit namespace
using SimpleMvvmToolkit;
using System.ServiceModel.DomainServices.Client;
using System.ComponentModel;
using WMAApp.Web.Services;
using WMAApp.Web.Models;
using System.Text;
using System.Windows.Browser;
using System.Collections.ObjectModel;
using WMAApp.WMASharedClasses;
using System.Threading.Tasks;
using System.Threading;
using WMAApp.Helpers;
using System.ComponentModel.DataAnnotations;
#endregion Using

namespace WMAApp.Services.Home
{

    // Add ServiceAgentExport attribute, setting AgentType to Real
    // todo: Instead of just .Real or .Mock, I'm hoping service agent framework can help us support differing databases
    [ServiceAgentExport(typeof(IHomeSA), AgentType = AgentType.Real)]
    public class HomeSA : IHomeSA
    {
        #region Constructors
        public HomeSA()
        {
            m_lstDomainContext = new List<WMATestDBDomainContext>();
        }

        #endregion

        #region Event Handlers

        // Notifies ViewModel to check IsDirty
        //public event EventHandler IsDirtyChanged;

        #endregion

        #region Members

        #region Data
        public ManualResetEvent ev;
        public ManualResetEvent ev2;
        //Task[] tasks;
        decimal nextVal;

        // domain context class serves as a client side proxy to access our domain RIA service domain service class.        
        List<WMATestDBDomainContext> m_lstDomainContext;

        Action<Exception> m_cbfCompleted;
        #endregion

        #region Connection
        public void vSetDbConnection(string sConnNames)
        {
            string[] sConns = sConnNames.Split(',');
            int i = 0;

            foreach (string sConn in sConns)
            {
                m_lstDomainContext.Add(new WMATestDBDomainContext());

                SetCookie("ConnString", sConn);
                i++;
            }

        }
        #endregion

        #region DBAccess

#if DO_DIRECT_SQL
        ////////public void vExecuteQueryGetTestResults(int _iCurrContext, string _sSql, object[] _sqlParams, Action<InvokeOperation<IEnumerable<TestData>>> _cbfCallback)
        //public void vExecuteQueryGetTestResults(int _iCurrContext, string _sSql, object[] _sqlParams, Action<InvokeOperation<IQueryable<TestData>>> _cbfCallback)
        //{
        //    m_lstDomainContext[_iCurrContext].ExecuteQueryGetTestResults(_sSql, _sqlParams, _cbfCallback, null);
        //}
        //public void vExecuteQueryGetTestResults(int _iCurrContext, string _sSql, string _sTestTime, string _sStandCode, Action<InvokeOperation<IQueryable<TestData>>> _cbfCallback)
        //{
        //    m_lstDomainContext[_iCurrContext].ExecuteQueryGetTestResultsQuery(_sSql, _sTestTime, _sStandCode, _cbfCallback, null);
        //}
        public void vExecuteQueryGetTestResults(int _iCurrContext, string _sSql, string _sTestTime, string _sStandCode, 
                                                Action<InvokeOperation<IEnumerable<TestData>>> _cbfCallback)
        {
            m_lstDomainContext[_iCurrContext].ExecuteQueryGetTestResults(_sSql, _sTestTime, _sStandCode, _cbfCallback, null);
        }

        public void vExecuteQueryGetTPPivotGridData(int _iCurrContext, string _sSql,
                                            Action<InvokeOperation<IEnumerable<TPPivotGridData>>> _cbfCallback)
        {
            m_lstDomainContext[_iCurrContext].ExecuteQueryGetTPPivotGridData(_sSql, _cbfCallback, null);
        }
#endif //DO_DIRECT_SQL

        // NOTE: Use this when expecting results to be returned.
        public void vExecuteQuery(int _iCurrContext, string _sSql, Action<InvokeOperation<IEnumerable<WMAApp.WMASharedClasses.Cxcrap>>> _cbfCallback)
        {
            m_lstDomainContext[_iCurrContext].ExecuteQuery(_sSql, _cbfCallback, null);
        }

        // NOTE: Use this when not expecting results to be returned.
        public int iExecuteCommand(int _iCurrContext, string _sSql, Action<int> _cbfCallback, bool _bSubmitChanges )
        {
            int iRowsAffected = 0;
            if (!_bSubmitChanges)
            {
                m_lstDomainContext[_iCurrContext].iExecuteCommand(_sSql,
                                                                   (iRowsAff) =>
                                                                   {
                                                                       if (iRowsAff.Value <= 0)
                                                                       {
                                                                           //todo: might have to handle as an error condition
                                                                       }
                                                                       else
                                                                       {
                                                                       }
                                                                       iRowsAffected = iRowsAff.Value;
                                                                       // Invoke completion callback
                                                                       if (_cbfCallback != null) _cbfCallback(iRowsAffected); //new
                                                                   }
                                                                    , null);
            }
            else
            {
                m_lstDomainContext[_iCurrContext].iExecuteCommand(_sSql,
                                                                    (iRowsAff) =>
                                                                    {
                                                                        iRowsAffected = iRowsAff.Value;
                                                                        if (iRowsAff.Value <= 0)
                                                                        {
                                                                            //todo: might have to handle as an error condition
                                                                            // Invoke completion callback
                                                                            if (_cbfCallback != null) _cbfCallback(iRowsAffected); //new                                                                            
                                                                        }
                                                                        else
                                                                        {
                                                                            m_lstDomainContext[_iCurrContext].SubmitChanges(submitOp =>
                                                                            {
                                                                                // Declare error
                                                                                Exception exError = null;

                                                                                // Set error or result
                                                                                if (submitOp.HasError)
                                                                                {
                                                                                    exError = submitOp.Error;
                                                                                    //todo:
                                                                                }
                                                                                // Invoke completion callback
                                                                                if (_cbfCallback != null) _cbfCallback(iRowsAffected); //new
                                                                            }, null);
                                                                        }
                                                                    }
                                                                     , null);

                
            
                //today vBlockDuringSubmit(_iCurrContext);

            }
            
            // Invoke completion callback
            //new if (_cbfCallback != null) _cbfCallback(iRowsAffected);

            return iRowsAffected;
        }
        public void vBlockDuringSubmit(int _iCurrContext)
        {
            m_lstDomainContext[_iCurrContext].PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(vcbfBlockingDuringSubmit);             
        }       
        public void vcbfBlockingDuringSubmit(object _sender, System.ComponentModel.PropertyChangedEventArgs _Args)
        {
            if (_Args.PropertyName == "IsSubmitting")
            { // _Args.PropertyName == "IsLoading" || 
                //IsBusy = (m_lstDomainContext[_iCurrContext].IsLoading && m_lstDomainContext[_iCurrContext].IsSubmitting);
                while (m_lstDomainContext[0].IsSubmitting ) // todo: how get proper context?????
                {
                    System.Threading.Thread.Sleep(10);
                    // todo: add bail out timeout check
                }
            }
        }
        public void vSubmitChanges(int _iCurrContext,
                                Action<Exception> _cbfCompleted)
        {
#if TRAP_SUBMITCHANGES_ERRORS_DIRECTLY
            m_cbfCompleted = _cbfCompleted; // remember this for use in SubmitChangesCompleted
            m_lstDomainContext[_iCurrContext].SubmitChanges(new Action<SubmitOperation>(SubmitChangesCompleted), null);
#else
            // Submit bulk update
            m_lstDomainContext[_iCurrContext].SubmitChanges(submitOp =>
            {
                // Declare error
                Exception exError = null;

                // Set error or result
                if (submitOp.HasError)
                {
                    exError = submitOp.Error;
                }

                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(exError); //todo: fix: this error doesn't get passed back to caller as it should???????
            }, null);
#endif
        }
#if TRAP_SUBMITCHANGES_ERRORS_DIRECTLY
        public void SubmitChangesCompleted(SubmitOperation so)
        {
            // Declare error
            Exception exError = null;

            // Set error or result
            if (so.HasError)
            {
                exError = so.Error;
            }
            //---
            string message;
            if (so.Error != null)
            {
                message = so.Error.Message;
                //if (so.EntitiesInError.Any())
                //{
                //    message = string.Empty;
                //    Entity entityInError = so.EntitiesInError.First();
                //    if (entityInError.EntityConflict != null)
                //    {
                //        EntityConflict conflict = entityInError.EntityConflict;
                //        foreach (string s in conflict.PropertyNames)
                //        {
                //            message += string.Format("Member '{0}' in conflict \r\n", s);
                //        }
                //    }
                //    else if (entityInError.ValidationErrors.Any())
                //    {
                //        foreach (System.ComponentModel.DataAnnotations.ValidationResult vr in entityInError.ValidationErrors)
                //        {
                //            message += string.Format("{0}\r\n", vr.ErrorMessage);
                //        }
                //    }
                //}
                ////MessageBox.Show(message, "Submit Failed", MessageBoxButton.OK);
                foreach (var entity in so.EntitiesInError)
                    foreach (ValidationResult operationError in entity.ValidationErrors)
                    {
                        message = operationError.ErrorMessage;
                    }

                //EntityChangeSet changeSet = m_lstDomainContext[0].EntityContainer.GetChanges();
                so.MarkErrorAsHandled();
            }

            //---

            // Invoke completion callback
            if (m_cbfCompleted != null) m_cbfCompleted(exError); //todo: fix: this error doesn't get passed back to caller as it should???????
        }
#endif
        //private void OnProfileCreateCallback(SubmitOperation submitOperation) {
        //    submitOperation.ChangeSet.AddedEntities.First().GetIdentity();     
        //} 
        #endregion

        private void SetCookie(string sName, string sValue)
        {
            DateTime expire = DateTime.Now + TimeSpan.FromDays(1);

            byte[] val;
            UnicodeEncoding encoder = new UnicodeEncoding();
            val = encoder.GetBytes(sValue);
            
            string newCookie = sName + "=" + System.Convert.ToBase64String(val) + ";expires=" + expire.ToString("R");
            HtmlPage.Document.SetProperty("cookie", newCookie);
        }
        
        #region Filtration
        public void vGetNextSequence(int _iCurrContext, string sSequenceName, Action<InvokeOperation<decimal>> _cbfCallback)
        {
            m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName, _cbfCallback, null);
        }
        public decimal decGetNextSequenceSync(int _iCurrContext, string sSequenceName)
        {
            //decimal nextVal = 0;
            //Task[] tasks = new Task<decimal>[1] 
            //{
            //    //Task.Factory.StartNew(() => { return m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName).Value; }).ContinueWith(t=> ..)
            //   Task.Factory.StartNew(
            //                                     () => { 
            //                                            return m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName).Value; 

            //                                           }
            //                                   )

            //};
            //Task.WaitAll(tasks);
            //return tasks[0].r;
            //ev = new ManualResetEvent(false);

            //Task<decimal> task1 = Task<decimal>.Factory.StartNew(
            //                                     () => {
                                                     
            //                                            return this.vGetNextSequence(_iCurrContext,sSequenceName, //m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName, cbfDone).Value; 
            //                                           }
            //                                   );
            //Task.WaitAll(task1);
            //return task1.Result;
            ev = new ManualResetEvent(false);
            ev2 = new ManualResetEvent(false);


            //Action<InvokeOperation<decimal>> cbfDone = delegate(InvokeOperation<decimal> op)
            //{
            //    ev.Set();
            //};

            //m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName, cbfDone, null); 
            ////////tasks = new Task[2] 
            ////////{
            ////////    Task.Factory.StartNew( () => m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName, (dNextSakey) =>
            ////////    {
            ////////        nextVal = dNextSakey.Value;
            ////////        ev.Set();
            ////////    }, null)),
            ////////    Task.Factory.StartNew( () =>  {ev.WaitOne(); })
            ////////};

            //tasks = new Task[2] 
            //{
            //    Task.Factory.StartNew( 
            //                            () => { 
            //                                    m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName, (dNextSakey) =>
            //                                                                                                                        {
            //                                                                                                                            nextVal = dNextSakey.Value;
            //                                                                                                                            ev.Set();
            //                                                                                                                        },null
            //                                                                                          );
            //                                   }
            //                         ),
            //    Task.Factory.StartNew( () =>  {ev.WaitOne(); })
            //};
           
            /*
            tasks = new Task[2] 
            {
                Task.Factory.StartNew( 
                                        () => { 
                                                m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName, (dNextSakey) =>
                                                                                                                                    {
                                                                                                                                        nextVal = dNextSakey.Value;
                                                                                                                                        ev.Set();                                                                                                                                        
                                                                                                                                    },null
                                                                                                      );
                                               },TaskCreationOptions.AttachedToParent
                                     ),
                Task.Factory.StartNew( () =>  {ev.WaitOne();  })
            };
            try
            {
                Task.WaitAll(tasks);
            }
            catch (Exception)
            {                
                throw;
            }
            */


            ThreadPool.QueueUserWorkItem((o) =>
            {
                m_lstDomainContext[_iCurrContext].GetNextSequenceValue(sSequenceName, (dNextSakey) =>
                                                                                                    {
                                                                                                        nextVal = dNextSakey.Value;
                                                                                                        ev.Set();                                                                                                                                        
                                                                                                    },null
                                                                        );
                // do your thing..
            });
            ThreadPool.QueueUserWorkItem((o) =>
            {
                ev.WaitOne(); 
            });
            //ThreadPool.QueueUserWorkItem((o) =>
            //{
                WaitHandle.WaitAll(new WaitHandle[] { ev, ev2 });
                // do your thing..
            //});

            return nextVal;
        }
        public void WaitOndone()
        {
            ev.WaitOne();
            ev2.Set();
            
        }

        //public void cbfDone(InvokeOperation<decimal> _op)
        //{
        //    if (_op.HasError)
        //    {
        //        // todo:handle error
        //    }
        //    else
        //    {

        //        nextVal = _op.Value;
        //        ev.Set();
        //    }
        //}
      

        //private  void cbfDone()
        //{
        //    ev.Set();
        //}

        public void vInsertMbxTop(int _iCurrContext, MBX_TOP _MbxTop,
                            Action<List<MBX_TOP>, Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            m_lstDomainContext[_iCurrContext].MBX_TOPs.Add(_MbxTop);

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback
                    _cbfCompleted(null, submitOp != null ? submitOp.GetBaseException() : exError);
                }
                );
            }
            else
            {
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(null, exError);
            }
        }
        public void vPreLoadFilters(int iCurrContext )
        {
            m_lstDomainContext[iCurrContext].FAMILY_DEFNs.Clear();
            m_lstDomainContext[iCurrContext].STAND_DEFNs.Clear();
            m_lstDomainContext[iCurrContext].MODEL_CODE_DEFNs.Clear();
            m_lstDomainContext[iCurrContext].SHIFT_DEFNs.Clear();
        }
        
        public void vLoadShiftDefns(int _iCurrContext, Action<List<SHIFT_DEFN>, Exception> _cbfCompleted)
        {
            EntityQuery<SHIFT_DEFN> query = m_lstDomainContext[_iCurrContext].GetSHIFT_DEFNQuery();
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                Exception exError = null;
                IEnumerable<SHIFT_DEFN> enShifts = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enShifts = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enShifts.ToList(), exError);
                }
            }, null);
        }

        public void vLoadFamilyDefns(int _iCurrContext,
                                   Action<List<FAMILY_DEFN>, Exception> _cbfCompleted )
        {
            // Load data
            EntityQuery<FAMILY_DEFN> query = m_lstDomainContext[_iCurrContext].GetFAMILY_DEFNQuery();
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<FAMILY_DEFN> enFamilyData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enFamilyData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enFamilyData.ToList(), exError);
                }
            }, null);
        }

        public void vLoadStandDefns(int _iCurrContext,
                                  Action<List<STAND_DEFN>, Exception> _cbfCompleted)
        {
            // Load data
            EntityQuery<STAND_DEFN> query = m_lstDomainContext[_iCurrContext].GetSTAND_DEFNQuery().OrderBy( sd => sd.STAND_NUMBER );
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<STAND_DEFN> enStandData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enStandData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enStandData.ToList(), exError);
                }
            }, null);
        }
/*
        public void vLoadProductData(int iCurrContext, DateTime _dtStartDate, DateTime _dtEndDate,
                                    Action<List<Web.Models.PRODUCT_DATA>, Exception> _cbfCompleted)
        {
            // Load product data

            m_lstDomainContext[iCurrContext].PRODUCT_DATAs.Clear();
            EntityQuery<Web.Models.PRODUCT_DATA> query = 
                m_lstDomainContext[iCurrContext].GetPRODUCT_DATAQuery().Where(t => t.TEST_DTS >= (_dtStartDate) && t.TEST_DTS <= _dtEndDate);
            m_lstDomainContext[iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.PRODUCT_DATA> enProductData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enProductData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enProductData.ToList(), exError);
                }
            }, null);
        }
            
        public void vLoadProductDataWStatAndRej(int _iCurrContext, 
                                               DateTime _dtStartTime,
                                               DateTime _dtEndTime,
                                               List<FamilyDef> _Family,
                                               List<StandDef> _Stands,
                                               List<ModelDef> _Models,
                                               List<int> _lIncStatus,
                                               List<int> _lExcStatus,                                   
                                               Action<List<PRODUCT_DATA>, Exception> _cbfCompleted)
        {
            EntityQuery<PRODUCT_DATA> query;
            List<int> lFamilyIds;
            List<string> lStandIds;
            List<string> lModels;
            
            // Add filter logic here to decide which query to call
            lFamilyIds = new List<int>();
            foreach (FamilyDef fd in _Family)
            {
                lFamilyIds.Add(fd.iFamilyId);
            }

            lStandIds = new List<string>();
            foreach (StandDef sd in _Stands)
            {
                lStandIds.Add(sd.iStandNumber.ToString());
            }

            lModels = new List<string>();
            foreach (ModelDef md in _Models)
            {
                lModels.Add(md.sModelName);
            }

            query = m_lstDomainContext[_iCurrContext].GetProductDataDateFamilyQuery(_dtStartTime, _dtEndTime, lFamilyIds, lStandIds, lModels, _lIncStatus, _lExcStatus, true);
            
            // Load data  
            
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<PRODUCT_DATA> enProductData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enProductData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enProductData.ToList(), exError);
                }
            }, null);
        }
*/
        public void vLoadProductData(int _iCurrContext,
                                          DateTime _dtStartTime,
                                          DateTime _dtEndTime,
                                          List<FamilyDef> _Family,
                                          List<StandDef> _Stands,
                                          List<ModelDef> _Models,
                                          List<int> _lFirstTest,
                                          List<int> _lTestStatus,
                                          List<int> _lLastTest,
                                          Boolean _boWithRejects,
                                          Action<List<PRODUCT_DATA>, Exception> _cbfCompleted)
        {
            EntityQuery<PRODUCT_DATA> query;
            List<int> lFamilyIds;
            List<string> lStandIds;
            List<string> lModels;

            // Add filter logic here to decide which query to call
            lFamilyIds = new List<int>();
            foreach (FamilyDef fd in _Family)
            {
                lFamilyIds.Add(fd.iFamilyId);
            }

            lStandIds = new List<string>();
            if (_Stands[0].iStandNumber != -1)
            {
                foreach (StandDef sd in _Stands)
                {
                    lStandIds.Add(sd.iStandNumber.ToString());
                }
            }

            lModels = new List<string>();

            if (_Models[0].sModelName != "All")
            {
                foreach (ModelDef md in _Models)
                {
                    lModels.Add(md.sModelName);
                }
            }

            query = m_lstDomainContext[_iCurrContext].GetProductDataDateFamilyQuery(_dtStartTime, _dtEndTime, lFamilyIds, lStandIds, lModels, _lFirstTest, _lTestStatus, _lLastTest, _boWithRejects);

            // Load data  

            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<PRODUCT_DATA> enProductData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enProductData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enProductData.ToList(), exError);
                }
            }, null);
        }

        public void vLoadProductDataWStatAndRejForParts(int _iCurrContext,
                                               List<string> _lstPartList, //IEnumerable<string> _iePartList, //IEnumerable<PartData> _iePartList,
                                               Action<List<Web.Models.PRODUCT_DATA>, Exception> _cbfCompleted)
        {
            
            // Load data  
            //EntityQuery<Web.Models.PRODUCT_DATA> query = _lstDomainContext[_iCurrContext].GetPRODUCT_DATAQuery().Where(t => t.TEST_DTS >= (_dtStartTime) && t.TEST_DTS <= _dtEndTime);            
            EntityQuery<Web.Models.PRODUCT_DATA> query = m_lstDomainContext[_iCurrContext].GetPRODUCT_DATA_W_STAT_AND_REJ_FOR_PARTSQuery(_lstPartList); //_iePartList);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.PRODUCT_DATA> enProductData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enProductData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enProductData.ToList(), exError);
                }
            }, null);
        }
        public void vLoadProductDataWStatForParts(int _iCurrContext,
                                              List<string> _lstPartList, //IEnumerable<string> _iePartList, //IEnumerable<PartData> _iePartList,
                                              Action<List<Web.Models.PRODUCT_DATA>, Exception> _cbfCompleted)
        {

            // Load data  
            //EntityQuery<Web.Models.PRODUCT_DATA> query = _lstDomainContext[_iCurrContext].GetPRODUCT_DATAQuery().Where(t => t.TEST_DTS >= (_dtStartTime) && t.TEST_DTS <= _dtEndTime);            
            EntityQuery<Web.Models.PRODUCT_DATA> query = m_lstDomainContext[_iCurrContext].GetPRODUCT_DATA_W_STAT_FOR_PARTSQuery(_lstPartList); //_iePartList);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.PRODUCT_DATA> enProductData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enProductData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enProductData.ToList(), exError);
                }
            }, null);
        }
        public void vLoadActiveModels(int _iCurrContext, 
                                     int _iFamilyId,
                                     Action<List<Web.Models.ModelDefData>, Exception> _cbfCompleted)
        {
            m_lstDomainContext[_iCurrContext].ModelDefDatas.Clear();
            // Load data


            EntityQuery<Web.Models.ModelDefData> query = m_lstDomainContext[_iCurrContext].GetActiveModelsQuery(_iFamilyId);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.ModelDefData> enModelData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enModelData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enModelData.ToList(), exError);
                }
            }, null);
        }
        #endregion

        #region TPDefns
        public void vLoadTPDefns(int _iCurrContext,
                                        List<string> _lstTestList, 
                                        Action<List<Web.Models.TP_DEFN>, Exception> _cbfCompleted)
        {

            // Load data  
            EntityQuery<Web.Models.TP_DEFN> query = m_lstDomainContext[_iCurrContext].GetTEST_POINT_DEFNSQuery(_lstTestList);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.TP_DEFN> enTpDefns = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enTpDefns = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enTpDefns.ToList(), exError);
                }
            }, null);
        }
        public void vLoadTPDefns(int _iCurrContext,
                                        Action<List<Web.Models.VU_TP_DEFN_CRUST>, Exception> _cbfCompleted)
        {            
            // Load data  
            EntityQuery<Web.Models.VU_TP_DEFN_CRUST> query = m_lstDomainContext[_iCurrContext].GetVU_TP_DEFN_CRUSTQuery().OrderBy(p=> p.FAMILY_ID).ThenBy(p2=>p2.TP_ID);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.VU_TP_DEFN_CRUST> enTpDefnsCrust = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enTpDefnsCrust = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enTpDefnsCrust.ToList(), exError);
                }
            }, null);
        }
        
        public void vLoadTPDefns(int _iCurrContext,
                         Action<List< WMAApp.Web.Models.TpDefn>, Exception> _cbfCompleted)
        {
            // Load data  
            EntityQuery<WMAApp.Web.Models.TpDefn> query = m_lstDomainContext[_iCurrContext].GetTpDefnsQuery();
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<TpDefn> enTpDefnsCrust = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enTpDefnsCrust = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enTpDefnsCrust.ToList(), exError);
                }
            }, null);
        }

		public void vLoadTPDefnsInFam(int _iCurrContext,
                                       List<decimal> _lstdDistinctFamilyIds,
                                       Action<List<Web.Models.TpDefn>, Exception> _cbfCompleted)
        {

            // Load data  
            EntityQuery<Web.Models.TpDefn> query = m_lstDomainContext[_iCurrContext].GetTpDefnsInFamQuery(_lstdDistinctFamilyIds);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.TpDefn> enTpDefns = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enTpDefns = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enTpDefns.ToList(), exError);
                }
            }, null);
        }
        #endregion TPDefns

        #region Test Results

        public void vLoadTestResults(int _iCurrContext, DateTime dtTestTime, string sStandCode, Action<List<TestData>, Exception> _cbfCompleted)
        {
            EntityQuery<TestData> query = m_lstDomainContext[_iCurrContext].GetTestResultsQuery(dtTestTime, sStandCode);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<TestData> enResults = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enResults = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enResults.ToList(), exError);
/*                    if (_cbfCompleted != null) _cbfCompleted(enResults.GroupBy(x => x.dId).Select(g => new TestData()
                        {
                            dId = g.First().dId,
                            sText = g.First().sText,
                            dFormattedLowLimit = g.First().dFormattedLowLimit,
                            dFormattedValue = g.First().dFormattedValue,
                            dFormattedHighLimit = g.First().dFormattedHighLimit,
                            sUnits = g.First().sUnits
                        }).ToList(), exError);*/
                }
            }, null);
        }

        #endregion
        #region TP Data results
        //todo: delete this if never used
        public void vLoadTPData(int _iCurrContext, decimal _dTpId, string _sUserName,
                             Action<List<TPData>, Exception> _cbfCompleted)

        {
            // Load data  
            EntityQuery<WMAApp.Web.Models.TPData> query = m_lstDomainContext[_iCurrContext].GetTPDataQuery(_dTpId, _sUserName);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<TPData> enTpData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enTpData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enTpData.ToList(), exError);
                }
            }, null);
        }

        public void vClearTempTPData(int _iCurrentContext)
        {
            m_lstDomainContext[_iCurrentContext].VAR_TREND_SUMs.Clear();
        }
        public void vInsertTempTPData(int _iCurrContext, Web.Models.VAR_TREND_SUM _VTS,
                                  Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {       
            m_lstDomainContext[_iCurrContext].VAR_TREND_SUMs.Add(_VTS);

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback                   
                    if (_cbfCompleted != null) { _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError); }
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) { _cbfCompleted(exError); }
            }
        }
#if crap
#else
        public void vExecuteQueryGetTPData(int _iCurrContext, string _sSql,
                                              Action<InvokeOperation<IEnumerable<TPData>>> _cbfCallback)
        {
            m_lstDomainContext[_iCurrContext].ExecuteQueryGetTPData(_sSql, _cbfCallback, null);
        }

   		public void vExecuteQueryGetLimits(int _iCurrContext, string _sSql, Action<InvokeOperation<IEnumerable<LimitData>>> _cbfCallback)
        {
            m_lstDomainContext[_iCurrContext].ExecuteQueryLimitData( _sSql, _cbfCallback, null);
        }
#endif // crap
        #endregion TP Data results
        #region TP Pivot Grid Data results
        public void vClearTempPGTestData(int _iCurrentContext)
        {
            m_lstDomainContext[_iCurrentContext].VAR_TREND_SUMs.Clear();
        }

        public void vInsertTempPGTestData(int _iCurrContext, Web.Models.VAR_TREND_SUM _VTS,
                                  Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            m_lstDomainContext[_iCurrContext].VAR_TREND_SUMs.Add(_VTS);

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback                   
                    if (_cbfCompleted != null) { _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError); }
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) { _cbfCompleted(exError); }
            }
        }
#if USE_VAR_TREND_SUM_TEMP 
        public void vClearTempPGTpData(int _iCurrentContext)
        {
            m_lstDomainContext[_iCurrentContext].VAR_TREND_SUM_TEMPs.Clear();
        }
        public void vInsertTempPGTpData(int _iCurrContext, Web.Models.VAR_TREND_SUM_TEMP _VTS,
                                 Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            m_lstDomainContext[_iCurrContext].VAR_TREND_SUM_TEMPs.Add(_VTS);

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback                   
                    if (_cbfCompleted != null) { _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError); }
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) { _cbfCompleted(exError); }
            }
        }
        
#else
        public void vClearTempPGTpData2(int _iCurrentContext)
        {
            m_lstDomainContext[_iCurrentContext].AUDIT_DEFNs.Clear();
        }
        public void vInsertTempPGTpData2(int _iCurrContext, Web.Models.AUDIT_DEFN _VTS,
                                 Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            m_lstDomainContext[_iCurrContext].AUDIT_DEFNs.Add(_VTS);

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback                   
                    if (_cbfCompleted != null) { _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError); }
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) { _cbfCompleted(exError); }
            }
        }
#endif
        public void vLoadTPPivotGridData(int _iCurrContext, string _sUsername, // List<string> _lstTestList, List<decimal> _lstTPIds,
                             Action<List<TPPivotGridData>, Exception> _cbfCompleted)
        {
            // Load data  
            EntityQuery<WMAApp.Web.Models.TPPivotGridData> query = m_lstDomainContext[_iCurrContext].GetTPPivotGridDataQuery(_sUsername); //_lstTestList, _lstTPIds);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<TPPivotGridData> enTpPivotGridData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enTpPivotGridData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enTpPivotGridData.ToList(), exError);
                }
            }, null);
        }

        #endregion TP Pivot Grid Data results
        #region PDB

        public void vLoadPDBDefns(int _iCurrContext, string _sPDBDefnUserName,
                  Action<List<PDB_DEFN>, Exception> _cbfCompleted)
        {
            // Load data
            EntityQuery<Web.Models.PDB_DEFN> query = m_lstDomainContext[_iCurrContext].GetPDB_DEFNQuery()
                                                        .Where(pdb => pdb.USER_NAME == _sPDBDefnUserName).OrderBy(pdb2 => pdb2.NAME);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.PDB_DEFN> enPDBDefns = null;

                // Set error or result
                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enPDBDefns = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enPDBDefns.ToList(), exError);
                }
            }, null);
        }

        //public void vOpenPDB(int _iCurrContext, string _sPDBDefnName, string _sPDBDefnUserName,
        //                   Action<List<Web.Models.PDB_DEFN>, Exception> _cbfCompleted)
        //{
        //    //todo:
        //    //// This method gets both pdb_defn and associated pdb_data

        //    //_lstDomainContext[_iCurrContext].PDB_DEFNs.Clear();
        //    ////_lstDomainContext[_iCurrContext].PDB_DATAs.Clear();
        //    //// Load data
        //    //EntityQuery<Web.Models.PDB_DEFN> query = _lstDomainContext[_iCurrContext].GetPDBQuery(_sPDBDefnName, _sPDBDefnUserName);
        //    //_lstDomainContext[_iCurrContext].Load(query, loadOp =>
        //    //{
        //    //    // Declare error and result
        //    //    Exception exError = null;
        //    //    IEnumerable<Web.Models.PDB_DEFN> pdbDefn = null;

        //    //    // Set error or result
        //    //    if (loadOp.HasError)
        //    //    {
        //    //        exError = loadOp.Error;
        //    //        // Invoke completion callback
        //    //        if (_cbfCompleted != null) _cbfCompleted(null, exError);
        //    //    }
        //    //    else
        //    //    {
        //    //        pdbDefn = loadOp.Entities;
        //    //        // Invoke completion callback
        //    //        if (_cbfCompleted != null) _cbfCompleted(pdbDefn.ToList(), exError);
        //    //    }

        //    //}, null);
        //}

        public void vGetPDB(int _iCurrContext, string _sPDBDefnName, string _sPDBDefnUserName,
                           Action<List<Web.Models.PDB_DEFN>, Exception> _cbfCompleted, bool _bGetPDBData)
        {
            // This method gets both pdb_defn and associated pdb_data

            m_lstDomainContext[_iCurrContext].PDB_DEFNs.Clear(); //todo: if not using composition, does this clear pdb_datas too?
            //_lstDomainContext[_iCurrContext].PDB_DATAs.Clear();
            // Load data
            EntityQuery<Web.Models.PDB_DEFN> query = m_lstDomainContext[_iCurrContext].GetPDB_DEFNExQuery(_sPDBDefnName, _sPDBDefnUserName, _bGetPDBData);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.PDB_DEFN> enPDBDefn = null;

                // Set error or result
                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    // Invoke completion callback
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enPDBDefn = loadOp.Entities;
                    // Invoke completion callback
                    if (_cbfCompleted != null) _cbfCompleted(enPDBDefn.ToList(), exError);
                }

            }, null);
        }

        public void vGetPDBViaSakey(int _iCurrContext, decimal _dSakey,
                                  Action<List<Web.Models.PDB_DEFN>, Exception> _cbfCompleted, bool _bGetPDBData)
        {
            // This method gets both pdb_defn and associated pdb_data

            m_lstDomainContext[_iCurrContext].PDB_DEFNs.Clear(); //todo: if not using composition, does this clear pdb_datas too?
            //_lstDomainContext[_iCurrContext].PDB_DATAs.Clear();
            // Load data
            EntityQuery<Web.Models.PDB_DEFN> query = m_lstDomainContext[_iCurrContext].GetPDB_DEFNViaSakeyQuery(_dSakey, _bGetPDBData);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.PDB_DEFN> enPDBDefn = null;

                // Set error or result
                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    // Invoke completion callback
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enPDBDefn = loadOp.Entities;
                    // Invoke completion callback
                    if (_cbfCompleted != null) _cbfCompleted(enPDBDefn.ToList(), exError);
                }

            }, null);
        }        
#if USE_COMPOSITION 
        public void DeletePDB(int _iCurrContext, Web.Models.PDB_DEFN _PDBDefn,
                              Action<List<Web.Models.PDB_DEFN>, Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            //_PDBDefn.PDB_DATA
            //_lstDomainContext[_iCurrContext].PDB_DEFNs.
            //// Note: This method assumes pdb_defn has be pre-loaded.
            //foreach (Web.Models.PDB_DEFN pdb in _lstDomainContext[_iCurrContext].PDB_DEFNs ) {
            //    pdb.PDB_DATA.Remove()
            //}

            // Since using [Composition] attribute, this next deletes parent and children(pdb_datas)
            _lstDomainContext[_iCurrContext].PDB_DEFNs.Remove(_PDBDefn);

            if (_bSubmitChanges)
            {
                SubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback
                    if (_cbfCompleted != null) _cbfCompleted(null, submitOp != null ? submitOp.GetBaseException() : error);
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(null, exError);
            }
        }
#else
        //public void DeletePDB(int _iCurrContext, string _sPDBDefnName, string _sPDBDefnUserName,
        //                      Action<List<Web.Models.PDB_DEFN>, Exception> _cbfCompleted, bool _bSubmitChanges)
        //{
        //    // todo: call getPDB first ....
        //    GetPDB(_iCurrContext, _sPDBDefnName, _sPDBDefnUserName, loadOp =>
        //        {
        //            // Declare error and result
        //            Exception exError = null;
        //            IEnumerable<Web.Models.PDB_DEFN> pdbDefn = null;

        //            // Set error or result
        //            if (loadOp.HasError)
        //            {
        //                exError = loadOp.Error;
        //                // Invoke completion callback
        //                _cbfCompleted(null, exError);
        //            }
        //            else
        //            {
        //                ObservableCollection<Web.Models.PDB_DEFN> _ocePdbDefn = new ObservableCollection<Web.Models.PDB_DEFN>(_entities);
        //                _lstDomainContext[_iCurrContext].PDB_DEFNs.Remove(_ocePdbDefn[0]);

        //                if (_bSubmitChanges)
        //                {
        //                    SubmitChanges(_iCurrContext, submitOp =>
        //                    {
        //                        // Invoke completion callback
        //                        _cbfCompleted(null, submitOp != null ? submitOp.GetBaseException() : error);
        //                    }
        //                    );
        //                }
        //                else
        //                {
        //                    // Invoke completion callback
        //                    _cbfCompleted(null, exError);
        //                }
        //            }

        //        }                
        //    );           
        //}

        public void vDeletePDBViaSakeys(int _iCurrContext, List<decimal> _lstSakeys,
                             Action<int> _cbfCompleted, bool _bSubmitChanges) 
        {
            bool bSubmitState = false;
            if (_bSubmitChanges)
            {
#if SUBMIT_IMMEDIATE
                bSubmitState = true;
#else
#endif

            }
            int iTotalRowsAffected = 0;
            foreach (decimal dSakey in _lstSakeys)
            {
                string sSql = "delete from pdb_data where pdb_defn_sakey = " + dSakey.ToString();
                iExecuteCommand(_iCurrContext, sSql,
                                ( iRowsAffected ) =>
                                    {
                                        if (iRowsAffected <= 0)
                                        {
                                            //todo: might have to handle as an error condition
                                        }
                                        else
                                        {
                                            iTotalRowsAffected += iRowsAffected;
                                            //---------
                                            sSql = "delete from pdb_defn where pdb_defn_sakey = " + dSakey.ToString();
                                            iExecuteCommand(_iCurrContext, sSql,
                                                            ( iRowsAffectedEx ) =>
                                                                {
                                                                    if (iRowsAffectedEx <= 0)
                                                                    {
                                                                        //todo: might have to handle as an error condition
                                                                    }
                                                                    else
                                                                    {
                                                                        iTotalRowsAffected += iRowsAffectedEx;
                                                                    }                                        
                                                                }, bSubmitState
                                            );
                                            //---------
                                        }
                                    }, true
                );  
  
            }
            //don't need to do this if we pass true to iExecuteCommand... above
            if (_bSubmitChanges)
            {
#if SUBMIT_IMMEDIATE
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);
#else
                vSubmitChanges(_iCurrContext, submitOp =>
                    {
                        // Declare error
                        Exception exError = null;
                        if ( submitOp != null ) {
                            //todo: handle error
                            error = submitOp.GetBaseException();
                        }
                        else {
                            if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);
                        }
                    }
                );
#endif
            }
            else
            {
                //Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);
            }
        }

        public void vDeletePDBViaSakeysEx(int _iCurrContext, List<decimal> _lstSakeys,
                        Action<int> _cbfCompleted, bool _bSubmitChanges)
        {
#if crap 
            ev = new ManualResetEvent(false);
            int iTotalRowsAffected = 0;
            ev.Reset();
            foreach (decimal dSakey in _lstSakeys)
            {
                string sSql = "delete from pdb_data where pdb_defn_sakey = " + dSakey.ToString();
                iExecuteCommand(_iCurrContext, sSql,
                                (iRowsAffected) =>
                                {
                                    if (iRowsAffected <= 0)
                                    {
                                        //todo: might have to handle as an error condition
                                    }
                                    else
                                    {
                                        iTotalRowsAffected += iRowsAffected;
                                        sSql = "delete from pdb_defn where pdb_defn_sakey = " + dSakey.ToString();
                                        iExecuteCommand(_iCurrContext, sSql,
                                                         cbfLoopCallBack
                                                        , false
                                        );
                                    }
                                }, false
                );
                
                // wait for that iteration (i.e., pdb_data and pdb_defn ) to be processed before going to next one
                WaitHandle.WaitAll(new WaitHandle[] { ev } );
                ev.Reset();
            }

            ev.Reset();

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                    {
                        // Declare error
                        Exception exError = null;
                        if (submitOp != null)
                        {
                            //todo: handle error
                            error = submitOp.GetBaseException();
                            // warning: without callback, caller is hung....
                        }
                        else
                        {
                            if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);
                            ev.Set();
                        }
                    }
                );
            }
            else
            {
                //Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);
                ev.Set();
            }
            WaitHandle.WaitAll(new WaitHandle[] { ev });
#else
            foreach (decimal dSakey in _lstSakeys)
            {
                var item = new PDB_DATA { PDB_DEFN_SAKEY = dSakey };
                m_lstDomainContext[_iCurrContext].PDB_DATAs.Attach(item);
                m_lstDomainContext[_iCurrContext].PDB_DATAs.Remove(item);

                var item2 = new PDB_DEFN { PDB_DEFN_SAKEY = dSakey };
                m_lstDomainContext[_iCurrContext].PDB_DEFNs.Attach(item2);
                m_lstDomainContext[_iCurrContext].PDB_DEFNs.Remove(item2);
            }
#endif

        }

        public void vDeletePDBs(int _iCurrContext, List<PDB_DEFN> _lstPDBDefns,
            Action<int> _cbfCompleted, bool _bSubmitChanges = false)
        {
            int iTotalRowsAffected = 0;
            foreach (PDB_DEFN pdb in _lstPDBDefns )
            {
                //doesn't always work?????
                try
                {
                    m_lstDomainContext[_iCurrContext].PDB_DEFNs.Attach(pdb);
                }
                catch (Exception)
                {                    
                    //throw;
                }
                m_lstDomainContext[_iCurrContext].PDB_DEFNs.Remove(pdb);
            }
            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                    {
                        // Declare error
                        Exception exError = null;
                        if (submitOp != null)
                        {
                            //todo: handle error
                            exError = submitOp.GetBaseException();
                            // warning: without callback, caller is hung....
                        }
                        else
                        {
                            if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);            
                        }
                    }
                );
            }
            else
            {
                //Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);
            }
        }
     
        public void cbfLoopCallBack( int _iRowsAffected )
        {
            //??????
            //if (_iRowsAffected <= 0)
            //{
            //    //todo: might have to handle as an error condition
            //}
            //else
            //{
            //    iTotalRowsAffected += _iRowsAffected;
            //}
                                                     
            ev.Set();
        }

        public void vDeletePDBDataViaSakey(int _iCurrContext, decimal _dSakey,
                             Action<int> _cbfCompleted )
        {
            int iTotalRowsAffected = 0;
            string sSql = "delete from pdb_data where pdb_defn_sakey = " + _dSakey.ToString();
            iExecuteCommand(_iCurrContext, sSql,
                            (iRowsAffected) =>
                            {
                                if (iRowsAffected <= 0)
                                {
                                    //todo: might have to handle as an error condition
                                }
                                else
                                {
                                    iTotalRowsAffected += iRowsAffected;
                                    if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);
                                }
                            }, false
            );
        }

        public void vDeletePDBDefnViaSakey(int _iCurrContext, decimal _dSakey,
                             Action<int> _cbfCompleted)
        {
            int iTotalRowsAffected = 0;
            string sSql = "delete from pdb_defn where pdb_defn_sakey = " + _dSakey.ToString();
            iExecuteCommand(_iCurrContext, sSql,
                            (iRowsAffected) =>
                            {
                                if (iRowsAffected <= 0)
                                {
                                    //todo: might have to handle as an error condition
                                }
                                else
                                {
                                    iTotalRowsAffected += iRowsAffected;
                                    if (_cbfCompleted != null) _cbfCompleted(iTotalRowsAffected);
                                }
                            }, false
            );
        }
        public void vDeletePDB(int _iCurrContext, Web.Models.PDB_DEFN _PDBDefn,
                              Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            //_PDBDefn.PDB_DATA
            //_lstDomainContext[_iCurrContext].PDB_DEFNs.
            //// Note: This method assumes pdb_defn has be pre-loaded.
            
            foreach (Web.Models.PDB_DATA pdd in _PDBDefn.PDB_DATA)
            {
                m_lstDomainContext[_iCurrContext].PDB_DATAs.Remove(pdd);
            }

            // If had used [Composition] attribute, this next remove would delete parent and children(pdb_datas)
            m_lstDomainContext[_iCurrContext].PDB_DEFNs.Remove(_PDBDefn);

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback
                    if (_cbfCompleted != null) _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError);
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(exError);
            }
        }
#endif
    
        public void vDeletePDBDefn(int _iCurrContext, Web.Models.PDB_DEFN _PDBDefn,
                                  Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            m_lstDomainContext[_iCurrContext].PDB_DEFNs.Remove(_PDBDefn);

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback
                    if (_cbfCompleted != null) _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError);
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(exError);
            }
        }
        public void vInsertPDBDefn(int _iCurrContext, Web.Models.PDB_DEFN _PDBDefn,
                                  Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            m_lstDomainContext[_iCurrContext].PDB_DEFNs.Add(_PDBDefn);
            //_lstDomainContext[_iCurrContext].SubmitChanges(new Action<SubmitOperation>(SubmitChangesCompleted), null);
            if (_bSubmitChanges)
            { 
                vSubmitChanges(_iCurrContext, submitOp => //todo: fix: if error is returned from SubmitChanges method, it is not received here properly...
                                            {
                                                // Declare error
                                                Exception exError = null;
                                                // Invoke completion callback
                                                if (_cbfCompleted != null) _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError);
                                            }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) _cbfCompleted(exError);
            }
        }

#if USE_COMPOSITION
#else
        public void vInsertPDBData(int _iCurrContext, Web.Models.PDB_DATA _PDBData,
                                  Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {
            m_lstDomainContext[_iCurrContext].PDB_DATAs.Add(_PDBData);

            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback                   
                    if (_cbfCompleted != null) { _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError); }
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) { _cbfCompleted(exError); }
            }
        }

        public void vDeletePDBData(int _iCurrContext, Web.Models.PDB_DATA _PDBData,
                                  Action<Exception> _cbfCompleted, bool _bSubmitChanges)
        {

            m_lstDomainContext[_iCurrContext].PDB_DATAs.Remove(_PDBData);
            if (_bSubmitChanges)
            {
                vSubmitChanges(_iCurrContext, submitOp =>
                {
                    // Declare error
                    Exception exError = null;
                    // Invoke completion callback                   
                    if (_cbfCompleted != null) { _cbfCompleted(submitOp != null ? submitOp.GetBaseException() : exError); }
                }
                );
            }
            else
            {
                //??? since blocking on SubmitChangesCompleted now, how call _cbfCompleted??????
                Exception exError = null;
                // Invoke completion callback
                if (_cbfCompleted != null) { _cbfCompleted(exError); }
            }
        }
#endif       

        public void vLoadPDBProductDataWStatAndRej(int _iCurrContext,
                                                   decimal _dPDBDefnSakey,
                                                   Action<List<Web.Models.PRODUCT_DATA>, Exception> _cbfCompleted)
        {
            // Load data  
            //EntityQuery<Web.Models.PRODUCT_DATA> query = _lstDomainContext[_iCurrContext].GetPRODUCT_DATAQuery().Where(t => t.TEST_DTS >= (_dtStartTime) && t.TEST_DTS <= _dtEndTime);            
            EntityQuery<Web.Models.PRODUCT_DATA> query = m_lstDomainContext[_iCurrContext].GetPDB_PRODUCT_DATA_W_STAT_AND_REJQuery(_dPDBDefnSakey);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.PRODUCT_DATA> enProductData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enProductData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enProductData.ToList(), exError);
                }
            }, null);
        }
        public void vLoadPDBProductDataWStat(int _iCurrContext,
                                             decimal _dPDBDefnSakey,
                                             Action<List<Web.Models.PRODUCT_DATA>, Exception> _cbfCompleted)
        {
            // Load data  
            //EntityQuery<Web.Models.PRODUCT_DATA> query = _lstDomainContext[_iCurrContext].GetPRODUCT_DATAQuery().Where(t => t.TEST_DTS >= (_dtStartTime) && t.TEST_DTS <= _dtEndTime);            
            EntityQuery<Web.Models.PRODUCT_DATA> query = m_lstDomainContext[_iCurrContext].GetPDB_PRODUCT_DATA_W_STATQuery(_dPDBDefnSakey);
            m_lstDomainContext[_iCurrContext].Load(query, loadOp =>
            {
                // Declare error and result
                Exception exError = null;
                IEnumerable<Web.Models.PRODUCT_DATA> enProductData = null;

                if (loadOp.HasError)
                {
                    exError = loadOp.Error;
                    if (_cbfCompleted != null) _cbfCompleted(null, exError);
                }
                else
                {
                    enProductData = loadOp.Entities;
                    if (_cbfCompleted != null) _cbfCompleted(enProductData.ToList(), exError);
                }
            }, null);
        }
        #endregion

      
        #endregion
    }

}

