﻿#define DO_DIRECT_SQL

#region Using
using System;
using System.Linq;
using System.Collections.Generic;
using WMAApp.Web.Models;
using WMAApp.Helpers;
using System.ServiceModel.DomainServices.Client;
using WMAApp.WMASharedClasses;
using System.ComponentModel;
#endregion Using



namespace WMAApp.Services.Home
{
    // Used by client to communicate with service to get HomeV data.
    public interface IHomeSA // todo: Service agent. Hoping this can help us support differing databases
    {
        #region DBAccess
        void vSubmitChanges(int _iCurrContext,
                           Action<Exception> _cbfCompleted = null);
        void vBlockDuringSubmit(int _iCurrContext);
        void vcbfBlockingDuringSubmit(object _sender, System.ComponentModel.PropertyChangedEventArgs _Args);

        void vGetNextSequence(int _iCurrContext, string sSequenceName, Action<InvokeOperation<decimal>> _cbfCallback);
        decimal decGetNextSequenceSync(int _iCurrContext, string sSequenceName);
        //z void ExecuteQuery(int _iCurrContext, string _sSql, Action<InvokeOperation<IEnumerable<string>>> _cbfCallback);
        void vExecuteQuery(int _iCurrContext, string _sSql, Action<InvokeOperation<IEnumerable<WMAApp.WMASharedClasses.Cxcrap>>> _cbfCallback);
        int iExecuteCommand(int _iCurrContext, string _sSql, Action<int> _cbfCallback, bool _bSubmitChanges = false);
#if DO_DIRECT_SQL
        ////////void vExecuteQueryGetTestResults(int _iCurrContext, string _sSql, object[] sqlParams, Action<InvokeOperation<IEnumerable<TestData>>> _cbfCallback);
        //void vExecuteQueryGetTestResults(int _iCurrContext, string _sSql, object[] sqlParams, Action<InvokeOperation<IQueryable<TestData>>> _cbfCallback);
        //void vExecuteQueryGetTestResults(int _iCurrContext, string _sSql, string _sTestTime, string _sStandCode, Action<InvokeOperation<IQueryable<TestData>>> _cbfCallback);
        void vExecuteQueryGetTestResults(int _iCurrContext, string _sSql, string _sTestTime, string _sStandCode, Action<InvokeOperation<IEnumerable<TestData>>> _cbfCallback);

        void vExecuteQueryGetTPPivotGridData(int _iCurrContext, string _sSql, Action<InvokeOperation<IEnumerable<TPPivotGridData>>> _cbfCallback);
#endif // DO_DIRECT_SQL
        #endregion

        #region Connection
        void vSetDbConnection(string _sConnNames);
        #endregion

        #region Filtration

        void vInsertMbxTop(int _iCurrContext, MBX_TOP _MbxTop,
                            Action<List<MBX_TOP>, Exception> _cbfCompleted = null, bool _bSubmitChanges = false);
        void vPreLoadFilters(int _iCurrContext);
        void vLoadShiftDefns(int _iCurrContext,
                            Action<List<SHIFT_DEFN>, Exception> _cbfCompleted);
        void vLoadFamilyDefns(int _iCurrContext, 
                            Action<List<FAMILY_DEFN>, Exception> _cbfCompleted);
        void vLoadStandDefns(int _iCurrContext, 
                           Action<List<STAND_DEFN>, Exception> _cbfCompleted);
        void vLoadProductData(int iCurrContext, DateTime _dtStartTime, DateTime _dtEndTime, List<FamilyDef> _Family, List<StandDef> _Stands, List<ModelDef> _Models, List<int> _lFirstTest, List<int> _lTestStatus, List<int> _lLastTest, Boolean _boWithRejects,
                                        Action<List<PRODUCT_DATA>, Exception> _cbfCompleted);
        void vLoadProductDataWStatAndRejForParts(int iCurrContext, List<string> _lstPartList, 
                                Action<List<PRODUCT_DATA>, Exception> _cbfCompleted);
        void vLoadProductDataWStatForParts(int iCurrContext, List<string> _lstPartList,
                               Action<List<PRODUCT_DATA>, Exception> _cbfCompleted);
        void vLoadTPDefns(int iCurrContext, List<string> _lstTestList, 
                                Action<List<TP_DEFN>, Exception> _cbfCompleted);
        void vLoadTPDefnsInFam(int iCurrContext, List<decimal> _lstdDistinctFamilyIds, 
                                Action<List<TpDefn>, Exception> _cbfCompleted);        
        void vLoadTPDefns(int iCurrContext,
                        Action<List<VU_TP_DEFN_CRUST>, Exception> _cbfCompleted);
      
        void vLoadTPDefns(int iCurrContext,
                Action<List<WMAApp.Web.Models.TpDefn>, Exception> _cbfCompleted);
        
        void vLoadActiveModels(int _iCurrContext, int _iFamilyId, 
                              Action<List<ModelDefData>, Exception> _cbfCompleted);
        #endregion

        #region Test Results

        void vLoadTestResults(int iCurrContext, DateTime dtTestTime, string sStandCode, 
                                Action<List<TestData>, Exception> _cbfCompleted);

        #endregion

        #region TP Data results
        //todo: delete this if never used
        void vLoadTPData(int iCurrContext, decimal _dTpId, string _sUsername,
                             Action<List<TPData>, Exception> _cbfCompleted);

        void vClearTempTPData(int _iCurrentContext);
        void vInsertTempTPData(int _iCurrContext, Web.Models.VAR_TREND_SUM _VTS,
                                  Action<Exception> _cbfCompleted, bool _bSubmitChanges);
        void vClearTempPGTestData(int _iCurrentContext);
        void vInsertTempPGTestData(int _iCurrContext, Web.Models.VAR_TREND_SUM _VTS,
                          Action<Exception> _cbfCompleted, bool _bSubmitChanges);
#if USE_VAR_TREND_SUM_TEMP 
        void vClearTempPGTpData(int _iCurrentContext);
        void vInsertTempPGTpData(int _iCurrContext, Web.Models.VAR_TREND_SUM_TEMP _VTS,
                  Action<Exception> _cbfCompleted, bool _bSubmitChanges);
#else
        void vClearTempPGTpData2(int _iCurrentContext);
        void vInsertTempPGTpData2(int _iCurrContext, Web.Models.AUDIT_DEFN _VTS,
          Action<Exception> _cbfCompleted, bool _bSubmitChanges);
#endif
#if crap
#else
        void vExecuteQueryGetTPData(int _iCurrContext, string _sSql, Action<InvokeOperation<IEnumerable<TPData>>> _cbfCallback);
        void vExecuteQueryGetLimits(int _iCurrContext, string _sSql, Action<InvokeOperation<IEnumerable<LimitData>>> _cbfCallback);
  
#endif // crap                     
        #endregion TP Data results
        #region TP Pivot Grid Data results
        void vLoadTPPivotGridData(int iCurrContext, string _sUsername, // List<string> _lstTestList, List<decimal> _listTPIds,
                             Action<List<TPPivotGridData>, Exception> _cbfCompleted);

        #endregion TP Pivot Grid Data results
        #region PDB

        void vLoadPDBDefns(int _iCurrContext, string _sPDBDefnUserName,
                          Action<List<PDB_DEFN>, Exception> _cbfCompleted);
        //void vOpenPDB(int _iCurrContext, string _sPDBDefnName, string _sPDBDefnUserName,
        //    Action<List<PDB_DEFN>, Exception> _cbfCompleted);

        void vGetPDB(int _iCurrContext, string _sPDBDefnName, string _sPDBDefnUserName,
                    Action<List<PDB_DEFN>, Exception> _cbfCompleted, bool _bGetPDBData = false); //todo: return type need not be a List
        void vGetPDBViaSakey(int _iCurrContext, decimal _dSakey,
            Action<List<PDB_DEFN>, Exception> _cbfCompleted, bool _bGetPDBData = false); //todo: return type need not be a List
        void vDeletePDB(int _iCurrContext, Web.Models.PDB_DEFN _PDBDefn,
                       Action< Exception> _cbfCompleted, bool _bSubmitChanges = false);
        void vDeletePDBViaSakeys(int _iCurrContext, List<decimal> _lstSakeys,
               Action<int> _cbfCompleted, bool _bSubmitChanges = false); //todo: return rowsAffected instead?
        void vDeletePDBViaSakeysEx(int _iCurrContext, List<decimal> _lstSakeys,
                Action<int> _cbfCompleted, bool _bSubmitChanges = false); //todo: return rowsAffected instead?

        void vDeletePDBs(int _iCurrContext, List<PDB_DEFN> _lstPDBDefns,
            Action<int> _cbfCompleted, bool _bSubmitChanges = false); 

        //void DeletePDB(int _iCurrContext, string _sPDBDefnName, string _sPDBDefnUserName,
        //               Action<List<PDB_DEFN>, Exception> _cbfCompleted, bool _bSubmitChanges = false); 
        void vDeletePDBDataViaSakey(int _iCurrContext, decimal _dSakey,
                              Action<int> _cbfCompleted);
        void vDeletePDBDefnViaSakey(int _iCurrContext, decimal _dSakey,
                      Action<int> _cbfCompleted);
        void vDeletePDBDefn(int _iCurrContext, PDB_DEFN _PDBDefn,
                           Action<Exception> _cbfCompleted, bool _bSubmitChanges = false);
        void vInsertPDBDefn(int _iCurrContext, PDB_DEFN _PDBDefn,
                           Action<Exception> _cbfCompleted = null, bool _bSubmitChanges = false);
#if USE_COMPOSITION
#else
        void vInsertPDBData(int _iCurrContext, PDB_DATA _PDBData,
                           Action<Exception> _cbfCompleted = null, bool _bSubmitChanges = false);
        //void vDeletePDBData(int _iCurrContext, PDB_DATA _PDBData,
        //                   Action<Exception> _cbfCompleted = null, bool _bSubmitChanges = false);
#endif
        void vLoadPDBProductDataWStatAndRej(int _iCurrContext,
                                            decimal _dPDBDefnSakey,
                                            Action<List<Web.Models.PRODUCT_DATA>, Exception> _cbfCompleted);
        void vLoadPDBProductDataWStat(int _iCurrContext,
                                      decimal _dPDBDefnSakey,
                                      Action<List<Web.Models.PRODUCT_DATA>, Exception> _cbfCompleted);
        #endregion



    }
}

