﻿
//#define USE_COMPOSITION
#define USE_SORTABLE_PDBDEFNS // sort pdb_defns when dropping down: todo: use IG approach.
#define SUPPORT_UNDO_REDO
#define SUPPORT_CHART_LAUNCH_FROM_FUL_REP
//#define GET_TP_DEFNS_DEPENDENT_ON_TEST_LIST
#define DO_DIRECT_SQL
#define SUPPORT_TEST_LIST_BANDS
#define GET_ACTUAL_TP_DATA
#define GET_ACTUAL_PIVOT_DATA

#region Using
using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using WMAApp.Web.Models;
using WMAApp.Web.Services;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.ServiceModel.DomainServices.Client;
using System.Windows.Browser;
using System.Text;
using WMAApp.Helpers;
using WMAApp.ViewModels.Connection;
using WMAApp.Views.Connection;
using SimpleMvvmToolkit;
using WMAApp.Services.Home;
using WMAApp.Other;
using System.Collections;
using System.Reflection;
using System.Linq;
using WMAApp.WMASharedClasses;
using System.Threading.Tasks;
using System.Threading;
using MyExtensions;
#if SUPPORT_UNDO_REDO
using Infragistics.Undo;
#endif
using System.Windows.Data;
using Infragistics.Controls.Editors;

#endregion Using

namespace WMAApp.ViewModels.Home
{

#if SUPPORT_UNDO_REDO
    public class ProductDataURVM : ObservableModel
    {
        private ProductDataUROC _urocProductData;
        private UndoManager _UndoManager;
        public UndoManager UndoManager
        {
            get { return _UndoManager; }
        }

        private CollectionViewSource _cvsViewSource;
        public ICollectionView cvProductDatas
        {
            get { return _cvsViewSource.View; }
        }
  
        public ProductDataURVM()
        {
            _UndoManager = new UndoManager();
            _UndoManager.RegisterReference(this);

            _urocProductData = new ProductDataUROC(_UndoManager);

            _cvsViewSource = new CollectionViewSource();
            _cvsViewSource.Source = _urocProductData;

            
        }
        public void LoadData( ObservableCollection<ProductData> _ocTests )
        {         
            // Suspend recording of UndoUnits in the history while data is loading
            UndoManager.Suspend();
            if (_urocProductData.Count > 0) _urocProductData.Clear();
            try
            {
                //todo: if this works could just use ProductDataUndoOC instead of ProductData as recipient of the data comming back in productdatacomplete function
                foreach (ProductData pd in _ocTests)
                {
                    #if SUPPORT_TEST_LIST_BANDS
                    ProductDataUR c = new ProductDataUR(pd.sFamilyId, pd.dtTime, pd.sStand, pd.sModel, pd.sSerial, pd.sStatus, pd.colStatusList, pd.colRejList);
                    #else
                    ProductDataUR c = new ProductDataUR(pd.sFamilyId, pd.dtTime, pd.sStand, pd.sModel, pd.sSerial, pd.sStatus);
                    #endif
                    _urocProductData.Add(c);
                }
            }
            finally
            {
                // Resume recording in history
                UndoManager.Resume();
            }

            ////////_cvsViewSource = new CollectionViewSource();
            ////////_cvsViewSource.Source = _urocProductData;
            this.cvProductDatas.MoveCurrentToFirst();
        }        
    }
#endif

    public class HomeVM : WMAVMBase<HomeVM>
    {
        const string sACCEPT_STATUS_CODE = "4"; // todo: store in global location later...
        const string sREJECT_STATUS_CODE = "5";

        #region Constructors

        // Default constructor
        public HomeVM()
        {
            if (!DesignerProperties.IsInDesignTool)
            {
                if (_ocStandDefns == null)
                    _ocStandDefns = new ObservableCollection<StandDef>();
                _ocSelStandDefns = new ObservableCollection<StandDef>();

                _ocFamilyDefns = new ObservableCollection<FamilyDef>();
                _ocSelFamilyDefns = new ObservableCollection<FamilyDef>();

                _ocModelDefns = new ObservableCollection<ModelDef>();
                _ocSelModelDefns = new ObservableCollection<ModelDef>();

                _ocTests = new ObservableCollection<ProductData>();
#if SUPPORT_UNDO_REDO
                _ocSelectedTests = new ObservableCollection<ProductDataUR>();
#else
                _ocSelectedTests = new ObservableCollection<ProductData>();
#endif
				_ocTestData = new ObservableCollection<TestData>(); 
                _ocTPData = new ObservableCollection<TPData>();
                _ocTPPivotGridData = new ObservableCollection<TPPivotGridData>();
                bIsBusy = false;

                m_iCurrContext = 0;
                _iSelFamIndex = _iSelStandIndex = _iSelModelIndex = -1;

                SelectedPDBDefn = null;
                _PrevSelectedPDBDefn = null;
                _bOpenPDBOnSave = true;               
                _lstSelectedPDBDefnsForDeletion = new List<PDB_DEFN>();
                _ocTpDefns = new ObservableCollection<WMAApp.Web.Models.TpDefn>();
#if SUPPORT_UNDO_REDO
                _oProductDataURVM = new ProductDataURVM();////////
#endif
                _ocSelectedTPs = new ObservableCollection<TpDefn>();
                sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
                // Register to get notified on db select change.
                this.RegisterToReceiveMessages<ObservableCollection<DbConnection>>(MessageTokens.sDB_CONNECTION_CHANGED, vOnDbSelectionChanged);
                //ev = new ManualResetEvent(false);
                bTestListRetrieveRejectInfo = false; // Initialize to not retrieving reject info
                
                // Initialize date selections
                boByCurrent = true;
                boHour = true;
                sResolution = "Hour(s)";
                iNoOfInterval = 0;
                iRefreshRate = 120;
                _lShifts = new List<SHIFT_DEFN>();

                // Initialize status selections
                boFirstTests = false;
                boLastTests = false;
                boAllTests = true;
                boAccepts = true;
                boRejects = false;
                boAborts = false;
                boAllData = true;
                boProdData = false;
                boNonProd = false;
            }
        }
        // constructor that accepts IHomeSA
        public HomeVM(IHomeSA _serviceAgent):this()
        {
            // Set service agent
            this.m_serviceAgent = _serviceAgent;           
        }
        #endregion
       
        #region Members
       
        decimal SAKEY_SINTENEL = -1;
        private int m_iCurrContext;
        private int m_iCounter = 0;
        // Add a member for IHomeSA
        private IHomeSA m_serviceAgent;
        private decimal m_dNextSakey = -1;
        //private ManualResetEvent ev; //z

        private WMASharedClasses.TestDescriptor oTestDescriptor;
        private WMASharedClasses.TPDescriptor oTPDescriptor;

        #endregion

        #region Properties

        // This is bound to the BusyIndicator to turn it on and off

        private bool _bIsBusy;
        public bool bIsBusy
        {
            get
            {
                return _bIsBusy;

            }
            set
            {
                if (value != _bIsBusy)
                {
                    _bIsBusy = value;
                    // if busy was set back to false, reset text back to default.
                    if (!value) _sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
                    NotifyPropertyChanged(m => m.bIsBusy);
                }
            }
        }
        private string _sBusyText;
        public string sBusyText
        {
            get
            {
                return _sBusyText;

            }
            set
            {
                if (value != _sBusyText)
                {
                    _sBusyText = value;
                    NotifyPropertyChanged(m => m.sBusyText);
                }
            }
        }

        #region StatusTypes
        
        private Boolean _boFirstTests;
        public Boolean boFirstTests
        {
            get
            {
                return _boFirstTests;
            }
            set
            {
                if (value != _boFirstTests)
                {
                    _boFirstTests = value;
                    NotifyPropertyChanged(m => m.boFirstTests);
                }
            }
        }

        private Boolean _boLastTests;
        public Boolean boLastTests
        {
            get
            {
                return _boLastTests;
            }
            set
            {
                if (value != _boLastTests)
                {
                    _boLastTests = value;
                    NotifyPropertyChanged(m => m.boLastTests);
                }
            }
        }

        private Boolean _boAllTests;
        public Boolean boAllTests
        {
            get
            {
                return _boAllTests;
            }
            set
            {
                if (value != _boAllTests)
                {
                    _boAllTests = value;
                    NotifyPropertyChanged(m => m.boAllTests);
                }
            }
        }

        private Boolean _boRejects;
        public Boolean boRejects
        {
            get
            {
                return _boRejects;
            }
            set
            {
                if (value != _boRejects)
                {
                    _boRejects = value;
                    NotifyPropertyChanged(m => m.boRejects);
                }
            }
        }

        private Boolean _boAccepts;
        public Boolean boAccepts
        {
            get
            {
                return _boAccepts;
            }
            set
            {
                if (value != _boAccepts)
                {
                    _boAccepts = value;
                    NotifyPropertyChanged(m => m.boAccepts);
                }
            }
        }

        private Boolean _boAborts;
        public Boolean boAborts
        {
            get
            {
                return _boAborts;
            }
            set
            {
                if (value != _boAborts)
                {
                    _boAborts = value;
                    NotifyPropertyChanged(m => m.boAborts);
                }
            }
        }

        private Boolean _boAllData;
        public Boolean boAllData
        {
            get
            {
                return _boAllData;
            }
            set
            {
                if (value != _boAllData)
                {
                    _boAllData = value;
                    NotifyPropertyChanged(m => m.boAllData);
                }
            }
        }

        private Boolean _boProdData;
        public Boolean boProdData
        {
            get
            {
                return _boProdData;
            }
            set
            {
                if (value != _boProdData)
                {
                    _boProdData = value;
                    NotifyPropertyChanged(m => m.boProdData);
                }
            }
        }

        private Boolean _boNonProd;
        public Boolean boNonProd
        {
            get
            {
                return _boNonProd;
            }
            set
            {
                if (value != _boNonProd)
                {
                    _boNonProd = value;
                    NotifyPropertyChanged(m => m.boNonProd);
                }
            }
        }

        #endregion

        #region DateResolution

        // These are used for data retrieval resolution selection
        private Boolean _boByCurrent;
        public Boolean boByCurrent
        {
            get
            {
                return _boByCurrent;
            }
            set
            {
                if (value != _boByCurrent)
                {
                    _boByCurrent = value;
                    NotifyPropertyChanged(m => m.boByCurrent);
                }
            }
        }

        private Boolean _boByPrevious;
        public Boolean boByPrevious
        {
            get
            {
                return _boByPrevious;
            }
            set
            {
                if (value != _boByPrevious)
                {
                    _boByPrevious = value;
                    NotifyPropertyChanged(m => m.boByPrevious);
                }
            }
        }

        private Boolean _boByCustom;
        public Boolean boByCustom
        {
            get
            {
                return _boByCustom;
            }
            set
            {
                if (value != _boByCustom)
                {
                    _boByCustom = value;
                    NotifyPropertyChanged(m => m.boByCustom);
                }
            }
        }

        private Boolean _boHour;
        public Boolean boHour
        {
            get
            {
                return _boHour;
            }
            set
            {
                if (value != _boHour)
                {
                    _boHour = value;
                    NotifyPropertyChanged(m => m.boHour);
                }
            }
        }

        private Boolean _boShift;
        public Boolean boShift
        {
            get
            {
                return _boShift;
            }
            set
            {
                if (value != _boShift)
                {
                    _boShift = value;
                    NotifyPropertyChanged(m => m.boShift);
                }
            }
        }

        private Boolean _boDay;
        public Boolean boDay
        {
            get
            {
                return _boDay;
            }
            set
            {
                if (value != _boDay)
                {
                    _boDay = value;
                    NotifyPropertyChanged(m => m.boDay);
                }
            }
        }

        private Boolean _boWeek;
        public Boolean boWeek
        {
            get
            {
                return _boWeek;
            }
            set
            {
                if (value != _boWeek)
                {
                    _boWeek = value;
                    NotifyPropertyChanged(m => m.boWeek);
                }
            }
        }

        private Boolean _boMonth;
        public Boolean boMonth
        {
            get
            {
                return _boMonth;
            }
            set
            {
                if (value != _boMonth)
                {
                    _boMonth = value;
                    NotifyPropertyChanged(m => m.boMonth);
                }
            }
        }

        private string _sResolution;
        public string sResolution
        {
            get
            {
                return _sResolution;
            }
            set
            {
                if (value != _sResolution)
                {
                    _sResolution = value;
                    NotifyPropertyChanged(m => m.sResolution);
                }
            }
        }

        private int _iNoOfInterval;
        public int iNoOfInterval
        {
            get
            {
                return _iNoOfInterval;
            }
            set
            {
                if (value != _iNoOfInterval)
                {
                    _iNoOfInterval = value;
                    NotifyPropertyChanged(m => m.iNoOfInterval);
                }
            }
        }

        private int _iRefreshRate;
        public int iRefreshRate
        {
            get
            {
                return _iRefreshRate;
            }

            set
            {
                if (value != _iRefreshRate)
                {
                    _iRefreshRate = value;
                    NotifyPropertyChanged(m => m.iRefreshRate);
                }
            }
        }

        private List<SHIFT_DEFN> _lShifts;
        public List<SHIFT_DEFN> lShifts
        {
            get
            {
                return _lShifts;
            }

            set
            {
                if (value != _lShifts)
                {
                    _lShifts = value;
                }
            }
        }

        #endregion

        private string _sUserName;
        public string sUserName    
        {
            get
            {
                return _sUserName;
            }
        }
        // This is bound to the Family selection ComboBox and returns the currently selected item

        FamilyDef _selectedFamily;
        public FamilyDef SelectedFamily
        {
            get
            {
                return _selectedFamily;
            }
            set
            {
                if (value != _selectedFamily)
                {
                    _selectedFamily = value;
                    NotifyPropertyChanged(m => m.SelectedFamily);
                }
            }
        }

        int _iSelFamIndex;
        public int SelFamIndex
        {
            get
            {
                return _iSelFamIndex;
            }
            set
            {
                if (value != _iSelFamIndex)
                {
                    _iSelFamIndex = value;
                    NotifyPropertyChanged(m => m.SelFamIndex);
                }
            }
        }

        StandDef _selectedStand;
        public StandDef SelectedStand
        {
            get
            {
                return _selectedStand;
            }
            set
            {
                if (value != _selectedStand)
                {
                    _selectedStand = value;
                    NotifyPropertyChanged(m => m.SelectedStand);
                }
            }
        }

        int _iSelStandIndex;
        public int SelStandIndex
        {
            get
            {
                return _iSelStandIndex;
            }

            set
            {
                if (_iSelStandIndex != value)
                {
                    _iSelStandIndex = value;
                    NotifyPropertyChanged(m => m.SelStandIndex);
                }
            }
        }

        ModelDef _selectedModel;
        public ModelDef SelectedModel
        {
            get
            {
                return _selectedModel;
            }
            set
            {
                if (value != _selectedModel)
                {
                    _selectedModel = value;
                    NotifyPropertyChanged(m => m.SelectedModel);
                }
            }
        }

        int _iSelModelIndex;
        public int SelModelIndex
        {
            get
            {
                return _iSelModelIndex;
            }

            set
            {
                if (_iSelModelIndex != value)
                {
                    _iSelModelIndex = value;
                    NotifyPropertyChanged(m => m.SelModelIndex);
                }
            }
        }

        string _startSerial;
        public string StartSerial
        {
            get
            {
                return _startSerial;
            }
            set
            {
                if (value != _startSerial)
                {
                    _startSerial = value;
                    NotifyPropertyChanged(m => m.StartSerial);
                }
            }
        }

        string _endSerial;
        public string EndSerial
        {
            get
            {
                return _endSerial;
            }
            set
            {
                if (value != _endSerial)
                {
                    _endSerial = value;
                    NotifyPropertyChanged(m => m.EndSerial);
                }
            }
        }

        DateTime _dtStartTime;
        public DateTime dtStartTime
        {
            get
            {
                return _dtStartTime;
            }

            set
            {
                if (value != _dtStartTime)
                {
                    _dtStartTime = value;
                    NotifyPropertyChanged(m => m.dtStartTime);
                }
            }
        }

        DateTime _dtStartDate;
        public DateTime dtStartDate
        {
            get
            {
                return _dtStartDate;
            }

            set
            {
                if (value != _dtStartDate)
                {
                    _dtStartDate = value;
                    NotifyPropertyChanged(m => m.dtStartDate);
                }
            }
        }

        DateTime _dtEndTime;
        public DateTime dtEndTime 
        {
            get
            {
                return _dtEndTime;
            }

            set
            {
                if (value != _dtEndTime)
                {
                    _dtEndTime = value;
                    NotifyPropertyChanged(m => m.dtEndTime);
                }
            }
        }

        DateTime _dtEndDate;
        public DateTime dtEndDate
        {
            get
            {
                return _dtEndDate;
            }

            set
            {
                if (value != _dtEndDate)
                {
                    _dtEndDate = value;
                    NotifyPropertyChanged(m => m.dtEndDate);
                }
            }
        }

        ObservableCollection<FamilyDef> _ocFamilyDefns;
        public ObservableCollection<FamilyDef> ocFamilyDefns
        {
            get
            {
                return _ocFamilyDefns;
            }
            set
            {
                if (value != _ocFamilyDefns)
                {
                    _ocFamilyDefns = value;
                    NotifyPropertyChanged(m => m.ocFamilyDefns);
                }
            }
        }

		ObservableCollection<FamilyDef> _ocSelFamilyDefns;
        public ObservableCollection<FamilyDef> ocSelFamilyDefns
        {
            get
            {
                return _ocSelFamilyDefns;
            }
            set
            {
                if (value != _ocSelFamilyDefns)
                {
                    _ocSelFamilyDefns = value;
                    NotifyPropertyChanged(m => m.ocSelFamilyDefns);
                }
            }
        }
        ObservableCollection<ModelDef> _ocModelDefns;
        public ObservableCollection<ModelDef> ocModelDefns
        {
            get
            {
                return _ocModelDefns;
            }
            set
            {
                if (value != _ocModelDefns)
                {
                    _ocModelDefns = value;
                    NotifyPropertyChanged(m => m.ocModelDefns);
                }
            }
        }

        ObservableCollection<ProductData> _ocTests;
        public ObservableCollection<ProductData> ocTests
        {
            get
            {
                return _ocTests;
            }
            set
            {
                if (value != _ocTests)
                {
                    _ocTests = value;
                    NotifyPropertyChanged(m => m.ocTests);
                }
            }
        }

        ObservableCollection<TestData> _ocTestData;
        public ObservableCollection<TestData> ocTestData
        {
            get
            {
                return _ocTestData;
            }
            set
            {
                if (value != _ocTestData)
                {
                    _ocTestData = value;
                    NotifyPropertyChanged(m => m.ocTestData);
                }
            }
        }

        ObservableCollection<TPData> _ocTPData;
        public ObservableCollection<TPData> ocTPData
        {
            get
            {
                return _ocTPData;
            }
            set
            {
                if (value != _ocTPData)
                {
                    _ocTPData = value;
                    NotifyPropertyChanged(m => m.ocTPData);
                }
            }
        }

        ObservableCollection<LimitData> _ocLowLimit;
        public ObservableCollection<LimitData> ocLowLimit
        {
            get
            {
                return _ocLowLimit;
            }
            set
            {
                if (value != _ocLowLimit)
                {
                    _ocLowLimit = value;
                    NotifyPropertyChanged(m => m.ocLowLimit);
                }
            }
        }

        ObservableCollection<LimitData> _ocHighLimit;
        public ObservableCollection<LimitData> ocHighLimit
        {
            get
            {
                return _ocHighLimit;
            }
            set
            {
                if (value != _ocHighLimit)
                {
                    _ocHighLimit = value;
                    NotifyPropertyChanged(m => m.ocHighLimit);
                }
            }
        }

        ObservableCollection<TPPivotGridData> _ocTPPivotGridData;
        public ObservableCollection<TPPivotGridData> ocTPPivotGridData
        {
            get
            {
                return _ocTPPivotGridData;
            }
            set
            {
                if (value != _ocTPPivotGridData)
                {
                    _ocTPPivotGridData = value;
                    NotifyPropertyChanged(m => m.ocTPPivotGridData);
                }
            }
        }        
#if SUPPORT_UNDO_REDO

        ProductDataURVM _oProductDataURVM;
        public ProductDataURVM oProductDataURVM {
            ////////get; set;
            get
            {
                return _oProductDataURVM;
            }
            set
            {
                if (value != _oProductDataURVM)
                {
                    _oProductDataURVM = value;                    
                }
            }
        }
        ////////public ICollectionView cvProductDatas // expose this directly because I can't seem to make oProductDataURVM.cvProductDatas work
        ////////{
        ////////    get { return oProductDataURVM.cvProductDatas; }
        ////////    //set { oProductDataURVM.cvProductDatas = value; }
        ////////}
        ////////public UndoManager ProductDatasUndoManager //expose
        ////////{
        ////////    get { return oProductDataURVM.UndoManager; }
        ////////    //set { oProductDataURVM.UndoManager = value; }
        ////////}
#endif

        // Maintain a collection of visible tests that have not been filtered out or deleted... i.e., those that are visible in the grid
        //todo: I could try to use the approach referenced in IG:91687 which uses behaviors and Dependency Objects
#if SUPPORT_UNDO_REDO
        ObservableCollection<ProductDataUR> _ocVisibleTests;
        public ObservableCollection<ProductDataUR> ocVisibleTests
        {
            get
            {
                return _ocVisibleTests;
            }
            set
            {
                if (value != _ocVisibleTests)
                {
                    _ocVisibleTests = value;
                    NotifyPropertyChanged(m => m.ocVisibleTests);
                }
            }
        }

        ObservableCollection<ProductDataUR> _ocSelectedTests;
        public ObservableCollection<ProductDataUR> ocSelectedTests
        {
            get
            {
                return _ocSelectedTests;
            }
            set
            {
                if (value != _ocSelectedTests)
                {
                    _ocSelectedTests = value;
                    NotifyPropertyChanged(m => m.ocSelectedTests);
                }
            }
        }
#else
        ObservableCollection<ProductData> _ocVisibleTests;
        public ObservableCollection<ProductData> ocVisibleTests
        {
            get
            {
                return _ocVisibleTests;
            }
            set
            {
                if (value != _ocVisibleTests)
                {
                    _ocVisibleTests = value;
                    NotifyPropertyChanged(m => m.ocVisibleTests);
                }
            }
        }

        ObservableCollection<ProductData> _ocSelectedTests;
        public ObservableCollection<ProductData> ocSelectedTests
        {
            get
            {
                return _ocSelectedTests;
            }
            set
            {
                if (value != _ocSelectedTests)
                {
                    _ocSelectedTests = value;
                    NotifyPropertyChanged(m => m.ocSelectedTests);
                }
            }
        }
#endif

        static ObservableCollection<StandDef> _ocStandDefns; 
        public ObservableCollection<StandDef> ocStandDefns
        {
            get
            {
                return _ocStandDefns;
            }
            set
            {
                if (value != _ocStandDefns)
                {
                    _ocStandDefns = value;
                    NotifyPropertyChanged(m => ocStandDefns);
                }
            }
        }

 		ObservableCollection<StandDef> _ocSelStandDefns;
        public ObservableCollection<StandDef> ocSelStandDefns
        {
            get
            {
                return _ocSelStandDefns;
            }
            set
            {
                if (value != _ocSelStandDefns)
                {
                    _ocSelStandDefns = value;
                    NotifyPropertyChanged(m => ocSelStandDefns);
                }
            }
        }
        
        ObservableCollection<PRODUCT_DATA> _oceProductData;
        public ObservableCollection<PRODUCT_DATA> oceProductData
        {
            get
            {
                return _oceProductData;
            }
            set
            {
                if (value != _oceProductData)
                {
                    _oceProductData = value;
                    NotifyPropertyChanged(m => m.oceProductData);
                }
            }
        }

        ObservableCollection<FAMILY_DEFN> _oceFamilyDefns;
        public ObservableCollection<FAMILY_DEFN> oceFamilyDefns
        {
            get
            {
                return _oceFamilyDefns;
            }
            set
            {
                if (value != _oceFamilyDefns)
                {
                    _oceFamilyDefns = value;
                    NotifyPropertyChanged(m => m.oceFamilyDefns);
                }
            }
        }

        static ObservableCollection<STAND_DEFN> _oceStandDefns; //todo: static????
        public ObservableCollection<STAND_DEFN> oceStandDefns
        {
            get
            {
                return _oceStandDefns;
            }
            set
            {
                if (value != _oceStandDefns)
                {
                    _oceStandDefns = value;
                    NotifyPropertyChanged(m => m.oceStandDefns);
                }
            }
        }

        static ObservableCollection<ModelDefData> _oceModelDefns; //todo: static????
        public ObservableCollection<ModelDefData> oceModelDefns
        {
            get
            {
                return _oceModelDefns;
            }
            set
            {
                if (value != _oceModelDefns)
                {
                    _oceModelDefns = value;
                    NotifyPropertyChanged(m => m.oceModelDefns);
                }
            }
        }
        
        ObservableCollection<ModelDef> _ocSelModelDefns;
        public ObservableCollection<ModelDef> ocSelModelDefns
        {
            get
            {
                return _ocSelModelDefns;
            }
            set
            {
                if (value != _ocSelModelDefns)
                {
                    _ocSelModelDefns = value;
                    NotifyPropertyChanged(m => ocSelModelDefns);
                }
            }
        }

        static ObservableCollection<MBX_TOP> _oceMbxTops; //todo: static????
        public ObservableCollection<MBX_TOP> oceMbxTops
        {
            get
            {
                return _oceMbxTops;
            }

            set
            {
                if (value != _oceMbxTops)
                {
                    _oceMbxTops = value;
                    NotifyPropertyChanged(m => m.oceMbxTops);
                }
            }
        }

        ObservableCollection<TP_DEFN> _oceTPDefns;
        public ObservableCollection<TP_DEFN> oceTPDefns
        {
            get
            {
                return _oceTPDefns;
            }
            set
            {
                if (value != _oceTPDefns)
                {
                    _oceTPDefns = value;
                    NotifyPropertyChanged(m => m.oceTPDefns);
                }
            }
        }

        ObservableCollection<VU_TP_DEFN_CRUST> _oceTPDefnsCrust;
        public ObservableCollection<VU_TP_DEFN_CRUST> oceTPDefnsCrust
        {
            get
            {
                return _oceTPDefnsCrust;
            }
            set
            {
                if (value != _oceTPDefnsCrust)
                {
                    _oceTPDefnsCrust = value;
                    NotifyPropertyChanged(m => m.oceTPDefnsCrust);
                }
            }
        }

        ObservableCollection<WMAApp.Web.Models.TpDefn> _ocTpDefns;
        public ObservableCollection<WMAApp.Web.Models.TpDefn> ocTpDefns
        {
            get
            {
                return _ocTpDefns;
            }
            set
            {
                if (value != _ocTpDefns)
                {
                    _ocTpDefns = value;
                    NotifyPropertyChanged(m => m.ocTpDefns);
                }
            }
        }

        ObservableCollection<TpDefn> _ocSelectedTPs;
        public ObservableCollection<TpDefn> ocSelectedTPs
        {
            get
            {
                return _ocSelectedTPs;
            }
            set
            {
                if (value != _ocSelectedTPs)
                {
                    _ocSelectedTPs = value;
                    NotifyPropertyChanged(m => m.ocSelectedTPs);
                }
            }
        }
        #region PDB 
      
        // Note: this collection will be synchronized with the db at all times.
        ObservableCollection<PDB_DEFN> _ocePDBDefns;
        public ObservableCollection<PDB_DEFN> ocePDBDefns
        {
            get
            {
                return _ocePDBDefns;
            }
            set
            {
                if (value != _ocePDBDefns)
                {
                    _ocePDBDefns = value;
                    NotifyPropertyChanged(m => m.ocePDBDefns);
                }
            }
        }

        SortableObservableCollection<PDB_DEFN> _soceSortablePDBDefns;
        public SortableObservableCollection<PDB_DEFN> soceSortablePDBDefns
        {
            get
            {
                return _soceSortablePDBDefns;
            }
            set
            {
                if (value != _soceSortablePDBDefns)
                {
                    _soceSortablePDBDefns = value;
                    NotifyPropertyChanged(m => m.soceSortablePDBDefns);
                }
            }
        }

        PDB_DEFN _SelectedPDBDefn;
        public PDB_DEFN SelectedPDBDefn
        {
            get { return _SelectedPDBDefn; }
            set
            {               
                _SelectedPDBDefn = value;
                NotifyPropertyChanged(m => m._SelectedPDBDefn);                
            }
        }

        // Used to keep track of previously selected pdb so that is user clicks a pdb to open it then cancels, I can 
        // restore the Selected pdb back to what it was.
        PDB_DEFN _PrevSelectedPDBDefn;
        public PDB_DEFN PrevSelectedPDBDefn
        {
            get { return _PrevSelectedPDBDefn; }
            set
            {
                _PrevSelectedPDBDefn = value;
                //NotifyPropertyChanged(m => m._SelectedPDBDefn);
            }
        }

        bool _bOpenPDBOnSave;
        public bool bOpenPDBOnSave
        {
            get { return _bOpenPDBOnSave; }
            set
            {
                _bOpenPDBOnSave = value;
                NotifyPropertyChanged(m => m._bOpenPDBOnSave);
            }
        }
        EPDBSaveTypes _eSaveType;
        public EPDBSaveTypes eSaveType
        {
            get { return _eSaveType; }
            set { _eSaveType = value; }
        }

        bool _bTestListRetrieveRejectInfo;
        public bool bTestListRetrieveRejectInfo
        {
            get { return _bTestListRetrieveRejectInfo; }
            set { _bTestListRetrieveRejectInfo = value; }
        }

        // used to store the selected pdb defn sakeys prior to deletion       
        List<PDB_DEFN> _lstSelectedPDBDefnsForDeletion;
        public List<PDB_DEFN> lstSelectedPDBDefnsForDeletion
        {
            get { return _lstSelectedPDBDefnsForDeletion; }
            set
            {
                _lstSelectedPDBDefnsForDeletion = value;
                NotifyPropertyChanged(m => m._lstSelectedPDBDefnsForDeletion);
            }
        }
        
        #endregion

        #endregion

        #region Methods
        #region Filtration
        public void vSetDbConnection(string sConnNames)
        {
            m_serviceAgent.vSetDbConnection(sConnNames);           
        }
        public void vGetDataSourceSelection( string sDefaultConns )
        {
            if (sDefaultConns.Length < 1)
            {
                SendMessage(MessageTokens.sSHOW_DBCONNECTIONS, new NotificationEventArgs() );
            }
            else
            {
                WebContext.Current.User.ConnectedToDb = true;
                vSetDbConnection( sDefaultConns );
                vLoadFilters();
            }
        }
        public void vLoadFilters()
        {
            // Get username
            _sUserName = WebContext.Current.User.Name.ToString();

            // Flip busy flag
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;

            // Note: Two way binding with view.
            dtStartDate = DateTime.Now;
            dtEndDate = DateTime.Now;
            dtStartTime = DateTime.Now;
            dtEndTime = DateTime.Now;
            StartSerial = "00000000";
            EndSerial = "99999999";

            m_serviceAgent.vPreLoadFilters(m_iCurrContext);

            // Reset property
            oceFamilyDefns = null;
            m_serviceAgent.vLoadFamilyDefns(m_iCurrContext,
                (entities, error) => cbfLoadFamilyDefnsComplete(entities, error));

            oceStandDefns = null;
            m_serviceAgent.vLoadStandDefns(m_iCurrContext,
                (entities, error) => cbfLoadStandDefnsComplete(entities, error));

            _oceModelDefns = null;
            m_serviceAgent.vLoadActiveModels(m_iCurrContext, WebContext.Current.User.DefaultFamilySelection,
                (entities, error) => cbfLoadModelsComplete(entities, error));

            lShifts = null;
            m_serviceAgent.vLoadShiftDefns(m_iCurrContext,
                (entities, error) => cbfLoadShiftsDefnsComplete(entities, error));
            
            // Get this PDB's for this user
            m_serviceAgent.vLoadPDBDefns(m_iCurrContext, _sUserName,
                 (entities, error) => cbfLoadPDBDefnsComplete(entities, error));
        }
        #endregion Filtration
        #region PDB

        #region Common

        #region Sorting
        public class SortableObservableCollection<T> : ObservableCollection<T>
        {
            public void vSort()
            {
                vSort(Comparer<T>.Default);
            }
            public void vSort(IComparer<T> comparer)
            {
                try
                {
                    int i, j;
                    T index;
                    for (i = 1; i < Count; i++)
                    {
                        index = this[i];
                        j = i;
                        while ((j > 0) && (comparer.Compare(this[j - 1], index) == 1))
                        {
                            this[j] = this[j - 1];
                            j = j - 1;
                        }
                        this[j] = index;
                    }
                }
                catch (Exception)
                {
                    // todo: handle
                    throw;
                }
               
            }
        }
        public class PDBDefnComparer : IComparer<PDB_DEFN>
        {
            #region IComparer<PDB_DEFN> Members
            public int Compare(PDB_DEFN pdb1, PDB_DEFN pdb2)
            {
                return string.Compare(pdb1.NAME, pdb2.NAME);  // sort by name
            }
            #endregion
        } 

        public void vSortPDBDefns()
        {
            //http://www.codeproject.com/Articles/178011/Sorting-an-Observable-Collection-using-the-View-Mo
            soceSortablePDBDefns.vSort(new PDBDefnComparer());
        }

        #endregion

        #endregion

        #region Save

        public void vSaveSelectedTestsToPDB()
        {
            // build and save pdb_defn to db ( note: we will always check but a pdb_defn of this name may or may not exist )
            int x = iSaveToPDB(EPDBSaveTypes.eSELECTED);
        }
        private int iSaveToPDB(EPDBSaveTypes _eSaveType = EPDBSaveTypes.eALL)
        {
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;
           
            m_serviceAgent.vGetPDB(m_iCurrContext, SelectedPDBDefn.NAME, SelectedPDBDefn.USER_NAME,
                ( entity, error ) =>
                {
                    if (error == null)
                    {

                        if (entity.Count > 0)
                        {
                            // PDB already exists. 
                            // Ask if overwrite later but just overwrite for now.
                            Notify(evOverwritePDBNotice, 
                                   new NotificationEventArgs<object, bool>
                                            ("PDB already exists. Do you wish to overwrite?", null,
                                                confirm =>
                                                {
                                                    if (confirm)
                                                    {
                                                        //redundant vDeletePDBBeforeInsert(entity[0], m_iCurrContext, _eSaveType, true);
                                                        vDeletePDBBeforeInsert(entity[0], true);
                                                    }
                                                    else
                                                    {
                                                        //todo: prompt for new pdb name...
                                                    }
                                                }));
                        }
                        else
                        {
                            //redundant vInsertPDB(_eSaveType);
                            vInsertPDB();
                        }
                    }
                    else
                    {
                        //todo: handle error
                    }
                }, true
            );

            return -1;
        }
        public void vSaveAllTests()
        {
            bOpenPDBOnSave = false; // Open PDB on Save question is not presented to user and is not valid.
            //redundant eSaveType = EPDBSaveTypes.eALL;
            //redundant int x = iSaveToPDB(eSaveType);
            int x = iSaveToPDB();

        }
        //composition private void InsertPDBDefn(EPDBSaveTypes _eSaveType) 
        //{
        //    // Insert PDBDefn
        //    PDB_DEFN pdb = new PDB_DEFN();
        //    // note: sakey is handled by db trigger.
        //    pdb.NAME = this.sPDBName;
        //    pdb.USER_NAME = this.sUserName;

        //    serviceAgent.InsertPDBDefn(iCurrContext, pdb,
        //        (entities, error) => PDBActionComplete(entities, EPDCompleteTypes.eINSERT_PDB_DEFN_COMPLETE, _eSaveType, error), true);
        //}

        //public PDB_DEFN oMakePDBDefn( string _sPDBName) {
        //    // build new pdb_defn but do not insert it.
        //    PDB_DEFN pdb = new PDB_DEFN();
        //    IsBusy = true;
        //    m_serviceAgent.vGetNextSequence(m_iCurrContext, "PDB_DEFN_SAKEY",
        //        (dNextSakey) =>
        //        {
        //            pdb.PDB_DEFN_SAKEY = dNextSakey.Value;
        //            pdb.NAME = sWorkingPDBName;
        //            pdb.USER_NAME = m_sUserName;

        //            // pdb_data
        //            //PDB_DATA pdd = null;
        //            foreach (ProductData pd in ocSelectedTests)
        //            {
        //                PDB_DATA pdd = new PDB_DATA();                        
        //                pdd.PDB_DEFN_SAKEY = dNextSakey.Value;
        //                pdd.TEST_DTS = pd.Time;
        //                pdd.STAND_CODE = pd.Stand;
        //                pdb.PDB_DATA.Add(pdd);
        //            }
        //            IsBusy = false;             
        //        }
        //    );
        //    return pdb;   
        //}

        // A "partial" pdbDefn is one which does not have a sakey yet and no pdb_datas assigned to it.        
        public PDB_DEFN oMakePartialPDBDefn(string _sPDBName)
        {

#if SYNCHRONOUS
            IsBusy = true;

            // build new pdb_defn but do not insert it.
            PDB_DEFN pdb = new PDB_DEFN();

            decimal dNextSakey = -1; // todo: can't get this to be synchronous m_serviceAgent.decGetNextSequenceSync(m_iCurrContext, "PDB_DEFN_SAKEY");
  
            pdb.PDB_DEFN_SAKEY = dNextSakey;
            pdb.NAME = sWorkingPDBName;
            pdb.USER_NAME = _sUserName;

            // pdb_data
            //PDB_DATA pdd = null;
            foreach (ProductData pd in ocSelectedTests)
            {
                PDB_DATA pdd = new PDB_DATA();
                pdd.PDB_DEFN_SAKEY = dNextSakey;
                pdd.TEST_DTS = pd.Time;
                pdd.STAND_CODE = pd.Stand;
                pdb.PDB_DATA.Add(pdd);
            }
            IsBusy = false;

            return pdb;
#else
            // build new "partial" pdb_defn
            PDB_DEFN pdb = new PDB_DEFN();

            pdb.PDB_DEFN_SAKEY = SAKEY_SINTENEL; //todo: might not even need to set this at all
            pdb.NAME = _sPDBName;
            pdb.USER_NAME = _sUserName;

            return pdb;
#endif

        }
        public void vVisibleTestListBuilt()
        {
            //TODO: Might be able to eliminate this BS by trapping the filter event on the grid and just clearing all selected rows then.
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;
            vInsertPDBData(ocVisibleTests);

        }

        //redundant private void vInsertPDBData(int _iCurrContext, ObservableCollection<ProductData> _fTestList, decimal _dNextSakey, EPDBSaveTypes _eSaveType)
#if SUPPORT_UNDO_REDO
        private void vInsertPDBData(ObservableCollection<ProductDataUR> _fTestList  )
#else
        private void vInsertPDBData(ObservableCollection<ProductData> _fTestList  )
#endif
        {
            PDB_DATA pdd = null;
#if SUPPORT_UNDO_REDO
            foreach (ProductDataUR pd in _fTestList)
#else
            foreach (ProductData pd in _fTestList)
#endif
            {
                pdd = new PDB_DATA();
                pdd.PDB_DEFN_SAKEY = m_dNextSakey;
                pdd.TEST_DTS = pd.dtTime;
                pdd.STAND_CODE = pd.sStand;
                m_serviceAgent.vInsertPDBData(m_iCurrContext, pdd, null, false); // bad?: not synchronized properly?  but 
                // might be working because vInsertPDBData just "adds" pdb_datas to the pdb_Defn entity ( which is probably very fast )                          
            }
            m_serviceAgent.vSubmitChanges(m_iCurrContext, (error2) =>
                {
                    //redundant vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, _eSaveType, error2);
                    vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, error2);
                }
            );
        }

        //redundant private void vInsertPDB(EPDBSaveTypes _eSaveType )
        private void vInsertPDB()
        {
#if SYNCHRONOUS
            // insert received pdb_defn into db.
            m_serviceAgent.vInsertPDBDefn(m_iCurrContext, _oPDBDefn,
                (entities, error) =>
                {
                    if (error == null)
                    {                        
                        foreach (PDB_DATA pdd in _oPDBDefn.PDB_DATA)
                        {
                            m_serviceAgent.vInsertPDBData(m_iCurrContext, pdd, null, false);
                        }
                        m_serviceAgent.vSubmitChanges(m_iCurrContext, 
                            (error2) =>
                            {
                                //redundant vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, _eSaveType, error2);
                                vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, error2);
                            }
                        );
                    }
                    else
                    {
                        //todo:
                        //redundant vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, _eSaveType, error);
                        vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, error);
                    }
                },
            true);
#else
            m_serviceAgent.vGetNextSequence(m_iCurrContext, "PDB_DEFN_SAKEY",
                (dNextSakey) =>
                {
                    // remember next sakey because if we are doing saveall case, I have to make a round trip to the view model and back.
                    m_dNextSakey = dNextSakey.Value;
                    PDB_DEFN pdb = SelectedPDBDefn;
                    pdb.PDB_DEFN_SAKEY = dNextSakey.Value;
                    m_serviceAgent.vInsertPDBDefn(m_iCurrContext, pdb,
                        (error) =>
                        {
                            if (error == null)
                            {
#if SUPPORT_UNDO_REDO
                                ObservableCollection<ProductDataUR> fTestList;
#else
                                ObservableCollection<ProductData> fTestList;
#endif
                                if ( eSaveType == EPDBSaveTypes.eSELECTED)
                                {
                                    fTestList = ocSelectedTests;
                                    //redundant vInsertPDBData( m_iCurrContext, fTestList, dNextSakey.Value, _eSaveType );
                                    vInsertPDBData( fTestList);
                                }
                                else
                                {
                                    // important need non-filtered rows here not the original entire set of rows.  ocTests   
                                    // Notify view to build visible test list.
                                    Notify(evBuildVisibleTestList, new NotificationEventArgs());                                                                                               
                                }                                
                            }
                            else
                            {
                                //todo: handle error
                                //redundant vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, _eSaveType, error);
                                vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE,  error);
                            }
                        },
                    true);
                }
            );
#endif

        }

       
#if UNSUSED
        //redundant private void vInsertPDBOld(EPDBSaveTypes _eSaveType)
        private void vInsertPDBOld()
        {
            // build new pdb_defn and insert it into db
            //string crap ="select LONG_DESC_TEXT from product_data_stat_desc";
            //string scrap = "SELECT a.USERNAME, b.sql_text, a.STATUS FROM V$SESSION a INNER JOIN V$SQLAREA b ON a.sql_address = b.address AND a.sql_hash_value = b.hash_value ";
            // + " and a.OSUSER='DBSRV01" + "\\\\" + "Peercy";
            //IList<string> str;
            //try
            //{
            //    //CCrap2 yx = new CCrap2();
            //    Ccrap x;
                
                
            //    InvokeOperation<IEnumerable<string>> y;
            //    InvokeOperation io;
            //    serviceAgent.ExecuteQuery(iCurrContext,
            //                   scrap,
            //                    (myStr) =>
            //                    {
            //                        io = (InvokeOperation)myStr;
            //                        //z IEnumerable<string> z = (IEnumerable<string>)io.Value;
            //                        IEnumerable<Ccrap> z = (IEnumerable<Ccrap>)io.Value;
            //                        //myStr[0].ToString();
            //                        //int x = 1;
            //                        foreach (Ccrap s in myStr.Value.ToList())
            //                        {
            //                            int yxx;

            //                            //MessageBox.Show(s.string1 + s.string2 + s.string3);

            //                        }



            //                    }
            //               );
            //}
            //catch (Exception)
            //{

            //    throw new Exception("bad");
                    
            //}

            ////
#if USE_COMPOSITION
            things have changed since this was coded so if decide to use it, needs rework...
            // Insert PDBDefn ( and associated PDB Data too )
            PDB_DEFN pdb = new PDB_DEFN();
            // note: sakey is handled by db trigger.
            pdb.NAME = sPDBName;
            pdb.USER_NAME = sUserName;
            serviceAgent.GetNextSequence(iCurrContext, "PDB_DEFN_SAKEY",
                (dNextSakey) =>
                {
                    pdb.PDB_DEFN_SAKEY = dNextSakey.Value;
                    PDB_DATA pdd;
                    foreach (ProductData pd in ocSelectedTests)
                    {
                        pdd = new PDB_DATA();
                        pdd.PDB_DEFN_SAKEY = pdb.PDB_DEFN_SAKEY;
                        pdd.TEST_DTS = pd.Time;
                        pdd.STAND_CODE = pd.Stand;
                        pdb.PDB_DATA.Add(pdd);
                    }

                    serviceAgent.InsertPDBDefn(iCurrContext, pdb,
                        //redundant (entities, error) => PDBActionComplete(entities, EPDCompleteTypes.eINSERT_PDB_COMPLETE, _eSaveType, error), true);
                        (entities, error) => PDBActionComplete(entities, EPDCompleteTypes.eINSERT_PDB_COMPLETE,  error), true);
                }
            );
#else
            //serviceAgent.GetNextSequence(iCurrContext, "PDB_DEFN_SAKEY",
            //    (dNextSakey) =>
            //    {

            //        PDB_DATA pdd = null;
            //        foreach (ProductData pd in ocSelectedTests)
            //        {
            //            pdd = new PDB_DATA();
            //            pdd.PDB_DEFN_SAKEY = dNextSakey.Value;
            //            pdd.TEST_DTS = pd.Time;
            //            pdd.STAND_CODE = pd.Stand;

            //        }
            //        serviceAgent.InsertPDBData(iCurrContext, pdd,
            //          (entities, error) => 
            //              {
            //                PDB_DEFN pdb = new PDB_DEFN();
            //                pdb.PDB_DEFN_SAKEY = dNextSakey.Value;
            //                pdb.NAME = this.sPDBName;
            //                pdb.USER_NAME = this.sUserName;

            //                serviceAgent.InsertPDBDefn(iCurrContext, pdb,
            //                    redundant (entities2, error2) => PDBActionComplete(entities2, EPDCompleteTypes.eINSERT_PDB_COMPLETE, _eSaveType, error2), true);
            //                    (entities2, error2) => PDBActionComplete(entities2, EPDCompleteTypes.eINSERT_PDB_COMPLETE, error2), true);
            //              },
            //        true); 
            //    }
            //);   
    
            m_serviceAgent.vGetNextSequence(m_iCurrContext, "PDB_DEFN_SAKEY",
                (dNextSakey) =>
                {
                    PDB_DEFN pdb = new PDB_DEFN();
                    pdb.PDB_DEFN_SAKEY = dNextSakey.Value;
                    pdb.NAME = sWorkingPDBName;
                    pdb.USER_NAME = _sUserName;
                    m_serviceAgent.vInsertPDBDefn(m_iCurrContext, pdb,
                        (entities, error) =>
                        {
                            if (error == null)
                            {
                                PDB_DATA pdd = null;
                                foreach (ProductData pd in ocSelectedTests)
                                {
                                    pdd = new PDB_DATA();
                                    pdd.PDB_DEFN_SAKEY = dNextSakey.Value;
                                    pdd.TEST_DTS = pd.Time;
                                    pdd.STAND_CODE = pd.Stand;
                                    m_serviceAgent.vInsertPDBData(m_iCurrContext, pdd, null, false);
                                }
                                m_serviceAgent.vSubmitChanges(m_iCurrContext, (error2) =>
                                    {
                                        //redundant vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, _eSaveType, error2);
                                        vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, error2);
                                    }
                                );
                            }
                            else
                            {
                                //todo:
                                //redundant vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, _eSaveType, error);
                                vPDBActionComplete(EPDCompleteTypes.eINSERT_PDB_COMPLETE, error);
                            }
                        },
                    true);
                }
            );
#endif

        }
#endif
        private void vDeletePDBViaSakeysActionComplete( EPDCompleteTypes _eCompleteType, int _io) {
            // update ocePDBDefn since some have been removed.
            foreach (PDB_DEFN pdb in lstSelectedPDBDefnsForDeletion)
            {
#if USE_SORTABLE_PDBDEFNS
                soceSortablePDBDefns.Remove(pdb);
#else
                ocePDBDefn.Remove(pdb);
#endif

            }
            bIsBusy = false;
        }

        // Handle cases with return values
        //redundant private void vPDBActionComplete(List<PDB_DEFN> _entities, EPDCompleteTypes _eCompleteType, EPDBSaveTypes _eSaveType, Exception exError)
        private void vPDBActionComplete(List<PDB_DEFN> _entities, EPDCompleteTypes _eCompleteType,  Exception _exError)
        {
        }

        // Handle cases without return values.
        //redundant private void vPDBActionComplete(EPDCompleteTypes _eCompleteType, EPDBSaveTypes _eSaveType, Exception exError)
        private void vPDBActionComplete(EPDCompleteTypes _eCompleteType,  Exception _exError)
        {
            switch (_eCompleteType)
            {
                //case EPDCompleteTypes.eGET_PDB_COMPLETE:
                //    //todo: this case should no longer be needed.

                //    // If no error is returned, set the PdbDefn to entities. Note, pdbDefn contains pdb_datas.
                //    if (_error == null)
                //    {
                //        ocePDBDefn = new ObservableCollection<PDB_DEFN>(_entities);
                //        if ( ocePDBDefn.Count > 0 ) ????
                //        {
                //            // PDB already exists. 
                //            // Ask if overwrite later but just overwrite for now.
                //            Notify(evOverwritePDBNotice, new NotificationEventArgs<object, bool>
                //                ("PDB already exists. Do you wish to overwrite?", null,
                //                confirm =>
                //                {
                //                    if (confirm)
                //                    {
                //                        // Save changes
                //                        //serviceAgent.SaveChanges
                //                        //    (error => ProductsSaved(error));
                //                        redundant vDeletePDB(SelectedPDBDefn, m_iCurrContext, _eSaveType, true);
                //                        vDeletePDB(SelectedPDBDefn, true);
                //                    }
                //                    else
                //                    {
                //                        //todo: prompt for new pdb name...
                //                    }
                //                }));

                //            //xx Notify(ShowNotice, new NotificationEventArgs<object, bool>
                //            //    ("PDB already exists. Do you wish to overwrite?", null,
                //            //    confirm =>
                //            //    {
                //            //        if (confirm)
                //            //        {
                //            //            // Save changes
                //            //            //serviceAgent.SaveChanges
                //            //            //    (error => ProductsSaved(error));
                //            //            redundant RemovePDB(iCurrContext, _eSaveType, true);
                //            //            RemovePDB( true);
                //            //        }
                //            //        else
                //            //        {
                //            //            //todo: prompt for new pdb name...
                //            //        }
                //            //    }));                       
                //        }
                //        else {
                //            redundant vInsertPDB(_eSaveType);
                //            vInsertPDB();
                //        }                        
                //    }
                //    // Otherwise notify view that there's an error
                //    else
                //    {
                //        vNotifyError("Unable to retrieve PdbDefn", _exError);
                //    }
                //    break;
                case EPDCompleteTypes.eDELETE_PDB_COMPLETE:
                    if (_exError == null)
                    {
                        //update ocePDBDefn
                        #if USE_SORTABLE_PDBDEFNS 
                            foreach (PDB_DEFN pdb in lstSelectedPDBDefnsForDeletion)
                            {
                                soceSortablePDBDefns.Remove(pdb);  
                            }
                        #else
                            ocePDBDefn.Remove(SelectedPDBDefn);
                        #endif
                    }
                    else
                    {
                        vNotifyError("Unable to remove personal database definition", _exError);
                    }
                    break;
                case EPDCompleteTypes.eDELETE_PDB_BEFORE_INSERT_COMPLETE:
                    if (_exError == null)
                    {
                        // Insert PDBDefn
                        //redundant vInsertPDB(_eSaveType);
                        vInsertPDB();
                    }
                    else
                    {
                        vNotifyError("Unable to remove personal database definition", _exError);
                    }
                    break;
                case EPDCompleteTypes.eINSERT_PDB_COMPLETE:
                    //decimal x = -1;
                    if (_exError != null)
                    {
                        //m_serviceAgent.vExecuteQuery(m_iCurrContext,
                        //    "select 1 from dual",
                        //     (myStr) =>
                        //     {
                        //         string str = myStr.ToString();
                        //     }
                        //);

                        //serviceAgent.GetNextSequence(iCurrContext, "PDB_DEFN_SAKEY",
                        //   (dNextSakey) =>
                        //   {
                        //       x = dNextSakey.Value;
                        //   }
                        //);
                        //MessageBox.Show(x.ToString());
                        vNotifyError("Unable to insert personal database definition", _exError);
                    }
                    else
                    {
                        // updating ocePDBDefn since some have been removed is
                        // done automagically via combo control ocePDBDefn.Add(SelectedPDBDefn);
#if SUPPORT_UNDO_REDO
                        _oProductDataURVM.UndoManager.ClearHistory();
#endif

                        if (bOpenPDBOnSave)
                        {
                            // need to clear any grid sorting, filtering, etc. here since it might be invalid
                            // and dataset has changed since these might have been applied.
                            Notify(evResetTestListTweaks, new NotificationEventArgs());
                            vOpenPDB(); 
                        }                        
                    }
                    bIsBusy = false;
                    break;
                //composition case EPDCompleteTypes.eINSERT_PDB_DEFN_COMPLETE:
                //    if (_error == null)
                //    {
                //        // get the pdbdefnsakey ( there will not be any associated pdb_data yet )
                //        serviceAgent.GetPDBDefn(iCurrContext, this.sPDBName, this.sUserName,
                //            redundant (entities, error) => PDBActionComplete(entities, EPDCompleteTypes.eGET_PDB_DEFN_SAKEY_COMPLETE, _eSaveType, error));   
                //            (entities, error) => PDBActionComplete(entities, EPDCompleteTypes.eGET_PDB_DEFN_SAKEY_COMPLETE, error));                    
                //    }
                //    else
                //    {
                //        NotifyError("Unable to insert PdbDefn", _exError);
                //    }
                //    break;
                //composition case EPDCompleteTypes.eGET_PDB_DEFN_SAKEY_COMPLETE:
                //    if (_error == null)
                //    {
                //        ocePDBDefn = new ObservableCollection<PDB_DEFN>(_entities);
                //        // Add the tests to the PDB_DATA table.
                //        redundant InsertPDBData(_eSaveType, ocePDBDefn[0].PDB_DEFN_SAKEY);
                //        InsertPDBData(ocePDBDefn[0].PDB_DEFN_SAKEY);
                //    }
                //    else
                //    {
                //        NotifyError("Unable to retrieve PdbDefnsakey", _exError);
                //    }
                //    break;

            }
        }
        //#if USE_COMPOSITION
        //#else
        //        redundant private void PDDDataActionComplete(List<PDB_DATA> _entities, EPDCompleteTypes _eCompleteType, EPDBSaveTypes _eSaveType, Exception exError)
        //        private void PDDDataActionComplete(List<PDB_DATA> _entities, EPDCompleteTypes _eCompleteType, Exception exError)
        //        {
        //            switch (_eCompleteType)
        //            {
        //                case EPDCompleteTypes.eINSERT_PDB_DATA_COMPELTE:
        //                    if (_error != null)
        //                    {
        //                        NotifyError("Failed to insert PdbData", _exError);
        //                    }
        //                    IsBusy = false;
        //                    break;
        //            }
        //        }
        //        private void PDDDataActionComplete( Exception exError)
        //        {
        //            if (_error != null)
        //            {
        //                NotifyError("Failed to insert PdbData", _exError);
        //            }
        //            IsBusy = false;
        //        }
        //#endif
        #endregion Save

        #region Open

        public void vOpenPDB()
        {               
            m_serviceAgent.vGetPDB(m_iCurrContext, SelectedPDBDefn.NAME, SelectedPDBDefn.USER_NAME,
                (entity, error) =>
                {
                    if (error == null)
                    {
                        if (entity.Count > 0)
                        {
                            // Found PDB.

                            // Get the test list for "SelectedPDBDefn"
                            vGetPDBProductData(SelectedPDBDefn.PDB_DEFN_SAKEY);

                            // todo: get the test data for the first test in the test list
                        }
                        else
                        {
                            // todo: didn't find pdb
                        }
                    }
                    else
                    {
                        //todo: handle error
                    }
                }, true
            );
        }
        private void vGetPDBProductData( decimal _dPDBDefnSakey )
        {
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;

            // Reset property
            oceProductData = null;
           
            if ( bTestListRetrieveRejectInfo )
                m_serviceAgent.vLoadPDBProductDataWStatAndRej(m_iCurrContext, _dPDBDefnSakey,
                                                        (entities, error) => cbfLoadProductDataComplete(entities, error));
            else
                m_serviceAgent.vLoadPDBProductDataWStat(m_iCurrContext, _dPDBDefnSakey,
                                        (entities, error) => cbfLoadProductDataComplete(entities, error));
        }
        #region Completion Callbacks
        private void cbfLoadPDBDefnsComplete(List<PDB_DEFN> _entities, Exception _exError)
        {
            // If no error is returned, set the pdb's to entities
            if (_exError == null)
            {
#if USE_SORTABLE_PDBDEFNS
                soceSortablePDBDefns = new SortableObservableCollection<PDB_DEFN>();
                foreach (PDB_DEFN pdb in _entities)
                {
                    soceSortablePDBDefns.Add(pdb);
                }
#else
                ocePDBDefn = new ObservableCollection<PDB_DEFN>(_entities);   
#endif

            }
            // Otherwise notify view that there's an error
            else
            {
                vNotifyError("Unable to retrieve PDB definitions", _exError);
            }

            // We're done
            bIsBusy = false;
        }
        #endregion Completion Callbacks
        #endregion Open

        #region Delete

        #region Tests
        // Handled completely by control 
        //public void vDeleteSelectedTests() {
        //}

        #endregion Tests

        //redundant private void vDeletePDBBeforeInsert(PDB_DEFN _PDBDefn, int _iCurrContext, EPDBSaveTypes _eSaveType, bool _boSubmitChanges)
        private void vDeletePDBBeforeInsert(PDB_DEFN _PDBDefn,  bool _boSubmitChanges)
        {
            // Delete this pdb
            m_serviceAgent.vDeletePDB(m_iCurrContext, _PDBDefn,
                //redundant (error) => vPDBActionComplete(EPDCompleteTypes.eDELETE_PDB_BEFORE_INSERT_COMPLETE, _eSaveType, error), _boSubmitChanges);
                (error) => vPDBActionComplete(EPDCompleteTypes.eDELETE_PDB_BEFORE_INSERT_COMPLETE, error), _boSubmitChanges);
        }           
        public void vDeleteSelectedPDBs_Load()
        {
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;
            m_iCounter = 0;

            // this seems like a stupid approach but works
            foreach (PDB_DEFN pdb in lstSelectedPDBDefnsForDeletion)
            {
                m_serviceAgent.vGetPDBViaSakey(m_iCurrContext, pdb.PDB_DEFN_SAKEY, cbGetPDBViaSakeyComplete, true );
            }            
        }

        public void cbGetPDBViaSakeyComplete(List<PDB_DEFN> _lstPDBDefns, Exception _exError)
        {
            if (_exError == null)
            {
                // found it
                m_serviceAgent.vDeletePDB(m_iCurrContext, _lstPDBDefns[0], cbfDeletePDBComplete, false);
            }
            else
            {
                //todo: handle error
            }
        }
        public void cbfDeletePDBComplete(Exception _exError)
        {
            ++m_iCounter;
            if (_exError == null)
            {
                if (lstSelectedPDBDefnsForDeletion.Count == m_iCounter)
                {
                    m_serviceAgent.vSubmitChanges(m_iCurrContext, cbfDeletePDBSubmitComplete);
                }
            }
            else
            {
                //todo: handle error
            }
        }
        public void cbfDeletePDBSubmitComplete(Exception _exError)
        {
            if (_exError == null)
            {
                
                // update ocePDBDefn since some have been removed.
                foreach (PDB_DEFN pdb in lstSelectedPDBDefnsForDeletion) 
                {
#if USE_SORTABLE_PDBDEFNS
                    soceSortablePDBDefns.Remove(pdb);
#else
                    ocePDBDefn.Remove(pdb);  
#endif
                }
                
            }
            else
            {
                //todo: handle error ( still should turn off bIsBusy... too
            }  
            bIsBusy = false;        
        }

        public void vDeleteSelectedPDBs_NoLoad()
        {
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;
            m_iCounter = 0;

            //m_serviceAgent.vDeletePDBViaSakeysEx(m_iCurrContext, lstPDBDefnSakeys,
            //    (iRowsAffected) => vDeletePDBViaSakeysActionComplete(EPDCompleteTypes.eDELETE_PDB_COMPLETE, iRowsAffected), true); // todo: add in exception too

            m_serviceAgent.vDeletePDBs(m_iCurrContext, lstSelectedPDBDefnsForDeletion,
                           (iRowsAffected) => vDeletePDBViaSakeysActionComplete(EPDCompleteTypes.eDELETE_PDB_COMPLETE, iRowsAffected), true); // todo: add in exception too
        }
       
        public void vRemovePartialPDBDefns(bool _bAll)
        {
            //rrp Check whether I really need to loop here since in xceSavePDBName_ItemAdding I try to disallow this.
            // remove all partial pdbDefns ( exclude the "selected" one if _bAll is false )
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;
            try
            {               
                //this next line throws error if it does not find match
#if USE_SORTABLE_PDBDEFNS
                IEnumerable<PDB_DEFN> enPdbDefns = soceSortablePDBDefns.Where(pdb => pdb.PDB_DEFN_SAKEY == SAKEY_SINTENEL);
                foreach (PDB_DEFN pdb in enPdbDefns)
                {
                    if (_bAll || (pdb.NAME != SelectedPDBDefn.NAME)) soceSortablePDBDefns.Remove(pdb);
                }
#else
                IEnumerable<PDB_DEFN> enPdbDefns = ocePDBDefn.Where(pdb => pdb.PDB_DEFN_SAKEY == SAKEY_SINTENEL);
                foreach (PDB_DEFN pdb in enPdbDefns)
                {
                    if (_bAll || (pdb.NAME != SelectedPDBDefn.NAME)) ocePDBDefn.Remove(pdb);
                }
#endif

            }
            catch (Exception)
            {
                // fall through since pdbDefn does not contain any "partial" pdbDefns.		        
            }
            bIsBusy = false;
        }
        
        #endregion Delete
        
        #region Tests
        public void vRetreivePartTests()
        {           
            List<string> lstDistinctParts = ocTests.Distinct(new WMAApp.Helpers.PartComparer()).Select(t => t.sModel + t.sSerial).ToList();
            if (lstDistinctParts.Count <= 0)
            {
                Notify(evGeneralAcknowledgmentNotice, new NotificationEventArgs<object, bool>
                        ("No tests from which to build part list.", null,
                          confirm => {}));
            }
            else
            {
                vGetPartProductData(lstDistinctParts, bTestListRetrieveRejectInfo); 
                SelectedPDBDefn = null;

            }
        }
        private void vGetPartProductData(List<string> _lstPartList, bool _bGetRejectInfo = false) //vGetPartProductData(IEnumerable<string> _iePartList)
        {
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;

            // Reset property
            oceProductData = null;

            if ( _bGetRejectInfo ) 
                m_serviceAgent.vLoadProductDataWStatAndRejForParts(m_iCurrContext, _lstPartList, //_iePartList,
                                                     (entities, error) => cbfLoadProductDataComplete(entities, error));
            else
                m_serviceAgent.vLoadProductDataWStatForParts(m_iCurrContext, _lstPartList, //_iePartList,
                                                        (entities, error) => cbfLoadProductDataComplete(entities, error));
        }
        #endregion Tests

        #region TPDefns
        public void vRetrieveTPDefns() {
#if GET_TP_DEFNS_DEPENDENT_ON_TEST_LIST

            List<string> lstTests = ocTests.Select(t => t.dtTime + t.sStand).ToList();
            if (lstTests.Count <= 0)
            {
                Notify(evGeneralAcknowledgmentNotice, new NotificationEventArgs<object, bool>
                    ("No tests from which to build test point list.", null,
                    confirm =>
                    {                        
                    }));
            }
            else
            {
                bIsBusy = true;

                // Reset property
                ocTpDefns = null;

                m_serviceAgent.vLoadTPDefns(m_iCurrContext, lstTests,
                                                  (entities, error) => cbfLoadTPDefnsComplete(entities, error));
            }
#else
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;
            
            if (ocTests != null && ocTests.Count > 0)
            {
                // get the distinct family's that are represented in the test list
                // convert to decimal so that I don't have the issue of converting to string inside of contains method in linq.
                List<decimal> lstdDistinctFamilyIds = ocTests.Select(t =>  Convert.ToDecimal(t.sFamilyId)).Distinct().ToList();

                // Reset property
                ocTpDefns = null;
                m_serviceAgent.vLoadTPDefnsInFam(m_iCurrContext, lstdDistinctFamilyIds,
                                                 (entities, error) => cbfLoadTPDefnsComplete(entities, error));
            }
            else
            {
                // todo:handle error
            }
#endif
        }
        #region Completion Callbacks
        private void cbfLoadTPDefnsComplete(List<WMAApp.Web.Models.TpDefn> _entities, Exception _exError)
        {
            // If no error is returned, set the model to entities
            if (_exError == null)
            {
                ocTpDefns = new ObservableCollection<WMAApp.Web.Models.TpDefn>(_entities);
                // Should be able to call orderby on octpdefns and not have to make a list and then reinsert back into octpdefns????
                var lstSorted = ocTpDefns.OrderBy(x => x.dFamilyId).ThenBy(y => y.dId).ToList();
                ocTpDefns.Clear();
                lstSorted.ForEach(ocTpDefns.Add);
            }
            // Otherwise notify view that there's an error
            else
            {
                vNotifyError("Unable to retrieve test point definitions", _exError);
            }

            // Make the testpoint pane the active one.

            // We're done
            bIsBusy = false;
        } 
        
        #endregion Completion Callbacks
        #endregion TPDefns

        #region TP Data results

        public void vProcessLL(bool _bBatchMode)
        {
            string sSqlLL = "select pd.test_dts as dtTestTime, pv1.param_id as dParamId, pv1.param_code_name as sParamCodeName, pv1.param_val_qty as dParamQty from param_val pv1, product_data pd, var_trend_sum vts where " +
                                //"pd.test_dts >= to_date('" + ocTests[0].dtTime + "','mm/dd/yyyy hh:mi:ss am') and " +
                                "pd.test_dts = vts.data_dts and pd.stand_code = vts.stand_code and vts.TP_TEXT = '" + _sUserName + "' and " +
                                //"pd.test_dts <= to_date('" + ocTests[ocTests.Count - 1].dtTime + "','mm/dd/yyyy hh:mi:ss am') and " +
                                "pv1.param_id in ( select param_id from param_tp_defn where tp_defn_sakey = " + oTPDescriptor.dTpDefnSakey + " and limit_code = 'L') and " +
                                "pv1.param_code_name = pd.model_code and " +
                                "pv1.param_val_rev_dts = ( select max(pv2.param_val_rev_dts) from param_val pv2 where pv2.param_id = pv1.param_id and " +
                                "pv2.param_code_name = pv1.param_code_name and pv2.param_val_rev_dts <= pd.max_param_val_rev_dts ) order by test_dts";


            m_serviceAgent.vExecuteQueryGetLimits(m_iCurrContext, sSqlLL,
                    (entities) =>
                    {
                        if (entities.Error == null)
                        {
                            ocLowLimit = new ObservableCollection<LimitData>(entities.Value);
                            if (ocLowLimit.Count <= 0)
                            {
                                // if in batch mode, don't display message box, just don't generate chart
                                //if (!_bBatchMode)
                                //    vNotifyError("No low limit data", null);
                                // notify view to show blank report
                                //Notify(evShowTPLimitData, new NotificationEventArgs<TPDescriptor>(MessageTokens.sNO_DATA, oTPDescriptor));
                                vProcessUL(_bBatchMode);
                            }
                            else
                            {
                                oTPDescriptor.sLimitType = "L";
                                // notify view to show report
                                Notify(evShowTPLimitData, new NotificationEventArgs<TPDescriptor>("some message", oTPDescriptor));
                                vProcessUL(_bBatchMode);
                            }
                        }
                        else
                        {
                            if (!_bBatchMode) 
                                vNotifyError("Error retrieving low limit data: " + entities.Error.Message.ToString(), null);
                            bIsBusy = false;
                        }
                        //rif (!_bBatchMode) bIsBusy = false;
                    }
                );
        }
        public void vProcessUL(bool _bBatchMode)
        {
            string sSqlHL = "select pd.test_dts as dtTestTime, pv1.param_id as dParamId, pv1.param_code_name as sParamCodeName, pv1.param_val_qty as dParamQty from param_val pv1, product_data pd, var_trend_sum vts  where " +
                                "pd.test_dts = vts.data_dts and pd.stand_code = vts.stand_code and vts.TP_TEXT = '" + _sUserName + "' and " +
                                "pv1.param_id in ( select param_id from param_tp_defn where tp_defn_sakey = " + oTPDescriptor.dTpDefnSakey + " and limit_code = 'H') and " +
                                "pv1.param_code_name = pd.model_code and " +
                                "pv1.param_val_rev_dts = ( select max(pv2.param_val_rev_dts) from param_val pv2 where pv2.param_id = pv1.param_id and " +
                                "pv2.param_code_name = pv1.param_code_name and pv2.param_val_rev_dts <= pd.max_param_val_rev_dts ) order by pd.test_dts";


            m_serviceAgent.vExecuteQueryGetLimits(m_iCurrContext, sSqlHL,
                    (entities) =>
                    {
                        if (entities.Error == null)
                        {
                            ocHighLimit = new ObservableCollection<LimitData>(entities.Value);
                            if (ocHighLimit.Count <= 0)
                            {
                                // if in batch mode, don't display message box, just don't generate chart
                                //if (!_bBatchMode)
                                //    vNotifyError("No high limit data", null);
                                // notify view to show blank report
                                //Notify(evShowTPLimitData, new NotificationEventArgs<TPDescriptor>(MessageTokens.sNO_DATA, oTPDescriptor));                                
                            }
                            else
                            {
                                oTPDescriptor.sLimitType = "H";
                                // notify view to show report
                                Notify(evShowTPLimitData, new NotificationEventArgs<TPDescriptor>("some message", oTPDescriptor));
                            }
                        }
                        else
                        {
                            if (!_bBatchMode) 
                                vNotifyError("Error retrieving high limit data: " + entities.Error.Message.ToString(), null);
                        }
                        if (!_bBatchMode) bIsBusy = false;
                    }
                );
        }


        public void vInsertTempTPData(List<TestDescriptor> _lstTests, decimal _dTpId, string _sUnits, bool _bBatchMode = false)
        {
            m_serviceAgent.vClearTempTPData(m_iCurrContext);
            VAR_TREND_SUM vts = null;
            foreach (TestDescriptor tdesc in _lstTests)
            {
                vts = new VAR_TREND_SUM();
                vts.DATA_DTS = tdesc.dtTestTime;
                vts.STAND_CODE = tdesc.sStandCode;
                vts.TP_ID = _dTpId;
                vts.UNITS_TEXT = _sUnits;
                vts.TP_TEXT = _sUserName;// don't stomp on another user of this hijacked db table...
               // The rest of the fields in vst really don't matter but are required 
                vts.MODEL_CODE = tdesc.sModelCode;
                vts.FAMILY_ID = Convert.ToInt16(tdesc.sFamilyId);
                m_serviceAgent.vInsertTempTPData(m_iCurrContext, vts, null, false);               
            }
            
            m_serviceAgent.vSubmitChanges(m_iCurrContext, (error2) =>
                {
                    if (error2 == null)
                    {
                        m_serviceAgent.vLoadTPData(m_iCurrContext, _dTpId, _sUserName,
                                                (entities, error) =>
                                                {
                                                    if (error == null)
                                                    {
                                                        ocTPData = new ObservableCollection<TPData>(entities);
                                                        if (ocTPData.Count <= 0)
                                                        {
                                                            //if in batch mode, don't display message box, just don't generate chart
                                                            if (!_bBatchMode)
                                                                vNotifyError("No test point results", null);
                                                            bIsBusy = false;
                                                        
                                                            // notify view to show blank report
                                                            //Notify(evShowTPData, new NotificationEventArgs<TPDescriptor>(MessageTokens.sNO_DATA, oTPDescriptor));
                                                            //vProcessLL(_bBatchMode);                                                            
                                                        }
                                                        else
                                                        {
                                                            //notify view to show report
                                                            Notify(evShowTPData, new NotificationEventArgs<TPDescriptor>("some message", oTPDescriptor));
                                                            vProcessLL(_bBatchMode);                                                                                                                                                                                 
                                                        }
                                                    }
                                                    else
                                                    {
                                                        if (!_bBatchMode) 
                                                            vNotifyError("Error retrieving test point results: " + error.Message.ToString(), null);
                                                        bIsBusy = false;
                                                    }
                                                    //if (!_bBatchMode) bIsBusy = false;
                                                }
                          );
                    }
                    else
                    {
                        bIsBusy = false;
                        if (!_bBatchMode) 
                            vNotifyError("Error collecting tp data: " + error2.Message.ToString(), null);
                    }
                }
            );
        }

        public void vGetTPData(TPDescriptor _oTPDescriptor, bool _bBatchMode = false) 
        {            
            if (!_bBatchMode) sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;

            // Reset property
            ocTPData = null;
            // remember data passed in so that it can be used when ResultsComplete calls back view method.           
            oTPDescriptor = _oTPDescriptor;

            int iSelTestCount = 0;
            int iTestCount = 0;
            // if no tests are selected, default to all tests
            if (ocSelectedTests != null)
                iSelTestCount = ocSelectedTests.Count;
            iTestCount = ocTests.Count;

            if (iTestCount > 0) 
            {
#if GET_ACTUAL_TP_DATA
                // make a list of testdts/standcode aggregations
                //List<string> lstTests = ocTests.Select(t => t.dtTime + t.sStand).ToList();                         

                List<TestDescriptor> lstTests = new List<TestDescriptor>();
                if (iSelTestCount > 0)
                {
#if SUPPORT_UNDO_REDO
                    foreach (ProductDataUR pd in ocSelectedTests)
                    {
                        lstTests.Add(new TestDescriptor(pd.sFamilyId, pd.dtTime, pd.dtTime.ToString(), pd.sStand, pd.sModel, pd.sSerial));
                    }
#else
                    foreach (ProductData pd in ocSelectedTests) 
                    {
                        lstTests.Add(new TestDescriptor(pd.sFamilyId, pd.dtTime, pd.dtTime.ToString(), pd.sStand, pd.sModel, pd.sSerial));
                    }
#endif
                }
                else
                {
                    foreach (ProductData pd in ocTests) 
                    {
                        lstTests.Add(new TestDescriptor(pd.sFamilyId, pd.dtTime, pd.dtTime.ToString(), pd.sStand, pd.sModel, pd.sSerial));
                    }
                }

                int iTotalRowsAffected = 0;
                string sSql = "delete from VAR_TREND_SUM where TP_TEXT = '" + _sUserName + "'" ;
                m_serviceAgent.iExecuteCommand(m_iCurrContext, sSql,
                                (iRowsAffected) =>
                                {                                   
                                    iTotalRowsAffected += iRowsAffected;
                                    vInsertTempTPData(lstTests, oTPDescriptor.dId, _oTPDescriptor.sUnits, _bBatchMode);
                                }, true
                );
#else
                // NOTE: this is just a temporary query to get some data... need to use the one above and EF
                                  
                //string sSql = " SELECT TPD.TP_QTY, TPDEFN.TP_ID FROM TP_DATA TPD,  TP_DEFN TPDEFN   " +                                         
                //                "where TPD.TEST_DTS >= to_date('2/2/2007 5:14:28 AM' , 'mm/dd/yyyy hh:mi:ss am') AND TPD.TEST_DTS <= to_date('2/2/2007 5:46:47 AM' , 'mm/dd/yyyy hh:mi:ss am') " +
                //            " AND TPD.TP_DEFN_SAKEY = TPDEFN.TP_DEFN_SAKEY AND TPDEFN.TP_ID =" + _oTPDescriptor.dId;
                 string sSql = " SELECT TPD.TEST_DTS as dtTestTime, TPD.STAND_CODE as sStandCode, TPD.TP_QTY as dTPQty, TPDEFN.TP_ID as dId, " +
                               " TPDEFN.TP_DEFN_SAKEY as dTpDefnSakey FROM TP_DATA TPD,  TP_DEFN TPDEFN   " +                                         
                               " where TPD.TEST_DTS >= to_date('" + ocTests[0].dtTime + "' , 'mm/dd/yyyy hh:mi:ss am') AND " +
                               " TPD.TEST_DTS <= to_date('" + ocTests[ocTests.Count - 1].dtTime + "' , 'mm/dd/yyyy hh:mi:ss am') " +
                               " AND TPD.TP_DEFN_SAKEY = TPDEFN.TP_DEFN_SAKEY AND TPDEFN.TP_ID =" +   oTPDescriptor.dId;
            
                
                m_serviceAgent.vExecuteQueryGetTPData(m_iCurrContext, sSql,
                        (entities) =>
                        {
                            if (entities.Error == null)
                            {
                                ocTPData = new ObservableCollection<TPData>(entities.Value);
                                if (ocTPData.Count <= 0)
                                {
                                    // if in batch mode, don't display message box, just don't generate chart
                                    if (!_bBatchMode)
                                        vNotifyError("No test point results", null);
                                    else
                                    {   // notify view to show blank report
                                        Notify(evShowTPData, new NotificationEventArgs<TPDescriptor>(MessageTokens.sNO_DATA, oTPDescriptor));
                                    }
                                }
                                else
                                {
                                    // notify view to show report
                                    Notify(evShowTPData, new NotificationEventArgs<TPDescriptor>("some message", oTPDescriptor));
                                }
                            }
                            else
                            {
                                vNotifyError("Error retrieving test point results: " + entities.Error.Message.ToString(), null);
                            }
                            if (!_bBatchMode) bIsBusy = false;
                        }
                    );
#endif //GET_ACTUAL_TP_DATA

            }
            else
            {
                // todo:handle error
                vNotifyError("Please select one or more tests", null);
            }

        }
        #region Completion Callbacks
      
        #endregion Completion Callbacks

        #endregion TP Data results
        #region TP Pivot Grid
#if GET_ACTUAL_PIVOT_DATA
        public void vGetTPPivotGridData(bool _bBatchMode = false)
#else
        public void vGetTPPivotGridData(List<string> _lstTests, List<decimal> _lstTPIds, bool _bBatchMode = false)
#endif
        {
            if (!_bBatchMode) sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;

            // Reset property
            ocTPPivotGridData = null;

#if GET_ACTUAL_PIVOT_DATA
            //m_serviceAgent.vLoadTPPivotGridData(m_iCurrContext, _lstTests, _lstTPIds,
            //                                     (entities, error) => cbfLoadTPPivotGridDataComplete(entities, error));
            // make a list of testdts/standcode aggregations
            //List<string> lstTests = ocTests.Select(t => t.dtTime + t.sStand).ToList();                         

            List<TestDescriptor> lstTests = new List<TestDescriptor>(); 
////////#if SUPPORT_UNDO_REDO
////////            foreach (ProductDataUR pd in ocSelectedTests)
////////            {
////////#else
////////            foreach (ProductData pd in ocSelectedTests) {
////////#endif
////////                lstTests.Add(new TestDescriptor(pd.sFamilyId, pd.dtTime, pd.dtTime.ToString(), pd.sStand, pd.sModel, pd.sSerial));
////////            }
            int iSelTestCount = 0;
            int iTestCount = 0;
            // if no tests are selected, default to all tests
            if (ocSelectedTests != null)
                iSelTestCount = ocSelectedTests.Count;
            iTestCount = ocTests.Count;

            if (iTestCount > 0)
            {
#if GET_ACTUAL_TP_DATA
                // make a list of testdts/standcode aggregations
                //List<string> lstTests = ocTests.Select(t => t.dtTime + t.sStand).ToList();                         

                //List<TestDescriptor> lstTests = new List<TestDescriptor>();
                if (iSelTestCount > 0)
                {
#if SUPPORT_UNDO_REDO
                    foreach (ProductDataUR pd in ocSelectedTests)
                    {
                        lstTests.Add(new TestDescriptor(pd.sFamilyId, pd.dtTime, pd.dtTime.ToString(), pd.sStand, pd.sModel, pd.sSerial));
                    }
#else
                    foreach (ProductData pd in ocSelectedTests) 
                    {
                        lstTests.Add(new TestDescriptor(pd.sFamilyId, pd.dtTime, pd.dtTime.ToString(), pd.sStand, pd.sModel, pd.sSerial));
                    }
#endif
                }
                else
                {
                    foreach (ProductData pd in ocTests)
                    {
                        lstTests.Add(new TestDescriptor(pd.sFamilyId, pd.dtTime, pd.dtTime.ToString(), pd.sStand, pd.sModel, pd.sSerial));
                    }
                }
            }
            else
            {
                // todo:handle error
                vNotifyError("Please select one or more tests", null);
            }
#endif
            List<decimal> lstTPs = new List<decimal>();
            // use all tp defns if user did not select any
            if (ocSelectedTPs != null && ocSelectedTPs.Count > 0)
            {
                foreach (TpDefn tpd in ocSelectedTPs)
                {
                    lstTPs.Add(tpd.dId);
                }
            }
            else
            {
                foreach (TpDefn tpd in ocTpDefns)
                {
                    lstTPs.Add(tpd.dId);
                }
            }
            int iTotalRowsAffected = 0;
            string sSql = "delete from VAR_TREND_SUM where TP_TEXT = '" + _sUserName + "'";
            m_serviceAgent.iExecuteCommand(m_iCurrContext, sSql,
                            (iRowsAffected) =>
                            {
                                iTotalRowsAffected += iRowsAffected;
                                vInsertTempPGTestData(lstTests, lstTPs, _bBatchMode);
                            }, true
            );
#else
            if (ocSelectedTests != null && ocSelectedTests.Count > 0)
            {           
                // NOTE: this is just a temporary query to get some data... need to use the one above and EF
                string sSql = " SELECT PD.MODEL_CODE as sModel, PD.SERIAL_CODE as sSerial, TPD.TEST_DTS as dtTestTime, TPD.STAND_CODE as sStandCode, TPD.TP_QTY as dTPQty, TPDEFN.TP_ID as dId, " +
                              " TPDEFN.TP_DEFN_SAKEY as dTpDefnSakey FROM PRODUCT_DATA PD, TP_DATA TPD,  TP_DEFN TPDEFN   " +
                              " where TPD.TEST_DTS >= to_date('" + ocTests[0].dtTime + "' , 'mm/dd/yyyy hh:mi:ss am') AND " +
                              " TPD.TEST_DTS <= to_date('" + ocTests[ocTests.Count - 1].dtTime + "' , 'mm/dd/yyyy hh:mi:ss am') " +
                              " AND TPD.TP_DEFN_SAKEY = TPDEFN.TP_DEFN_SAKEY AND PD.TEST_DTS = TPD.TEST_DTS AND PD.STAND_CODE = TPD.STAND_CODE"; // AND TPDEFN.TP_ID =" + oTPDescriptor.dId;

                m_serviceAgent.vExecuteQueryGetTPPivotGridData(m_iCurrContext, sSql,
                        (entities) =>
                        {
                            if (entities.Error == null)
                            {
                                ocTPPivotGridData = new ObservableCollection<TPPivotGridData>(entities.Value);
                                if (ocTPPivotGridData.Count <= 0)
                                {
                                    // if in batch mode, don't display message box, just don't generate chart
                                    if (!_bBatchMode)
                                        vNotifyError("No test point pivot results", null);
                                    else
                                    {   // notify view to show blank report
                                        Notify(evShowTPPivotGridData, new NotificationEventArgs<TPDescriptor>(MessageTokens.sNO_DATA, null));
                                    }
                                }
                                else
                                {
                                    // notify view to show report
                                    Notify(evShowTPPivotGridData, new NotificationEventArgs<TPDescriptor>("some message", oTPDescriptor));
                                }
                            }
                            else
                            {
                                vNotifyError("Error retrieving test point pivot results: " + entities.Error.Message.ToString(), null);
                            }
                            if (!_bBatchMode) bIsBusy = false;
                        }
                    );
            }
            else
            {
                // todo:handle error
            }
#endif //GET_ACTUAL_PIVOT_DATA
        }
        public void vInsertTempPGTestData(List<TestDescriptor> _lstTests, List<decimal> _lstTPIds, bool _bBatchMode = false)
        {

            int iTotalRowsAffected = 0;
            #if USE_VAR_TREND_SUM_TEMP
            string sSql = "delete from VAR_TREND_SUM_TEMP where TP_TEXT = '" + _sUserName + "'";
#else
            string sSql = "delete from AUDIT_DEFN where TABLE_NAME = '" + _sUserName + "'";
#endif

            m_serviceAgent.iExecuteCommand(m_iCurrContext, sSql,
                            (iRowsAffected) =>
                            {
                                iTotalRowsAffected += iRowsAffected;
                                #region A
                                m_serviceAgent.vClearTempPGTestData(m_iCurrContext);
                                VAR_TREND_SUM vts = null;
                                foreach (TestDescriptor tdesc in _lstTests)
                                {
                                    vts = new VAR_TREND_SUM();
                                    vts.DATA_DTS = tdesc.dtTestTime;
                                    vts.LOW_PARAM_CODE = tdesc.sStandCode; // Using low_param_code for 1 character standcode (for now until we make a dedicated table for this )
                                    vts.TP_TEXT = _sUserName;// don't stomp on another user of this hijacked db table...
                                    vts.MODEL_CODE = tdesc.sModelCode;
                                    vts.FAMILY_ID = Convert.ToInt16(tdesc.sFamilyId);
                                    vts.STAND_CODE = tdesc.sSerialCode; // using stand_code ( which can hold 10 chars ) for serial code (for now until we make a dedicated table for this )
                                    // The rest of the fields in vst really don't matter
                                    vts.TP_ID = 0; // tp_ids will be joined in via VAR_TREND_SUM_TEMP table

                                    m_serviceAgent.vInsertTempPGTestData(m_iCurrContext, vts, null, false);
                                }

                                m_serviceAgent.vSubmitChanges(m_iCurrContext, (error2) =>
                                {
                                    if (error2 == null)
                                    {

#if USE_VAR_TREND_SUM_TEMP                
                                        m_serviceAgent.vClearTempPGTpData(m_iCurrContext);
                                        VAR_TREND_SUM_TEMP vtst = null;
                                        DateTime dtNow = DateTime.Now;
                                        foreach (decimal dId in _lstTPIds)
                                        {
                                            vtst = new VAR_TREND_SUM_TEMP();
                                            vtst.TP_ID = dId;                        
                                            vtst.TP_TEXT = _sUserName;// don't stomp on another user of this hijacked db table...
                                            // The rest of the fields in vst really don't matter
                                            vtst.DATA_DTS = dtNow;
                                            vtst.STAND_CODE = "1234567890";
                                            vtst.MODEL_CODE = "1234567890"; // meaningless
                                            vtst.FAMILY_ID = 1;
                                            m_serviceAgent.vInsertTempPGTpData(m_iCurrContext, vtst, null, false);
                                        }
#else
                                        m_serviceAgent.vClearTempPGTpData2(m_iCurrContext);
                                        DateTime dtNow = DateTime.Now;
                                        DateTime dtTime = dtNow;
                                        foreach (decimal dId in _lstTPIds)
                                        {
                                            AUDIT_DEFN ad = new AUDIT_DEFN();                                            
                                            ad.AUDIT_DEFN_REV_DTS = dtTime;// .AddTicks(1); // dtNow; //rev dts and table name make up key and I am processing too fast and getting same rev dts
                                            dtTime = dtTime.AddSeconds(1);
                                            ad.TABLE_NAME = _sUserName;
                                            ad.SHIFT_ID = dId;
                                            // Remaining not important
                                            ad.USER_ID = "x";
                                            ad.REASON = "x";
                                            m_serviceAgent.vInsertTempPGTpData2(m_iCurrContext, ad, null, false);
                                        }
#endif

                                        m_serviceAgent.vSubmitChanges(m_iCurrContext, (error3) =>
                                        {
                                            if (error3 == null)
                                            {
                                                m_serviceAgent.vLoadTPPivotGridData(m_iCurrContext, _sUserName,
                                                                        (entities, error4) =>
                                                                        {
                                                                            if (error4 == null)
                                                                            {
                                                                                ocTPPivotGridData = new ObservableCollection<TPPivotGridData>(entities);
                                                                                if (ocTPPivotGridData.Count <= 0)
                                                                                {
                                                                                    //if in batch mode, don't display message box, just don't generate chart
                                                                                    if (!_bBatchMode)
                                                                                        vNotifyError("No test point pivot results", null);
                                                                                    else
                                                                                    {   // notify view to show blank report
                                                                                        Notify(evShowTPPivotGridData, new NotificationEventArgs<TPDescriptor>(MessageTokens.sNO_DATA, oTPDescriptor));
                                                                                    }
                                                                                }
                                                                                else
                                                                                {
                                                                                    //notify view to show report
                                                                                    Notify(evShowTPPivotGridData, new NotificationEventArgs<TPDescriptor>("some message", oTPDescriptor));
                                                                                }
                                                                            }
                                                                            else
                                                                            {
                                                                                vNotifyError("Error retrieving test point pivot results: " + error4.Message.ToString(), null);
                                                                            }
                                                                            if (!_bBatchMode) bIsBusy = false;
                                                                        }
                                                  );
                                            }
                                            else
                                            {
                                                bIsBusy = false;
                                                vNotifyError("Error collecting tp data: " + error3.Message.ToString(), null);
                                            }
                                        });
                                         
                                    }
                                    else
                                    {
                                        bIsBusy = false;
                                        vNotifyError("Error collecting tp data: " + error2.Message.ToString(), null);
                                    }
                                }
                                );
                                #endregion A

                            }, true
            );        
        }
        #region Completion Callbacks
        //private void cbfLoadTPPivotGridDataComplete(List<WMAApp.Web.Models.TPPivotGridData> _entities, Exception _exError)
        //{
        //    // If no error is returned, set the model to entities
        //    if (_exError == null)
        //    {
        //        ocTPPivotGridData = new ObservableCollection<WMAApp.Web.Models.TPPivotGridData>(_entities);
        //    }
        //    // Otherwise notify view that there's an error
        //    else
        //    {
        //        vNotifyError("Unable to retrieve test point pivot data", _exError);
        //    }

        //    // Make the testpoint pane the active one.

        //    // We're done
        //    bIsBusy = false;
        //}
        #endregion Completion Callbacks
        #endregion TP Pivot Grid

        #endregion PDB

        #endregion Methods

        #region Event Handlers

        #region Filtration
        public void vOnDbSelectionChanged(object sender, NotificationEventArgs<ObservableCollection<DbConnection>> e)
        {           
            //DbSelectClosed(sender, e.Data); 
            string sConnections = "";

            ObservableCollection<DbConnection> ocConnections = e.Data;
            foreach (DbConnection dbConn in ocConnections) //? dbsVM.Connections)
            {
                if (dbConn.boSelected)
                {
                    sConnections += dbConn.sConnString + ",";
                }
            }

            if (sConnections.Length > 0)
            {
                sConnections = sConnections.Substring(0, sConnections.Length - 1);
                vSetDbConnection(sConnections);
                vLoadFilters();
            }
            else
            {
                // clear out everything due to no connection
            }
            
        }

        public void OnChangeFamilySel()
        {
            if (SelectedFamily != null)
            {
                sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
                bIsBusy = true;
                m_serviceAgent.vLoadActiveModels(m_iCurrContext, _selectedFamily.iFamilyId, (entities, error) => cbfLoadModelsComplete(entities, error));
            }
        }

        public void ProcessComboBoxEntries(XamMultiColumnComboEditor cmb, string sSelected, ModelDef md, StandDef sd)
        {
            string sText = "";

            if (cmb.SelectedItems.Count > 0)
            {
                if (sSelected == "All")
                {
                    for (int i = 0; i < cmb.SelectedItems.Count; i++)
                    {
                        if (md != null)
                        {
                            md = (ModelDef)cmb.SelectedItems[i];
                            sText = md.sModelName;
                        }
                        else
                        {
                            sd = (StandDef)cmb.SelectedItems[i];
                            sText = sd.sStandCode;
                        }

                        if (sText == "All")
                        {
                            cmb.SelectedItems.Clear();
                            if (md != null)
                                cmb.SelectedItems.Add(md);
                            else
                                cmb.SelectedItems.Add(sd);

                            break;
                        }
                    }
                }
                else
                {
                    for (int i = 0; i < cmb.SelectedItems.Count; i++)
                    {
                        if (md != null)
                        {
                            md = (ModelDef)cmb.SelectedItems[i];
                            sText = md.sModelName;
                        }
                        else
                        {
                            sd = (StandDef)cmb.SelectedItems[i];
                            sText = sd.sStandCode;
                        }

                        if (sText == "All")
                        {
                            if (md != null)
                                cmb.SelectedItems.Remove(md);
                            else
                                cmb.SelectedItems.Remove(sd);
                        }
                    }
                }
            }

        }

        public void OnChangeStandSel(XamMultiColumnComboEditor cmb)
        {
            ProcessComboBoxEntries(cmb, SelectedStand.sStandCode, null, new StandDef());
        }

        public void OnChangeModelsSel(XamMultiColumnComboEditor cmb)
        {
            ProcessComboBoxEntries( cmb, SelectedModel.sModelName, new ModelDef(), null);
        }

        public void OnSaveFilter()
        {
            MBX_TOP MbxTop = new MBX_TOP();

            MbxTop.MBX_SAKEY = -1;
            MbxTop.OSUSER = WebContext.Current.User.Name.ToString();
            MbxTop.MACHINE = "CUSMA-03";
            MbxTop.REPORT = "FUL_REP";
            MbxTop.SETUP_NAME = "Test Setup";
            MbxTop.START_DATA_TIME = dtStartDate + dtStartTime.TimeOfDay;
            MbxTop.END_DATA_TIME = dtEndDate + dtEndTime.TimeOfDay;
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;
            m_serviceAgent.vInsertMbxTop(m_iCurrContext, MbxTop, (entities, error) => vSaveMbxTopComplete(entities, error), true );
        }
        #endregion Filtration
        #region Tests

        private void vRemoveStatus( List<int> lStatusList, int iStatusCode )
        {
            lStatusList.Sort();

            int iIndex = lStatusList.BinarySearch(iStatusCode);
            if (iIndex > 0) lStatusList.Remove(iIndex);
        }

        public void evhGetProductData( XamMultiColumnComboEditor cmbStands,
                                       XamMultiColumnComboEditor cmbFamilys,
                                       XamMultiColumnComboEditor cmbModels )
        {
            // Populated the selected stands list

            ocSelStandDefns.Clear();

            foreach (StandDef sd in cmbStands.SelectedItems)
            {
                ocSelStandDefns.Add(sd);
            }

            ocSelModelDefns.Clear();

            foreach (ModelDef md in cmbModels.SelectedItems)
            {
                ocSelModelDefns.Add(md);
            }

            // Populate the selected families list

            ocSelFamilyDefns.Clear();

            foreach (FamilyDef fd in cmbFamilys.SelectedItems)
            {
                ocSelFamilyDefns.Add(fd);
            }

            // build a list of ints representing the test status that were checked

            List<int> lTestStatus = new List<int>();
            List<int> lFirstTest = new List<int>();
            List<int> lLastTest = new List<int>();

            if (boFirstTests) lFirstTest.Add(1);

            if (boAccepts)
                lTestStatus.Add(4);

            if (boRejects)
                lTestStatus.Add(5);

            if (boAborts)
                lTestStatus.Add(6);

            // build a list of status to be used for last test only

            if (boLastTests)
            {
                lLastTest.Add(12); // Next Accept
                lLastTest.Add(13); // Next Reject
            }

            // All Tests

            if (boAllTests)
            {
                vRemoveStatus(lFirstTest, 1);
                vRemoveStatus(lLastTest, 12);
                vRemoveStatus(lLastTest, 13);
            }

            // Tell the user we are working
            sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;

            // Reset property
            oceProductData = null;           
            
            // Figure out time range

            DateTime dtStart;
            DateTime dtEnd;

            if (boByPrevious)
            {
                dtStart = dtCalculateDate(DateTime.Now, false);
                dtEnd = dtCalculateDate(DateTime.Now, true);
            }
            else
            {
                dtStart = dtCalculateDate(DateTime.Now, false);
                dtEnd = DateTime.Now;
            }

            if (boByCustom)
            {
                dtStart = dtStartDate + dtStartTime.TimeOfDay;
                dtEnd = dtEndDate + dtEndTime.TimeOfDay;
            }
            else
            {
                dtStartDate = dtStart.Date;
                dtStartTime = dtStart.ToLocalTime();
            }
            
            m_serviceAgent.vLoadProductData(m_iCurrContext,
                                            dtStart,
                                            dtEnd,
                                            ocSelFamilyDefns.ToList(),
                                            ocSelStandDefns.ToList(),
                                            ocSelModelDefns.ToList(),
                                            lFirstTest,
                                            lTestStatus,
                                            lLastTest,
                                            true, //bTestListRetrieveRejectInfo,
                                            (entities, error) => cbfLoadProductDataComplete(entities, error));

        }

        DateTime dtCalculateDate( DateTime dtTime, Boolean boEnd )
        {
            DateTime dtNew = dtTime;

            if (boHour)
            {
                dtNew = dtNew.Subtract(new TimeSpan(0, dtTime.Minute, dtTime.Second));

                if (!boEnd)
                {
                    if (boByPrevious)
                        dtNew = dtNew.AddHours(-1 * (iNoOfInterval + 1));
                    else
                        dtNew = dtNew.AddHours(-1 * iNoOfInterval);
                }
            }
            else if (boShift)
            {
                int i = 0;
                // Find current shift
                while (!((dtNew.TimeOfDay >= lShifts[i].START_TIME.TimeOfDay) && 
                            (dtNew.TimeOfDay <= lShifts[i].END_TIME.TimeOfDay)) && ( i < lShifts.Count ))
                {
                    i++;
                }

                if (i < lShifts.Count)
                {
                    if (boByPrevious)
                    {
                        i -= 1;
                        if (i < 0) i = lShifts.Count - 1;

                        dtNew = lShifts[i].START_TIME;
                    }
                    else
                        dtNew = lShifts[i].START_TIME;

                    // rip through the shift defs and subtract the hours diff off the starting time

                    if (iNoOfInterval > 0)
                    {
                        int iCount = 0;
                        while (iCount < iNoOfInterval)
                        {
                            // adjust shift def index
                            if (i < lShifts.Count)
                                i++;
                            else
                                i = 0;

                            // subtract curr shift hours from start time
                            dtNew = dtNew.AddHours( -1 * Math.Abs((lShifts[i].END_TIME - lShifts[i].START_TIME).Hours));
                        }
                    }
                }
                else
                {
                    MessageBox.Show( "No valid shift could be found, check shift definitions." );
                }
            }
            else if (boDay)
            {
                dtNew = dtNew.Subtract(new TimeSpan(dtTime.Hour, dtTime.Minute, dtTime.Second));

                if (!boEnd)
                {
                    if (boByPrevious)
                        dtNew = dtNew.AddDays(-1 * (iNoOfInterval + 1));
                    else
                        dtNew = dtNew.AddDays(-1 * iNoOfInterval);
                }
            }
            else if (boWeek)
            {
                dtNew = dtNew.Subtract(new TimeSpan(dtTime.Hour, dtTime.Minute, dtTime.Second));
                // Go back to the beginning of the week
                dtNew = dtNew.AddDays(-1 * ((int)dtNew.DayOfWeek - 1));

                if (!boEnd)
                {
                    if (boByPrevious)
                        // Go back the specified number of weeks
                        dtNew = dtNew.AddDays( -7 * (iNoOfInterval+1) );
                    else
                        // Go back the specified number of weeks
                        dtNew = dtNew.AddDays( -7 * iNoOfInterval );
                }
            }
            else if (boMonth)
            {
                dtNew = dtNew.Subtract(new TimeSpan(dtTime.Hour, dtTime.Minute, dtTime.Second));
                // Go back to begining of the month
                dtNew = dtNew.AddDays(-1 * (dtNew.Day-1) );
                if (!boEnd)
                {
                    if (boByPrevious)
                        // Go back requested number of months
                        dtNew = dtNew.AddMonths(-1 * (iNoOfInterval+1));
                    else
                        // Go back requested number of months
                        dtNew = dtNew.AddMonths(-1 * iNoOfInterval);
                }
            }

            return dtNew;
        }

        #endregion Tests
        #region Test results
        public void vGetTestResults(TestDescriptor _oTestDescriptor, bool _bBatchMode = false) 
        {
            if ( !_bBatchMode ) sBusyText = ApplicationStrings.BusyIndicatorPleaseWait;
            bIsBusy = true;
            ocTestData = null;
            // remember data passed in so that it can be used when ResultsComplete calls back view method.           
            oTestDescriptor = _oTestDescriptor;

#if DO_DIRECT_SQL
            //object[] sqlParams = { oTestDescriptor.sTestTime, oTestDescriptor.sStandCode };
            string sSql =
                    " SELECT T3.THREAD_NUM as iThreadNum, T3.PHASE_ID as iPhaseId, T3.PHASE_TEXT as sPhase, T3.STEP_ID as iStepId, T3.STEP_TEXT as sStep, T3.TP_ID as dId, T3.TP_TEXT as sText, " +
                    "  TO_NUMBER(TO_CHAR(FN_GET_LIMIT(PD.MAX_PARAM_VAL_REV_DTS, case PTPDL.PARAM_CODE when 'M' then PD.MODEL_CODE when 'S' then PD.STAND_CODE end, PTPDL.PARAM_CODE, PTPDL.PARAM_ID),T3.FORMAT_SPECIFIER_TEXT)) dFormattedLowLimit, " +
                    "  TO_NUMBER(TO_CHAR(T3.TP_QTY,T3.FORMAT_SPECIFIER_TEXT)) dFormattedValue, " +
                    "  TO_NUMBER(TO_CHAR(FN_GET_LIMIT(PD.MAX_PARAM_VAL_REV_DTS, case PTPDH.PARAM_CODE when 'M' then PD.MODEL_CODE when 'S' then PD.STAND_CODE end, PTPDH.PARAM_CODE, PTPDH.PARAM_ID),T3.FORMAT_SPECIFIER_TEXT)) dFormattedHighLimit, " +
                    "  UT.UNITS_TEXT as sUnits, T3.PHASE_ORDER_NUM as iPhaseOrderNum, T3.STEP_ORDER_NUM as iStepOrderNum" +
                    #if SUPPORT_CHART_LAUNCH_FROM_FUL_REP
                    " , PD.TEST_DTS as dtTestTime, PD.STAND_CODE as StandCode, T3.TP_DEFN_SAKEY as dTpDefnSakey " +
                    #endif
                    " FROM " +
                    " ( SELECT " +
                    "		T2. *, " +
                    "       CASE WHEN PSI.THREAD_NUM IS NULL THEN TO_NUMBER('9') ELSE PSI.THREAD_NUM END AS THREAD_NUM, " +
                    "       CASE WHEN PSI.PHASE_ORDER_NUM IS NULL THEN TO_NUMBER('99999') ELSE PSI.PHASE_ORDER_NUM END AS PHASE_ORDER_NUM, " +
                    "       CASE WHEN PSI.STEP_ORDER_NUM IS NULL THEN TO_NUMBER('99999') ELSE PSI.STEP_ORDER_NUM END AS STEP_ORDER_NUM, " +
                    "       CASE WHEN PSI.PHASE_ID IS NULL THEN T2.PHASE_ID_DIS ELSE PSI.PHASE_ID END AS PHASE_ID, " +
                    "       CASE WHEN PSI.STEP_ID IS NULL THEN T2.STEP_ID_DIS ELSE PSI.STEP_ID END AS STEP_ID, " +
                    "       CASE WHEN PSI.PHASE_TEXT IS NULL THEN T2.PHASE_TEXT_DIS ELSE PSI.PHASE_TEXT END AS PHASE_TEXT, " +
                    "       CASE WHEN PSI.STEP_TEXT IS NULL THEN T2.STEP_TEXT_DIS ELSE PSI.STEP_TEXT END AS STEP_TEXT " +
                    "   FROM " +
                    " 	    ( SELECT T2A.*, T2B.* " +
	                "  	      FROM " +
	                "	    		(SELECT  " +
	                "	    	    	TPD.TP_DEFN_SAKEY, TPD.TP_QTY, TPT.TEST_TEXT PHASE_TEXT_DIS, TPT.TEST_TEXT_ID PHASE_ID_DIS, " +
	                "			    	TPDEF.PHASE_PHRASE_SAKEY, TPDEF.TP_ID, TPDEF.TP_TEXT, TPDEF.UNITS_TEXT_SAKEY, TPDEF.FORMAT_SPECIFIER_TEXT " +
	                "				FROM TP_DATA TPD, TP_DEFN TPDEF, TEST_TEXT TPT " +
	                "				WHERE TPD.TEST_DTS = to_date('{0}' , 'mm/dd/yyyy hh:mi:ss am') AND TPD.STAND_CODE = '{1}'" +
	                "               	AND TPD.TP_DEFN_SAKEY = TPDEF.TP_DEFN_SAKEY AND TPT.TEST_TEXT_SAKEY(+) = TPDEF.PHASE_PHRASE_SAKEY " +
	                "				) T2A," +
	                "	    		(SELECT  " +
	                "	    	    	TPDEF.TP_ID MY_ID, TST.TEST_TEXT STEP_TEXT_DIS, TST.TEST_TEXT_ID STEP_ID_DIS, TPDEF.STEP_PHRASE_SAKEY " +
	                "				FROM TP_DATA TPD, TP_DEFN TPDEF, TEST_TEXT TST " +
	                "				WHERE TPD.TEST_DTS = to_date('{0}' , 'mm/dd/yyyy hh:mi:ss am') AND TPD.STAND_CODE = '{1}'" +
	                "               	AND TPD.TP_DEFN_SAKEY = TPDEF.TP_DEFN_SAKEY AND TST.TEST_TEXT_SAKEY(+) = TPDEF.STEP_PHRASE_SAKEY " +
	                "				) T2B	" +
	                "  		  WHERE " +
	                "				T2A.TP_ID = T2B.MY_ID " +
	                "		) T2,  " +
                    "	    ( SELECT " +
                    "		   	PSO.THREAD_NUM, PSO.PHASE_ORDER_NUM, PSO.STEP_ORDER_NUM, PSO.PHASE_PHRASE_SAKEY, PSO.STEP_PHRASE_SAKEY, " +
                    "		    TPT.TEST_TEXT PHASE_TEXT, TPT.TEST_TEXT_ID PHASE_ID, " +
                    "           TST.TEST_TEXT STEP_TEXT, TST.TEST_TEXT_ID STEP_ID  " +
                    "       FROM" +
                    "           PHASE_STEP_ORDER PSO, TEST_TEXT TPT, TEST_TEXT TST " +
                    "       WHERE " +
                    "	        PSO.TEST_DTS(+) = to_date('{0}' , 'mm/dd/yyyy hh:mi:ss am') AND PSO.STAND_CODE(+) = '{1}' AND " +
                    "	        TPT.TEST_TEXT_SAKEY(+) = PSO.PHASE_PHRASE_SAKEY AND TST.TEST_TEXT_SAKEY(+) = PSO.STEP_PHRASE_SAKEY " +
                    "       ) PSI " +
                    "    WHERE " +
                    "		T2.PHASE_PHRASE_SAKEY = PSI.PHASE_PHRASE_SAKEY(+) AND T2.STEP_PHRASE_SAKEY = PSI.STEP_PHRASE_SAKEY(+)  " +
                    " ) T3," +
                    " UNITS_TEXT UT, " +
                    " PARAM_TP_DEFN PTPDL, " +
                    " PARAM_TP_DEFN PTPDH, " +
                    " ( SELECT " +
                    "       PD.TEST_DTS, PD.STAND_CODE, PD.MODEL_CODE, PD.MAX_PARAM_DEFN_REV_DTS, PD.MAX_PARAM_VAL_REV_DTS " +
                    "   FROM " +
                    "       PRODUCT_DATA PD " +
                    "   WHERE " +
                    "		PD.TEST_DTS = to_date('{0}' , 'mm/dd/yyyy hh:mi:ss am') AND PD.STAND_CODE = '{1}' " +
                    " )PD " +
                    " WHERE T3.UNITS_TEXT_SAKEY = UT.UNITS_TEXT_SAKEY AND " +
                    "		PTPDL.TP_DEFN_SAKEY(+) = T3.TP_DEFN_SAKEY AND PTPDL.LIMIT_CODE(+) = 'L' AND " +
                    "		PTPDH.TP_DEFN_SAKEY(+) = T3.TP_DEFN_SAKEY AND PTPDH.LIMIT_CODE(+) = 'H' " +
                    " ORDER BY " +
                    "       THREAD_NUM, PHASE_ORDER_NUM, STEP_ORDER_NUM, TP_ID ";

                    //m_serviceAgent.vExecuteQueryGetTestResults(m_iCurrContext, sSql, sqlParams, (entities, error) => cbfLoadTestResultsComplete(entities, error));
                    //m_serviceAgent.vExecuteQueryGetTestResults(m_iCurrContext, sSql, oTestDescriptor.sTestTime, oTestDescriptor.sStandCode, 
                    //    (entities) => cbfLoadTestResultsCompleteEx(entities));
            
                    m_serviceAgent.vExecuteQueryGetTestResults(m_iCurrContext, sSql, oTestDescriptor.sTestTime, oTestDescriptor.sStandCode, 
                        (entities) => {                            
                            if (entities.Error == null)
                            {
                                ocTestData = new ObservableCollection<TestData>(entities.Value);
                                if (ocTestData.Count <= 0)
                                {
                                    // if in batch mode, don't display message box, just don't generate report
                                    if (!_bBatchMode)
                                        vNotifyError("No test results", null);
                                    else
                                    {   // notify view to show blank report
                                        Notify(evShowFullRep, new NotificationEventArgs<TestDescriptor>(MessageTokens.sNO_DATA, oTestDescriptor));
                                    }
                                }
                                else
                                {
                                    // notify view to show full report
                                    Notify(evShowFullRep, new NotificationEventArgs<TestDescriptor>("some message", oTestDescriptor));
                                }
                            }
                            else
                            {
                                vNotifyError("Error retrieving test results: " + entities.Error.Message.ToString(), null);
                            }
                            if ( !_bBatchMode)  bIsBusy = false;
                        }
                    );
#else
            m_serviceAgent.vLoadTestResults(m_iCurrContext, oTestDescriptor.dtTestTime, oTestDescriptor.sStandCode, 
                                            (entities, error) => cbfLoadTestResultsComplete(entities, error));
#endif // DO_DIRECT_SQL
        }        
        #endregion Test results
       
        #region Mbx
        private void vSaveMbxTopComplete(List<MBX_TOP> _entities, Exception _exError)
        {
            // If no error is returned, set the family to entities
            if (_exError == null)
            {
                //  dbMbxTops = new ObservableCollection<MBX_TOP>(_entities);

            }
            // Otherwise notify view that there's an error
            else
            {
                vNotifyError("Unable to save MbxTop definition", _exError);
            }

            // We're done
            bIsBusy = false;
        }
        #endregion Mbx
        #endregion Event Handlers

        //not used private void vGetProductData(DateTime _dtStart, DateTime _dtEnd)
        //{
        //    bIsBusy = true;

        //    // Reset property
        //    oceProductData = null;

        //    m_serviceAgent.vLoadProductDataWStatAndRej(m_iCurrContext, dtStartDate + dtStartTime.TimeOfDay, dtEndDate,
        //                                            (entities, error) => cbfLoadProductDataComplete(entities, error));

        //}
       
        #region Completion Callbacks
        #region Filtration
        // Add callback methods for async calls to the service agent
        private void cbfLoadFamilyDefnsComplete(List<FAMILY_DEFN> _entities, Exception _exError)
        {
            // If no error is returned, set the family to entities
            if (_exError == null)
            {
                oceFamilyDefns = new ObservableCollection<FAMILY_DEFN>(_entities);

                if (ocFamilyDefns.Count > 0) ocFamilyDefns.Clear();

                foreach (FAMILY_DEFN fd in oceFamilyDefns) 
                {
                    ocFamilyDefns.Add(new FamilyDef(fd.FAMILY_TEXT, (int)fd.FAMILY_ID));

                    if (WebContext.Current.User.DefaultFamilySelection == fd.FAMILY_ID)
                    {
                        SelFamIndex = ocFamilyDefns.Count - 1;
                    }
                }
            }
            // Otherwise notify view that there's an error
            else
            {
                vNotifyError("Unable to retrieve FAMILY definitions", _exError);
            }

            // We're done
            bIsBusy = false;
        }

        private void cbfLoadShiftsDefnsComplete(List<SHIFT_DEFN> _entities, Exception _exError)
        {
            if (_exError == null)
            {
                lShifts = new List<SHIFT_DEFN>(_entities);
            }
            else
            {
                vNotifyError( "Unable to retrieve SHIFT definitions", _exError);
            }
        }

        // Add callback methods for async calls to the service agent
        private void cbfLoadStandDefnsComplete(List<STAND_DEFN> _entities, Exception _exError)
        {
            // If no error is returned, set the stand to entities
            if (_exError == null)
            {
                oceStandDefns = new ObservableCollection<STAND_DEFN>(_entities);
                if (ocStandDefns.Count > 0) ocStandDefns.Clear();

                ocStandDefns.Insert(0, new StandDef("All", "", -1, true));
                SelStandIndex = 0;

                foreach (STAND_DEFN sd in oceStandDefns)
                {
                    ocStandDefns.Add(new StandDef(sd.STAND_CODE, sd.BT_CODE, (int)sd.STAND_NUMBER, false));
                    if (WebContext.Current.User.DefaultStandSelection == sd.STAND_NUMBER)
                    {
                        SelStandIndex = ocStandDefns.Count - 1;
                    }
                }

            }
            // Otherwise notify view that there's an error
            else
            {
                vNotifyError("Unable to retrieve STAND definitions", _exError);
            }

           
            // We're done
            bIsBusy = false;
        }
        private void cbfLoadModelsComplete(List<ModelDefData> _entities, Exception _exError)
        {
            // If no error is returned, set the model to entities
            if (_exError == null)
            {
                oceModelDefns = new ObservableCollection<ModelDefData>(_entities);
                if (ocModelDefns.Count > 0) ocModelDefns.Clear();

                // Insert an All for selection purposes

                ocModelDefns.Insert(0, new ModelDef("All", "All Models", true)); //todo: make resource string for All
                SelModelIndex = 0;

                foreach (ModelDefData mdc in oceModelDefns)
                {
                    ocModelDefns.Add(new ModelDef(mdc.sModelName, mdc.sModelText, false));
                    if (WebContext.Current.User.DefaultModelSelection == mdc.sModelName)
                    {
                        SelModelIndex = ocModelDefns.Count - 1;
                    }
                }
            }
            // Otherwise notify view that there's an error
            else
            {
                vNotifyError("Unable to retrieve MODEL definitions", _exError);
            }

            // We're done
            bIsBusy = false;
        }
        #endregion Filtration

        private void cbfLoadTestResultsComplete(List<TestData> _entities, Exception _exError )
        {
            if (_exError == null)
            {
                ocTestData = new ObservableCollection<TestData>(_entities);

                if (ocTestData.Count <= 0)
                {
                    vNotifyError("No test record Found", _exError);
                }
                else
                {
                    // notify view to show full report
                    Notify(evShowFullRep, new NotificationEventArgs<TestDescriptor>("some message", oTestDescriptor));
                }

            }
            else
            {
                vNotifyError("Unable to retrieve test data", _exError);
            }
        }

        private void cbfLoadProductDataComplete(List<PRODUCT_DATA> _entities, Exception _exError)
        {
            // If no error is returned, set the model to entities
            if (_exError == null)
            {
                oceProductData = new ObservableCollection<PRODUCT_DATA>(_entities);
                if (oceProductData.Count <= 0)
                {
                    vNotifyError("No Product data", _exError);
                }
                else
                {
                    if (ocTests.Count > 0) ocTests.Clear();
                    string sStatus;

                    foreach (PRODUCT_DATA pd in oceProductData)
                    {                        
                        sStatus = "";

                        // TODO: can't we use some built in function like .contains(..)???
                        foreach (PRODUCT_DATA_STAT pds in pd.PRODUCT_DATA_STAT)
                        {
                            //  sStatus += pds.PRODUCT_DATA_STAT_ID.ToString() + ",";
                            sStatus = pds.PRODUCT_DATA_STAT_ID.ToString();
                            if (sStatus == sACCEPT_STATUS_CODE || sStatus == sREJECT_STATUS_CODE) break;
                        }
                        #if SUPPORT_TEST_LIST_BANDS
                            ocTests.Add(new ProductData(pd.FAMILY_ID.ToString(), pd.TEST_DTS, pd.STAND_CODE, pd.MODEL_CODE, pd.SERIAL_CODE, sStatus,
                                                        pd.PRODUCT_DATA_STAT.ToList(), pd.PRODUCT_DATA_REJ.ToList()));
                        #else
                            ocTests.Add(new ProductData(pd.FAMILY_ID.ToString(), pd.TEST_DTS, pd.STAND_CODE, pd.MODEL_CODE, pd.SERIAL_CODE, sStatus));
                        #endif

                    }

#if SUPPORT_UNDO_REDO
                    _oProductDataURVM.UndoManager.ClearHistory();
                    _oProductDataURVM.LoadData(ocTests);
#endif
                    Notify(evSetupBindings, new NotificationEventArgs()); // seems odd, but I have to do this each time or it doesn't update
                }
            }
            // Otherwise notify view that there's an error
            else
            {
                vNotifyError("Unable to retrieve Product data", _exError);
            }
            
            // go get the test point definitions for convenience
            vRetrieveTPDefns();
            
            // We're done
            bIsBusy = false;
        }

        #endregion

        #region Notifications
        // Communication between viewModel and view.
        #region General
        // Add events to notify the view or obtain data from the view
        public event EventHandler<NotificationEventArgs<Exception>> evErrorNotice;
        #endregion

        #region PDB
        public event EventHandler<NotificationEventArgs<object, bool>> evOverwritePDBNotice;
        public event EventHandler<NotificationEventArgs<object, bool>> evGeneralAcknowledgmentNotice; 
        public event EventHandler<NotificationEventArgs> evSetupBindings;
        public event EventHandler<NotificationEventArgs> evResetTestListTweaks; // clear filters, sorting, etc.
        public event EventHandler<NotificationEventArgs> evBuildVisibleTestList;
        public event EventHandler<NotificationEventArgs<TestDescriptor>> evShowFullRep;
        public event EventHandler<NotificationEventArgs<TPDescriptor>> evShowTPData;
        public event EventHandler<NotificationEventArgs<TPDescriptor>> evShowTPPivotGridData;
        public event EventHandler<NotificationEventArgs<TPDescriptor>> evShowTPLimitData;
        #endregion

        // notify view when to show myself
        //xx public event EventHandler<NotificationEventArgs> ShowNotice;
        //xxpublic event EventHandler<NotificationEventArgs<object, bool>> ShowNotice;

        #endregion

        #region Helpers

        // Helper method to notify View of an error
        private void vNotifyError(string _sMessage, Exception _exError)
        {
            // Notify view of an error
            Notify(evErrorNotice, new NotificationEventArgs<Exception>(_sMessage, _exError));
            //Notify(ErrorNotice, new NotificationEventArgs<Exception>(_message + _error.ToString(), _error));
        }

        #endregion
    }
}
