﻿using System;
using System.Net;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Data;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using WMAApp.ViewModels.Charts;
using WMAApp.Controls;
using Infragistics.Controls.Charts;
using Infragistics.Controls;
using Infragistics;
using Infragistics.Controls.Menus;
using System.Collections.ObjectModel;
using WMAApp.Web.Models;
using WMAApp.Views.Charts.Resources;
using System.Collections.Generic;
using System.Windows.Media.Imaging;
using System.IO;
using Infragistics.Imaging;
using MathNet.Numerics.Statistics;
using WMAApp.WMASharedClasses;

namespace WMAApp.Views.Charts
{
    public class ChartBaseV : UserControl
    {
        private XamDataChartEx m_xdcTheChart;
        private XamZoombar m_xzbTheZoombar;
        private string sContextMenuXDC;

        public string m_sTitle;
        private string m_sName;

        private decimal m_dPlotMin;
        private decimal m_dPlotMax;

        public ChartsVM m_vm;
        
        public ChartTypes m_ctType;

        #region Contruction

        public ChartBaseV(ChartTypes _ctType) : this()
        {
            this.m_ctType = _ctType;
        }

        public ChartBaseV()
        {
            m_vm = (ChartsVM)DataContext;
            if (m_vm == null) m_vm = new ChartsVM(m_ctType);

        }
        
        #endregion

        #region Properties

        public XamDataChartEx xdcTheChart
        {
            get { return m_xdcTheChart; }
            set { m_xdcTheChart = value; }
        }

        public string Title
        {
            get { return m_sTitle; }
            set { m_sTitle = value; }
        }

        public string sName
        {
            get { return m_sName; }
            set
            {
                m_sName = value;
            }
        }

        #endregion

        public void vSetupChart(ChartTypes ctType)
        {
            m_ctType = ctType;

            vSetupChart();
        }

        public void vSetupChart()
        {
            Grid grdParent = (Grid)this.Content;
            //RowDefinition rParentGridRow0 = grdParent.RowDefinitions[0];
            //Grid grdChart = (Grid)grdParent.Children[0];
            XamDataChart xdc = (XamDataChart)xdcTheChart;

            // the colors for the chart

            if ( xdc.Brushes.Count > 0 ) xdc.Brushes.Clear();

            switch (m_ctType)
            {
                case ChartTypes.ctTrend:
                    
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Red));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Red));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Orange)); 
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Yellow));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Green));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Blue));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Purple));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Gray));
            
                    Binding binding = new Binding
                    {
                        Source = m_vm.ocTPData
                    };

                    xdc.Axes["xdcXAxis"].SetBinding(CategoryDateTimeXAxis.ItemsSourceProperty, binding);

                    LineSeries ls = (LineSeries)xdc.Series[2];
//                    ls.Brush = new SolidColorBrush(Colors.Green);
//                    ls.MarkerBrush = ls.Brush;
                    ls.Name = "AllData";
                    ls.SetBinding(LineSeries.ItemsSourceProperty, binding);
                    break;

                case ChartTypes.ctHistogram:
                    
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Red));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Orange)); 
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Yellow));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Green));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Blue));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Purple));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Gray));
                    xdc.Brushes.Add(new SolidColorBrush(Colors.Black));
                    
                    m_vm.iNumberBars = 50;

                    break;

                case ChartTypes.ctScatter:
                    break;
                case ChartTypes.ctXBarR:
                    break;
            }

        }

        public void vAddLimitData(string sType, ObservableCollection<LimitData> _lData)
        {
            CategoryDateTimeXAxis currx = (CategoryDateTimeXAxis)xdcTheChart.Axes["xdcXAxis"];
            Boolean boNew = false;

            m_vm.vStoreLimitData(sType, _lData);

            Binding binding;
            int iAxis = 0;

            string sAxisName = sType + "lXAxis";

            if (sType == "L")
            {
                binding = new Binding
                {
                    Source = m_vm.ocLowLimit
                };
                iAxis = 1;
            }
            else
            {
                binding = new Binding
                {
                    Source = m_vm.ocHighLimit
                };
            }

            CategoryDateTimeXAxis lsX = (CategoryDateTimeXAxis)xdcTheChart.Axes[sAxisName];

            if (lsX == null)
            {
                lsX = new CategoryDateTimeXAxis();
                boNew = true;
            }

            lsX.DisplayType = TimeAxisDisplayType.Discrete;
            lsX.MinorStroke = currx.MinorStroke;
            lsX.MajorStroke = currx.MajorStroke;
            lsX.MinimumValue = currx.ActualMinimumValue;
            lsX.MaximumValue = currx.ActualMaximumValue;

            lsX.LabelSettings = new AxisLabelSettings { Location = AxisLabelsLocation.OutsideBottom };

            lsX.DateTimeMemberPath = currx.DateTimeMemberPath;
            lsX.SetBinding(CategoryDateTimeXAxis.ItemsSourceProperty, binding);
            lsX.Name = sAxisName;
            lsX.LabelSettings.Visibility = System.Windows.Visibility.Collapsed;

            LineSeries ls = (LineSeries)xdcTheChart.Series[iAxis];
            ls.SetBinding(LineSeries.ItemsSourceProperty, binding);
            ls.Name = sType + "Limit";
            ls.XAxis = lsX;
            if (ls.YAxis == null) ls.YAxis = (NumericYAxis)xdcTheChart.Axes["xdcYAxis"];

            if (sType == "L")
            {
                int iMin = (int)m_vm.ocLowLimit.Min(ll => ll.dParamQty);
                ls.YAxis.MinimumValue = iMin - Math.Abs((iMin * 0.1));
            }
            else
            {
                int iMax = (int)m_vm.ocHighLimit.Max(ll => ll.dParamQty);
                ls.YAxis.MaximumValue = iMax + Math.Abs((iMax * 0.1));
            }

//            ls.Brush = new SolidColorBrush(Colors.Red);
//            ls.MarkerBrush = ls.Brush;
            ls.DashArray = new DoubleCollection { 3.0, 3.0 };
            ls.DashCap = PenLineCap.Flat;
            

            if (boNew) xdcTheChart.Axes.Add(lsX);
        }

        public void vShowAllData()
        {
            LineSeries ls = (LineSeries)xdcTheChart.Series[2];

            while (xdcTheChart.Series.Count > 2)
            {
                xdcTheChart.Series.RemoveAt(xdcTheChart.Series.Count - 1);
            }
            while (xdcTheChart.Axes.Count > 4)
            {
                xdcTheChart.Axes.RemoveAt(xdcTheChart.Axes.Count - 1);
            }

            Binding binding = new Binding
            {
                Source = m_vm.ocTPData
            };

            LineSeries lsNew = new LineSeries();

            lsNew.SetBinding(LineSeries.ItemsSourceProperty, binding);
            lsNew.XAxis = (CategoryDateTimeXAxis)xdcTheChart.Axes["xdcXAxis"];
            lsNew.YAxis = (NumericYAxis)xdcTheChart.Axes["xdcYAxis"];
            lsNew.ToolTip = ls.ToolTip;
            //lsNew.Brush = new SolidColorBrush(Colors.Green);
            //lsNew.MarkerBrush = lsNew.Brush;
            lsNew.ValueMemberPath = "dTPQty";
            lsNew.Name = "AllData";
            lsNew.Title = ViewStrings.TestPointValues;
            lsNew.Legend = xdcTheChart.Series[0].Legend;
            xdcTheChart.Series.Add(lsNew);
        }

        public void vSetData(ObservableCollection<TPData> _Data)
        {
            m_vm.vStoreData(_Data);
        }

        public void vComputeChartMetrics( string sFilterType )
        {
            List<string> sFilter = new List<string>();

            switch (m_ctType)
            {
                case ChartTypes.ctHistogram:

                    sFilter = m_vm.GetFilterItems(sFilterType);

                    // this is where all the specific histogram code goes

                    //DescriptiveStatistics ds = new DescriptiveStatistics(m_vm.ocTPData.Select(x => (double)x.dTPQty).ToList());

                    // overall chart settings
                    double fDataMin = m_vm.ocTPData.Select(x => (double)x.dTPQty).Min();
                    fDataMin -= Math.Abs(fDataMin) * 0.10;
                    
                    double fDataMax = m_vm.ocTPData.Select(x => (double)x.dTPQty).Max();
                    fDataMax += fDataMax * 0.10;

                    double fWidth = (Math.Abs(fDataMax) - Math.Abs(fDataMin))/100.0;

                    m_vm.ocData.Clear();

                    if (xdcTheChart == null) xdcTheChart = new XamDataChartEx();

                    // allocate the histogram data area
                    for (int j = 0; j < m_vm.iNumberBars; j++)
                    {
                        m_vm.ocData.Add(new HistogramColumns());
                        m_vm.ocData[j].sRange = (fDataMin + (fWidth * j)).ToString("#.##") + "-" + (fDataMin + (fWidth * (j + 1))).ToString("#.##");
                        //m_vm.ocData[j].sRange = "Bin " + (j+1);

                        for (int i = 0; i < sFilter.Count; i++)
                        {
                            m_vm.ocData[j].lsGroups.Add(new HistogramGroup(i));
                        }
                    }

                    int iGroup = 0;

                    foreach (string sFilt in sFilter)
                    {
                        // create a group for filter each filter item with the specified number of buckets

                        if (sFilterType == "S")
                        {
                            List<double> tp = m_vm.ocTPData.Where(y => y.sStandCode == sFilt).Select(x => (double)x.dTPQty).ToList();
                            
                            foreach ( double value in tp )
                            {
                                int iBucket =  (int)(m_vm.ocData.Count * (( value - fDataMin ) / ( fDataMax - fDataMin)));

                                if ((iBucket > 0 ) && ( iBucket < m_vm.iNumberBars )) 
                                    m_vm.ocData[iBucket].lsGroups[iGroup].dCount++;
                            }

                            iGroup++;
                        }
//                        else if (sFilterType == "M")
//                        {
//                            data = new Histogram(m_vm.ocTPData.Where(y => y.sModel == sFilt).Select(x => (double)x.dTPQty).ToList(), 100);
//                            sTitle = sFilt;
//                        }
                    }

                    // Get the group by data resource from the views resource list, then populate it
                    // with the data for the chart

                    HistoChartData hcd =  (HistoChartData)Resources["data"];
                    if (hcd.Count > 0) hcd.Clear();

                    foreach (HistogramColumns hc in m_vm.ocData)
                    {
                        for (int i = 0; i < hc.lsGroups.Count; i++)
                        {
                            hcd.Add(new HistoData( hc.lsGroups[i].sLabel, (int)hc.lsGroups[i].dCount, hc.sRange ));
                        }
                    }

                    break;
            }

        }

        public void vShowTpByFilter(string sFilterType)
        {
            List<string> sFilter = new List<string>();
            // build a list of the stands
            foreach (TPData tp in m_vm.ocTPData)
            {
                if (sFilterType == "S")
                {
                    if (!sFilter.Contains(tp.sStandCode))
                    {
                        sFilter.Add(tp.sStandCode);
                    }
                }
                else if (sFilterType == "M")
                {
                    if (!sFilter.Contains(tp.sModel))
                    {
                        sFilter.Add(tp.sModel);
                    }
                }
            }

            sFilter.Sort();

            LineSeries ls = (LineSeries)xdcTheChart.Series[2];
            CategoryDateTimeXAxis currx = (CategoryDateTimeXAxis)xdcTheChart.Axes[0];

            //Find the data series and remove them
            // remove all series except low and high limit series
            int i = 0;
            while ( i < xdcTheChart.Series.Count )
            {
                if (xdcTheChart.Series[i].Name.Contains("Data"))
                {
                    xdcTheChart.Series.Remove(xdcTheChart.Series[i]);
                }
                else
                {
                    i++;
                }
            }

            // remove all extra axes, there should be initially 4, 1 for the Y and 3 for the X, data, low limit and high limit
            while (xdcTheChart.Axes.Count > 4)
            {
                xdcTheChart.Axes.RemoveAt(xdcTheChart.Axes.Count - 1);
            }

            List<Binding> bData = new List<Binding>();

            foreach (string sFilt in sFilter)
            {
                List<TPData> data = new List<TPData>();

                if (sFilterType == "S")
                {
                    data = (from tp in m_vm.ocTPData where tp.sStandCode == sFilt select tp).ToList();
                }
                else if (sFilterType == "M")
                {
                    data = (from tp in m_vm.ocTPData where tp.sModel == sFilt select tp).ToList();
                }

                Binding binding = new Binding
                {
                    Source = data
                };
                bData.Add(binding);

                currx = (CategoryDateTimeXAxis)xdcTheChart.Axes["xdcXAxis"];

                CategoryDateTimeXAxis lsX = new CategoryDateTimeXAxis();
                lsX.DisplayType = TimeAxisDisplayType.Discrete;
                lsX.MinorStroke = currx.MinorStroke;
                lsX.MajorStroke = currx.MajorStroke;
                lsX.MinimumValue = currx.ActualMinimumValue;
                lsX.MaximumValue = currx.ActualMaximumValue;

                lsX.LabelSettings = new AxisLabelSettings { Location = AxisLabelsLocation.OutsideBottom };

                lsX.DateTimeMemberPath = currx.DateTimeMemberPath;
                lsX.SetBinding(CategoryDateTimeXAxis.ItemsSourceProperty, bData[bData.Count - 1]);
                lsX.Name = sFilt + "XAxis";
                lsX.LabelSettings.Visibility = System.Windows.Visibility.Collapsed;
                xdcTheChart.Axes.Add(lsX);

                LineSeries lsNew = new LineSeries();
                lsNew.SetBinding(LineSeries.ItemsSourceProperty, bData[bData.Count - 1]);
                lsNew.ToolTip = ls.ToolTip;
                lsNew.Name = sFilterType + sFilt + "Data";
                lsNew.XAxis = lsX;
                lsNew.YAxis = (NumericYAxis)xdcTheChart.Axes["xdcYAxis"];
                lsNew.ValueMemberPath = "dTPQty";
                if (sFilterType == "S")
                    lsNew.Title = "Stand " + sFilt;
                else
                    lsNew.Title = sFilt;

                lsNew.Legend = xdcTheChart.Series[0].Legend;

                xdcTheChart.Series.Add(lsNew);
            }
        }

        public void vChartLoaded(object _sender, RoutedEventArgs _evArgs)
        {
            // remember reference to the chart.
            m_xdcTheChart = _sender as XamDataChartEx;
            m_xdcTheChart.Title = Title;
        }
        
        public void vSetTitle(string _sTitle)
        {
            this.Title = _sTitle;
        }

        #region Context Menu
        public void vChartItemClicked(object _sender, ItemClickedEventArgs _evArgs)
        {
            // menu level click handler
            // IG:95417 Make context menu invisibible when item is choosen until IG bug is fixed. 
            Infragistics.Controls.Charts.XamDataChart xdc = m_xdcTheChart;// m_oHomeV.dmPDB.FindName(sContextMenuXDC) as XamDataChart;
            if (xdc != null)
            {
                Infragistics.Controls.Menus.ContextMenuManager cmMgr = Infragistics.Controls.Menus.ContextMenuService.GetManager(xdc);
                cmMgr.ContextMenu.Visibility = System.Windows.Visibility.Collapsed;
            }
        }

        public void vContextMenuOpening(object _sender, OpeningEventArgs _evArgs)
        {
            XamContextMenu xcm = (XamContextMenu)_sender;

            // Determine the type of control on which the context menu has been activated
            var oControlType = xcm.PlacementTargetResolved;

            switch (oControlType.GetType().ToString())
            {
                case "WMAApp.Controls.XamDataChartEx":
                case "WMAApp.Controls.XamDataChart":
                case "Infragistics.Controls.Charts.xdcTrendChart":
                    XamDataChart xdc = xcm.PlacementTargetResolved as XamDataChart;
                    // Process the appropriate menu
                    sContextMenuXDC = xdc.Name;
                    break;
            }

        }
        #endregion Context Menu

        #region Fit Chart
        public void vFitChartClick(object _sender, EventArgs _evArgs)
        {

            //Grid grdParent = (Grid)this.Content;
            //RowDefinition rParentGridRow0 = grdParent.RowDefinitions[0];
            //Grid grdChart = (Grid)grdParent.Children[0];
            //XamDataChartEx xdcc = (XamDataChartEx)grdChart.Children[0];

            //Infragistics.Controls.XamZoombar xzb = dmPDB.FindName("xzbZoombar") as XamZoombar;
            //Infragistics.Controls.Charts.XamDataChart xdc = dmPDB.FindName("xdcChart") as XamDataChart;
            //XamDataChartEx xdc = _oHomeV.dmPDB.FindName("xdcChart") as XamDataChartEx;

            m_xdcTheChart.WindowRect = new Rect
            {
                Y = 0,
                Height = 1,
                X = 0,
                Width = 1
            };

            //Infragistics.Controls.XamZoombar xzb = m_oHomeV.dmPDB.FindName("xzbZoombar") as XamZoombar;
            Range newXzbRange = new Range
            {
                Minimum = 0,
                Maximum = 1
            };
            if (m_xzbTheZoombar != null)
            {
                m_xzbTheZoombar.Range = newXzbRange;
            }

            Infragistics.Controls.Menus.ContextMenuManager cmMgr = Infragistics.Controls.Menus.ContextMenuService.GetManager(m_xdcTheChart);
            cmMgr.ContextMenu.Visibility = System.Windows.Visibility.Collapsed;
        }
        #endregion Fit Chart

        #region ZoomBar
        public void vzbZoombarLoaded(object _sender, RoutedEventArgs _evArgs)
        {
            // remember reference to the zoombar.
            m_xzbTheZoombar = _sender as XamZoombar;
        }


        public bool IsXzbChanging;

        public void vzbZoomChanged(object _sender, ZoomChangedEventArgs _evArgs)
        {
            //if (_oHomeV == null) return;
            //if (_oHomeV.dmPDB == null) return;
            //Infragistics.Controls.Charts.XamDataChart xdc = dmPDB.FindName("xdcChart") as XamDataChart;
            //XamDataChartEx xdc = _oHomeV.dmPDB.FindName("xdcChart") as XamDataChartEx;
            if (m_xdcTheChart == null) return;
            if (IsXzbChanging) return;
            try
            {
                IsXzbChanging = true;
                Range xzbRange = _evArgs.NewRange;
                m_xdcTheChart.WindowRect = new Rect
                {
                    Y = 0,
                    Height = 1,
                    X = xzbRange.Minimum,
                    Width = (xzbRange.Maximum - xzbRange.Minimum)
                };
            }
            finally
            {
                IsXzbChanging = false;
            }
        }

        public void vWindowRectChanged(object sender, RectChangedEventArgs e)
        {
            if (IsXzbChanging) return;
            try
            {
                //Infragistics.Controls.XamZoombar xzb = m_oHomeV.dmPDB.FindName("xzbZoombar") as XamZoombar;
                IsXzbChanging = true;
                Range newXzbRange = new Range
                {
                    Minimum = e.NewRect.X,
                    Maximum = e.NewRect.X + e.NewRect.Width
                };
                if (m_xzbTheZoombar != null)
                {
                    m_xzbTheZoombar.Range = newXzbRange;
                }
            }
            finally
            {
                IsXzbChanging = false;
            }
        }
        #endregion Zoombar

        #region Panning
        //private void OnPanButtonClick(object sender, RoutedEventArgs e)
        //{
        //    Button btn = (sender as Button);
        //    if (btn == null) return;
        //    string tag = btn.Tag.ToString();
        //    // #######################################################################################################
        //    if (tag.Equals("FitWindowButton"))
        //    {
        //        m_xdcTheChart.WindowRect = new Rect(0, 0, 1, 1);
        //    }
        //    // #######################################################################################################
        //    else if (tag.Equals("ZoomInButton"))
        //    {
        //        // zoom in by factor of 0.05
        //        m_xdcTheChart.WindowScaleHorizontal -= 0.05;
        //        m_xdcTheChart.WindowScaleVertical -= 0.05;

        //    }
        //    else if (tag.Equals("ZoomOutButton"))
        //    {
        //        // zoom out by factor of 0.05
        //        m_xdcTheChart.WindowScaleHorizontal += 0.05;
        //        m_xdcTheChart.WindowScaleVertical += 0.05;
        //    }
        //    // #######################################################################################################
        //    else if (tag.Equals("PanNorthButton"))
        //    {
        //        // pan up (north direction) by factor of 0.05
        //        m_xdcTheChart.WindowPositionVertical -= 0.05;
        //    }
        //    else if (tag.Equals("PanSouthButton"))
        //    {
        //        // pan down (south direction) by factor of 0.05
        //        m_xdcTheChart.WindowPositionVertical += 0.05;
        //    }
        //    else if (tag.Equals("PanWestButton"))
        //    {
        //        // pan left (west direction) by factor of 0.05
        //        m_xdcTheChart.WindowPositionHorizontal -= 0.05;
        //    }
        //    else if (tag.Equals("PanEastButton"))
        //    {
        //        // pan right (east direction) by factor of 0.05
        //        m_xdcTheChart.WindowPositionHorizontal += 0.05;
        //    }
        //    // #######################################################################################################
        //}
        ////private void OnPanModifierSelectionChanged(object sender, SelectionChangedEventArgs e)
        ////{
        ////    ComboBox cmb = sender as ComboBox;
        ////    if (cmb == null) return;
        ////    ComboBoxItem item = cmb.SelectedItem as ComboBoxItem;
        ////    if (item == null) return;
        ////    string tag = item.Tag.ToString();

        ////    if (m_xdcTheChart == null) return;
        ////    m_xdcTheChart.PanModifier = (ModifierKeys)Enum.Parse(typeof(ModifierKeys), tag, true);
        ////}
        #endregion Panning

        public void vExportChartClick(object _sender, EventArgs _evArgs, Boolean boJpeg)
        {
            // hide scroll bars
            xdcTheChart.VerticalZoombarVisibility = System.Windows.Visibility.Collapsed;

            //Grid g = m_oHomeV.dmPDB.FindName("grdChart") as Grid;
            Grid grdParent = (Grid)this.Content;
            //RowDefinition rParentGridRow0 = grdParent.RowDefinitions[0];
            Grid g = (Grid)grdParent.Children[0];
            // Scale the image on the screen by the appropriate amount to fill a page.
            double h = g.ActualHeight;
            double w = g.ActualWidth;

            //temporary multiply 8.5 x 300 = 2550 pixels and 11 x 300 = 3300 pixels. 72 is standard screen dpi, so multiply 8.5 x 72 and 11 x 72 for your pixels. 612 pixels x 792 
            double s = 2550; //??? number of pixels for 11 landscape
            //double scaleFactorH = 768 / h;
            //double scaleFactorW = 1024 / w;
            double scaleFactor = s / w;

            //WriteableBitmap bitmap = new WriteableBitmap(g, null); // pass grid in not just chart, otherwise legend will not be exported with chart
            //WriteableBitmap bitmap = new WriteableBitmap(g, new ScaleTransform() { ScaleX = scaleFactorW, ScaleY = scaleFactorH });
            WriteableBitmap bitmap = new WriteableBitmap(g, new ScaleTransform() { ScaleX = scaleFactor, ScaleY = scaleFactor });

            SaveFileDialog dlgSaveDialog = new SaveFileDialog();
            dlgSaveDialog.DefaultExt = "JPEG"; // or "PNG"
            if (dlgSaveDialog.ShowDialog() == true)
            {
                try
                {
                    using (Stream stream = dlgSaveDialog.OpenFile())
                    {
                        if (boJpeg == true)
                        {
                            JpegImageEncoder encoder = new JpegImageEncoder();
                            List<EncodingProperty> qualityList = new List<EncodingProperty>();
                            qualityList.Add(new JpegQualityProperty() { Quality = 90 });
                            encoder.Encode(bitmap, qualityList, stream);
                        }
                        else
                        {
                            // Exporting to PNG
                            PngImageEncoder encoder = new PngImageEncoder();
                            encoder.Encode(bitmap, new List<EncodingProperty>(0), stream);
                        }
                    }
                }
                catch (Exception exc)
                {
                    MessageBox.Show(exc.Message);
                }
            }

            xdcTheChart.VerticalZoombarVisibility = System.Windows.Visibility.Visible;
            Infragistics.Controls.Menus.ContextMenuManager cmMgr = Infragistics.Controls.Menus.ContextMenuService.GetManager(xdcTheChart);
            cmMgr.ContextMenu.Visibility = System.Windows.Visibility.Collapsed;

        }
    
    }
}
