﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace WMAApp.Views.Login
{
    public partial class ProfileSettings : ChildWindow
    {
        private void vInitComboBox( ComboBox cb, string userDefault)
        {
            foreach (ComboBoxItem cbi in cb.Items)
            {
                if (cbi.Content.ToString() == userDefault)
                {
                    cb.SelectedItem = cbi;
                    break;
                }
            }
        }

        public ProfileSettings()
        {
            InitializeComponent();

            string userDefaultFamily = WebContext.Current.User.DefaultFamilySelection.ToString();
            string userDefaultStand = WebContext.Current.User.DefaultStandSelection.ToString();

            vInitComboBox(defaultFamily, WebContext.Current.User.DefaultFamilySelection.ToString());
            vInitComboBox(defaultStand, WebContext.Current.User.DefaultStandSelection.ToString());
        }

        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            int newSelection = int.Parse(defaultFamily.SelectionBoxItem.ToString());
            if (newSelection != WebContext.Current.User.DefaultFamilySelection)
            {
                WebContext.Current.User.DefaultFamilySelection = newSelection;
                WebContext.Current.Authentication.SaveUser(true);
            }

            newSelection = int.Parse(defaultStand.SelectionBoxItem.ToString());
            if (newSelection != WebContext.Current.User.DefaultStandSelection)
            {
                WebContext.Current.User.DefaultStandSelection = newSelection;
                WebContext.Current.Authentication.SaveUser(true);
            }

            this.DialogResult = true;
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }
    }
}

