﻿
namespace WMAApp.Web.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data.Objects.DataClasses;
    using System.Linq;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;


    // The MetadataTypeAttribute identifies PDB_DATAMetadata as the class
    // that carries additional metadata for the PDB_DATA class.
    [MetadataTypeAttribute(typeof(PDB_DATA.PDB_DATAMetadata))]
    public partial class PDB_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the PDB_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PDB_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PDB_DATAMetadata()
            {
            }

            public decimal PDB_DEFN_SAKEY { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<DateTime> TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PDB_DEFNMetadata as the class
    // that carries additional metadata for the PDB_DEFN class.
    [MetadataTypeAttribute(typeof(PDB_DEFN.PDB_DEFNMetadata))]
    public partial class PDB_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the PDB_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PDB_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PDB_DEFNMetadata()
            {
            }

            [Include] // Modification: Allows accessibility from this class.
#if USE_COMPOSITION
            [Composition] // Modification: Allows hierarchical deletion.
#endif
            public EntityCollection<PDB_DATA> PDB_DATA { get; set; }
            
            public string NAME { get; set; }

            public decimal PDB_DEFN_SAKEY { get; set; }

            public string USER_NAME { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies ALLOW_COMPONENT_MARRIAGEMetadata as the class
    // that carries additional metadata for the ALLOW_COMPONENT_MARRIAGE class.
    [MetadataTypeAttribute(typeof(ALLOW_COMPONENT_MARRIAGE.ALLOW_COMPONENT_MARRIAGEMetadata))]
    public partial class ALLOW_COMPONENT_MARRIAGE
    {

        // This class allows you to attach custom attributes to properties
        // of the ALLOW_COMPONENT_MARRIAGE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class ALLOW_COMPONENT_MARRIAGEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private ALLOW_COMPONENT_MARRIAGEMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public string TRANS_MODEL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies ASSO_TP_DATAMetadata as the class
    // that carries additional metadata for the ASSO_TP_DATA class.
    [MetadataTypeAttribute(typeof(ASSO_TP_DATA.ASSO_TP_DATAMetadata))]
    public partial class ASSO_TP_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the ASSO_TP_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class ASSO_TP_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private ASSO_TP_DATAMetadata()
            {
            }

            public int PRODUCT_DATA_REJ_SAKEY { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public decimal TP_QTY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies AUDIT_DEFNMetadata as the class
    // that carries additional metadata for the AUDIT_DEFN class.
    [MetadataTypeAttribute(typeof(AUDIT_DEFN.AUDIT_DEFNMetadata))]
    public partial class AUDIT_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the AUDIT_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class AUDIT_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private AUDIT_DEFNMetadata()
            {
            }

            public DateTime AUDIT_DEFN_REV_DTS { get; set; }

            public Nullable<decimal> FAMILY_ID { get; set; }

            public string REASON { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string TABLE_NAME { get; set; }

            public string USER_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies AUTO_CAL_DATAMetadata as the class
    // that carries additional metadata for the AUTO_CAL_DATA class.
    [MetadataTypeAttribute(typeof(AUTO_CAL_DATA.AUTO_CAL_DATAMetadata))]
    public partial class AUTO_CAL_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the AUTO_CAL_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class AUTO_CAL_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private AUTO_CAL_DATAMetadata()
            {
            }

            public DateTime AUTO_CAL_REV_DTS { get; set; }

            public int AUTO_CAL_SAKEY { get; set; }

            public CALIB_DEFN CALIB_DEFN { get; set; }

            public int CALIB_DEFN_SAKEY { get; set; }

            public decimal CORRECTED_OFFSET { get; set; }

            public decimal RAW_SPAN_QTY { get; set; }

            public decimal RAW_ZERO_QTY { get; set; }

            public SHIFT_DEFN SHIFT_DEFN { get; set; }

            public decimal SHIFT_ID { get; set; }

            public decimal SLOPE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies CALIB_DEFNMetadata as the class
    // that carries additional metadata for the CALIB_DEFN class.
    [MetadataTypeAttribute(typeof(CALIB_DEFN.CALIB_DEFNMetadata))]
    public partial class CALIB_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the CALIB_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class CALIB_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private CALIB_DEFNMetadata()
            {
            }

            public EntityCollection<AUTO_CAL_DATA> AUTO_CAL_DATA { get; set; }

            public Nullable<decimal> AUTO_CAL_FLAG { get; set; }

            public int CALIB_DEFN_SAKEY { get; set; }

            public EntityCollection<CHARACTERIZATION_DEFN> CHARACTERIZATION_DEFN { get; set; }

            public Nullable<int> CHARACTERIZATION_TEXT_SAKEY { get; set; }

            public string COMMENT_TEXT { get; set; }

            public DW_CAL_DEFN DW_CAL_DEFN { get; set; }

            public Nullable<decimal> EXPECTED_SPAN_QTY { get; set; }

            public Nullable<decimal> EXPECTED_ZERO_QTY { get; set; }

            public Nullable<DateTime> LAST_DW_DTS { get; set; }

            public decimal OFFSET_QTY { get; set; }

            public Nullable<decimal> OFFSET_TOLERANCE_QTY { get; set; }

            public string PALLET_CODE { get; set; }

            public PALLET_DEFN PALLET_DEFN { get; set; }

            public decimal SLOPE_QTY { get; set; }

            public Nullable<decimal> SLOPE_TOLERANCE_QTY { get; set; }

            public string STAND_CODE { get; set; }

            public string TAG_NAME { get; set; }

            public DateTime TIMESTAMP_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies CHARACTERIZATION_DEFNMetadata as the class
    // that carries additional metadata for the CHARACTERIZATION_DEFN class.
    [MetadataTypeAttribute(typeof(CHARACTERIZATION_DEFN.CHARACTERIZATION_DEFNMetadata))]
    public partial class CHARACTERIZATION_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the CHARACTERIZATION_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class CHARACTERIZATION_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private CHARACTERIZATION_DEFNMetadata()
            {
            }

            public CALIB_DEFN CALIB_DEFN { get; set; }

            public int CALIB_DEFN_SAKEY { get; set; }

            public decimal ORDER_NUM { get; set; }

            public decimal PARAM_1 { get; set; }

            public Nullable<decimal> PARAM_2 { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies CORE_TAG_DEFNMetadata as the class
    // that carries additional metadata for the CORE_TAG_DEFN class.
    [MetadataTypeAttribute(typeof(CORE_TAG_DEFN.CORE_TAG_DEFNMetadata))]
    public partial class CORE_TAG_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the CORE_TAG_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class CORE_TAG_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private CORE_TAG_DEFNMetadata()
            {
            }

            public int COMMON_TEXT_DESC_SAKEY { get; set; }

            public DateTime CORE_TAG_DEFN_REV_DTS { get; set; }

            public int DATATYPE_TEXT_DESC_SAKEY { get; set; }

            public int IOTYPE_TEXT_DESC_SAKEY { get; set; }

            public decimal SIZE_QTY { get; set; }

            public string SWEEP_FLAG { get; set; }

            public string TAG_NAME { get; set; }

            public string VARIABLE_NAME { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies DOWNLOAD_DEFNMetadata as the class
    // that carries additional metadata for the DOWNLOAD_DEFN class.
    [MetadataTypeAttribute(typeof(DOWNLOAD_DEFN.DOWNLOAD_DEFNMetadata))]
    public partial class DOWNLOAD_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the DOWNLOAD_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class DOWNLOAD_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private DOWNLOAD_DEFNMetadata()
            {
            }

            public string DATA_SOURCE_FLAG { get; set; }

            public int DOWNLOAD_DEFN_SAKEY { get; set; }

            public string FILE_NETWORK_PATH { get; set; }

            public int FILE_TYPE_SAKEY { get; set; }

            public Nullable<int> MEMORY_BLOCK_SIZE { get; set; }

            public EntityCollection<MODEL_DOWNLOAD_DEFN> MODEL_DOWNLOAD_DEFN { get; set; }

            public Nullable<int> START_ADDRESS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies DW_CAL_DEFNMetadata as the class
    // that carries additional metadata for the DW_CAL_DEFN class.
    [MetadataTypeAttribute(typeof(DW_CAL_DEFN.DW_CAL_DEFNMetadata))]
    public partial class DW_CAL_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the DW_CAL_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class DW_CAL_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private DW_CAL_DEFNMetadata()
            {
            }

            public CALIB_DEFN CALIB_DEFN { get; set; }

            public int CALIB_DEFN_SAKEY { get; set; }

            public decimal DW_VAL_1_COUNTS { get; set; }

            public decimal DW_VAL_1_ENGR_QTY { get; set; }

            public Nullable<decimal> DW_VAL_2_COUNTS { get; set; }

            public Nullable<decimal> DW_VAL_2_ENGR_QTY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies ECPC_DATAMetadata as the class
    // that carries additional metadata for the ECPC_DATA class.
    [MetadataTypeAttribute(typeof(ECPC_DATA.ECPC_DATAMetadata))]
    public partial class ECPC_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the ECPC_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class ECPC_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private ECPC_DATAMetadata()
            {
            }

            public decimal ECPC_ID { get; set; }

            public decimal ECPC_PART_NUMBER { get; set; }

            public Nullable<decimal> ECPC_QTY { get; set; }

            public string ECPC_SEQUENCE { get; set; }

            public string MODEL_CODE { get; set; }

            public string SERIAL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies FAMILY_DEFNMetadata as the class
    // that carries additional metadata for the FAMILY_DEFN class.
    [MetadataTypeAttribute(typeof(FAMILY_DEFN.FAMILY_DEFNMetadata))]
    public partial class FAMILY_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the FAMILY_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class FAMILY_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private FAMILY_DEFNMetadata()
            {
            }

            public DateTime FAMILY_DEFN_REV_DTS { get; set; }

            public decimal FAMILY_ID { get; set; }

            public EntityCollection<FAMILY_TAG_TEXT> FAMILY_TAG_TEXT { get; set; }

            public string FAMILY_TEXT { get; set; }

            public EntityCollection<MODEL_DEFN> MODEL_DEFN { get; set; }

            public EntityCollection<MONTR_PARAM_DEFN> MONTR_PARAM_DEFN { get; set; }

            public EntityCollection<PARAM_DEFN> PARAM_DEFN { get; set; }

            public EntityCollection<RAMP_PARAM_DEFN> RAMP_PARAM_DEFN { get; set; }

            public EntityCollection<REJ_DEFN> REJ_DEFN { get; set; }

            public EntityCollection<TEST_TEXT> TEST_TEXT { get; set; }

            public EntityCollection<TP_DEFN> TP_DEFN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies FAMILY_TAG_TEXTMetadata as the class
    // that carries additional metadata for the FAMILY_TAG_TEXT class.
    [MetadataTypeAttribute(typeof(FAMILY_TAG_TEXT.FAMILY_TAG_TEXTMetadata))]
    public partial class FAMILY_TAG_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the FAMILY_TAG_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class FAMILY_TAG_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private FAMILY_TAG_TEXTMetadata()
            {
            }

            public Nullable<decimal> AUTO_CAL_FLAG { get; set; }

            public FAMILY_DEFN FAMILY_DEFN { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string FAMILY_TAG_NAME { get; set; }

            public TAG_DEFN TAG_DEFN { get; set; }

            public string TAG_NAME { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies GROUP_DEFNMetadata as the class
    // that carries additional metadata for the GROUP_DEFN class.
    [MetadataTypeAttribute(typeof(GROUP_DEFN.GROUP_DEFNMetadata))]
    public partial class GROUP_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the GROUP_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class GROUP_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private GROUP_DEFNMetadata()
            {
            }

            public int GROUP_DEFN_SAKEY { get; set; }

            public string GROUP_NAME { get; set; }

            public EntityCollection<MBX_TOP> MBX_TOP { get; set; }

            public EntityCollection<MODEL_GROUP_DEFN> MODEL_GROUP_DEFN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies HVT_CROP_DEFNMetadata as the class
    // that carries additional metadata for the HVT_CROP_DEFN class.
    [MetadataTypeAttribute(typeof(HVT_CROP_DEFN.HVT_CROP_DEFNMetadata))]
    public partial class HVT_CROP_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the HVT_CROP_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class HVT_CROP_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private HVT_CROP_DEFNMetadata()
            {
            }

            public string DESC_TEXT { get; set; }

            public string FILE_EXT { get; set; }

            public string HEADER { get; set; }

            public EntityCollection<HVT_PLOT_DEFN> HVT_PLOT_DEFN { get; set; }

            public string SORT_BY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies HVT_PLOT_DEFNMetadata as the class
    // that carries additional metadata for the HVT_PLOT_DEFN class.
    [MetadataTypeAttribute(typeof(HVT_PLOT_DEFN.HVT_PLOT_DEFNMetadata))]
    public partial class HVT_PLOT_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the HVT_PLOT_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class HVT_PLOT_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private HVT_PLOT_DEFNMetadata()
            {
            }

            public string DATA_PATH { get; set; }

            public string ERROR_FILE { get; set; }

            public Nullable<DateTime> ERROR_FILE_DTS { get; set; }

            public string ERROR_PATH { get; set; }

            public string FILE_EXT { get; set; }

            public HVT_CROP_DEFN HVT_CROP_DEFN { get; set; }

            public EntityCollection<HVT_SILO_DEFN> HVT_SILO_DEFN { get; set; }

            public Nullable<decimal> KEEP_COUNT { get; set; }

            public string LAST_FILE { get; set; }

            public Nullable<DateTime> LAST_FILE_DTS { get; set; }

            public Nullable<decimal> ORDER_NUM { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies HVT_SILO_DEFNMetadata as the class
    // that carries additional metadata for the HVT_SILO_DEFN class.
    [MetadataTypeAttribute(typeof(HVT_SILO_DEFN.HVT_SILO_DEFNMetadata))]
    public partial class HVT_SILO_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the HVT_SILO_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class HVT_SILO_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private HVT_SILO_DEFNMetadata()
            {
            }

            public Nullable<decimal> ARCHIVE_COUNT { get; set; }

            public string ARCHIVE_PATH { get; set; }

            public string DATA_PATH { get; set; }

            public string FILE_EXT { get; set; }

            public HVT_PLOT_DEFN HVT_PLOT_DEFN { get; set; }

            public string LAST_FILE { get; set; }

            public Nullable<DateTime> LAST_FILE_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies IO_DEFNMetadata as the class
    // that carries additional metadata for the IO_DEFN class.
    [MetadataTypeAttribute(typeof(IO_DEFN.IO_DEFNMetadata))]
    public partial class IO_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the IO_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class IO_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private IO_DEFNMetadata()
            {
            }

            public Nullable<decimal> ANALOG_GAIN_QTY { get; set; }

            public decimal HIGH_COUNTS_QTY { get; set; }

            public decimal HIGH_VOLTS_QTY { get; set; }

            public int IO_DEFN_SAKEY { get; set; }

            public decimal LOW_COUNTS_QTY { get; set; }

            public decimal LOW_VOLTS_QTY { get; set; }

            public Nullable<int> PALLET_TYPE_SAKEY { get; set; }

            public string PRIMARY_FORMAT_SPECIFIER { get; set; }

            public decimal PRIMARY_HIGH_ENG_QTY { get; set; }

            public decimal PRIMARY_LOW_ENG_QTY { get; set; }

            public int PRIMARY_UNITS_TEXT_SAKEY { get; set; }

            public Nullable<decimal> SECONDARY_ENG_OFFSET_QTY { get; set; }

            public string SECONDARY_FORMAT_SPECIFIER { get; set; }

            public Nullable<decimal> SECONDARY_HIGH_ENG_QTY { get; set; }

            public Nullable<decimal> SECONDARY_LOW_ENG_QTY { get; set; }

            public Nullable<int> SECONDARY_UNITS_TEXT_SAKEY { get; set; }

            public TAG_DEFN TAG_DEFN { get; set; }

            public string TAG_NAME { get; set; }

            public TEXT_DESC TEXT_DESC { get; set; }

            public UNITS_TEXT UNITS_TEXT { get; set; }

            public UNITS_TEXT UNITS_TEXT1 { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies LEAK_TAB_COLUMN_DEFNMetadata as the class
    // that carries additional metadata for the LEAK_TAB_COLUMN_DEFN class.
    [MetadataTypeAttribute(typeof(LEAK_TAB_COLUMN_DEFN.LEAK_TAB_COLUMN_DEFNMetadata))]
    public partial class LEAK_TAB_COLUMN_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the LEAK_TAB_COLUMN_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class LEAK_TAB_COLUMN_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private LEAK_TAB_COLUMN_DEFNMetadata()
            {
            }

            public string COLUMN_ID { get; set; }

            public string COLUMN_NAME { get; set; }

            public string TABLE_NAME { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies LIMIT_RECALC_COLLECTMetadata as the class
    // that carries additional metadata for the LIMIT_RECALC_COLLECT class.
    [MetadataTypeAttribute(typeof(LIMIT_RECALC_COLLECT.LIMIT_RECALC_COLLECTMetadata))]
    public partial class LIMIT_RECALC_COLLECT
    {

        // This class allows you to attach custom attributes to properties
        // of the LIMIT_RECALC_COLLECT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class LIMIT_RECALC_COLLECTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private LIMIT_RECALC_COLLECTMetadata()
            {
            }

            public Nullable<decimal> MAX_MONTHS { get; set; }

            public Nullable<decimal> MAX_PARTS { get; set; }

            public string MODEL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies LIMIT_RECALC_PARAMSMetadata as the class
    // that carries additional metadata for the LIMIT_RECALC_PARAMS class.
    [MetadataTypeAttribute(typeof(LIMIT_RECALC_PARAMS.LIMIT_RECALC_PARAMSMetadata))]
    public partial class LIMIT_RECALC_PARAMS
    {

        // This class allows you to attach custom attributes to properties
        // of the LIMIT_RECALC_PARAMS class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class LIMIT_RECALC_PARAMSMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private LIMIT_RECALC_PARAMSMetadata()
            {
            }

            public decimal CEILING_QTY { get; set; }

            public decimal EQUATION_ID { get; set; }

            public decimal FLOOR_QTY { get; set; }

            public string LIMIT_TYPE { get; set; }

            public decimal MAX_CHANGE_QTY { get; set; }

            public decimal MIN_CHANGE_QTY { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> PARAM_1 { get; set; }

            public Nullable<decimal> PARAM_2 { get; set; }

            public Nullable<decimal> PARAM_3 { get; set; }

            public Nullable<decimal> PARAM_4 { get; set; }

            public Nullable<decimal> PARAM_5 { get; set; }

            public Nullable<DateTime> PARAM_DTS { get; set; }

            public string PARAM_SERIAL_ID_CODE { get; set; }

            public decimal TP_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies LIMIT_RECALC_RESULTSMetadata as the class
    // that carries additional metadata for the LIMIT_RECALC_RESULTS class.
    [MetadataTypeAttribute(typeof(LIMIT_RECALC_RESULTS.LIMIT_RECALC_RESULTSMetadata))]
    public partial class LIMIT_RECALC_RESULTS
    {

        // This class allows you to attach custom attributes to properties
        // of the LIMIT_RECALC_RESULTS class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class LIMIT_RECALC_RESULTSMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private LIMIT_RECALC_RESULTSMetadata()
            {
            }

            public decimal EQUATION_ID { get; set; }

            public DateTime LIMIT_RECALC_DTS { get; set; }

            public decimal LIMIT_RECALC_STAT_ID { get; set; }

            public string LIMIT_TYPE { get; set; }

            public string MODEL_CODE { get; set; }

            public decimal NEW_LIMIT { get; set; }

            public decimal OLD_LIMIT { get; set; }

            public decimal PARAM_ID { get; set; }

            public decimal TP_AVE { get; set; }

            public decimal TP_COUNT { get; set; }

            public decimal TP_ID { get; set; }

            public decimal TP_STDDEV { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies LIMIT_RECALC_SHIFT_IDMetadata as the class
    // that carries additional metadata for the LIMIT_RECALC_SHIFT_ID class.
    [MetadataTypeAttribute(typeof(LIMIT_RECALC_SHIFT_ID.LIMIT_RECALC_SHIFT_IDMetadata))]
    public partial class LIMIT_RECALC_SHIFT_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the LIMIT_RECALC_SHIFT_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class LIMIT_RECALC_SHIFT_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private LIMIT_RECALC_SHIFT_IDMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies LIMIT_RECALC_STAND_CODEMetadata as the class
    // that carries additional metadata for the LIMIT_RECALC_STAND_CODE class.
    [MetadataTypeAttribute(typeof(LIMIT_RECALC_STAND_CODE.LIMIT_RECALC_STAND_CODEMetadata))]
    public partial class LIMIT_RECALC_STAND_CODE
    {

        // This class allows you to attach custom attributes to properties
        // of the LIMIT_RECALC_STAND_CODE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class LIMIT_RECALC_STAND_CODEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private LIMIT_RECALC_STAND_CODEMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public string STAND_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies LIMIT_RECALC_STATUS_IDMetadata as the class
    // that carries additional metadata for the LIMIT_RECALC_STATUS_ID class.
    [MetadataTypeAttribute(typeof(LIMIT_RECALC_STATUS_ID.LIMIT_RECALC_STATUS_IDMetadata))]
    public partial class LIMIT_RECALC_STATUS_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the LIMIT_RECALC_STATUS_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class LIMIT_RECALC_STATUS_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private LIMIT_RECALC_STATUS_IDMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public decimal PRODUCT_DATA_STAT_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_COMPONENT_CODEMetadata as the class
    // that carries additional metadata for the MBX_COMPONENT_CODE class.
    [MetadataTypeAttribute(typeof(MBX_COMPONENT_CODE.MBX_COMPONENT_CODEMetadata))]
    public partial class MBX_COMPONENT_CODE
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_COMPONENT_CODE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_COMPONENT_CODEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_COMPONENT_CODEMetadata()
            {
            }

            public int COMPONENT_CODE_SAKEY { get; set; }

            public int MBX_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_COMPONENT_TYPEMetadata as the class
    // that carries additional metadata for the MBX_COMPONENT_TYPE class.
    [MetadataTypeAttribute(typeof(MBX_COMPONENT_TYPE.MBX_COMPONENT_TYPEMetadata))]
    public partial class MBX_COMPONENT_TYPE
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_COMPONENT_TYPE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_COMPONENT_TYPEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_COMPONENT_TYPEMetadata()
            {
            }

            public int COMPONENT_TYPE_SAKEY { get; set; }

            public int MBX_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_FAMILY_DEFNMetadata as the class
    // that carries additional metadata for the MBX_FAMILY_DEFN class.
    [MetadataTypeAttribute(typeof(MBX_FAMILY_DEFN.MBX_FAMILY_DEFNMetadata))]
    public partial class MBX_FAMILY_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_FAMILY_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_FAMILY_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_FAMILY_DEFNMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public int MBX_SAKEY { get; set; }

            public MBX_TOP MBX_TOP { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_MISC_PHRASE_IDMetadata as the class
    // that carries additional metadata for the MBX_MISC_PHRASE_ID class.
    [MetadataTypeAttribute(typeof(MBX_MISC_PHRASE_ID.MBX_MISC_PHRASE_IDMetadata))]
    public partial class MBX_MISC_PHRASE_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_MISC_PHRASE_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_MISC_PHRASE_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_MISC_PHRASE_IDMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal PHRASE_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_MODEL_CODEMetadata as the class
    // that carries additional metadata for the MBX_MODEL_CODE class.
    [MetadataTypeAttribute(typeof(MBX_MODEL_CODE.MBX_MODEL_CODEMetadata))]
    public partial class MBX_MODEL_CODE
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_MODEL_CODE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_MODEL_CODEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_MODEL_CODEMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public MBX_TOP MBX_TOP { get; set; }

            public string MODEL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_PALLET_CODEMetadata as the class
    // that carries additional metadata for the MBX_PALLET_CODE class.
    [MetadataTypeAttribute(typeof(MBX_PALLET_CODE.MBX_PALLET_CODEMetadata))]
    public partial class MBX_PALLET_CODE
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_PALLET_CODE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_PALLET_CODEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_PALLET_CODEMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public string PALLET_CODE { get; set; }

            public PALLET_DEFN PALLET_DEFN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_PARAM_PHRASE_IDMetadata as the class
    // that carries additional metadata for the MBX_PARAM_PHRASE_ID class.
    [MetadataTypeAttribute(typeof(MBX_PARAM_PHRASE_ID.MBX_PARAM_PHRASE_IDMetadata))]
    public partial class MBX_PARAM_PHRASE_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_PARAM_PHRASE_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_PARAM_PHRASE_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_PARAM_PHRASE_IDMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal PHRASE_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_PDBMetadata as the class
    // that carries additional metadata for the MBX_PDB class.
    [MetadataTypeAttribute(typeof(MBX_PDB.MBX_PDBMetadata))]
    public partial class MBX_PDB
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_PDB class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_PDBMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_PDBMetadata()
            {
            }

            public decimal MBX_SAKEY { get; set; }

            public decimal PDB_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_PHASE_PHRASE_IDMetadata as the class
    // that carries additional metadata for the MBX_PHASE_PHRASE_ID class.
    [MetadataTypeAttribute(typeof(MBX_PHASE_PHRASE_ID.MBX_PHASE_PHRASE_IDMetadata))]
    public partial class MBX_PHASE_PHRASE_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_PHASE_PHRASE_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_PHASE_PHRASE_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_PHASE_PHRASE_IDMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal PHRASE_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_REJ_IDMetadata as the class
    // that carries additional metadata for the MBX_REJ_ID class.
    [MetadataTypeAttribute(typeof(MBX_REJ_ID.MBX_REJ_IDMetadata))]
    public partial class MBX_REJ_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_REJ_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_REJ_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_REJ_IDMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public MBX_TOP MBX_TOP { get; set; }

            public decimal REJ_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_REJECT_TYPEMetadata as the class
    // that carries additional metadata for the MBX_REJECT_TYPE class.
    [MetadataTypeAttribute(typeof(MBX_REJECT_TYPE.MBX_REJECT_TYPEMetadata))]
    public partial class MBX_REJECT_TYPE
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_REJECT_TYPE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_REJECT_TYPEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_REJECT_TYPEMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public int REJ_TYPE_TEXT_DESC_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_REPAIR_TEXT_IDMetadata as the class
    // that carries additional metadata for the MBX_REPAIR_TEXT_ID class.
    [MetadataTypeAttribute(typeof(MBX_REPAIR_TEXT_ID.MBX_REPAIR_TEXT_IDMetadata))]
    public partial class MBX_REPAIR_TEXT_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_REPAIR_TEXT_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_REPAIR_TEXT_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_REPAIR_TEXT_IDMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal REPAIR_TEXT_ID { get; set; }

            public string REPAIR_TEXT_LEVEL { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_SERIAL_RANGEMetadata as the class
    // that carries additional metadata for the MBX_SERIAL_RANGE class.
    [MetadataTypeAttribute(typeof(MBX_SERIAL_RANGE.MBX_SERIAL_RANGEMetadata))]
    public partial class MBX_SERIAL_RANGE
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_SERIAL_RANGE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_SERIAL_RANGEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_SERIAL_RANGEMetadata()
            {
            }

            public string END_SERIAL_CODE { get; set; }

            public int MBX_SAKEY { get; set; }

            public MBX_TOP MBX_TOP { get; set; }

            public string START_SERIAL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_SHIFTMetadata as the class
    // that carries additional metadata for the MBX_SHIFT class.
    [MetadataTypeAttribute(typeof(MBX_SHIFT.MBX_SHIFTMetadata))]
    public partial class MBX_SHIFT
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_SHIFT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_SHIFTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_SHIFTMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal SHIFT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_STAND_CODEMetadata as the class
    // that carries additional metadata for the MBX_STAND_CODE class.
    [MetadataTypeAttribute(typeof(MBX_STAND_CODE.MBX_STAND_CODEMetadata))]
    public partial class MBX_STAND_CODE
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_STAND_CODE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_STAND_CODEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_STAND_CODEMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public MBX_TOP MBX_TOP { get; set; }

            public string STAND_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_STAT_PHRASE_IDMetadata as the class
    // that carries additional metadata for the MBX_STAT_PHRASE_ID class.
    [MetadataTypeAttribute(typeof(MBX_STAT_PHRASE_ID.MBX_STAT_PHRASE_IDMetadata))]
    public partial class MBX_STAT_PHRASE_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_STAT_PHRASE_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_STAT_PHRASE_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_STAT_PHRASE_IDMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal PHRASE_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_STEP_PHRASE_IDMetadata as the class
    // that carries additional metadata for the MBX_STEP_PHRASE_ID class.
    [MetadataTypeAttribute(typeof(MBX_STEP_PHRASE_ID.MBX_STEP_PHRASE_IDMetadata))]
    public partial class MBX_STEP_PHRASE_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_STEP_PHRASE_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_STEP_PHRASE_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_STEP_PHRASE_IDMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal PHRASE_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_TEST_STATUSMetadata as the class
    // that carries additional metadata for the MBX_TEST_STATUS class.
    [MetadataTypeAttribute(typeof(MBX_TEST_STATUS.MBX_TEST_STATUSMetadata))]
    public partial class MBX_TEST_STATUS
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_TEST_STATUS class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_TEST_STATUSMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_TEST_STATUSMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public MBX_TOP MBX_TOP { get; set; }

            public PRODUCT_DATA_STAT_DESC PRODUCT_DATA_STAT_DESC { get; set; }

            public string SWITCH { get; set; }

            public decimal TEST_STATUS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_THREAD_NUMMetadata as the class
    // that carries additional metadata for the MBX_THREAD_NUM class.
    [MetadataTypeAttribute(typeof(MBX_THREAD_NUM.MBX_THREAD_NUMMetadata))]
    public partial class MBX_THREAD_NUM
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_THREAD_NUM class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_THREAD_NUMMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_THREAD_NUMMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal THREAD_NUM { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_TOPMetadata as the class
    // that carries additional metadata for the MBX_TOP class.
    [MetadataTypeAttribute(typeof(MBX_TOP.MBX_TOPMetadata))]
    public partial class MBX_TOP
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_TOP class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_TOPMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_TOPMetadata()
            {
            }

            public string ALL_FIRST_REJ_ID { get; set; }

            public string ALL_FIRST_REP { get; set; }

            public string ALL_OR_BY_GCAUSE { get; set; }

            public string ALL_OR_BY_PART { get; set; }

            public string ALL_OR_BY_RESPA { get; set; }

            public string ALL_OR_BY_SCAUSE { get; set; }

            public DateTime END_DATA_TIME { get; set; }

            public string END_SERIAL_CODE { get; set; }

            public Nullable<DateTime> END_SHIFT_TIME { get; set; }

            public string FIRST_REJECT_ONLY { get; set; }

            public string FLA_PARTS { get; set; }

            public EntityCollection<GROUP_DEFN> GROUP_DEFN { get; set; }

            public string HISTORY_REJECTS_ONLY { get; set; }

            public string LAST_TEST_ONLY { get; set; }

            public string MACHINE { get; set; }

            public EntityCollection<MBX_FAMILY_DEFN> MBX_FAMILY_DEFN { get; set; }

            public EntityCollection<MBX_MODEL_CODE> MBX_MODEL_CODE { get; set; }

            public EntityCollection<MBX_REJ_ID> MBX_REJ_ID { get; set; }
            [Key]
            public int MBX_SAKEY { get; set; }

            public EntityCollection<MBX_SERIAL_RANGE> MBX_SERIAL_RANGE { get; set; }

            public EntityCollection<MBX_STAND_CODE> MBX_STAND_CODE { get; set; }

            public EntityCollection<MBX_TEST_STATUS> MBX_TEST_STATUS { get; set; }

            public EntityCollection<MBX_TP_QTY> MBX_TP_QTY { get; set; }

            public EntityCollection<MBX_TP_RANGE> MBX_TP_RANGE { get; set; }

            public string OSUSER { get; set; }

            public Nullable<int> PROCESS { get; set; }

            public string REJECTS_BY_CNT { get; set; }

            public string REPORT { get; set; }

            public string SAMP_FREQ { get; set; }

            public string SBGP_SIZE { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_COMPONENT_CODES { get; set; }

            public string SE_COMPONENT_TYPES { get; set; }

            public string SE_FAMILY_IDS { get; set; }

            public string SE_LEVEL_1_TEXT_IDS { get; set; }

            public string SE_LEVEL_2_TEXT_IDS { get; set; }

            public string SE_LEVEL_3_TEXT_IDS { get; set; }

            public string SE_LEVEL_4_TEXT_IDS { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_MODEL_CODES { get; set; }

            public string SE_MODEL_GROUPS { get; set; }

            public string SE_ORIGIN_TEXT_IDS { get; set; }

            public string SE_PALLET_CODES { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_SERIAL_CODES { get; set; }

            public string SE_SHIFTS { get; set; }

            public string SE_STAND_CODES { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TEST_STATUS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SE_TP_PRIORITY { get; set; }

            public string SE_TP_QTY { get; set; }

            public string SETUP_NAME { get; set; }

            public DateTime START_DATA_TIME { get; set; }

            public string START_SERIAL_CODE { get; set; }

            public Nullable<DateTime> START_SHIFT_TIME { get; set; }

            public string USE_PDB { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_TP_IDMetadata as the class
    // that carries additional metadata for the MBX_TP_ID class.
    [MetadataTypeAttribute(typeof(MBX_TP_ID.MBX_TP_IDMetadata))]
    public partial class MBX_TP_ID
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_TP_ID class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_TP_IDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_TP_IDMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal TP_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_TP_QTYMetadata as the class
    // that carries additional metadata for the MBX_TP_QTY class.
    [MetadataTypeAttribute(typeof(MBX_TP_QTY.MBX_TP_QTYMetadata))]
    public partial class MBX_TP_QTY
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_TP_QTY class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_TP_QTYMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_TP_QTYMetadata()
            {
            }

            public Nullable<decimal> HIGH_QTY { get; set; }

            public Nullable<decimal> LOW_QTY { get; set; }

            public int MBX_SAKEY { get; set; }

            public MBX_TOP MBX_TOP { get; set; }

            public decimal TP_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MBX_TP_RANGEMetadata as the class
    // that carries additional metadata for the MBX_TP_RANGE class.
    [MetadataTypeAttribute(typeof(MBX_TP_RANGE.MBX_TP_RANGEMetadata))]
    public partial class MBX_TP_RANGE
    {

        // This class allows you to attach custom attributes to properties
        // of the MBX_TP_RANGE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MBX_TP_RANGEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MBX_TP_RANGEMetadata()
            {
            }

            public decimal END_TP_ID { get; set; }

            public int MBX_SAKEY { get; set; }

            public MBX_TOP MBX_TOP { get; set; }

            public decimal START_TP_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MODEL_CODE_DEFNMetadata as the class
    // that carries additional metadata for the MODEL_CODE_DEFN class.
    [MetadataTypeAttribute(typeof(MODEL_CODE_DEFN.MODEL_CODE_DEFNMetadata))]
    public partial class MODEL_CODE_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the MODEL_CODE_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MODEL_CODE_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MODEL_CODE_DEFNMetadata()
            {
            }

            public string HIGHEST_SER_CODE { get; set; }

            public string LOWEST_SER_CODE { get; set; }

            public string MODEL_ACTIVE_FLAG { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_CODE_DEFN_REV_DTS { get; set; }

            public EntityCollection<MODEL_DEFN> MODEL_DEFN { get; set; }

            public string TESTED_TODAY_FLAG { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MODEL_DEFNMetadata as the class
    // that carries additional metadata for the MODEL_DEFN class.
    [MetadataTypeAttribute(typeof(MODEL_DEFN.MODEL_DEFNMetadata))]
    public partial class MODEL_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the MODEL_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MODEL_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MODEL_DEFNMetadata()
            {
            }

            public FAMILY_DEFN FAMILY_DEFN { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string MODEL_CODE { get; set; }

            public MODEL_CODE_DEFN MODEL_CODE_DEFN { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string MODEL_NAME_TEXT { get; set; }

            public string MODEL_TEXT { get; set; }

            public int TEST_SEQ_SAKEY { get; set; }

            public TEXT_DESC TEXT_DESC { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MODEL_DOWNLOAD_DEFNMetadata as the class
    // that carries additional metadata for the MODEL_DOWNLOAD_DEFN class.
    [MetadataTypeAttribute(typeof(MODEL_DOWNLOAD_DEFN.MODEL_DOWNLOAD_DEFNMetadata))]
    public partial class MODEL_DOWNLOAD_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the MODEL_DOWNLOAD_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MODEL_DOWNLOAD_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MODEL_DOWNLOAD_DEFNMetadata()
            {
            }

            public DOWNLOAD_DEFN DOWNLOAD_DEFN { get; set; }

            public int DOWNLOAD_DEFN_SAKEY { get; set; }

            public int FILE_TYPE_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MODEL_GROUP_DEFNMetadata as the class
    // that carries additional metadata for the MODEL_GROUP_DEFN class.
    [MetadataTypeAttribute(typeof(MODEL_GROUP_DEFN.MODEL_GROUP_DEFNMetadata))]
    public partial class MODEL_GROUP_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the MODEL_GROUP_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MODEL_GROUP_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MODEL_GROUP_DEFNMetadata()
            {
            }

            public GROUP_DEFN GROUP_DEFN { get; set; }

            public int GROUP_DEFN_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MODEL_PSPS_DATAMetadata as the class
    // that carries additional metadata for the MODEL_PSPS_DATA class.
    [MetadataTypeAttribute(typeof(MODEL_PSPS_DATA.MODEL_PSPS_DATAMetadata))]
    public partial class MODEL_PSPS_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the MODEL_PSPS_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MODEL_PSPS_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MODEL_PSPS_DATAMetadata()
            {
            }

            public decimal CLUTCH_NUM { get; set; }

            public string MODEL_CODE { get; set; }

            public decimal ORDER_NUM { get; set; }

            public decimal TP_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MODEL_TCU_DEFNMetadata as the class
    // that carries additional metadata for the MODEL_TCU_DEFN class.
    [MetadataTypeAttribute(typeof(MODEL_TCU_DEFN.MODEL_TCU_DEFNMetadata))]
    public partial class MODEL_TCU_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the MODEL_TCU_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MODEL_TCU_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MODEL_TCU_DEFNMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public TCU_DEFN TCU_DEFN { get; set; }

            public int TCU_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies MONTR_PARAM_DEFNMetadata as the class
    // that carries additional metadata for the MONTR_PARAM_DEFN class.
    [MetadataTypeAttribute(typeof(MONTR_PARAM_DEFN.MONTR_PARAM_DEFNMetadata))]
    public partial class MONTR_PARAM_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the MONTR_PARAM_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class MONTR_PARAM_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private MONTR_PARAM_DEFNMetadata()
            {
            }

            public Nullable<decimal> END_SLOPE_QTY { get; set; }

            public Nullable<decimal> END_SLOPE_TYPE_NUM { get; set; }

            public FAMILY_DEFN FAMILY_DEFN { get; set; }

            public decimal FAMILY_ID { get; set; }

            public decimal GOODREAD_QTY { get; set; }

            public decimal GOODREAD_TYPE_NUM { get; set; }

            public Nullable<decimal> HIGH_LIM_QTY { get; set; }

            public Nullable<decimal> HIGH_LIM_TYPE_NUM { get; set; }

            public Nullable<decimal> LOW_LIM_QTY { get; set; }

            public Nullable<decimal> LOW_LIM_TYPE_NUM { get; set; }

            public Nullable<decimal> MIN_CHANGE_QTY { get; set; }

            public Nullable<decimal> MIN_CHANGE_TYPE_NUM { get; set; }

            public Nullable<decimal> MIN_TIME_QTY { get; set; }

            public Nullable<decimal> MIN_TIME_TYPE_NUM { get; set; }

            public decimal MONTR_ID { get; set; }

            public string MONTR_NAME { get; set; }

            public DateTime MONTR_PARAM_DEFN_REV_DTS { get; set; }

            public string MONTR_TEXT { get; set; }

            public int MONTR_TEXT_DESC_SAKEY { get; set; }

            public string PRIMARY_TAG_NAME { get; set; }

            public Nullable<decimal> READ_OFST_QTY { get; set; }

            public Nullable<decimal> READ_OFST_TYPE_NUM { get; set; }

            public string SECONDARY_TAG_NAME { get; set; }

            public Nullable<decimal> SLOPE_PERIOD_QTY { get; set; }

            public Nullable<decimal> SLOPE_PERIOD_TYPE_NUM { get; set; }

            public Nullable<decimal> START_SLOPE_QTY { get; set; }

            public Nullable<decimal> START_SLOPE_TYPE_NUM { get; set; }

            public TAG_DEFN TAG_DEFN { get; set; }

            public TAG_DEFN TAG_DEFN1 { get; set; }

            public TEXT_DESC TEXT_DESC { get; set; }

            public decimal TIMEOUT_QTY { get; set; }

            public decimal TIMEOUT_TYPE_NUM { get; set; }

            public Nullable<decimal> TOLERANCE_QTY { get; set; }

            public Nullable<decimal> TOLERANCE_TYPE_NUM { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies NEW_KK_TEST_RESULTSMetadata as the class
    // that carries additional metadata for the NEW_KK_TEST_RESULTS class.
    [MetadataTypeAttribute(typeof(NEW_KK_TEST_RESULTS.NEW_KK_TEST_RESULTSMetadata))]
    public partial class NEW_KK_TEST_RESULTS
    {

        // This class allows you to attach custom attributes to properties
        // of the NEW_KK_TEST_RESULTS class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class NEW_KK_TEST_RESULTSMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private NEW_KK_TEST_RESULTSMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public string SERIAL_CODE { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies NEW_TEST_RESULTSMetadata as the class
    // that carries additional metadata for the NEW_TEST_RESULTS class.
    [MetadataTypeAttribute(typeof(NEW_TEST_RESULTS.NEW_TEST_RESULTSMetadata))]
    public partial class NEW_TEST_RESULTS
    {

        // This class allows you to attach custom attributes to properties
        // of the NEW_TEST_RESULTS class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class NEW_TEST_RESULTSMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private NEW_TEST_RESULTSMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public string SERIAL_CODE { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PALLET_DATAMetadata as the class
    // that carries additional metadata for the PALLET_DATA class.
    [MetadataTypeAttribute(typeof(PALLET_DATA.PALLET_DATAMetadata))]
    public partial class PALLET_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the PALLET_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PALLET_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PALLET_DATAMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public string PALLET_CODE { get; set; }

            public DateTime PALLET_DATA_REV_DTS { get; set; }

            public PALLET_DATA_STAT_DESC PALLET_DATA_STAT_DESC { get; set; }

            public decimal PALLET_DATA_STAT_ID { get; set; }

            public PALLET_DEFN PALLET_DEFN { get; set; }

            public string PREP_OPER_ID { get; set; }

            public string PREP_OPER_NAME { get; set; }

            public Nullable<decimal> PRODUCT_DATA_STAT_ID { get; set; }

            public string SERIAL_CODE { get; set; }

            public string STAND_CODE { get; set; }

            public string TC_SERIAL_CODE { get; set; }

            public Nullable<DateTime> TEST_DTS { get; set; }

            public string VB_MODEL_CODE { get; set; }

            public string VB_SERIAL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PALLET_DATA_STAT_DESCMetadata as the class
    // that carries additional metadata for the PALLET_DATA_STAT_DESC class.
    [MetadataTypeAttribute(typeof(PALLET_DATA_STAT_DESC.PALLET_DATA_STAT_DESCMetadata))]
    public partial class PALLET_DATA_STAT_DESC
    {

        // This class allows you to attach custom attributes to properties
        // of the PALLET_DATA_STAT_DESC class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PALLET_DATA_STAT_DESCMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PALLET_DATA_STAT_DESCMetadata()
            {
            }

            public string LONG_DESC_TEXT { get; set; }

            public EntityCollection<PALLET_DATA> PALLET_DATA { get; set; }

            public decimal PALLET_DATA_STAT_ID { get; set; }

            public string SHORT_DESC_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PALLET_DEFNMetadata as the class
    // that carries additional metadata for the PALLET_DEFN class.
    [MetadataTypeAttribute(typeof(PALLET_DEFN.PALLET_DEFNMetadata))]
    public partial class PALLET_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the PALLET_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PALLET_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PALLET_DEFNMetadata()
            {
            }

            public string BT_CODE { get; set; }

            public EntityCollection<CALIB_DEFN> CALIB_DEFN { get; set; }

            public EntityCollection<MBX_PALLET_CODE> MBX_PALLET_CODE { get; set; }

            public string PALLET_CODE { get; set; }

            public PALLET_DATA PALLET_DATA { get; set; }

            public DateTime PALLET_DEFN_REV_DTS { get; set; }

            public Nullable<decimal> PALLET_NUMBER { get; set; }

            public int PALLET_TYPE_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PARAM_DEFNMetadata as the class
    // that carries additional metadata for the PARAM_DEFN class.
    [MetadataTypeAttribute(typeof(PARAM_DEFN.PARAM_DEFNMetadata))]
    public partial class PARAM_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the PARAM_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PARAM_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PARAM_DEFNMetadata()
            {
            }

            public string CUSTOM_TEXT_FLAG { get; set; }

            public FAMILY_DEFN FAMILY_DEFN { get; set; }

            public Nullable<decimal> FAMILY_ID { get; set; }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public string PARAM_CODE { get; set; }

            public DateTime PARAM_DEFN_REV_DTS { get; set; }

            public int PARAM_DEFN_SAKEY { get; set; }

            public decimal PARAM_ID { get; set; }

            public string PARAM_TEXT { get; set; }

            public UNITS_TEXT UNITS_TEXT { get; set; }

            public int UNITS_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PARAM_TP_DEFNMetadata as the class
    // that carries additional metadata for the PARAM_TP_DEFN class.
    [MetadataTypeAttribute(typeof(PARAM_TP_DEFN.PARAM_TP_DEFNMetadata))]
    public partial class PARAM_TP_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the PARAM_TP_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PARAM_TP_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PARAM_TP_DEFNMetadata()
            {
            }

            public string LIMIT_CODE { get; set; }

            public string PARAM_CODE { get; set; }

            public decimal PARAM_ID { get; set; }

            public TP_DEFN TP_DEFN { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PARAM_VALMetadata as the class
    // that carries additional metadata for the PARAM_VAL class.
    [MetadataTypeAttribute(typeof(PARAM_VAL.PARAM_VALMetadata))]
    public partial class PARAM_VAL
    {

        // This class allows you to attach custom attributes to properties
        // of the PARAM_VAL class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PARAM_VALMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PARAM_VALMetadata()
            {
            }

            public string PARAM_CODE { get; set; }

            public string PARAM_CODE_NAME { get; set; }

            public decimal PARAM_ID { get; set; }

            public decimal PARAM_VAL_QTY { get; set; }

            public DateTime PARAM_VAL_REV_DTS { get; set; }

            public int PARAM_VAL_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PART_COMMENTMetadata as the class
    // that carries additional metadata for the PART_COMMENT class.
    [MetadataTypeAttribute(typeof(PART_COMMENT.PART_COMMENTMetadata))]
    public partial class PART_COMMENT
    {

        // This class allows you to attach custom attributes to properties
        // of the PART_COMMENT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PART_COMMENTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PART_COMMENTMetadata()
            {
            }

            public string PART_COMMENT1 { get; set; }

            public decimal PART_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PHASE_STEP_ORDERMetadata as the class
    // that carries additional metadata for the PHASE_STEP_ORDER class.
    [MetadataTypeAttribute(typeof(PHASE_STEP_ORDER.PHASE_STEP_ORDERMetadata))]
    public partial class PHASE_STEP_ORDER
    {

        // This class allows you to attach custom attributes to properties
        // of the PHASE_STEP_ORDER class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PHASE_STEP_ORDERMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PHASE_STEP_ORDERMetadata()
            {
            }

            public decimal PHASE_ORDER_NUM { get; set; }

            public int PHASE_PHRASE_SAKEY { get; set; }

            public int PHASE_STEP_ORDER_SAKEY { get; set; }

            public PRODUCT_DATA PRODUCT_DATA { get; set; }

            public string STAND_CODE { get; set; }

            public decimal STEP_ORDER_NUM { get; set; }

            public int STEP_PHRASE_SAKEY { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal THREAD_NUM { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PRODUCT_DATAMetadata as the class
    // that carries additional metadata for the PRODUCT_DATA class.
    [MetadataTypeAttribute(typeof(PRODUCT_DATA.PRODUCT_DATAMetadata))]
    public partial class PRODUCT_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the PRODUCT_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PRODUCT_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PRODUCT_DATAMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public EntityCollection<PHASE_STEP_ORDER> PHASE_STEP_ORDER { get; set; }

            public EntityCollection<PRODUCT_DATA_COMPONENT> PRODUCT_DATA_COMPONENT { get; set; }

            public PRODUCT_DATA_MARRIAGE PRODUCT_DATA_MARRIAGE { get; set; }

            [Include] // Modification: Allows accessibility from this class.
            public EntityCollection<PRODUCT_DATA_REJ> PRODUCT_DATA_REJ { get; set; }
            [Include] // Modification: Allows accessibility from this class.
            public EntityCollection<PRODUCT_DATA_STAT> PRODUCT_DATA_STAT { get; set; }

            public string SERIAL_CODE { get; set; }

            public SHIFT_DEFN SHIFT_DEFN { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public EntityCollection<TP_DATA> TP_DATA { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PRODUCT_DATA_COMPONENTMetadata as the class
    // that carries additional metadata for the PRODUCT_DATA_COMPONENT class.
    [MetadataTypeAttribute(typeof(PRODUCT_DATA_COMPONENT.PRODUCT_DATA_COMPONENTMetadata))]
    public partial class PRODUCT_DATA_COMPONENT
    {

        // This class allows you to attach custom attributes to properties
        // of the PRODUCT_DATA_COMPONENT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PRODUCT_DATA_COMPONENTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PRODUCT_DATA_COMPONENTMetadata()
            {
            }

            public string COMPONENT_CODE { get; set; }

            public int COMPONENT_CODE_SAKEY { get; set; }

            public int COMPONENT_NUM { get; set; }

            public int COMPONENT_TYPE_SAKEY { get; set; }

            public PRODUCT_DATA PRODUCT_DATA { get; set; }

            public decimal PRODUCT_DATA_COMPONENT_SAKEY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PRODUCT_DATA_MARRIAGEMetadata as the class
    // that carries additional metadata for the PRODUCT_DATA_MARRIAGE class.
    [MetadataTypeAttribute(typeof(PRODUCT_DATA_MARRIAGE.PRODUCT_DATA_MARRIAGEMetadata))]
    public partial class PRODUCT_DATA_MARRIAGE
    {

        // This class allows you to attach custom attributes to properties
        // of the PRODUCT_DATA_MARRIAGE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PRODUCT_DATA_MARRIAGEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PRODUCT_DATA_MARRIAGEMetadata()
            {
            }

            public Nullable<DateTime> MARRIAGE_DTS { get; set; }

            public PRODUCT_DATA PRODUCT_DATA { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public string TRANS_MODEL_CODE { get; set; }

            public string TRANS_SERIAL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PRODUCT_DATA_REJMetadata as the class
    // that carries additional metadata for the PRODUCT_DATA_REJ class.
    [MetadataTypeAttribute(typeof(PRODUCT_DATA_REJ.PRODUCT_DATA_REJMetadata))]
    public partial class PRODUCT_DATA_REJ
    {

        // This class allows you to attach custom attributes to properties
        // of the PRODUCT_DATA_REJ class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PRODUCT_DATA_REJMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PRODUCT_DATA_REJMetadata()
            {
            }

            public string CURRENT_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public PRODUCT_DATA PRODUCT_DATA { get; set; }

            public int PRODUCT_DATA_REJ_SAKEY { get; set; }

            public DateTime REJ_DEFN_REV_DTS { get; set; }

            public decimal REJ_ID { get; set; }

            public decimal REJ_ORDER_NUM { get; set; }

            public Nullable<int> REPAIR_MADE_SAKEY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public Nullable<int> TP_DEFN_SAKEY { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PRODUCT_DATA_STATMetadata as the class
    // that carries additional metadata for the PRODUCT_DATA_STAT class.
    [MetadataTypeAttribute(typeof(PRODUCT_DATA_STAT.PRODUCT_DATA_STATMetadata))]
    public partial class PRODUCT_DATA_STAT
    {

        // This class allows you to attach custom attributes to properties
        // of the PRODUCT_DATA_STAT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PRODUCT_DATA_STATMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PRODUCT_DATA_STATMetadata()
            {
            }

          //  public string COLUMN1 { get; set; }

            public PRODUCT_DATA PRODUCT_DATA { get; set; }

            [Include] // Modification: Allows accessibility from this class.
            public PRODUCT_DATA_STAT_DESC PRODUCT_DATA_STAT_DESC { get; set; }

            public decimal PRODUCT_DATA_STAT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PRODUCT_DATA_STAT_DESCMetadata as the class
    // that carries additional metadata for the PRODUCT_DATA_STAT_DESC class.
    [MetadataTypeAttribute(typeof(PRODUCT_DATA_STAT_DESC.PRODUCT_DATA_STAT_DESCMetadata))]
    public partial class PRODUCT_DATA_STAT_DESC
    {

        // This class allows you to attach custom attributes to properties
        // of the PRODUCT_DATA_STAT_DESC class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PRODUCT_DATA_STAT_DESCMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PRODUCT_DATA_STAT_DESCMetadata()
            {
            }

            public string LONG_DESC_TEXT { get; set; }

            public EntityCollection<MBX_TEST_STATUS> MBX_TEST_STATUS { get; set; }

            public EntityCollection<PRODUCT_DATA_STAT> PRODUCT_DATA_STAT { get; set; }

            public decimal PRODUCT_DATA_STAT_ID { get; set; }

            public string SHORT_DESC_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PRODUCT_DATA_TCMetadata as the class
    // that carries additional metadata for the PRODUCT_DATA_TC class.
    [MetadataTypeAttribute(typeof(PRODUCT_DATA_TC.PRODUCT_DATA_TCMetadata))]
    public partial class PRODUCT_DATA_TC
    {

        // This class allows you to attach custom attributes to properties
        // of the PRODUCT_DATA_TC class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PRODUCT_DATA_TCMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PRODUCT_DATA_TCMetadata()
            {
            }

            public string STAND_CODE { get; set; }

            public string TC_SERIAL_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies PRODUCT_DATA_VBMetadata as the class
    // that carries additional metadata for the PRODUCT_DATA_VB class.
    [MetadataTypeAttribute(typeof(PRODUCT_DATA_VB.PRODUCT_DATA_VBMetadata))]
    public partial class PRODUCT_DATA_VB
    {

        // This class allows you to attach custom attributes to properties
        // of the PRODUCT_DATA_VB class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class PRODUCT_DATA_VBMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private PRODUCT_DATA_VBMetadata()
            {
            }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public string VB_MODEL_CODE { get; set; }

            public string VB_SERIAL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies QUERY_DEFNMetadata as the class
    // that carries additional metadata for the QUERY_DEFN class.
    [MetadataTypeAttribute(typeof(QUERY_DEFN.QUERY_DEFNMetadata))]
    public partial class QUERY_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the QUERY_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class QUERY_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private QUERY_DEFNMetadata()
            {
            }

            public string PROGRAM_NAME { get; set; }

            public decimal QUERY_ID { get; set; }

            public string QUERY_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies RAMP_PARAM_DEFNMetadata as the class
    // that carries additional metadata for the RAMP_PARAM_DEFN class.
    [MetadataTypeAttribute(typeof(RAMP_PARAM_DEFN.RAMP_PARAM_DEFNMetadata))]
    public partial class RAMP_PARAM_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the RAMP_PARAM_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class RAMP_PARAM_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private RAMP_PARAM_DEFNMetadata()
            {
            }

            public decimal ENDPOINT_QTY { get; set; }

            public decimal ENDPOINT_TYPE_NUM { get; set; }

            public FAMILY_DEFN FAMILY_DEFN { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string FEEDBACK_TAG_NAME { get; set; }

            public decimal GOODREAD_QTY { get; set; }

            public decimal GOODREAD_TYPE_NUM { get; set; }

            public string OUTPUT_TAG_NAME { get; set; }

            public decimal RAMP_ID { get; set; }

            public string RAMP_NAME { get; set; }

            public DateTime RAMP_PARAM_DEFN_REV_DTS { get; set; }

            public string RAMP_TEXT { get; set; }

            public int RAMP_TEXT_DESC_SAKEY { get; set; }

            public decimal RATE_QTY { get; set; }

            public decimal RATE_TYPE_NUM { get; set; }

            public decimal SETPOINT_QTY { get; set; }

            public decimal SETPOINT_TYPE_NUM { get; set; }

            public TAG_DEFN TAG_DEFN { get; set; }

            public TAG_DEFN TAG_DEFN1 { get; set; }

            public TEXT_DESC TEXT_DESC { get; set; }

            public decimal TIMEOUT_QTY { get; set; }

            public decimal TIMEOUT_TYPE_NUM { get; set; }

            public decimal TOLERANCE_QTY { get; set; }

            public decimal TOLERANCE_TYPE_NUM { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies REJ_ASSO_TP_DEFNMetadata as the class
    // that carries additional metadata for the REJ_ASSO_TP_DEFN class.
    [MetadataTypeAttribute(typeof(REJ_ASSO_TP_DEFN.REJ_ASSO_TP_DEFNMetadata))]
    public partial class REJ_ASSO_TP_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the REJ_ASSO_TP_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class REJ_ASSO_TP_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private REJ_ASSO_TP_DEFNMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public DateTime REJ_DEFN_REV_DTS { get; set; }

            public decimal REJ_ID { get; set; }

            public decimal TP_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies REJ_DEFNMetadata as the class
    // that carries additional metadata for the REJ_DEFN class.
    [MetadataTypeAttribute(typeof(REJ_DEFN.REJ_DEFNMetadata))]
    public partial class REJ_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the REJ_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class REJ_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private REJ_DEFNMetadata()
            {
            }

            public string CUSTOM_PHRASE_FLAG { get; set; }

            public FAMILY_DEFN FAMILY_DEFN { get; set; }

            public decimal FAMILY_ID { get; set; }

            public Nullable<int> MISC_PHRASE_SAKEY { get; set; }

            public Nullable<int> PARAM_PHRASE_SAKEY { get; set; }

            public Nullable<int> PHASE_PHRASE_SAKEY { get; set; }

            public int REJ_ACTION_TEXT_DESC_SAKEY { get; set; }

            public DateTime REJ_DEFN_REV_DTS { get; set; }

            public decimal REJ_ID { get; set; }

            public string REJ_TEXT { get; set; }

            public int REJ_TYPE_TEXT_DESC_SAKEY { get; set; }

            public Nullable<decimal> REJ_ZONE { get; set; }

            public Nullable<int> REJECT_GROUP_SAKEY { get; set; }

            public Nullable<int> STAT_PHRASE_SAKEY { get; set; }

            public Nullable<int> STEP_PHRASE_SAKEY { get; set; }

            public TEST_TEXT TEST_TEXT { get; set; }

            public TEST_TEXT TEST_TEXT1 { get; set; }

            public TEST_TEXT TEST_TEXT2 { get; set; }

            public TEST_TEXT TEST_TEXT3 { get; set; }

            public TEXT_DESC TEXT_DESC { get; set; }

            public TEXT_DESC TEXT_DESC1 { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies REJ_TP_DEFNMetadata as the class
    // that carries additional metadata for the REJ_TP_DEFN class.
    [MetadataTypeAttribute(typeof(REJ_TP_DEFN.REJ_TP_DEFNMetadata))]
    public partial class REJ_TP_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the REJ_TP_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class REJ_TP_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private REJ_TP_DEFNMetadata()
            {
            }

            public string LIMIT_CODE { get; set; }

            public decimal REJ_ID { get; set; }

            public TP_DEFN TP_DEFN { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies REJ_TRIGGER_DEFNMetadata as the class
    // that carries additional metadata for the REJ_TRIGGER_DEFN class.
    [MetadataTypeAttribute(typeof(REJ_TRIGGER_DEFN.REJ_TRIGGER_DEFNMetadata))]
    public partial class REJ_TRIGGER_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the REJ_TRIGGER_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class REJ_TRIGGER_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private REJ_TRIGGER_DEFNMetadata()
            {
            }

            public Nullable<decimal> FAMILY_ID { get; set; }

            public decimal REJ_ID { get; set; }

            public decimal STAND_TRIGGER_TYPE_ID { get; set; }

            public decimal TRIGGERED_REJ_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies REPAIR_MADEMetadata as the class
    // that carries additional metadata for the REPAIR_MADE class.
    [MetadataTypeAttribute(typeof(REPAIR_MADE.REPAIR_MADEMetadata))]
    public partial class REPAIR_MADE
    {

        // This class allows you to attach custom attributes to properties
        // of the REPAIR_MADE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class REPAIR_MADEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private REPAIR_MADEMetadata()
            {
            }

            public int LEVEL_1 { get; set; }

            public Nullable<int> LEVEL_2 { get; set; }

            public Nullable<int> LEVEL_3 { get; set; }

            public Nullable<int> LEVEL_4 { get; set; }

            public int ORIGIN { get; set; }

            public decimal REJ_ORDER_NUM { get; set; }

            public DateTime REPAIR_DTS { get; set; }

            public int REPAIR_MADE_SAKEY { get; set; }

            public string REPAIR_MAN_TEXT { get; set; }

            public REPAIR_TEXT REPAIR_TEXT { get; set; }

            public REPAIR_TEXT REPAIR_TEXT1 { get; set; }

            public REPAIR_TEXT REPAIR_TEXT2 { get; set; }

            public REPAIR_TEXT REPAIR_TEXT3 { get; set; }

            public REPAIR_TEXT REPAIR_TEXT4 { get; set; }

            public decimal REPAIR_TIME_SECS_DURN { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies REPAIR_TEXTMetadata as the class
    // that carries additional metadata for the REPAIR_TEXT class.
    [MetadataTypeAttribute(typeof(REPAIR_TEXT.REPAIR_TEXTMetadata))]
    public partial class REPAIR_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the REPAIR_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class REPAIR_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private REPAIR_TEXTMetadata()
            {
            }

            public string REPAIR_LEVEL_TEXT { get; set; }

            public EntityCollection<REPAIR_MADE> REPAIR_MADE { get; set; }

            public EntityCollection<REPAIR_MADE> REPAIR_MADE1 { get; set; }

            public EntityCollection<REPAIR_MADE> REPAIR_MADE2 { get; set; }

            public EntityCollection<REPAIR_MADE> REPAIR_MADE3 { get; set; }

            public EntityCollection<REPAIR_MADE> REPAIR_MADE4 { get; set; }

            public decimal REPAIR_TEXT_ID { get; set; }

            public string REPAIR_TEXT_LEVEL { get; set; }

            public DateTime REPAIR_TEXT_REV_DTS { get; set; }

            public int REPAIR_TEXT_SAKEY { get; set; }

            public EntityCollection<REPAIR_TREE> REPAIR_TREE { get; set; }

            public EntityCollection<REPAIR_TREE> REPAIR_TREE1 { get; set; }

            public EntityCollection<REPAIR_TREE> REPAIR_TREE2 { get; set; }

            public EntityCollection<REPAIR_TREE> REPAIR_TREE3 { get; set; }

            public EntityCollection<SUGGESTED_TEXT> SUGGESTED_TEXT { get; set; }

            public EntityCollection<SUGGESTED_TEXT> SUGGESTED_TEXT1 { get; set; }

            public EntityCollection<SUGGESTED_TEXT> SUGGESTED_TEXT2 { get; set; }

            public EntityCollection<SUGGESTED_TEXT> SUGGESTED_TEXT3 { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies REPAIR_TREEMetadata as the class
    // that carries additional metadata for the REPAIR_TREE class.
    [MetadataTypeAttribute(typeof(REPAIR_TREE.REPAIR_TREEMetadata))]
    public partial class REPAIR_TREE
    {

        // This class allows you to attach custom attributes to properties
        // of the REPAIR_TREE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class REPAIR_TREEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private REPAIR_TREEMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public int LEVEL_1 { get; set; }

            public Nullable<int> LEVEL_2 { get; set; }

            public Nullable<int> LEVEL_3 { get; set; }

            public Nullable<int> LEVEL_4 { get; set; }

            public REPAIR_TEXT REPAIR_TEXT { get; set; }

            public REPAIR_TEXT REPAIR_TEXT1 { get; set; }

            public REPAIR_TEXT REPAIR_TEXT2 { get; set; }

            public REPAIR_TEXT REPAIR_TEXT3 { get; set; }

            public Nullable<DateTime> REPAIR_TREE_REV_DTS { get; set; }

            public int REPAIR_TREE_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies SEQUENCE_DEFNMetadata as the class
    // that carries additional metadata for the SEQUENCE_DEFN class.
    [MetadataTypeAttribute(typeof(SEQUENCE_DEFN.SEQUENCE_DEFNMetadata))]
    public partial class SEQUENCE_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the SEQUENCE_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class SEQUENCE_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private SEQUENCE_DEFNMetadata()
            {
            }

            public string ACTIVE { get; set; }

            public Nullable<decimal> HEARTBEAT_INCREMENT { get; set; }

            public Nullable<decimal> HEARTBEAT_INTERVAL { get; set; }

            public string HEARTBEAT_TAG { get; set; }

            public Nullable<decimal> INACTIVE_TIMEOUT { get; set; }

            public decimal SEQ_DEFN_SAKEY { get; set; }

            public DateTime SEQUENCE_DEFN_REV_DTS { get; set; }

            public decimal SEQUENCE_ID { get; set; }

            public string SEQUENCE_TEXT { get; set; }

            public decimal TYPE_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies SHIFT_DEFNMetadata as the class
    // that carries additional metadata for the SHIFT_DEFN class.
    [MetadataTypeAttribute(typeof(SHIFT_DEFN.SHIFT_DEFNMetadata))]
    public partial class SHIFT_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the SHIFT_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class SHIFT_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private SHIFT_DEFNMetadata()
            {
            }

            public EntityCollection<AUTO_CAL_DATA> AUTO_CAL_DATA { get; set; }

            public DateTime END_TIME { get; set; }

            public EntityCollection<PRODUCT_DATA> PRODUCT_DATA { get; set; }

            public decimal SHIFT_ID { get; set; }

            public DateTime START_TIME { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies STAND_DEFNMetadata as the class
    // that carries additional metadata for the STAND_DEFN class.
    [MetadataTypeAttribute(typeof(STAND_DEFN.STAND_DEFNMetadata))]
    public partial class STAND_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the STAND_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class STAND_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private STAND_DEFNMetadata()
            {
            }

            public string BT_CODE { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime STAND_DEFN_REV_DTS { get; set; }

            public Nullable<decimal> STAND_NUMBER { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies STAND_TRIGGER_TYPE_DEFNMetadata as the class
    // that carries additional metadata for the STAND_TRIGGER_TYPE_DEFN class.
    [MetadataTypeAttribute(typeof(STAND_TRIGGER_TYPE_DEFN.STAND_TRIGGER_TYPE_DEFNMetadata))]
    public partial class STAND_TRIGGER_TYPE_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the STAND_TRIGGER_TYPE_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class STAND_TRIGGER_TYPE_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private STAND_TRIGGER_TYPE_DEFNMetadata()
            {
            }

            public string ACTION { get; set; }

            public decimal PERIOD_QTY { get; set; }

            public string RESET_ACTION { get; set; }

            public string STAND_CODE { get; set; }

            public decimal STAND_TRIGGER_TYPE_ID { get; set; }

            public decimal THRESHOLD_QTY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies SUGGESTED_TEXTMetadata as the class
    // that carries additional metadata for the SUGGESTED_TEXT class.
    [MetadataTypeAttribute(typeof(SUGGESTED_TEXT.SUGGESTED_TEXTMetadata))]
    public partial class SUGGESTED_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the SUGGESTED_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class SUGGESTED_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private SUGGESTED_TEXTMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<int> LEVEL_1 { get; set; }

            public Nullable<int> LEVEL_2 { get; set; }

            public Nullable<int> LEVEL_3 { get; set; }

            public Nullable<int> LEVEL_4 { get; set; }

            public decimal PRIORITY_NUM { get; set; }

            public DateTime REJ_DEFN_REV_DTS { get; set; }

            public decimal REJ_ID { get; set; }

            public REPAIR_TEXT REPAIR_TEXT { get; set; }

            public REPAIR_TEXT REPAIR_TEXT1 { get; set; }

            public REPAIR_TEXT REPAIR_TEXT2 { get; set; }

            public REPAIR_TEXT REPAIR_TEXT3 { get; set; }

            public string SUGGESTED_TEXT1 { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies SYS_PARAMSMetadata as the class
    // that carries additional metadata for the SYS_PARAMS class.
    [MetadataTypeAttribute(typeof(SYS_PARAMS.SYS_PARAMSMetadata))]
    public partial class SYS_PARAMS
    {

        // This class allows you to attach custom attributes to properties
        // of the SYS_PARAMS class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class SYS_PARAMSMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private SYS_PARAMSMetadata()
            {
            }

            public string PGM_NAME { get; set; }

            public string PGM_USER { get; set; }

            public SYS_PARAMS_LONG SYS_PARAMS_LONG { get; set; }

            public string SYS_PARAMS_NAME { get; set; }

            public DateTime SYS_PARAMS_REV_DTS { get; set; }

            public int SYS_PARAMS_SAKEY { get; set; }

            public SYS_PARAMS_STRING SYS_PARAMS_STRING { get; set; }

            public int SYS_PARAMS_TYPE_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies SYS_PARAMS_FLOATMetadata as the class
    // that carries additional metadata for the SYS_PARAMS_FLOAT class.
    [MetadataTypeAttribute(typeof(SYS_PARAMS_FLOAT.SYS_PARAMS_FLOATMetadata))]
    public partial class SYS_PARAMS_FLOAT
    {

        // This class allows you to attach custom attributes to properties
        // of the SYS_PARAMS_FLOAT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class SYS_PARAMS_FLOATMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private SYS_PARAMS_FLOATMetadata()
            {
            }

            public decimal SYS_PARAMS_FLOAT_VALUE { get; set; }

            public int SYS_PARAMS_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies SYS_PARAMS_LONGMetadata as the class
    // that carries additional metadata for the SYS_PARAMS_LONG class.
    [MetadataTypeAttribute(typeof(SYS_PARAMS_LONG.SYS_PARAMS_LONGMetadata))]
    public partial class SYS_PARAMS_LONG
    {

        // This class allows you to attach custom attributes to properties
        // of the SYS_PARAMS_LONG class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class SYS_PARAMS_LONGMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private SYS_PARAMS_LONGMetadata()
            {
            }

            public SYS_PARAMS SYS_PARAMS { get; set; }

            public Nullable<int> SYS_PARAMS_LONG_VALUE { get; set; }

            public int SYS_PARAMS_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies SYS_PARAMS_STRINGMetadata as the class
    // that carries additional metadata for the SYS_PARAMS_STRING class.
    [MetadataTypeAttribute(typeof(SYS_PARAMS_STRING.SYS_PARAMS_STRINGMetadata))]
    public partial class SYS_PARAMS_STRING
    {

        // This class allows you to attach custom attributes to properties
        // of the SYS_PARAMS_STRING class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class SYS_PARAMS_STRINGMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private SYS_PARAMS_STRINGMetadata()
            {
            }

            public SYS_PARAMS SYS_PARAMS { get; set; }

            public int SYS_PARAMS_SAKEY { get; set; }

            public string SYS_PARAMS_STRING_VALUE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies SYSTEM_INFOMetadata as the class
    // that carries additional metadata for the SYSTEM_INFO class.
    [MetadataTypeAttribute(typeof(SYSTEM_INFO.SYSTEM_INFOMetadata))]
    public partial class SYSTEM_INFO
    {

        // This class allows you to attach custom attributes to properties
        // of the SYSTEM_INFO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class SYSTEM_INFOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private SYSTEM_INFOMetadata()
            {
            }

            public string COMPANY { get; set; }

            public string EDITOR_VERSION { get; set; }

            public string LIMIT_RECALC_FUNCTION { get; set; }

            public string MAX_SERIAL_CODE { get; set; }

            public Nullable<int> NO_OF_ASSO_SUGGS { get; set; }

            public Nullable<int> NO_OF_CALC_IN { get; set; }

            public Nullable<int> NO_OF_CALC_OUT { get; set; }

            public Nullable<int> NO_OF_CARRIERS { get; set; }

            public Nullable<int> NO_OF_COM_TO_LAD { get; set; }

            public Nullable<int> NO_OF_DIGITAL_INPUTS { get; set; }

            public Nullable<int> NO_OF_DIGITAL_OUTPUTS { get; set; }

            public Nullable<int> NO_OF_FAMILY { get; set; }

            public Nullable<int> NO_OF_FIXTURES { get; set; }

            public Nullable<int> NO_OF_HIGHSPEED_ANALOGS { get; set; }

            public Nullable<int> NO_OF_INTERNALS { get; set; }

            public Nullable<int> NO_OF_LAD_TO_COM { get; set; }

            public Nullable<int> NO_OF_LINES { get; set; }

            public Nullable<int> NO_OF_MODEL_PARAMS { get; set; }

            public Nullable<int> NO_OF_MODELS { get; set; }

            public Nullable<int> NO_OF_MONITORS { get; set; }

            public Nullable<int> NO_OF_PALLET_PARAMS { get; set; }

            public Nullable<int> NO_OF_PALLETS { get; set; }

            public Nullable<int> NO_OF_PHRASES { get; set; }

            public Nullable<int> NO_OF_RAMPS { get; set; }

            public Nullable<int> NO_OF_RAW_ANALOG_IN { get; set; }

            public Nullable<int> NO_OF_RAW_ANALOG_OUT { get; set; }

            public Nullable<int> NO_OF_REJECT_ACTIONS { get; set; }

            public Nullable<int> NO_OF_REJECT_TYPE_TEXT { get; set; }

            public Nullable<int> NO_OF_REJECT_TYPES { get; set; }

            public Nullable<int> NO_OF_REJECTS { get; set; }

            public Nullable<int> NO_OF_REPAIR_TEXT { get; set; }

            public Nullable<int> NO_OF_STAND_PARAMS { get; set; }

            public Nullable<int> NO_OF_STANDS { get; set; }

            public Nullable<int> NO_OF_STATIONS { get; set; }

            public Nullable<int> NO_OF_TEST_DATA_POINTS { get; set; }

            public Nullable<int> NO_OF_TEST_SEQUENCES { get; set; }

            public Nullable<int> NO_OF_THREADS { get; set; }

            public string PART_LIST { get; set; }

            public string PLANT { get; set; }

            public string PRODUCT { get; set; }

            public string SYSTEM_TYPE { get; set; }

            public string TAGS { get; set; }

            public string TRIGGERED_REJ_SUPPORT { get; set; }

            public string ZONES { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies TAG_DEFNMetadata as the class
    // that carries additional metadata for the TAG_DEFN class.
    [MetadataTypeAttribute(typeof(TAG_DEFN.TAG_DEFNMetadata))]
    public partial class TAG_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the TAG_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class TAG_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private TAG_DEFNMetadata()
            {
            }

            public string CHARACTERIZATION_TAG_NAME { get; set; }

            public Nullable<decimal> CONTROL_ID { get; set; }

            public Nullable<decimal> DEVICE_NUM { get; set; }

            public EntityCollection<FAMILY_TAG_TEXT> FAMILY_TAG_TEXT { get; set; }

            public string FEEDBACK_TAG_NAME { get; set; }

            public decimal IO_CHANNEL_NUM { get; set; }

            public EntityCollection<IO_DEFN> IO_DEFN { get; set; }

            public int IO_TYPE_TEXT_DESC_SAKEY { get; set; }

            public EntityCollection<MONTR_PARAM_DEFN> MONTR_PARAM_DEFN { get; set; }

            public EntityCollection<MONTR_PARAM_DEFN> MONTR_PARAM_DEFN1 { get; set; }

            public EntityCollection<RAMP_PARAM_DEFN> RAMP_PARAM_DEFN { get; set; }

            public EntityCollection<RAMP_PARAM_DEFN> RAMP_PARAM_DEFN1 { get; set; }

            public string SHORT_NAME { get; set; }

            public DateTime TAG_DEFN_REV_DTS { get; set; }

            public EntityCollection<TAG_DEFN> TAG_DEFN1 { get; set; }

            public TAG_DEFN TAG_DEFN2 { get; set; }

            public string TAG_NAME { get; set; }

            public TEXT_DESC TEXT_DESC { get; set; }

            public string TSI_NAME { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies TCU_DEFNMetadata as the class
    // that carries additional metadata for the TCU_DEFN class.
    [MetadataTypeAttribute(typeof(TCU_DEFN.TCU_DEFNMetadata))]
    public partial class TCU_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the TCU_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class TCU_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private TCU_DEFNMetadata()
            {
            }

            public Nullable<decimal> ADDRESS { get; set; }

            public EntityCollection<MODEL_TCU_DEFN> MODEL_TCU_DEFN { get; set; }

            public Nullable<decimal> NO_OF_SEGMENTS { get; set; }

            public Nullable<decimal> PAGE_SIZE { get; set; }

            public Nullable<decimal> PAGES_PER_SEGMENT { get; set; }

            public int TCU_DEFN_SAKEY { get; set; }

            public string TCU_DESC { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies TEST_RECORDMetadata as the class
    // that carries additional metadata for the TEST_RECORD class.
    [MetadataTypeAttribute(typeof(TEST_RECORD.TEST_RECORDMetadata))]
    public partial class TEST_RECORD
    {

        // This class allows you to attach custom attributes to properties
        // of the TEST_RECORD class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class TEST_RECORDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private TEST_RECORDMetadata()
            {
            }

            public string CURRENT_FLAG { get; set; }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public string HIGH_PARAM_CODE { get; set; }

            public Nullable<decimal> HIGH_PARAM_ID { get; set; }

            public string LOW_PARAM_CODE { get; set; }

            public Nullable<decimal> LOW_PARAM_ID { get; set; }

            public string MACHINE { get; set; }

            public Nullable<DateTime> MAX_PARAM_VAL_REV_DTS { get; set; }

            public Nullable<decimal> PHASE_ORDER_NUM { get; set; }

            public Nullable<decimal> PHASE_PHRASE_ID { get; set; }

            public string PHASE_PHRASE_TEXT { get; set; }

            public Nullable<decimal> REJ_ID { get; set; }

            public Nullable<decimal> REJ_ORDER_NUM { get; set; }

            public string REJ_TEXT { get; set; }

            public Nullable<decimal> REJ_TP_QTY { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STEP_ORDER_NUM { get; set; }

            public Nullable<decimal> STEP_PHRASE_ID { get; set; }

            public string STEP_PHRASE_TEXT { get; set; }

            public Nullable<DateTime> TEST_DTS { get; set; }

            public Nullable<decimal> THREAD_NUM { get; set; }

            public Nullable<int> TP_DEFN_SAKEY { get; set; }

            public Nullable<decimal> TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public string TP_TEXT { get; set; }

            public string UNITS_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies TEST_RECORD_TWOMetadata as the class
    // that carries additional metadata for the TEST_RECORD_TWO class.
    [MetadataTypeAttribute(typeof(TEST_RECORD_TWO.TEST_RECORD_TWOMetadata))]
    public partial class TEST_RECORD_TWO
    {

        // This class allows you to attach custom attributes to properties
        // of the TEST_RECORD_TWO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class TEST_RECORD_TWOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private TEST_RECORD_TWOMetadata()
            {
            }

            public string CURRENT_FLAG { get; set; }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public string HIGH_PARAM_CODE { get; set; }

            public Nullable<decimal> HIGH_PARAM_ID { get; set; }

            public Nullable<decimal> HIGH_PARAM_QTY { get; set; }

            public Nullable<int> LEVEL_1 { get; set; }

            public Nullable<int> LEVEL_2 { get; set; }

            public Nullable<int> LEVEL_3 { get; set; }

            public Nullable<int> LEVEL_4 { get; set; }

            public string LOW_PARAM_CODE { get; set; }

            public Nullable<decimal> LOW_PARAM_ID { get; set; }

            public Nullable<decimal> LOW_PARAM_QTY { get; set; }

            public string MACHINE { get; set; }

            public Nullable<DateTime> MAX_PARAM_VAL_REV_DTS { get; set; }

            public Nullable<int> ORIGIN { get; set; }

            public Nullable<decimal> PHASE_ORDER_NUM { get; set; }

            public Nullable<decimal> PHASE_PHRASE_ID { get; set; }

            public string PHASE_PHRASE_TEXT { get; set; }

            public Nullable<int> PRODUCT_DATA_REJ_SAKEY { get; set; }

            public Nullable<DateTime> REJ_DEFN_REV_DTS { get; set; }

            public Nullable<decimal> REJ_ID { get; set; }

            public Nullable<decimal> REJ_ORDER_NUM { get; set; }

            public string REJ_TEXT { get; set; }

            public Nullable<decimal> REJ_TP_QTY { get; set; }

            public Nullable<int> REPAIR_MADE_SAKEY { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STEP_ORDER_NUM { get; set; }

            public Nullable<decimal> STEP_PHRASE_ID { get; set; }

            public string STEP_PHRASE_TEXT { get; set; }

            public Nullable<DateTime> TEST_DTS { get; set; }

            public Nullable<decimal> THREAD_NUM { get; set; }

            public Nullable<int> TP_DEFN_SAKEY { get; set; }

            public Nullable<decimal> TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public string TP_TEXT { get; set; }

            public string UNITS_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies TEST_TEXTMetadata as the class
    // that carries additional metadata for the TEST_TEXT class.
    [MetadataTypeAttribute(typeof(TEST_TEXT.TEST_TEXTMetadata))]
    public partial class TEST_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the TEST_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class TEST_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private TEST_TEXTMetadata()
            {
            }

            public FAMILY_DEFN FAMILY_DEFN { get; set; }

            public decimal FAMILY_ID { get; set; }

            public EntityCollection<REJ_DEFN> REJ_DEFN { get; set; }

            public EntityCollection<REJ_DEFN> REJ_DEFN1 { get; set; }

            public EntityCollection<REJ_DEFN> REJ_DEFN2 { get; set; }

            public EntityCollection<REJ_DEFN> REJ_DEFN3 { get; set; }

            public decimal TEST_TEXT_ID { get; set; }

            public string TEST_TEXT_LEVEL { get; set; }

            public DateTime TEST_TEXT_REV_DTS { get; set; }

            public int TEST_TEXT_SAKEY { get; set; }

            public string TEST_TEXT1 { get; set; }

            public EntityCollection<TP_DEFN> TP_DEFN { get; set; }

            public EntityCollection<TP_DEFN> TP_DEFN1 { get; set; }

            public EntityCollection<TP_DEFN> TP_DEFN2 { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies TEXT_DESCMetadata as the class
    // that carries additional metadata for the TEXT_DESC class.
    [MetadataTypeAttribute(typeof(TEXT_DESC.TEXT_DESCMetadata))]
    public partial class TEXT_DESC
    {

        // This class allows you to attach custom attributes to properties
        // of the TEXT_DESC class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class TEXT_DESCMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private TEXT_DESCMetadata()
            {
            }

            public EntityCollection<IO_DEFN> IO_DEFN { get; set; }

            public EntityCollection<MODEL_DEFN> MODEL_DEFN { get; set; }

            public EntityCollection<MONTR_PARAM_DEFN> MONTR_PARAM_DEFN { get; set; }

            public EntityCollection<RAMP_PARAM_DEFN> RAMP_PARAM_DEFN { get; set; }

            public EntityCollection<REJ_DEFN> REJ_DEFN { get; set; }

            public EntityCollection<REJ_DEFN> REJ_DEFN1 { get; set; }

            public EntityCollection<TAG_DEFN> TAG_DEFN { get; set; }

            public decimal TEXT_DESC_ID { get; set; }

            public DateTime TEXT_DESC_REV_DTS { get; set; }

            public int TEXT_DESC_SAKEY { get; set; }

            public string TEXT_DESC_TEXT { get; set; }

            public string TEXT_DESC_TYPE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies TP_DATAMetadata as the class
    // that carries additional metadata for the TP_DATA class.
    [MetadataTypeAttribute(typeof(TP_DATA.TP_DATAMetadata))]
    public partial class TP_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the TP_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class TP_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private TP_DATAMetadata()
            {
            }

            public PRODUCT_DATA PRODUCT_DATA { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies TP_DEFNMetadata as the class
    // that carries additional metadata for the TP_DEFN class.
    [MetadataTypeAttribute(typeof(TP_DEFN.TP_DEFNMetadata))]
    public partial class TP_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the TP_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class TP_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private TP_DEFNMetadata()
            {
            }

            public string CUSTOM_TEXT_FLAG { get; set; }

            public FAMILY_DEFN FAMILY_DEFN { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public Nullable<int> PARAM_PHRASE_SAKEY { get; set; }

            public EntityCollection<PARAM_TP_DEFN> PARAM_TP_DEFN { get; set; }

            public Nullable<int> PHASE_PHRASE_SAKEY { get; set; }

            public EntityCollection<REJ_TP_DEFN> REJ_TP_DEFN { get; set; }

            public Nullable<int> STEP_PHRASE_SAKEY { get; set; }

            public TEST_TEXT TEST_TEXT { get; set; }

            public TEST_TEXT TEST_TEXT1 { get; set; }

            public TEST_TEXT TEST_TEXT2 { get; set; }

            public string TP_ACTIVE_FLAG { get; set; }

            public DateTime TP_DEFN_REV_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public decimal TP_ID { get; set; }

            public string TP_TEXT { get; set; }

            public UNITS_TEXT UNITS_TEXT { get; set; }

            public int UNITS_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies UNITS_TEXTMetadata as the class
    // that carries additional metadata for the UNITS_TEXT class.
    [MetadataTypeAttribute(typeof(UNITS_TEXT.UNITS_TEXTMetadata))]
    public partial class UNITS_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the UNITS_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class UNITS_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private UNITS_TEXTMetadata()
            {
            }

            public EntityCollection<IO_DEFN> IO_DEFN { get; set; }

            public EntityCollection<IO_DEFN> IO_DEFN1 { get; set; }

            public EntityCollection<PARAM_DEFN> PARAM_DEFN { get; set; }

            public EntityCollection<TP_DEFN> TP_DEFN { get; set; }

            public DateTime UNITS_TEXT_REV_DTS { get; set; }

            public int UNITS_TEXT_SAKEY { get; set; }

            public string UNITS_TEXT1 { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VAR_SUM_TEMPMetadata as the class
    // that carries additional metadata for the VAR_SUM_TEMP class.
    [MetadataTypeAttribute(typeof(VAR_SUM_TEMP.VAR_SUM_TEMPMetadata))]
    public partial class VAR_SUM_TEMP
    {

        // This class allows you to attach custom attributes to properties
        // of the VAR_SUM_TEMP class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VAR_SUM_TEMPMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VAR_SUM_TEMPMetadata()
            {
            }
            [Editable(true)]
            public decimal FAMILY_ID { get; set; }
            [Editable(true)]
            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }
            [Editable(true)]
            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }
            [Editable(true)]
            public string MODEL_CODE { get; set; }
            [Editable(true)]
            public string STAND_CODE { get; set; }
            //[Editable(true)]
            public DateTime TEST_DTS_DAY { get; set; }
            [Editable(true)]
            public DateTime TP_DEFN_REV_DTS { get; set; }
            [Editable(true)]
            public decimal TP_ID { get; set; }
            [Editable(true)]
            public decimal TP_QTY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VAR_SUM_TEMP_MAXESMetadata as the class
    // that carries additional metadata for the VAR_SUM_TEMP_MAXES class.
    [MetadataTypeAttribute(typeof(VAR_SUM_TEMP_MAXES.VAR_SUM_TEMP_MAXESMetadata))]
    public partial class VAR_SUM_TEMP_MAXES
    {

        // This class allows you to attach custom attributes to properties
        // of the VAR_SUM_TEMP_MAXES class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VAR_SUM_TEMP_MAXESMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VAR_SUM_TEMP_MAXESMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public DateTime MAX_TP_DEFN_REV_DTS { get; set; }

            public DateTime TEST_DTS_DAY { get; set; }

            public decimal TP_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VAR_TREND_SUMMetadata as the class
    // that carries additional metadata for the VAR_TREND_SUM class.
    [MetadataTypeAttribute(typeof(VAR_TREND_SUM.VAR_TREND_SUMMetadata))]
    public partial class VAR_TREND_SUM
    {

        // This class allows you to attach custom attributes to properties
        // of the VAR_TREND_SUM class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VAR_TREND_SUMMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VAR_TREND_SUMMetadata()
            {
            }

            public string ACTIVE { get; set; }

            public Nullable<decimal> CP_QTY { get; set; }

            public Nullable<decimal> CPK_QTY { get; set; }

            public DateTime DATA_DTS { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string FORMAT { get; set; }

            public Nullable<decimal> HI_LIMIT_QTY { get; set; }

            public string HIGH_PARAM_CODE { get; set; }

            public Nullable<decimal> HIGH_PARAM_ID { get; set; }

            public string HIGH_REJ_ID { get; set; }

            public Nullable<decimal> LO_LIMIT_QTY { get; set; }

            public string LOW_PARAM_CODE { get; set; }

            public Nullable<decimal> LOW_PARAM_ID { get; set; }

            public string LOW_REJ_ID { get; set; }

            public Nullable<decimal> MAX_QTY { get; set; }

            public Nullable<decimal> MEAN_QTY { get; set; }

            public Nullable<decimal> MIN_QTY { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> SAMPLES { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STD_DEV_QTY { get; set; }

            public Nullable<decimal> SUM_X { get; set; }

            public Nullable<decimal> SUM_X2 { get; set; }

            public decimal TP_ID { get; set; }

            public string TP_TEXT { get; set; }

            public string UNITS_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VAR_TREND_SUM_TEMPMetadata as the class
    // that carries additional metadata for the VAR_TREND_SUM_TEMP class.
    [MetadataTypeAttribute(typeof(VAR_TREND_SUM_TEMP.VAR_TREND_SUM_TEMPMetadata))]
    public partial class VAR_TREND_SUM_TEMP
    {

        // This class allows you to attach custom attributes to properties
        // of the VAR_TREND_SUM_TEMP class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VAR_TREND_SUM_TEMPMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VAR_TREND_SUM_TEMPMetadata()
            {
            }

            public string ACTIVE { get; set; }

            public Nullable<decimal> CP_QTY { get; set; }

            public Nullable<decimal> CPK_QTY { get; set; }

            public DateTime DATA_DTS { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string FORMAT { get; set; }

            public Nullable<decimal> HI_LIMIT_QTY { get; set; }

            public string HIGH_PARAM_CODE { get; set; }

            public Nullable<decimal> HIGH_PARAM_ID { get; set; }

            public string HIGH_REJ_ID { get; set; }

            public Nullable<decimal> LO_LIMIT_QTY { get; set; }

            public string LOW_PARAM_CODE { get; set; }

            public Nullable<decimal> LOW_PARAM_ID { get; set; }

            public string LOW_REJ_ID { get; set; }

            public Nullable<decimal> MAX_QTY { get; set; }

            public Nullable<decimal> MEAN_QTY { get; set; }

            public Nullable<decimal> MIN_QTY { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> SAMPLES { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STD_DEV_QTY { get; set; }

            public Nullable<decimal> SUM_X { get; set; }

            public Nullable<decimal> SUM_X2 { get; set; }

            public decimal TP_ID { get; set; }

            public string TP_TEXT { get; set; }

            public string UNITS_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VB_LEAK_DATAMetadata as the class
    // that carries additional metadata for the VB_LEAK_DATA class.
    [MetadataTypeAttribute(typeof(VB_LEAK_DATA.VB_LEAK_DATAMetadata))]
    public partial class VB_LEAK_DATA
    {

        // This class allows you to attach custom attributes to properties
        // of the VB_LEAK_DATA class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VB_LEAK_DATAMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VB_LEAK_DATAMetadata()
            {
            }

            public decimal LEAK_ID { get; set; }

            public decimal LEAK_QTY { get; set; }

            public string VB_MODEL_CODE { get; set; }

            public string VB_SERIAL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VB_MODEL_TABLE_DEFNMetadata as the class
    // that carries additional metadata for the VB_MODEL_TABLE_DEFN class.
    [MetadataTypeAttribute(typeof(VB_MODEL_TABLE_DEFN.VB_MODEL_TABLE_DEFNMetadata))]
    public partial class VB_MODEL_TABLE_DEFN
    {

        // This class allows you to attach custom attributes to properties
        // of the VB_MODEL_TABLE_DEFN class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VB_MODEL_TABLE_DEFNMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VB_MODEL_TABLE_DEFNMetadata()
            {
            }

            public string OWNER { get; set; }

            public string TABLE_NAME { get; set; }

            public string VB_MODEL_CODE { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_AUDIT_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_AUDIT_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_AUDIT_VIA_MBX_TABLE.VU_AUDIT_VIA_MBX_TABLEMetadata))]
    public partial class VU_AUDIT_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_AUDIT_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_AUDIT_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_AUDIT_VIA_MBX_TABLEMetadata()
            {
            }

            public DateTime AUDIT_DEFN_REV_DTS { get; set; }

            public Nullable<decimal> FAMILY_ID { get; set; }

            public int MBX_SAKEY { get; set; }

            public string REASON { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string TABLE_NAME { get; set; }

            public string USER_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_FLAT_LIMITMetadata as the class
    // that carries additional metadata for the VU_FLAT_LIMIT class.
    [MetadataTypeAttribute(typeof(VU_FLAT_LIMIT.VU_FLAT_LIMITMetadata))]
    public partial class VU_FLAT_LIMIT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_FLAT_LIMIT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_FLAT_LIMITMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_FLAT_LIMITMetadata()
            {
            }

            public Nullable<decimal> HIGH_LIMIT { get; set; }

            public string HIGH_PARAM_CODE { get; set; }

            public Nullable<decimal> HIGH_PARAM_ID { get; set; }

            public Nullable<decimal> LOW_LIMIT { get; set; }

            public string LOW_PARAM_CODE { get; set; }

            public Nullable<decimal> LOW_PARAM_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_GET_TP_RECALC_TIMEMetadata as the class
    // that carries additional metadata for the VU_GET_TP_RECALC_TIME class.
    [MetadataTypeAttribute(typeof(VU_GET_TP_RECALC_TIME.VU_GET_TP_RECALC_TIMEMetadata))]
    public partial class VU_GET_TP_RECALC_TIME
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_GET_TP_RECALC_TIME class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_GET_TP_RECALC_TIMEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_GET_TP_RECALC_TIMEMetadata()
            {
            }

            public string RECALC_LIMIT_TYPE { get; set; }

            public string RECALC_STAND_CODE { get; set; }

            public DateTime RECALC_START_TIME { get; set; }

            public decimal RECALC_TP_ID { get; set; }

            public string RECALC_TP_MODEL { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_HIGH_MODEL_LIMITMetadata as the class
    // that carries additional metadata for the VU_HIGH_MODEL_LIMIT class.
    [MetadataTypeAttribute(typeof(VU_HIGH_MODEL_LIMIT.VU_HIGH_MODEL_LIMITMetadata))]
    public partial class VU_HIGH_MODEL_LIMIT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_HIGH_MODEL_LIMIT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_HIGH_MODEL_LIMITMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_HIGH_MODEL_LIMITMetadata()
            {
            }

            public decimal PARAM_VAL_QTY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_HIGH_STAND_LIMITMetadata as the class
    // that carries additional metadata for the VU_HIGH_STAND_LIMIT class.
    [MetadataTypeAttribute(typeof(VU_HIGH_STAND_LIMIT.VU_HIGH_STAND_LIMITMetadata))]
    public partial class VU_HIGH_STAND_LIMIT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_HIGH_STAND_LIMIT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_HIGH_STAND_LIMITMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_HIGH_STAND_LIMITMetadata()
            {
            }

            public decimal PARAM_VAL_QTY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LEVEL_1_REPAIR_TEXTMetadata as the class
    // that carries additional metadata for the VU_LEVEL_1_REPAIR_TEXT class.
    [MetadataTypeAttribute(typeof(VU_LEVEL_1_REPAIR_TEXT.VU_LEVEL_1_REPAIR_TEXTMetadata))]
    public partial class VU_LEVEL_1_REPAIR_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LEVEL_1_REPAIR_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LEVEL_1_REPAIR_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LEVEL_1_REPAIR_TEXTMetadata()
            {
            }

            public string REPAIR_LEVEL_TEXT { get; set; }

            public decimal REPAIR_TEXT_ID { get; set; }

            public DateTime REPAIR_TEXT_REV_DTS { get; set; }

            public int REPAIR_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LEVEL_2_REPAIR_TEXTMetadata as the class
    // that carries additional metadata for the VU_LEVEL_2_REPAIR_TEXT class.
    [MetadataTypeAttribute(typeof(VU_LEVEL_2_REPAIR_TEXT.VU_LEVEL_2_REPAIR_TEXTMetadata))]
    public partial class VU_LEVEL_2_REPAIR_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LEVEL_2_REPAIR_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LEVEL_2_REPAIR_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LEVEL_2_REPAIR_TEXTMetadata()
            {
            }

            public string REPAIR_LEVEL_TEXT { get; set; }

            public decimal REPAIR_TEXT_ID { get; set; }

            public DateTime REPAIR_TEXT_REV_DTS { get; set; }

            public int REPAIR_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LEVEL_3_REPAIR_TEXTMetadata as the class
    // that carries additional metadata for the VU_LEVEL_3_REPAIR_TEXT class.
    [MetadataTypeAttribute(typeof(VU_LEVEL_3_REPAIR_TEXT.VU_LEVEL_3_REPAIR_TEXTMetadata))]
    public partial class VU_LEVEL_3_REPAIR_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LEVEL_3_REPAIR_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LEVEL_3_REPAIR_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LEVEL_3_REPAIR_TEXTMetadata()
            {
            }

            public string REPAIR_LEVEL_TEXT { get; set; }

            public decimal REPAIR_TEXT_ID { get; set; }

            public DateTime REPAIR_TEXT_REV_DTS { get; set; }

            public int REPAIR_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LEVEL_4_REPAIR_TEXTMetadata as the class
    // that carries additional metadata for the VU_LEVEL_4_REPAIR_TEXT class.
    [MetadataTypeAttribute(typeof(VU_LEVEL_4_REPAIR_TEXT.VU_LEVEL_4_REPAIR_TEXTMetadata))]
    public partial class VU_LEVEL_4_REPAIR_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LEVEL_4_REPAIR_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LEVEL_4_REPAIR_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LEVEL_4_REPAIR_TEXTMetadata()
            {
            }

            public string REPAIR_LEVEL_TEXT { get; set; }

            public decimal REPAIR_TEXT_ID { get; set; }

            public DateTime REPAIR_TEXT_REV_DTS { get; set; }

            public int REPAIR_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LIMITMetadata as the class
    // that carries additional metadata for the VU_LIMIT class.
    [MetadataTypeAttribute(typeof(VU_LIMIT.VU_LIMITMetadata))]
    public partial class VU_LIMIT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LIMIT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LIMITMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LIMITMetadata()
            {
            }

            public string LIMIT_CODE { get; set; }

            public string PARAM_CODE { get; set; }

            public decimal PARAM_ID { get; set; }

            public decimal PARAM_VAL_QTY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LIMIT_TEXTMetadata as the class
    // that carries additional metadata for the VU_LIMIT_TEXT class.
    [MetadataTypeAttribute(typeof(VU_LIMIT_TEXT.VU_LIMIT_TEXTMetadata))]
    public partial class VU_LIMIT_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LIMIT_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LIMIT_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LIMIT_TEXTMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public string LIMIT_CODE { get; set; }

            public string PARAM_CODE { get; set; }

            public decimal PARAM_ID { get; set; }

            public string PARAM_PHRASE_TEXT { get; set; }

            public string PHASE_PHRASE_TEXT { get; set; }

            public string STEP_PHRASE_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LIMIT_TEXT_NEWMetadata as the class
    // that carries additional metadata for the VU_LIMIT_TEXT_NEW class.
    [MetadataTypeAttribute(typeof(VU_LIMIT_TEXT_NEW.VU_LIMIT_TEXT_NEWMetadata))]
    public partial class VU_LIMIT_TEXT_NEW
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LIMIT_TEXT_NEW class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LIMIT_TEXT_NEWMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LIMIT_TEXT_NEWMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public string LIMIT_CODE { get; set; }

            public string PARAM_CODE { get; set; }

            public decimal PARAM_ID { get; set; }

            public Nullable<int> PARAM_PHRASE_SAKEY { get; set; }

            public Nullable<int> PHASE_PHRASE_SAKEY { get; set; }

            public Nullable<int> STEP_PHRASE_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LOW_MODEL_LIMITMetadata as the class
    // that carries additional metadata for the VU_LOW_MODEL_LIMIT class.
    [MetadataTypeAttribute(typeof(VU_LOW_MODEL_LIMIT.VU_LOW_MODEL_LIMITMetadata))]
    public partial class VU_LOW_MODEL_LIMIT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LOW_MODEL_LIMIT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LOW_MODEL_LIMITMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LOW_MODEL_LIMITMetadata()
            {
            }

            public decimal PARAM_VAL_QTY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_LOW_STAND_LIMITMetadata as the class
    // that carries additional metadata for the VU_LOW_STAND_LIMIT class.
    [MetadataTypeAttribute(typeof(VU_LOW_STAND_LIMIT.VU_LOW_STAND_LIMITMetadata))]
    public partial class VU_LOW_STAND_LIMIT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_LOW_STAND_LIMIT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_LOW_STAND_LIMITMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_LOW_STAND_LIMITMetadata()
            {
            }

            public decimal PARAM_VAL_QTY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_MISC_INFOMetadata as the class
    // that carries additional metadata for the VU_MISC_INFO class.
    [MetadataTypeAttribute(typeof(VU_MISC_INFO.VU_MISC_INFOMetadata))]
    public partial class VU_MISC_INFO
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_MISC_INFO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_MISC_INFOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_MISC_INFOMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public decimal MISC_PHRASE_ID { get; set; }

            public int MISC_PHRASE_SAKEY { get; set; }

            public string MISC_PHRASE_TEXT { get; set; }

            public DateTime MISC_PHRASE_TEXT_REV_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_ORIGIN_REPAIR_TEXTMetadata as the class
    // that carries additional metadata for the VU_ORIGIN_REPAIR_TEXT class.
    [MetadataTypeAttribute(typeof(VU_ORIGIN_REPAIR_TEXT.VU_ORIGIN_REPAIR_TEXTMetadata))]
    public partial class VU_ORIGIN_REPAIR_TEXT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_ORIGIN_REPAIR_TEXT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_ORIGIN_REPAIR_TEXTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_ORIGIN_REPAIR_TEXTMetadata()
            {
            }

            public string REPAIR_TEXT { get; set; }

            public decimal REPAIR_TEXT_ID { get; set; }

            public DateTime REPAIR_TEXT_REV_DTS { get; set; }

            public int REPAIR_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PARAM_DEFN_CRUSTMetadata as the class
    // that carries additional metadata for the VU_PARAM_DEFN_CRUST class.
    [MetadataTypeAttribute(typeof(VU_PARAM_DEFN_CRUST.VU_PARAM_DEFN_CRUSTMetadata))]
    public partial class VU_PARAM_DEFN_CRUST
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PARAM_DEFN_CRUST class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PARAM_DEFN_CRUSTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PARAM_DEFN_CRUSTMetadata()
            {
            }

            public string CUSTOM_TEXT_FLAG { get; set; }

            public Nullable<decimal> FAMILY_ID { get; set; }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public string PARAM_CODE { get; set; }

            public DateTime PARAM_DEFN_REV_DTS { get; set; }

            public int PARAM_DEFN_SAKEY { get; set; }

            public decimal PARAM_ID { get; set; }

            public string PARAM_TEXT { get; set; }

            public int UNITS_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PARAM_INFOMetadata as the class
    // that carries additional metadata for the VU_PARAM_INFO class.
    [MetadataTypeAttribute(typeof(VU_PARAM_INFO.VU_PARAM_INFOMetadata))]
    public partial class VU_PARAM_INFO
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PARAM_INFO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PARAM_INFOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PARAM_INFOMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public decimal PARAM_PHRASE_ID { get; set; }

            public int PARAM_PHRASE_SAKEY { get; set; }

            public string PARAM_PHRASE_TEXT { get; set; }

            public DateTime PARAM_PHRASE_TEXT_REV_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PARAM_VAL_CRUSTMetadata as the class
    // that carries additional metadata for the VU_PARAM_VAL_CRUST class.
    [MetadataTypeAttribute(typeof(VU_PARAM_VAL_CRUST.VU_PARAM_VAL_CRUSTMetadata))]
    public partial class VU_PARAM_VAL_CRUST
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PARAM_VAL_CRUST class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PARAM_VAL_CRUSTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PARAM_VAL_CRUSTMetadata()
            {
            }

            public string PARAM_CODE { get; set; }

            public string PARAM_CODE_NAME { get; set; }

            public decimal PARAM_ID { get; set; }

            public decimal PARAM_VAL_QTY { get; set; }

            public DateTime PARAM_VAL_REV_DTS { get; set; }

            public int PARAM_VAL_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PARAMSHIGHMetadata as the class
    // that carries additional metadata for the VU_PARAMSHIGH class.
    [MetadataTypeAttribute(typeof(VU_PARAMSHIGH.VU_PARAMSHIGHMetadata))]
    public partial class VU_PARAMSHIGH
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PARAMSHIGH class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PARAMSHIGHMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PARAMSHIGHMetadata()
            {
            }

            public string LIMIT_CODE { get; set; }

            public string PARAM_CODE { get; set; }

            public decimal PARAM_ID { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PARAMSLOWMetadata as the class
    // that carries additional metadata for the VU_PARAMSLOW class.
    [MetadataTypeAttribute(typeof(VU_PARAMSLOW.VU_PARAMSLOWMetadata))]
    public partial class VU_PARAMSLOW
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PARAMSLOW class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PARAMSLOWMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PARAMSLOWMetadata()
            {
            }

            public string LIMIT_CODE { get; set; }

            public string PARAM_CODE { get; set; }

            public decimal PARAM_ID { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PD_MBXMetadata as the class
    // that carries additional metadata for the VU_PD_MBX class.
    [MetadataTypeAttribute(typeof(VU_PD_MBX.VU_PD_MBXMetadata))]
    public partial class VU_PD_MBX
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PD_MBX class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PD_MBXMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PD_MBXMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PD_STAT_MBXMetadata as the class
    // that carries additional metadata for the VU_PD_STAT_MBX class.
    [MetadataTypeAttribute(typeof(VU_PD_STAT_MBX.VU_PD_STAT_MBXMetadata))]
    public partial class VU_PD_STAT_MBX
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PD_STAT_MBX class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PD_STAT_MBXMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PD_STAT_MBXMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public decimal TEST_STATUS { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PD_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_PD_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_PD_VIA_MBX_TABLE.VU_PD_VIA_MBX_TABLEMetadata))]
    public partial class VU_PD_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PD_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PD_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PD_VIA_MBX_TABLEMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PD1_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_PD1_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_PD1_VIA_MBX_TABLE.VU_PD1_VIA_MBX_TABLEMetadata))]
    public partial class VU_PD1_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PD1_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PD1_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PD1_VIA_MBX_TABLEMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PDR_MODEL_STANDMetadata as the class
    // that carries additional metadata for the VU_PDR_MODEL_STAND class.
    [MetadataTypeAttribute(typeof(VU_PDR_MODEL_STAND.VU_PDR_MODEL_STANDMetadata))]
    public partial class VU_PDR_MODEL_STAND
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PDR_MODEL_STAND class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PDR_MODEL_STANDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PDR_MODEL_STANDMetadata()
            {
            }

            public string CURRENT_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public decimal PRODUCT_DATA_STAT_ID { get; set; }

            public DateTime REJ_DEFN_REV_DTS { get; set; }

            public decimal REJ_ID { get; set; }

            public decimal REJ_ORDER_NUM { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PDS_MODEL_STANDMetadata as the class
    // that carries additional metadata for the VU_PDS_MODEL_STAND class.
    [MetadataTypeAttribute(typeof(VU_PDS_MODEL_STAND.VU_PDS_MODEL_STANDMetadata))]
    public partial class VU_PDS_MODEL_STAND
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PDS_MODEL_STAND class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PDS_MODEL_STANDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PDS_MODEL_STANDMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public decimal PRODUCT_DATA_STAT_ID { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_PHASE_INFOMetadata as the class
    // that carries additional metadata for the VU_PHASE_INFO class.
    [MetadataTypeAttribute(typeof(VU_PHASE_INFO.VU_PHASE_INFOMetadata))]
    public partial class VU_PHASE_INFO
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_PHASE_INFO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_PHASE_INFOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_PHASE_INFOMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public decimal PHASE_PHRASE_ID { get; set; }

            public int PHASE_PHRASE_SAKEY { get; set; }

            public string PHASE_PHRASE_TEXT { get; set; }

            public DateTime PHASE_PHRASE_TEXT_REV_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_RD_HIST_MBXMetadata as the class
    // that carries additional metadata for the VU_RD_HIST_MBX class.
    [MetadataTypeAttribute(typeof(VU_RD_HIST_MBX.VU_RD_HIST_MBXMetadata))]
    public partial class VU_RD_HIST_MBX
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_RD_HIST_MBX class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_RD_HIST_MBXMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_RD_HIST_MBXMetadata()
            {
            }

            public string CURRENT_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public Nullable<decimal> TEST_STATUS { get; set; }

            public Nullable<int> TP_DEFN_SAKEY { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_RD_MBXMetadata as the class
    // that carries additional metadata for the VU_RD_MBX class.
    [MetadataTypeAttribute(typeof(VU_RD_MBX.VU_RD_MBXMetadata))]
    public partial class VU_RD_MBX
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_RD_MBX class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_RD_MBXMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_RD_MBXMetadata()
            {
            }

            public string CURRENT_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public int REJ_ACTION_TEXT_DESC_SAKEY { get; set; }

            public Nullable<DateTime> REJ_DEFN_REV_DTS { get; set; }

            public Nullable<decimal> REJ_ID { get; set; }

            public Nullable<decimal> REJ_ORDER_NUM { get; set; }

            public string REJ_TEXT { get; set; }

            public int REJ_TYPE_TEXT_DESC_SAKEY { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public decimal TEST_STATUS { get; set; }

            public Nullable<int> TP_DEFN_SAKEY { get; set; }

            public Nullable<decimal> TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_RECYCLES_PER_TESTMetadata as the class
    // that carries additional metadata for the VU_RECYCLES_PER_TEST class.
    [MetadataTypeAttribute(typeof(VU_RECYCLES_PER_TEST.VU_RECYCLES_PER_TESTMetadata))]
    public partial class VU_RECYCLES_PER_TEST
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_RECYCLES_PER_TEST class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_RECYCLES_PER_TESTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_RECYCLES_PER_TESTMetadata()
            {
            }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public Nullable<decimal> HIGH_LIMIT { get; set; }

            public Nullable<decimal> LOW_LIMIT { get; set; }

            public decimal REJ_ACTION_ID { get; set; }

            public decimal REJ_ID { get; set; }

            public decimal REJ_ORDER_NUM { get; set; }

            public string REJ_TEXT { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public Nullable<decimal> TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public string TP_TEXT { get; set; }

            public string UNITS_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REJ_ACTION_INFOMetadata as the class
    // that carries additional metadata for the VU_REJ_ACTION_INFO class.
    [MetadataTypeAttribute(typeof(VU_REJ_ACTION_INFO.VU_REJ_ACTION_INFOMetadata))]
    public partial class VU_REJ_ACTION_INFO
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REJ_ACTION_INFO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REJ_ACTION_INFOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REJ_ACTION_INFOMetadata()
            {
            }

            public decimal REJ_ACTION_ID { get; set; }

            public int REJ_ACTION_ID_SAKEY { get; set; }

            public string REJ_ACTION_TEXT { get; set; }

            public DateTime REJ_ACTION_TEXT_REV_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REJ_ID_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_REJ_ID_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_REJ_ID_VIA_MBX_TABLE.VU_REJ_ID_VIA_MBX_TABLEMetadata))]
    public partial class VU_REJ_ID_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REJ_ID_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REJ_ID_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REJ_ID_VIA_MBX_TABLEMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public int MBX_SAKEY { get; set; }

            public DateTime REJ_DEFN_REV_DTS { get; set; }

            public decimal REJ_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REJ_TYPE_INFOMetadata as the class
    // that carries additional metadata for the VU_REJ_TYPE_INFO class.
    [MetadataTypeAttribute(typeof(VU_REJ_TYPE_INFO.VU_REJ_TYPE_INFOMetadata))]
    public partial class VU_REJ_TYPE_INFO
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REJ_TYPE_INFO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REJ_TYPE_INFOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REJ_TYPE_INFOMetadata()
            {
            }

            public decimal REJ_TYPE_ID { get; set; }

            public int REJ_TYPE_ID_SAKEY { get; set; }

            public string REJ_TYPE_TEXT { get; set; }

            public DateTime REJ_TYPE_TEXT_REV_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REJECTSHIGHMetadata as the class
    // that carries additional metadata for the VU_REJECTSHIGH class.
    [MetadataTypeAttribute(typeof(VU_REJECTSHIGH.VU_REJECTSHIGHMetadata))]
    public partial class VU_REJECTSHIGH
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REJECTSHIGH class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REJECTSHIGHMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REJECTSHIGHMetadata()
            {
            }

            public string CUSTOM_PHRASE_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public Nullable<int> MISC_PHRASE_SAKEY { get; set; }

            public int REJ_ACTION_TEXT_DESC_SAKEY { get; set; }

            public DateTime REJ_DEFN_REV_DTS { get; set; }

            public decimal REJ_ID { get; set; }

            public string REJ_TEXT { get; set; }

            public int REJ_TYPE_TEXT_DESC_SAKEY { get; set; }

            public Nullable<int> STAT_PHRASE_SAKEY { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REJECTSLOWMetadata as the class
    // that carries additional metadata for the VU_REJECTSLOW class.
    [MetadataTypeAttribute(typeof(VU_REJECTSLOW.VU_REJECTSLOWMetadata))]
    public partial class VU_REJECTSLOW
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REJECTSLOW class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REJECTSLOWMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REJECTSLOWMetadata()
            {
            }

            public string CUSTOM_PHRASE_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public Nullable<int> MISC_PHRASE_SAKEY { get; set; }

            public int REJ_ACTION_TEXT_DESC_SAKEY { get; set; }

            public DateTime REJ_DEFN_REV_DTS { get; set; }

            public decimal REJ_ID { get; set; }

            public string REJ_TEXT { get; set; }

            public int REJ_TYPE_TEXT_DESC_SAKEY { get; set; }

            public Nullable<int> STAT_PHRASE_SAKEY { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REJTPDEFNHIGHMetadata as the class
    // that carries additional metadata for the VU_REJTPDEFNHIGH class.
    [MetadataTypeAttribute(typeof(VU_REJTPDEFNHIGH.VU_REJTPDEFNHIGHMetadata))]
    public partial class VU_REJTPDEFNHIGH
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REJTPDEFNHIGH class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REJTPDEFNHIGHMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REJTPDEFNHIGHMetadata()
            {
            }

            public string LIMIT_CODE { get; set; }

            public decimal REJ_ID { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REJTPDEFNLOWMetadata as the class
    // that carries additional metadata for the VU_REJTPDEFNLOW class.
    [MetadataTypeAttribute(typeof(VU_REJTPDEFNLOW.VU_REJTPDEFNLOWMetadata))]
    public partial class VU_REJTPDEFNLOW
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REJTPDEFNLOW class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REJTPDEFNLOWMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REJTPDEFNLOWMetadata()
            {
            }

            public string LIMIT_CODE { get; set; }

            public decimal REJ_ID { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REP_EFF_REPAIR_MADEMetadata as the class
    // that carries additional metadata for the VU_REP_EFF_REPAIR_MADE class.
    [MetadataTypeAttribute(typeof(VU_REP_EFF_REPAIR_MADE.VU_REP_EFF_REPAIR_MADEMetadata))]
    public partial class VU_REP_EFF_REPAIR_MADE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REP_EFF_REPAIR_MADE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REP_EFF_REPAIR_MADEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REP_EFF_REPAIR_MADEMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public decimal REJ_ORDER_NUM { get; set; }

            public int REPAIR_MADE_SAKEY { get; set; }

            public string REPAIR_MADE_TEXT { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_REP_FLOATMetadata as the class
    // that carries additional metadata for the VU_REP_FLOAT class.
    [MetadataTypeAttribute(typeof(VU_REP_FLOAT.VU_REP_FLOATMetadata))]
    public partial class VU_REP_FLOAT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_REP_FLOAT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_REP_FLOATMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_REP_FLOATMetadata()
            {
            }

            public string MODEL_CODE { get; set; }

            public string SERIAL_CODE { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_RETESTS_PER_TESTMetadata as the class
    // that carries additional metadata for the VU_RETESTS_PER_TEST class.
    [MetadataTypeAttribute(typeof(VU_RETESTS_PER_TEST.VU_RETESTS_PER_TESTMetadata))]
    public partial class VU_RETESTS_PER_TEST
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_RETESTS_PER_TEST class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_RETESTS_PER_TESTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_RETESTS_PER_TESTMetadata()
            {
            }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public Nullable<decimal> HIGH_LIMIT { get; set; }

            public Nullable<decimal> LOW_LIMIT { get; set; }

            public decimal REJ_ACTION_ID { get; set; }

            public decimal REJ_ID { get; set; }

            public decimal REJ_ORDER_NUM { get; set; }

            public string REJ_TEXT { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public Nullable<decimal> TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public string TP_TEXT { get; set; }

            public string UNITS_TEXT { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_RM_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_RM_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_RM_VIA_MBX_TABLE.VU_RM_VIA_MBX_TABLEMetadata))]
    public partial class VU_RM_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_RM_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_RM_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_RM_VIA_MBX_TABLEMetadata()
            {
            }

            public int MBX_SAKEY { get; set; }

            public int REPAIR_MADE_SAKEY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_STAT_INFOMetadata as the class
    // that carries additional metadata for the VU_STAT_INFO class.
    [MetadataTypeAttribute(typeof(VU_STAT_INFO.VU_STAT_INFOMetadata))]
    public partial class VU_STAT_INFO
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_STAT_INFO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_STAT_INFOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_STAT_INFOMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public decimal STAT_PHRASE_ID { get; set; }

            public int STAT_PHRASE_SAKEY { get; set; }

            public string STAT_PHRASE_TEXT { get; set; }

            public DateTime STAT_PHRASE_TEXT_REV_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_STEP_INFOMetadata as the class
    // that carries additional metadata for the VU_STEP_INFO class.
    [MetadataTypeAttribute(typeof(VU_STEP_INFO.VU_STEP_INFOMetadata))]
    public partial class VU_STEP_INFO
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_STEP_INFO class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_STEP_INFOMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_STEP_INFOMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public decimal STEP_PHRASE_ID { get; set; }

            public int STEP_PHRASE_SAKEY { get; set; }

            public string STEP_PHRASE_TEXT { get; set; }

            public DateTime STEP_PHRASE_TEXT_REV_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_SUGGESTED_REPAIRMetadata as the class
    // that carries additional metadata for the VU_SUGGESTED_REPAIR class.
    [MetadataTypeAttribute(typeof(VU_SUGGESTED_REPAIR.VU_SUGGESTED_REPAIRMetadata))]
    public partial class VU_SUGGESTED_REPAIR
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_SUGGESTED_REPAIR class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_SUGGESTED_REPAIRMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_SUGGESTED_REPAIRMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public decimal REPAIRED_REJECT { get; set; }

            public string SUGGESTED_REPAIR_TEXT { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TD_LIMITMetadata as the class
    // that carries additional metadata for the VU_TD_LIMIT class.
    [MetadataTypeAttribute(typeof(VU_TD_LIMIT.VU_TD_LIMITMetadata))]
    public partial class VU_TD_LIMIT
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TD_LIMIT class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TD_LIMITMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TD_LIMITMetadata()
            {
            }

            public string LIMIT_CODE { get; set; }

            public string PARAM_CODE { get; set; }

            public string PARAM_CODE_NAME { get; set; }

            public Nullable<decimal> PARAM_ID { get; set; }

            public Nullable<decimal> PARAM_VAL_QTY { get; set; }

            public Nullable<DateTime> PARAM_VAL_REV_DTS { get; set; }

            public Nullable<int> PARAM_VAL_SAKEY { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TD_MBXMetadata as the class
    // that carries additional metadata for the VU_TD_MBX class.
    [MetadataTypeAttribute(typeof(VU_TD_MBX.VU_TD_MBXMetadata))]
    public partial class VU_TD_MBX
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TD_MBX class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TD_MBXMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TD_MBXMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public decimal TEST_STATUS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public decimal TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TD_TP_MBXMetadata as the class
    // that carries additional metadata for the VU_TD_TP_MBX class.
    [MetadataTypeAttribute(typeof(VU_TD_TP_MBX.VU_TD_TP_MBXMetadata))]
    public partial class VU_TD_TP_MBX
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TD_TP_MBX class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TD_TP_MBXMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TD_TP_MBXMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public int MBX_SAKEY_2 { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public decimal TEST_STATUS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public decimal TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TD1_REJECTS_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_TD1_REJECTS_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_TD1_REJECTS_VIA_MBX_TABLE.VU_TD1_REJECTS_VIA_MBX_TABLEMetadata))]
    public partial class VU_TD1_REJECTS_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TD1_REJECTS_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TD1_REJECTS_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TD1_REJECTS_VIA_MBX_TABLEMetadata()
            {
            }

            public string CURRENT_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public int REJ_ACTION_TEXT_DESC_SAKEY { get; set; }

            public decimal REJ_ID { get; set; }

            public decimal REJ_ORDER_NUM { get; set; }

            public string REJ_TEXT { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public decimal TEST_STATUS { get; set; }

            public Nullable<int> TP_DEFN_SAKEY { get; set; }

            public decimal TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TD1_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_TD1_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_TD1_VIA_MBX_TABLE.VU_TD1_VIA_MBX_TABLEMetadata))]
    public partial class VU_TD1_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TD1_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TD1_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TD1_VIA_MBX_TABLEMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public decimal TEST_STATUS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public decimal TP_ID { get; set; }

            public Nullable<decimal> TP_QTY { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TEST_STATUSMetadata as the class
    // that carries additional metadata for the VU_TEST_STATUS class.
    [MetadataTypeAttribute(typeof(VU_TEST_STATUS.VU_TEST_STATUSMetadata))]
    public partial class VU_TEST_STATUS
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TEST_STATUS class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TEST_STATUSMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TEST_STATUSMetadata()
            {
            }

            public Nullable<decimal> ABORT { get; set; }

            public Nullable<decimal> ACCEPT { get; set; }

            public Nullable<decimal> ALREADY_ACCEPT { get; set; }

            public Nullable<decimal> ALREADY_REP { get; set; }

            public Nullable<decimal> AUDIT_RECORD { get; set; }

            public Nullable<decimal> BUTTON_UP { get; set; }

            public Nullable<decimal> BUTTON_UP_REJECT { get; set; }

            public Nullable<decimal> DIAGNOSTIC { get; set; }

            public Nullable<decimal> FIELD_RETURN { get; set; }

            public Nullable<decimal> FIRST_ACCEPT { get; set; }

            public Nullable<decimal> FULL_TEST { get; set; }

            public Nullable<decimal> FUN_AIR_TESTED { get; set; }

            public Nullable<decimal> MAINT_TEST { get; set; }

            public Nullable<decimal> MASTER_TEST { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> NEVER_REPAIRED { get; set; }

            public Nullable<decimal> NEW_BUILD { get; set; }

            public Nullable<decimal> NEW_SERIAL { get; set; }

            public Nullable<decimal> NEWBUILD_RETEST { get; set; }

            public Nullable<decimal> NEXT_ACCEPTED { get; set; }

            public Nullable<decimal> NEXT_REJECTED { get; set; }

            public Nullable<decimal> NON_PROD { get; set; }

            public Nullable<decimal> OPERATOR_ACCEPT { get; set; }

            public Nullable<decimal> OVERIDE_ACCEPT { get; set; }

            public Nullable<decimal> RE_PREPPED { get; set; }

            public Nullable<decimal> RECYCLE_RECORD { get; set; }

            public Nullable<decimal> REJECTED { get; set; }

            public Nullable<decimal> RELEASED_BUTTON_UP { get; set; }

            public Nullable<decimal> RELEASED_NO_REPAIR { get; set; }

            public Nullable<decimal> REPAIR_1 { get; set; }

            public Nullable<decimal> REPAIR_RETEST { get; set; }

            public Nullable<decimal> REPAIRED { get; set; }

            public Nullable<decimal> RETEST_RECORD { get; set; }

            public Nullable<decimal> SCRAPPED { get; set; }

            public string SERIAL_CODE { get; set; }

            public Nullable<decimal> SOUND_TEST { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STAND_REJECT { get; set; }

            public Nullable<decimal> SYSTEM_UTIL { get; set; }

            public Nullable<decimal> TEST_ADJUSTED { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TEST_STATUS_BY_STANDMetadata as the class
    // that carries additional metadata for the VU_TEST_STATUS_BY_STAND class.
    [MetadataTypeAttribute(typeof(VU_TEST_STATUS_BY_STAND.VU_TEST_STATUS_BY_STANDMetadata))]
    public partial class VU_TEST_STATUS_BY_STAND
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TEST_STATUS_BY_STAND class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TEST_STATUS_BY_STANDMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TEST_STATUS_BY_STANDMetadata()
            {
            }

            public Nullable<decimal> ABORT { get; set; }

            public Nullable<decimal> ACCEPT { get; set; }

            public Nullable<decimal> AUDIT_RECORD { get; set; }

            public Nullable<decimal> BUTTON_UP { get; set; }

            public Nullable<decimal> BUTTON_UP_REJECT { get; set; }

            public Nullable<decimal> DIAGNOSTIC { get; set; }

            public Nullable<decimal> FIELD_RETURN { get; set; }

            public Nullable<decimal> FULL_TEST { get; set; }

            public Nullable<decimal> FUN_AIR_TESTED { get; set; }

            public Nullable<decimal> MAINT_TEST { get; set; }

            public Nullable<decimal> MASTER_TEST { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> NEVER_REPAIRED { get; set; }

            public Nullable<decimal> NEW_BUILD { get; set; }

            public Nullable<decimal> NEW_SERIAL { get; set; }

            public Nullable<decimal> NEWBUILD_RETEST { get; set; }

            public Nullable<decimal> NEXT_ACCEPTED { get; set; }

            public Nullable<decimal> NEXT_REJECTED { get; set; }

            public Nullable<decimal> NON_PROD { get; set; }

            public Nullable<decimal> OPERATOR_ACCEPT { get; set; }

            public Nullable<decimal> OVERIDE_ACCEPT { get; set; }

            public Nullable<decimal> RE_PREPPED { get; set; }

            public Nullable<decimal> RECYCLE_RECORD { get; set; }

            public Nullable<decimal> REJECTED { get; set; }

            public Nullable<decimal> RELEASED_BUTTON_UP { get; set; }

            public Nullable<decimal> RELEASED_NO_REPAIR { get; set; }

            public Nullable<decimal> REPAIR_1 { get; set; }

            public Nullable<decimal> REPAIR_RETEST { get; set; }

            public Nullable<decimal> REPAIRED { get; set; }

            public Nullable<decimal> RETEST_RECORD { get; set; }

            public Nullable<decimal> SCRAPPED { get; set; }

            public string SERIAL_CODE { get; set; }

            public Nullable<decimal> SOUND_TEST { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STAND_REJECT { get; set; }

            public Nullable<decimal> SYSTEM_UTIL { get; set; }

            public Nullable<decimal> TEST_ADJUSTED { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TEST_STATUS_MBXMetadata as the class
    // that carries additional metadata for the VU_TEST_STATUS_MBX class.
    [MetadataTypeAttribute(typeof(VU_TEST_STATUS_MBX.VU_TEST_STATUS_MBXMetadata))]
    public partial class VU_TEST_STATUS_MBX
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TEST_STATUS_MBX class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TEST_STATUS_MBXMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TEST_STATUS_MBXMetadata()
            {
            }

            public Nullable<decimal> ABORT { get; set; }

            public Nullable<decimal> ACCEPT { get; set; }

            public Nullable<decimal> ALREADY_ACCEPT { get; set; }

            public Nullable<decimal> ALREADY_REP { get; set; }

            public Nullable<decimal> AUDIT_RECORD { get; set; }

            public Nullable<decimal> BUTTON_UP { get; set; }

            public Nullable<decimal> BUTTON_UP_REJECT { get; set; }

            public Nullable<decimal> DIAGNOSTIC { get; set; }

            public Nullable<decimal> FIELD_RETURN { get; set; }

            public Nullable<decimal> FIRST_ACCEPT { get; set; }

            public Nullable<decimal> FULL_TEST { get; set; }

            public Nullable<decimal> FUN_AIR_TESTED { get; set; }

            public Nullable<decimal> MAINT_TEST { get; set; }

            public Nullable<decimal> MASTER_TEST { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> NEVER_REPAIRED { get; set; }

            public Nullable<decimal> NEW_BUILD { get; set; }

            public Nullable<decimal> NEW_SERIAL { get; set; }

            public Nullable<decimal> NEWBUILD_RETEST { get; set; }

            public Nullable<decimal> NEXT_ACCEPTED { get; set; }

            public Nullable<decimal> NEXT_REJECTED { get; set; }

            public Nullable<decimal> NON_PROD { get; set; }

            public Nullable<decimal> OPERATOR_ACCEPT { get; set; }

            public Nullable<decimal> OVERIDE_ACCEPT { get; set; }

            public Nullable<decimal> RE_PREPPED { get; set; }

            public Nullable<decimal> RECYCLE_RECORD { get; set; }

            public Nullable<decimal> REJECTED { get; set; }

            public Nullable<decimal> RELEASED_BUTTON_UP { get; set; }

            public Nullable<decimal> RELEASED_NO_REPAIR { get; set; }

            public Nullable<decimal> REPAIR_1 { get; set; }

            public Nullable<decimal> REPAIR_RETEST { get; set; }

            public Nullable<decimal> REPAIRED { get; set; }

            public Nullable<decimal> RETEST_RECORD { get; set; }

            public Nullable<decimal> SCRAPPED { get; set; }

            public string SERIAL_CODE { get; set; }

            public Nullable<decimal> SOUND_TEST { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STAND_REJECT { get; set; }

            public Nullable<decimal> SYSTEM_UTIL { get; set; }

            public Nullable<decimal> TEST_ADJUSTED { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TEST_STATUS_VIA_DATEMetadata as the class
    // that carries additional metadata for the VU_TEST_STATUS_VIA_DATE class.
    [MetadataTypeAttribute(typeof(VU_TEST_STATUS_VIA_DATE.VU_TEST_STATUS_VIA_DATEMetadata))]
    public partial class VU_TEST_STATUS_VIA_DATE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TEST_STATUS_VIA_DATE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TEST_STATUS_VIA_DATEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TEST_STATUS_VIA_DATEMetadata()
            {
            }

            public Nullable<decimal> ABORT { get; set; }

            public Nullable<decimal> ACCEPT { get; set; }

            public Nullable<decimal> ALREADY_ACCEPT { get; set; }

            public Nullable<decimal> ALREADY_REP { get; set; }

            public Nullable<decimal> AUDIT_RECORD { get; set; }

            public Nullable<decimal> BUTTON_UP { get; set; }

            public Nullable<decimal> BUTTON_UP_REJECT { get; set; }

            public Nullable<decimal> DIAGNOSTIC { get; set; }

            public Nullable<decimal> FIELD_RETURN { get; set; }

            public Nullable<decimal> FIRST_ACCEPT { get; set; }

            public Nullable<decimal> FULL_TEST { get; set; }

            public Nullable<decimal> FUN_AIR_TESTED { get; set; }

            public Nullable<decimal> MAINT_TEST { get; set; }

            public Nullable<decimal> MASTER_TEST { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> NEVER_REPAIRED { get; set; }

            public Nullable<decimal> NEW_BUILD { get; set; }

            public Nullable<decimal> NEW_SERIAL { get; set; }

            public Nullable<decimal> NEWBUILD_RETEST { get; set; }

            public Nullable<decimal> NEXT_ACCEPTED { get; set; }

            public Nullable<decimal> NEXT_REJECTED { get; set; }

            public Nullable<decimal> NON_PROD { get; set; }

            public Nullable<decimal> OPERATOR_ACCEPT { get; set; }

            public Nullable<decimal> OVERIDE_ACCEPT { get; set; }

            public Nullable<decimal> RE_PREPPED { get; set; }

            public Nullable<decimal> RECYCLE_RECORD { get; set; }

            public Nullable<decimal> REJECTED { get; set; }

            public Nullable<decimal> RELEASED_BUTTON_UP { get; set; }

            public Nullable<decimal> RELEASED_NO_REPAIR { get; set; }

            public Nullable<decimal> REPAIR_1 { get; set; }

            public Nullable<decimal> REPAIR_RETEST { get; set; }

            public Nullable<decimal> REPAIRED { get; set; }

            public Nullable<decimal> RETEST_RECORD { get; set; }

            public Nullable<decimal> SCRAPPED { get; set; }

            public string SERIAL_CODE { get; set; }

            public Nullable<decimal> SOUND_TEST { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STAND_REJECT { get; set; }

            public Nullable<decimal> SYSTEM_UTIL { get; set; }

            public Nullable<decimal> TEST_ADJUSTED { get; set; }

            public DateTime TEST_DTS { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TEST_STATUS_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_TEST_STATUS_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_TEST_STATUS_VIA_MBX_TABLE.VU_TEST_STATUS_VIA_MBX_TABLEMetadata))]
    public partial class VU_TEST_STATUS_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TEST_STATUS_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TEST_STATUS_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TEST_STATUS_VIA_MBX_TABLEMetadata()
            {
            }

            public Nullable<decimal> ABORT { get; set; }

            public Nullable<decimal> ACCEPT { get; set; }

            public Nullable<decimal> ALREADY_ACCEPT { get; set; }

            public Nullable<decimal> ALREADY_REP { get; set; }

            public Nullable<decimal> AUDIT_RECORD { get; set; }

            public Nullable<decimal> BUTTON_UP { get; set; }

            public Nullable<decimal> BUTTON_UP_REJECT { get; set; }

            public Nullable<decimal> DIAGNOSTIC { get; set; }

            public Nullable<decimal> FIELD_RETURN { get; set; }

            public Nullable<decimal> FIRST_ACCEPT { get; set; }

            public Nullable<decimal> FULL_TEST { get; set; }

            public Nullable<decimal> FUN_AIR_TESTED { get; set; }

            public Nullable<decimal> MAINT_TEST { get; set; }

            public Nullable<decimal> MASTER_TEST { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> NEVER_REPAIRED { get; set; }

            public Nullable<decimal> NEW_BUILD { get; set; }

            public Nullable<decimal> NEW_SERIAL { get; set; }

            public Nullable<decimal> NEWBUILD_RETEST { get; set; }

            public Nullable<decimal> NEXT_ACCEPTED { get; set; }

            public Nullable<decimal> NEXT_REJECTED { get; set; }

            public Nullable<decimal> NON_PROD { get; set; }

            public Nullable<decimal> OPERATOR_ACCEPT { get; set; }

            public Nullable<decimal> OVERIDE_ACCEPT { get; set; }

            public Nullable<decimal> RE_PREPPED { get; set; }

            public Nullable<decimal> RECYCLE_RECORD { get; set; }

            public Nullable<decimal> REJECTED { get; set; }

            public Nullable<decimal> RELEASED_BUTTON_UP { get; set; }

            public Nullable<decimal> RELEASED_NO_REPAIR { get; set; }

            public Nullable<decimal> REPAIR_1 { get; set; }

            public Nullable<decimal> REPAIR_RETEST { get; set; }

            public Nullable<decimal> REPAIRED { get; set; }

            public Nullable<decimal> RETEST_RECORD { get; set; }

            public Nullable<decimal> SCRAPPED { get; set; }

            public string SERIAL_CODE { get; set; }

            public Nullable<decimal> SOUND_TEST { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STAND_REJECT { get; set; }

            public Nullable<decimal> SYSTEM_UTIL { get; set; }

            public Nullable<decimal> TEST_ADJUSTED { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TEST_TEXT_CRUSTMetadata as the class
    // that carries additional metadata for the VU_TEST_TEXT_CRUST class.
    [MetadataTypeAttribute(typeof(VU_TEST_TEXT_CRUST.VU_TEST_TEXT_CRUSTMetadata))]
    public partial class VU_TEST_TEXT_CRUST
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TEST_TEXT_CRUST class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TEST_TEXT_CRUSTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TEST_TEXT_CRUSTMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public string TEST_TEXT { get; set; }

            public decimal TEST_TEXT_ID { get; set; }

            public string TEST_TEXT_LEVEL { get; set; }

            public DateTime TEST_TEXT_REV_DTS { get; set; }

            public int TEST_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TESTPOINTDEFINITIONSEDITORMetadata as the class
    // that carries additional metadata for the VU_TESTPOINTDEFINITIONSEDITOR class.
    [MetadataTypeAttribute(typeof(VU_TESTPOINTDEFINITIONSEDITOR.VU_TESTPOINTDEFINITIONSEDITORMetadata))]
    public partial class VU_TESTPOINTDEFINITIONSEDITOR
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TESTPOINTDEFINITIONSEDITOR class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TESTPOINTDEFINITIONSEDITORMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TESTPOINTDEFINITIONSEDITORMetadata()
            {
            }

            public string CUSTOM_TEXT_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public string HIGH_PARAM_CODE { get; set; }

            public Nullable<decimal> HIGH_PARAM_ID { get; set; }

            public Nullable<decimal> HIGH_REJ_ID { get; set; }

            public string LOW_PARAM_CODE { get; set; }

            public Nullable<decimal> LOW_PARAM_ID { get; set; }

            public Nullable<decimal> LOW_REJ_ID { get; set; }

            public Nullable<decimal> PARAM_PHRASE_ID { get; set; }

            public Nullable<decimal> PHASE_PHRASE_ID { get; set; }

            public Nullable<decimal> STEP_PHRASE_ID { get; set; }

            public string TP_ACTIVE_FLAG { get; set; }

            public DateTime TP_DEFN_REV_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public decimal TP_ID { get; set; }

            public string TP_TEXT { get; set; }

            public int UNITS_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TOT_REP_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_TOT_REP_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_TOT_REP_VIA_MBX_TABLE.VU_TOT_REP_VIA_MBX_TABLEMetadata))]
    public partial class VU_TOT_REP_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TOT_REP_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TOT_REP_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TOT_REP_VIA_MBX_TABLEMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public Nullable<decimal> LOAD_TIME_SECS_DURN { get; set; }

            public DateTime MAX_PARAM_DEFN_REV_DTS { get; set; }

            public DateTime MAX_PARAM_VAL_REV_DTS { get; set; }

            public int MBX_SAKEY { get; set; }

            public string MODEL_CODE { get; set; }

            public DateTime MODEL_DEFN_REV_DTS { get; set; }

            public string OPR_TEXT { get; set; }

            public string PALLET_CODE { get; set; }

            public decimal PRODUCT_DATA_STAT_ID { get; set; }

            public string SE_BY_REJECT { get; set; }

            public string SE_MISC_PHRASE_IDS { get; set; }

            public string SE_PARAM_PHRASE_IDS { get; set; }

            public string SE_PHASE_PHRASE_IDS { get; set; }

            public string SE_STAT_PHRASE_IDS { get; set; }

            public string SE_STEP_PHRASE_IDS { get; set; }

            public string SE_TP_IDS { get; set; }

            public string SERIAL_CODE { get; set; }

            public decimal SHIFT_ID { get; set; }

            public string STAND_CODE { get; set; }

            public DateTime TEST_DTS { get; set; }

            public decimal TEST_SECS_DURN { get; set; }

            public Nullable<decimal> UNLOAD_TIME_SECS_DURN { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TP_DEFN_CRUSTMetadata as the class
    // that carries additional metadata for the VU_TP_DEFN_CRUST class.
    [MetadataTypeAttribute(typeof(VU_TP_DEFN_CRUST.VU_TP_DEFN_CRUSTMetadata))]
    public partial class VU_TP_DEFN_CRUST
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TP_DEFN_CRUST class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TP_DEFN_CRUSTMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TP_DEFN_CRUSTMetadata()
            {
            }

            public string CUSTOM_TEXT_FLAG { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string FORMAT_SPECIFIER_TEXT { get; set; }

            public Nullable<int> PARAM_PHRASE_SAKEY { get; set; }

            public Nullable<int> PHASE_PHRASE_SAKEY { get; set; }

            public Nullable<int> STEP_PHRASE_SAKEY { get; set; }

            public string TP_ACTIVE_FLAG { get; set; }

            public DateTime TP_DEFN_REV_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public decimal TP_ID { get; set; }

            public string TP_TEXT { get; set; }

            public int UNITS_TEXT_SAKEY { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_TP_ID_VIA_MBX_TABLEMetadata as the class
    // that carries additional metadata for the VU_TP_ID_VIA_MBX_TABLE class.
    [MetadataTypeAttribute(typeof(VU_TP_ID_VIA_MBX_TABLE.VU_TP_ID_VIA_MBX_TABLEMetadata))]
    public partial class VU_TP_ID_VIA_MBX_TABLE
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_TP_ID_VIA_MBX_TABLE class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_TP_ID_VIA_MBX_TABLEMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_TP_ID_VIA_MBX_TABLEMetadata()
            {
            }

            public decimal FAMILY_ID { get; set; }

            public int MBX_SAKEY { get; set; }

            public DateTime TP_DEFN_REV_DTS { get; set; }

            public int TP_DEFN_SAKEY { get; set; }

            public decimal TP_ID { get; set; }
        }
    }

    // The MetadataTypeAttribute identifies VU_VAR_TREND_SUMMetadata as the class
    // that carries additional metadata for the VU_VAR_TREND_SUM class.
    [MetadataTypeAttribute(typeof(VU_VAR_TREND_SUM.VU_VAR_TREND_SUMMetadata))]
    public partial class VU_VAR_TREND_SUM
    {

        // This class allows you to attach custom attributes to properties
        // of the VU_VAR_TREND_SUM class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class VU_VAR_TREND_SUMMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private VU_VAR_TREND_SUMMetadata()
            {
            }

            public string ACTIVE { get; set; }

            public Nullable<decimal> CP_QTY { get; set; }

            public Nullable<decimal> CPK_QTY { get; set; }

            public DateTime DATA_DTS { get; set; }

            public decimal FAMILY_ID { get; set; }

            public string FORMAT { get; set; }

            public Nullable<decimal> HI_LIMIT_QTY { get; set; }

            public string HIGH_PARAM_CODE { get; set; }

            public Nullable<decimal> HIGH_PARAM_ID { get; set; }

            public string HIGH_REJ_ID { get; set; }

            public Nullable<decimal> LO_LIMIT_QTY { get; set; }

            public string LOW_PARAM_CODE { get; set; }

            public Nullable<decimal> LOW_PARAM_ID { get; set; }

            public string LOW_REJ_ID { get; set; }

            public Nullable<decimal> MAX_QTY { get; set; }

            public int MBX_SAKEY { get; set; }

            public Nullable<decimal> MEAN_QTY { get; set; }

            public Nullable<decimal> MIN_QTY { get; set; }

            public string MODEL_CODE { get; set; }

            public Nullable<decimal> SAMPLES { get; set; }

            public string STAND_CODE { get; set; }

            public Nullable<decimal> STD_DEV_QTY { get; set; }

            public Nullable<decimal> SUM_X { get; set; }

            public Nullable<decimal> SUM_X2 { get; set; }

            public decimal TP_ID { get; set; }

            public string TP_TEXT { get; set; }

            public string UNITS_TEXT { get; set; }
        }
    }
}
