﻿
namespace WMAApp.Web.Services
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data;
    using System.Linq;
    using System.Net;
    using System.Text;
    using System.ServiceModel.DomainServices.EntityFramework;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;
    using WMAApp.Web.Models;
    using System.Configuration;
    using System.Data.EntityClient;

    // RIA will project a DomainContext class to the client when the projects are built

    // Implements application logic using the WMATestDBEntities context.
    // TODO: Add your application logic to these methods or in additional methods.
    // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
    // Also consider adding roles to restrict access as appropriate.
    // [RequiresAuthentication]

    public abstract class WMATestDBBaseDomainService : LinqToEntitiesDomainService<WMATestDBEntities>
    {      
        public override void Initialize(DomainServiceContext context)
        {
            base.Initialize(context);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'ALLOW_COMPONENT_MARRIAGE' query.
        public IQueryable<PDB_DATA> GetPDB_DATA()
        {
            return this.ObjectContext.PDB_DATA;
        }

        public void InsertPDB_DATA(PDB_DATA pDB_DATA)
        {
            if ((pDB_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pDB_DATA, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PDB_DATA.AddObject(pDB_DATA);
            }
        }

        public void UpdatePDB_DATA(PDB_DATA currentPDB_DATA)
        {
            this.ObjectContext.PDB_DATA.AttachAsModified(currentPDB_DATA, this.ChangeSet.GetOriginal(currentPDB_DATA));
        }

        public void DeletePDB_DATA(PDB_DATA pDB_DATA)
        {
            if ((pDB_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pDB_DATA, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PDB_DATA.Attach(pDB_DATA);
                this.ObjectContext.PDB_DATA.DeleteObject(pDB_DATA);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PDB_DEFN' query.

        public IQueryable<PDB_DEFN> GetPDB_DEFN()
        {
            return this.ObjectContext.PDB_DEFN;
        }

        public void InsertPDB_DEFN(PDB_DEFN pDB_DEFN)
        {
            if ((pDB_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pDB_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PDB_DEFN.AddObject(pDB_DEFN);
            }
        }

        public void UpdatePDB_DEFN(PDB_DEFN currentPDB_DEFN)
        {
            this.ObjectContext.PDB_DEFN.AttachAsModified(currentPDB_DEFN, this.ChangeSet.GetOriginal(currentPDB_DEFN));
        }

        public void DeletePDB_DEFN(PDB_DEFN pDB_DEFN)
        {
            if ((pDB_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pDB_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PDB_DEFN.Attach(pDB_DEFN);
                this.ObjectContext.PDB_DEFN.DeleteObject(pDB_DEFN);
            }
        }

        public IQueryable<ALLOW_COMPONENT_MARRIAGE> GetALLOW_COMPONENT_MARRIAGE()
        {
            return this.ObjectContext.ALLOW_COMPONENT_MARRIAGE;
        }

        public void InsertALLOW_COMPONENT_MARRIAGE(ALLOW_COMPONENT_MARRIAGE aLLOW_COMPONENT_MARRIAGE)
        {
            if ((aLLOW_COMPONENT_MARRIAGE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(aLLOW_COMPONENT_MARRIAGE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.ALLOW_COMPONENT_MARRIAGE.AddObject(aLLOW_COMPONENT_MARRIAGE);
            }
        }

        public void UpdateALLOW_COMPONENT_MARRIAGE(ALLOW_COMPONENT_MARRIAGE currentALLOW_COMPONENT_MARRIAGE)
        {
            this.ObjectContext.ALLOW_COMPONENT_MARRIAGE.AttachAsModified(currentALLOW_COMPONENT_MARRIAGE, this.ChangeSet.GetOriginal(currentALLOW_COMPONENT_MARRIAGE));
        }

        public void DeleteALLOW_COMPONENT_MARRIAGE(ALLOW_COMPONENT_MARRIAGE aLLOW_COMPONENT_MARRIAGE)
        {
            if ((aLLOW_COMPONENT_MARRIAGE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(aLLOW_COMPONENT_MARRIAGE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.ALLOW_COMPONENT_MARRIAGE.Attach(aLLOW_COMPONENT_MARRIAGE);
                this.ObjectContext.ALLOW_COMPONENT_MARRIAGE.DeleteObject(aLLOW_COMPONENT_MARRIAGE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'ASSO_TP_DATA' query.
        public IQueryable<ASSO_TP_DATA> GetASSO_TP_DATA()
        {
            return this.ObjectContext.ASSO_TP_DATA;
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'AUDIT_DEFN' query.
        public IQueryable<AUDIT_DEFN> GetAUDIT_DEFN()
        {
            return this.ObjectContext.AUDIT_DEFN;
        }

        public void InsertAUDIT_DEFN(AUDIT_DEFN aUDIT_DEFN)
        {
            if ((aUDIT_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(aUDIT_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.AUDIT_DEFN.AddObject(aUDIT_DEFN);
            }
        }

        public void UpdateAUDIT_DEFN(AUDIT_DEFN currentAUDIT_DEFN)
        {
            this.ObjectContext.AUDIT_DEFN.AttachAsModified(currentAUDIT_DEFN, this.ChangeSet.GetOriginal(currentAUDIT_DEFN));
        }

        public void DeleteAUDIT_DEFN(AUDIT_DEFN aUDIT_DEFN)
        {
            if ((aUDIT_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(aUDIT_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.AUDIT_DEFN.Attach(aUDIT_DEFN);
                this.ObjectContext.AUDIT_DEFN.DeleteObject(aUDIT_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'AUTO_CAL_DATA' query.
        public IQueryable<AUTO_CAL_DATA> GetAUTO_CAL_DATA()
        {
            return this.ObjectContext.AUTO_CAL_DATA;
        }

        public void InsertAUTO_CAL_DATA(AUTO_CAL_DATA aUTO_CAL_DATA)
        {
            if ((aUTO_CAL_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(aUTO_CAL_DATA, EntityState.Added);
            }
            else
            {
                this.ObjectContext.AUTO_CAL_DATA.AddObject(aUTO_CAL_DATA);
            }
        }

        public void UpdateAUTO_CAL_DATA(AUTO_CAL_DATA currentAUTO_CAL_DATA)
        {
            this.ObjectContext.AUTO_CAL_DATA.AttachAsModified(currentAUTO_CAL_DATA, this.ChangeSet.GetOriginal(currentAUTO_CAL_DATA));
        }

        public void DeleteAUTO_CAL_DATA(AUTO_CAL_DATA aUTO_CAL_DATA)
        {
            if ((aUTO_CAL_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(aUTO_CAL_DATA, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.AUTO_CAL_DATA.Attach(aUTO_CAL_DATA);
                this.ObjectContext.AUTO_CAL_DATA.DeleteObject(aUTO_CAL_DATA);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'CALIB_DEFN' query.
        public IQueryable<CALIB_DEFN> GetCALIB_DEFN()
        {
            return this.ObjectContext.CALIB_DEFN;
        }

        public void InsertCALIB_DEFN(CALIB_DEFN cALIB_DEFN)
        {
            if ((cALIB_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(cALIB_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.CALIB_DEFN.AddObject(cALIB_DEFN);
            }
        }

        public void UpdateCALIB_DEFN(CALIB_DEFN currentCALIB_DEFN)
        {
            this.ObjectContext.CALIB_DEFN.AttachAsModified(currentCALIB_DEFN, this.ChangeSet.GetOriginal(currentCALIB_DEFN));
        }

        public void DeleteCALIB_DEFN(CALIB_DEFN cALIB_DEFN)
        {
            if ((cALIB_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(cALIB_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.CALIB_DEFN.Attach(cALIB_DEFN);
                this.ObjectContext.CALIB_DEFN.DeleteObject(cALIB_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'CHARACTERIZATION_DEFN' query.
        public IQueryable<CHARACTERIZATION_DEFN> GetCHARACTERIZATION_DEFN()
        {
            return this.ObjectContext.CHARACTERIZATION_DEFN;
        }

        public void InsertCHARACTERIZATION_DEFN(CHARACTERIZATION_DEFN cHARACTERIZATION_DEFN)
        {
            if ((cHARACTERIZATION_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(cHARACTERIZATION_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.CHARACTERIZATION_DEFN.AddObject(cHARACTERIZATION_DEFN);
            }
        }

        public void UpdateCHARACTERIZATION_DEFN(CHARACTERIZATION_DEFN currentCHARACTERIZATION_DEFN)
        {
            this.ObjectContext.CHARACTERIZATION_DEFN.AttachAsModified(currentCHARACTERIZATION_DEFN, this.ChangeSet.GetOriginal(currentCHARACTERIZATION_DEFN));
        }

        public void DeleteCHARACTERIZATION_DEFN(CHARACTERIZATION_DEFN cHARACTERIZATION_DEFN)
        {
            if ((cHARACTERIZATION_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(cHARACTERIZATION_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.CHARACTERIZATION_DEFN.Attach(cHARACTERIZATION_DEFN);
                this.ObjectContext.CHARACTERIZATION_DEFN.DeleteObject(cHARACTERIZATION_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'CORE_TAG_DEFN' query.
        public IQueryable<CORE_TAG_DEFN> GetCORE_TAG_DEFN()
        {
            return this.ObjectContext.CORE_TAG_DEFN;
        }

        public void InsertCORE_TAG_DEFN(CORE_TAG_DEFN cORE_TAG_DEFN)
        {
            if ((cORE_TAG_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(cORE_TAG_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.CORE_TAG_DEFN.AddObject(cORE_TAG_DEFN);
            }
        }

        public void UpdateCORE_TAG_DEFN(CORE_TAG_DEFN currentCORE_TAG_DEFN)
        {
            this.ObjectContext.CORE_TAG_DEFN.AttachAsModified(currentCORE_TAG_DEFN, this.ChangeSet.GetOriginal(currentCORE_TAG_DEFN));
        }

        public void DeleteCORE_TAG_DEFN(CORE_TAG_DEFN cORE_TAG_DEFN)
        {
            if ((cORE_TAG_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(cORE_TAG_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.CORE_TAG_DEFN.Attach(cORE_TAG_DEFN);
                this.ObjectContext.CORE_TAG_DEFN.DeleteObject(cORE_TAG_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'DOWNLOAD_DEFN' query.
        public IQueryable<DOWNLOAD_DEFN> GetDOWNLOAD_DEFN()
        {
            return this.ObjectContext.DOWNLOAD_DEFN;
        }

        public void InsertDOWNLOAD_DEFN(DOWNLOAD_DEFN dOWNLOAD_DEFN)
        {
            if ((dOWNLOAD_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(dOWNLOAD_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.DOWNLOAD_DEFN.AddObject(dOWNLOAD_DEFN);
            }
        }

        public void UpdateDOWNLOAD_DEFN(DOWNLOAD_DEFN currentDOWNLOAD_DEFN)
        {
            this.ObjectContext.DOWNLOAD_DEFN.AttachAsModified(currentDOWNLOAD_DEFN, this.ChangeSet.GetOriginal(currentDOWNLOAD_DEFN));
        }

        public void DeleteDOWNLOAD_DEFN(DOWNLOAD_DEFN dOWNLOAD_DEFN)
        {
            if ((dOWNLOAD_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(dOWNLOAD_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.DOWNLOAD_DEFN.Attach(dOWNLOAD_DEFN);
                this.ObjectContext.DOWNLOAD_DEFN.DeleteObject(dOWNLOAD_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'DW_CAL_DEFN' query.
        public IQueryable<DW_CAL_DEFN> GetDW_CAL_DEFN()
        {
            return this.ObjectContext.DW_CAL_DEFN;
        }

        public void InsertDW_CAL_DEFN(DW_CAL_DEFN dW_CAL_DEFN)
        {
            if ((dW_CAL_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(dW_CAL_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.DW_CAL_DEFN.AddObject(dW_CAL_DEFN);
            }
        }

        public void UpdateDW_CAL_DEFN(DW_CAL_DEFN currentDW_CAL_DEFN)
        {
            this.ObjectContext.DW_CAL_DEFN.AttachAsModified(currentDW_CAL_DEFN, this.ChangeSet.GetOriginal(currentDW_CAL_DEFN));
        }

        public void DeleteDW_CAL_DEFN(DW_CAL_DEFN dW_CAL_DEFN)
        {
            if ((dW_CAL_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(dW_CAL_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.DW_CAL_DEFN.Attach(dW_CAL_DEFN);
                this.ObjectContext.DW_CAL_DEFN.DeleteObject(dW_CAL_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'ECPC_DATA' query.
        public IQueryable<ECPC_DATA> GetECPC_DATA()
        {
            return this.ObjectContext.ECPC_DATA;
        }

        public void InsertECPC_DATA(ECPC_DATA eCPC_DATA)
        {
            if ((eCPC_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(eCPC_DATA, EntityState.Added);
            }
            else
            {
                this.ObjectContext.ECPC_DATA.AddObject(eCPC_DATA);
            }
        }

        public void UpdateECPC_DATA(ECPC_DATA currentECPC_DATA)
        {
            this.ObjectContext.ECPC_DATA.AttachAsModified(currentECPC_DATA, this.ChangeSet.GetOriginal(currentECPC_DATA));
        }

        public void DeleteECPC_DATA(ECPC_DATA eCPC_DATA)
        {
            if ((eCPC_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(eCPC_DATA, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.ECPC_DATA.Attach(eCPC_DATA);
                this.ObjectContext.ECPC_DATA.DeleteObject(eCPC_DATA);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'FAMILY_DEFN' query.
        public IQueryable<FAMILY_DEFN> GetFAMILY_DEFN()
        {
            return this.ObjectContext.FAMILY_DEFN;
        }

        public void InsertFAMILY_DEFN(FAMILY_DEFN fAMILY_DEFN)
        {
            if ((fAMILY_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(fAMILY_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.FAMILY_DEFN.AddObject(fAMILY_DEFN);
            }
        }

        public void UpdateFAMILY_DEFN(FAMILY_DEFN currentFAMILY_DEFN)
        {
            this.ObjectContext.FAMILY_DEFN.AttachAsModified(currentFAMILY_DEFN, this.ChangeSet.GetOriginal(currentFAMILY_DEFN));
        }

        public void DeleteFAMILY_DEFN(FAMILY_DEFN fAMILY_DEFN)
        {
            if ((fAMILY_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(fAMILY_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.FAMILY_DEFN.Attach(fAMILY_DEFN);
                this.ObjectContext.FAMILY_DEFN.DeleteObject(fAMILY_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'FAMILY_TAG_TEXT' query.
        public IQueryable<FAMILY_TAG_TEXT> GetFAMILY_TAG_TEXT()
        {
            return this.ObjectContext.FAMILY_TAG_TEXT;
        }

        public void InsertFAMILY_TAG_TEXT(FAMILY_TAG_TEXT fAMILY_TAG_TEXT)
        {
            if ((fAMILY_TAG_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(fAMILY_TAG_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.FAMILY_TAG_TEXT.AddObject(fAMILY_TAG_TEXT);
            }
        }

        public void UpdateFAMILY_TAG_TEXT(FAMILY_TAG_TEXT currentFAMILY_TAG_TEXT)
        {
            this.ObjectContext.FAMILY_TAG_TEXT.AttachAsModified(currentFAMILY_TAG_TEXT, this.ChangeSet.GetOriginal(currentFAMILY_TAG_TEXT));
        }

        public void DeleteFAMILY_TAG_TEXT(FAMILY_TAG_TEXT fAMILY_TAG_TEXT)
        {
            if ((fAMILY_TAG_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(fAMILY_TAG_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.FAMILY_TAG_TEXT.Attach(fAMILY_TAG_TEXT);
                this.ObjectContext.FAMILY_TAG_TEXT.DeleteObject(fAMILY_TAG_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'GROUP_DEFN' query.
        public IQueryable<GROUP_DEFN> GetGROUP_DEFN()
        {
            return this.ObjectContext.GROUP_DEFN;
        }

        public void InsertGROUP_DEFN(GROUP_DEFN gROUP_DEFN)
        {
            if ((gROUP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(gROUP_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.GROUP_DEFN.AddObject(gROUP_DEFN);
            }
        }

        public void UpdateGROUP_DEFN(GROUP_DEFN currentGROUP_DEFN)
        {
            this.ObjectContext.GROUP_DEFN.AttachAsModified(currentGROUP_DEFN, this.ChangeSet.GetOriginal(currentGROUP_DEFN));
        }

        public void DeleteGROUP_DEFN(GROUP_DEFN gROUP_DEFN)
        {
            if ((gROUP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(gROUP_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.GROUP_DEFN.Attach(gROUP_DEFN);
                this.ObjectContext.GROUP_DEFN.DeleteObject(gROUP_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'HVT_CROP_DEFN' query.
        public IQueryable<HVT_CROP_DEFN> GetHVT_CROP_DEFN()
        {
            return this.ObjectContext.HVT_CROP_DEFN;
        }

        public void InsertHVT_CROP_DEFN(HVT_CROP_DEFN hVT_CROP_DEFN)
        {
            if ((hVT_CROP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(hVT_CROP_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.HVT_CROP_DEFN.AddObject(hVT_CROP_DEFN);
            }
        }

        public void UpdateHVT_CROP_DEFN(HVT_CROP_DEFN currentHVT_CROP_DEFN)
        {
            this.ObjectContext.HVT_CROP_DEFN.AttachAsModified(currentHVT_CROP_DEFN, this.ChangeSet.GetOriginal(currentHVT_CROP_DEFN));
        }

        public void DeleteHVT_CROP_DEFN(HVT_CROP_DEFN hVT_CROP_DEFN)
        {
            if ((hVT_CROP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(hVT_CROP_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.HVT_CROP_DEFN.Attach(hVT_CROP_DEFN);
                this.ObjectContext.HVT_CROP_DEFN.DeleteObject(hVT_CROP_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'HVT_PLOT_DEFN' query.
        public IQueryable<HVT_PLOT_DEFN> GetHVT_PLOT_DEFN()
        {
            return this.ObjectContext.HVT_PLOT_DEFN;
        }

        public void InsertHVT_PLOT_DEFN(HVT_PLOT_DEFN hVT_PLOT_DEFN)
        {
            if ((hVT_PLOT_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(hVT_PLOT_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.HVT_PLOT_DEFN.AddObject(hVT_PLOT_DEFN);
            }
        }

        public void UpdateHVT_PLOT_DEFN(HVT_PLOT_DEFN currentHVT_PLOT_DEFN)
        {
            this.ObjectContext.HVT_PLOT_DEFN.AttachAsModified(currentHVT_PLOT_DEFN, this.ChangeSet.GetOriginal(currentHVT_PLOT_DEFN));
        }

        public void DeleteHVT_PLOT_DEFN(HVT_PLOT_DEFN hVT_PLOT_DEFN)
        {
            if ((hVT_PLOT_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(hVT_PLOT_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.HVT_PLOT_DEFN.Attach(hVT_PLOT_DEFN);
                this.ObjectContext.HVT_PLOT_DEFN.DeleteObject(hVT_PLOT_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'HVT_SILO_DEFN' query.
        public IQueryable<HVT_SILO_DEFN> GetHVT_SILO_DEFN()
        {
            return this.ObjectContext.HVT_SILO_DEFN;
        }

        public void InsertHVT_SILO_DEFN(HVT_SILO_DEFN hVT_SILO_DEFN)
        {
            if ((hVT_SILO_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(hVT_SILO_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.HVT_SILO_DEFN.AddObject(hVT_SILO_DEFN);
            }
        }

        public void UpdateHVT_SILO_DEFN(HVT_SILO_DEFN currentHVT_SILO_DEFN)
        {
            this.ObjectContext.HVT_SILO_DEFN.AttachAsModified(currentHVT_SILO_DEFN, this.ChangeSet.GetOriginal(currentHVT_SILO_DEFN));
        }

        public void DeleteHVT_SILO_DEFN(HVT_SILO_DEFN hVT_SILO_DEFN)
        {
            if ((hVT_SILO_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(hVT_SILO_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.HVT_SILO_DEFN.Attach(hVT_SILO_DEFN);
                this.ObjectContext.HVT_SILO_DEFN.DeleteObject(hVT_SILO_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'IO_DEFN' query.
        public IQueryable<IO_DEFN> GetIO_DEFN()
        {
            return this.ObjectContext.IO_DEFN;
        }

        public void InsertIO_DEFN(IO_DEFN iO_DEFN)
        {
            if ((iO_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(iO_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.IO_DEFN.AddObject(iO_DEFN);
            }
        }

        public void UpdateIO_DEFN(IO_DEFN currentIO_DEFN)
        {
            this.ObjectContext.IO_DEFN.AttachAsModified(currentIO_DEFN, this.ChangeSet.GetOriginal(currentIO_DEFN));
        }

        public void DeleteIO_DEFN(IO_DEFN iO_DEFN)
        {
            if ((iO_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(iO_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.IO_DEFN.Attach(iO_DEFN);
                this.ObjectContext.IO_DEFN.DeleteObject(iO_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'LEAK_TAB_COLUMN_DEFN' query.
        public IQueryable<LEAK_TAB_COLUMN_DEFN> GetLEAK_TAB_COLUMN_DEFN()
        {
            return this.ObjectContext.LEAK_TAB_COLUMN_DEFN;
        }

        public void InsertLEAK_TAB_COLUMN_DEFN(LEAK_TAB_COLUMN_DEFN lEAK_TAB_COLUMN_DEFN)
        {
            if ((lEAK_TAB_COLUMN_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lEAK_TAB_COLUMN_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.LEAK_TAB_COLUMN_DEFN.AddObject(lEAK_TAB_COLUMN_DEFN);
            }
        }

        public void UpdateLEAK_TAB_COLUMN_DEFN(LEAK_TAB_COLUMN_DEFN currentLEAK_TAB_COLUMN_DEFN)
        {
            this.ObjectContext.LEAK_TAB_COLUMN_DEFN.AttachAsModified(currentLEAK_TAB_COLUMN_DEFN, this.ChangeSet.GetOriginal(currentLEAK_TAB_COLUMN_DEFN));
        }

        public void DeleteLEAK_TAB_COLUMN_DEFN(LEAK_TAB_COLUMN_DEFN lEAK_TAB_COLUMN_DEFN)
        {
            if ((lEAK_TAB_COLUMN_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lEAK_TAB_COLUMN_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.LEAK_TAB_COLUMN_DEFN.Attach(lEAK_TAB_COLUMN_DEFN);
                this.ObjectContext.LEAK_TAB_COLUMN_DEFN.DeleteObject(lEAK_TAB_COLUMN_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'LIMIT_RECALC_COLLECT' query.
        public IQueryable<LIMIT_RECALC_COLLECT> GetLIMIT_RECALC_COLLECT()
        {
            return this.ObjectContext.LIMIT_RECALC_COLLECT;
        }

        public void InsertLIMIT_RECALC_COLLECT(LIMIT_RECALC_COLLECT lIMIT_RECALC_COLLECT)
        {
            if ((lIMIT_RECALC_COLLECT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_COLLECT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_COLLECT.AddObject(lIMIT_RECALC_COLLECT);
            }
        }

        public void UpdateLIMIT_RECALC_COLLECT(LIMIT_RECALC_COLLECT currentLIMIT_RECALC_COLLECT)
        {
            this.ObjectContext.LIMIT_RECALC_COLLECT.AttachAsModified(currentLIMIT_RECALC_COLLECT, this.ChangeSet.GetOriginal(currentLIMIT_RECALC_COLLECT));
        }

        public void DeleteLIMIT_RECALC_COLLECT(LIMIT_RECALC_COLLECT lIMIT_RECALC_COLLECT)
        {
            if ((lIMIT_RECALC_COLLECT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_COLLECT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_COLLECT.Attach(lIMIT_RECALC_COLLECT);
                this.ObjectContext.LIMIT_RECALC_COLLECT.DeleteObject(lIMIT_RECALC_COLLECT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'LIMIT_RECALC_PARAMS' query.
        public IQueryable<LIMIT_RECALC_PARAMS> GetLIMIT_RECALC_PARAMS()
        {
            return this.ObjectContext.LIMIT_RECALC_PARAMS;
        }

        public void InsertLIMIT_RECALC_PARAMS(LIMIT_RECALC_PARAMS lIMIT_RECALC_PARAMS)
        {
            if ((lIMIT_RECALC_PARAMS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_PARAMS, EntityState.Added);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_PARAMS.AddObject(lIMIT_RECALC_PARAMS);
            }
        }

        public void UpdateLIMIT_RECALC_PARAMS(LIMIT_RECALC_PARAMS currentLIMIT_RECALC_PARAMS)
        {
            this.ObjectContext.LIMIT_RECALC_PARAMS.AttachAsModified(currentLIMIT_RECALC_PARAMS, this.ChangeSet.GetOriginal(currentLIMIT_RECALC_PARAMS));
        }

        public void DeleteLIMIT_RECALC_PARAMS(LIMIT_RECALC_PARAMS lIMIT_RECALC_PARAMS)
        {
            if ((lIMIT_RECALC_PARAMS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_PARAMS, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_PARAMS.Attach(lIMIT_RECALC_PARAMS);
                this.ObjectContext.LIMIT_RECALC_PARAMS.DeleteObject(lIMIT_RECALC_PARAMS);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'LIMIT_RECALC_RESULTS' query.
        public IQueryable<LIMIT_RECALC_RESULTS> GetLIMIT_RECALC_RESULTS()
        {
            return this.ObjectContext.LIMIT_RECALC_RESULTS;
        }

        public void InsertLIMIT_RECALC_RESULTS(LIMIT_RECALC_RESULTS lIMIT_RECALC_RESULTS)
        {
            if ((lIMIT_RECALC_RESULTS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_RESULTS, EntityState.Added);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_RESULTS.AddObject(lIMIT_RECALC_RESULTS);
            }
        }

        public void UpdateLIMIT_RECALC_RESULTS(LIMIT_RECALC_RESULTS currentLIMIT_RECALC_RESULTS)
        {
            this.ObjectContext.LIMIT_RECALC_RESULTS.AttachAsModified(currentLIMIT_RECALC_RESULTS, this.ChangeSet.GetOriginal(currentLIMIT_RECALC_RESULTS));
        }

        public void DeleteLIMIT_RECALC_RESULTS(LIMIT_RECALC_RESULTS lIMIT_RECALC_RESULTS)
        {
            if ((lIMIT_RECALC_RESULTS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_RESULTS, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_RESULTS.Attach(lIMIT_RECALC_RESULTS);
                this.ObjectContext.LIMIT_RECALC_RESULTS.DeleteObject(lIMIT_RECALC_RESULTS);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'LIMIT_RECALC_SHIFT_ID' query.
        public IQueryable<LIMIT_RECALC_SHIFT_ID> GetLIMIT_RECALC_SHIFT_ID()
        {
            return this.ObjectContext.LIMIT_RECALC_SHIFT_ID;
        }

        public void InsertLIMIT_RECALC_SHIFT_ID(LIMIT_RECALC_SHIFT_ID lIMIT_RECALC_SHIFT_ID)
        {
            if ((lIMIT_RECALC_SHIFT_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_SHIFT_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_SHIFT_ID.AddObject(lIMIT_RECALC_SHIFT_ID);
            }
        }

        public void UpdateLIMIT_RECALC_SHIFT_ID(LIMIT_RECALC_SHIFT_ID currentLIMIT_RECALC_SHIFT_ID)
        {
            this.ObjectContext.LIMIT_RECALC_SHIFT_ID.AttachAsModified(currentLIMIT_RECALC_SHIFT_ID, this.ChangeSet.GetOriginal(currentLIMIT_RECALC_SHIFT_ID));
        }

        public void DeleteLIMIT_RECALC_SHIFT_ID(LIMIT_RECALC_SHIFT_ID lIMIT_RECALC_SHIFT_ID)
        {
            if ((lIMIT_RECALC_SHIFT_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_SHIFT_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_SHIFT_ID.Attach(lIMIT_RECALC_SHIFT_ID);
                this.ObjectContext.LIMIT_RECALC_SHIFT_ID.DeleteObject(lIMIT_RECALC_SHIFT_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'LIMIT_RECALC_STAND_CODE' query.
        public IQueryable<LIMIT_RECALC_STAND_CODE> GetLIMIT_RECALC_STAND_CODE()
        {
            return this.ObjectContext.LIMIT_RECALC_STAND_CODE;
        }

        public void InsertLIMIT_RECALC_STAND_CODE(LIMIT_RECALC_STAND_CODE lIMIT_RECALC_STAND_CODE)
        {
            if ((lIMIT_RECALC_STAND_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_STAND_CODE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_STAND_CODE.AddObject(lIMIT_RECALC_STAND_CODE);
            }
        }

        public void UpdateLIMIT_RECALC_STAND_CODE(LIMIT_RECALC_STAND_CODE currentLIMIT_RECALC_STAND_CODE)
        {
            this.ObjectContext.LIMIT_RECALC_STAND_CODE.AttachAsModified(currentLIMIT_RECALC_STAND_CODE, this.ChangeSet.GetOriginal(currentLIMIT_RECALC_STAND_CODE));
        }

        public void DeleteLIMIT_RECALC_STAND_CODE(LIMIT_RECALC_STAND_CODE lIMIT_RECALC_STAND_CODE)
        {
            if ((lIMIT_RECALC_STAND_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_STAND_CODE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_STAND_CODE.Attach(lIMIT_RECALC_STAND_CODE);
                this.ObjectContext.LIMIT_RECALC_STAND_CODE.DeleteObject(lIMIT_RECALC_STAND_CODE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'LIMIT_RECALC_STATUS_ID' query.
        public IQueryable<LIMIT_RECALC_STATUS_ID> GetLIMIT_RECALC_STATUS_ID()
        {
            return this.ObjectContext.LIMIT_RECALC_STATUS_ID;
        }

        public void InsertLIMIT_RECALC_STATUS_ID(LIMIT_RECALC_STATUS_ID lIMIT_RECALC_STATUS_ID)
        {
            if ((lIMIT_RECALC_STATUS_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_STATUS_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_STATUS_ID.AddObject(lIMIT_RECALC_STATUS_ID);
            }
        }

        public void UpdateLIMIT_RECALC_STATUS_ID(LIMIT_RECALC_STATUS_ID currentLIMIT_RECALC_STATUS_ID)
        {
            this.ObjectContext.LIMIT_RECALC_STATUS_ID.AttachAsModified(currentLIMIT_RECALC_STATUS_ID, this.ChangeSet.GetOriginal(currentLIMIT_RECALC_STATUS_ID));
        }

        public void DeleteLIMIT_RECALC_STATUS_ID(LIMIT_RECALC_STATUS_ID lIMIT_RECALC_STATUS_ID)
        {
            if ((lIMIT_RECALC_STATUS_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(lIMIT_RECALC_STATUS_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.LIMIT_RECALC_STATUS_ID.Attach(lIMIT_RECALC_STATUS_ID);
                this.ObjectContext.LIMIT_RECALC_STATUS_ID.DeleteObject(lIMIT_RECALC_STATUS_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_COMPONENT_CODE' query.
        public IQueryable<MBX_COMPONENT_CODE> GetMBX_COMPONENT_CODE()
        {
            return this.ObjectContext.MBX_COMPONENT_CODE;
        }

        public void InsertMBX_COMPONENT_CODE(MBX_COMPONENT_CODE mBX_COMPONENT_CODE)
        {
            if ((mBX_COMPONENT_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_COMPONENT_CODE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_COMPONENT_CODE.AddObject(mBX_COMPONENT_CODE);
            }
        }

        public void UpdateMBX_COMPONENT_CODE(MBX_COMPONENT_CODE currentMBX_COMPONENT_CODE)
        {
            this.ObjectContext.MBX_COMPONENT_CODE.AttachAsModified(currentMBX_COMPONENT_CODE, this.ChangeSet.GetOriginal(currentMBX_COMPONENT_CODE));
        }

        public void DeleteMBX_COMPONENT_CODE(MBX_COMPONENT_CODE mBX_COMPONENT_CODE)
        {
            if ((mBX_COMPONENT_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_COMPONENT_CODE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_COMPONENT_CODE.Attach(mBX_COMPONENT_CODE);
                this.ObjectContext.MBX_COMPONENT_CODE.DeleteObject(mBX_COMPONENT_CODE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_COMPONENT_TYPE' query.
        public IQueryable<MBX_COMPONENT_TYPE> GetMBX_COMPONENT_TYPE()
        {
            return this.ObjectContext.MBX_COMPONENT_TYPE;
        }

        public void InsertMBX_COMPONENT_TYPE(MBX_COMPONENT_TYPE mBX_COMPONENT_TYPE)
        {
            if ((mBX_COMPONENT_TYPE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_COMPONENT_TYPE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_COMPONENT_TYPE.AddObject(mBX_COMPONENT_TYPE);
            }
        }

        public void UpdateMBX_COMPONENT_TYPE(MBX_COMPONENT_TYPE currentMBX_COMPONENT_TYPE)
        {
            this.ObjectContext.MBX_COMPONENT_TYPE.AttachAsModified(currentMBX_COMPONENT_TYPE, this.ChangeSet.GetOriginal(currentMBX_COMPONENT_TYPE));
        }

        public void DeleteMBX_COMPONENT_TYPE(MBX_COMPONENT_TYPE mBX_COMPONENT_TYPE)
        {
            if ((mBX_COMPONENT_TYPE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_COMPONENT_TYPE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_COMPONENT_TYPE.Attach(mBX_COMPONENT_TYPE);
                this.ObjectContext.MBX_COMPONENT_TYPE.DeleteObject(mBX_COMPONENT_TYPE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_FAMILY_DEFN' query.
        public IQueryable<MBX_FAMILY_DEFN> GetMBX_FAMILY_DEFN()
        {
            return this.ObjectContext.MBX_FAMILY_DEFN;
        }

        public void InsertMBX_FAMILY_DEFN(MBX_FAMILY_DEFN mBX_FAMILY_DEFN)
        {
            if ((mBX_FAMILY_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_FAMILY_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_FAMILY_DEFN.AddObject(mBX_FAMILY_DEFN);
            }
        }

        public void UpdateMBX_FAMILY_DEFN(MBX_FAMILY_DEFN currentMBX_FAMILY_DEFN)
        {
            this.ObjectContext.MBX_FAMILY_DEFN.AttachAsModified(currentMBX_FAMILY_DEFN, this.ChangeSet.GetOriginal(currentMBX_FAMILY_DEFN));
        }

        public void DeleteMBX_FAMILY_DEFN(MBX_FAMILY_DEFN mBX_FAMILY_DEFN)
        {
            if ((mBX_FAMILY_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_FAMILY_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_FAMILY_DEFN.Attach(mBX_FAMILY_DEFN);
                this.ObjectContext.MBX_FAMILY_DEFN.DeleteObject(mBX_FAMILY_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_MISC_PHRASE_ID' query.
        public IQueryable<MBX_MISC_PHRASE_ID> GetMBX_MISC_PHRASE_ID()
        {
            return this.ObjectContext.MBX_MISC_PHRASE_ID;
        }

        public void InsertMBX_MISC_PHRASE_ID(MBX_MISC_PHRASE_ID mBX_MISC_PHRASE_ID)
        {
            if ((mBX_MISC_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_MISC_PHRASE_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_MISC_PHRASE_ID.AddObject(mBX_MISC_PHRASE_ID);
            }
        }

        public void UpdateMBX_MISC_PHRASE_ID(MBX_MISC_PHRASE_ID currentMBX_MISC_PHRASE_ID)
        {
            this.ObjectContext.MBX_MISC_PHRASE_ID.AttachAsModified(currentMBX_MISC_PHRASE_ID, this.ChangeSet.GetOriginal(currentMBX_MISC_PHRASE_ID));
        }

        public void DeleteMBX_MISC_PHRASE_ID(MBX_MISC_PHRASE_ID mBX_MISC_PHRASE_ID)
        {
            if ((mBX_MISC_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_MISC_PHRASE_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_MISC_PHRASE_ID.Attach(mBX_MISC_PHRASE_ID);
                this.ObjectContext.MBX_MISC_PHRASE_ID.DeleteObject(mBX_MISC_PHRASE_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_MODEL_CODE' query.
        public IQueryable<MBX_MODEL_CODE> GetMBX_MODEL_CODE()
        {
            return this.ObjectContext.MBX_MODEL_CODE;
        }

        public void InsertMBX_MODEL_CODE(MBX_MODEL_CODE mBX_MODEL_CODE)
        {
            if ((mBX_MODEL_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_MODEL_CODE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_MODEL_CODE.AddObject(mBX_MODEL_CODE);
            }
        }

        public void UpdateMBX_MODEL_CODE(MBX_MODEL_CODE currentMBX_MODEL_CODE)
        {
            this.ObjectContext.MBX_MODEL_CODE.AttachAsModified(currentMBX_MODEL_CODE, this.ChangeSet.GetOriginal(currentMBX_MODEL_CODE));
        }

        public void DeleteMBX_MODEL_CODE(MBX_MODEL_CODE mBX_MODEL_CODE)
        {
            if ((mBX_MODEL_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_MODEL_CODE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_MODEL_CODE.Attach(mBX_MODEL_CODE);
                this.ObjectContext.MBX_MODEL_CODE.DeleteObject(mBX_MODEL_CODE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_PALLET_CODE' query.
        public IQueryable<MBX_PALLET_CODE> GetMBX_PALLET_CODE()
        {
            return this.ObjectContext.MBX_PALLET_CODE;
        }

        public void InsertMBX_PALLET_CODE(MBX_PALLET_CODE mBX_PALLET_CODE)
        {
            if ((mBX_PALLET_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_PALLET_CODE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_PALLET_CODE.AddObject(mBX_PALLET_CODE);
            }
        }

        public void UpdateMBX_PALLET_CODE(MBX_PALLET_CODE currentMBX_PALLET_CODE)
        {
            this.ObjectContext.MBX_PALLET_CODE.AttachAsModified(currentMBX_PALLET_CODE, this.ChangeSet.GetOriginal(currentMBX_PALLET_CODE));
        }

        public void DeleteMBX_PALLET_CODE(MBX_PALLET_CODE mBX_PALLET_CODE)
        {
            if ((mBX_PALLET_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_PALLET_CODE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_PALLET_CODE.Attach(mBX_PALLET_CODE);
                this.ObjectContext.MBX_PALLET_CODE.DeleteObject(mBX_PALLET_CODE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_PARAM_PHRASE_ID' query.
        public IQueryable<MBX_PARAM_PHRASE_ID> GetMBX_PARAM_PHRASE_ID()
        {
            return this.ObjectContext.MBX_PARAM_PHRASE_ID;
        }

        public void InsertMBX_PARAM_PHRASE_ID(MBX_PARAM_PHRASE_ID mBX_PARAM_PHRASE_ID)
        {
            if ((mBX_PARAM_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_PARAM_PHRASE_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_PARAM_PHRASE_ID.AddObject(mBX_PARAM_PHRASE_ID);
            }
        }

        public void UpdateMBX_PARAM_PHRASE_ID(MBX_PARAM_PHRASE_ID currentMBX_PARAM_PHRASE_ID)
        {
            this.ObjectContext.MBX_PARAM_PHRASE_ID.AttachAsModified(currentMBX_PARAM_PHRASE_ID, this.ChangeSet.GetOriginal(currentMBX_PARAM_PHRASE_ID));
        }

        public void DeleteMBX_PARAM_PHRASE_ID(MBX_PARAM_PHRASE_ID mBX_PARAM_PHRASE_ID)
        {
            if ((mBX_PARAM_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_PARAM_PHRASE_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_PARAM_PHRASE_ID.Attach(mBX_PARAM_PHRASE_ID);
                this.ObjectContext.MBX_PARAM_PHRASE_ID.DeleteObject(mBX_PARAM_PHRASE_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_PDB' query.
        public IQueryable<MBX_PDB> GetMBX_PDB()
        {
            return this.ObjectContext.MBX_PDB;
        }

        public void InsertMBX_PDB(MBX_PDB mBX_PDB)
        {
            if ((mBX_PDB.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_PDB, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_PDB.AddObject(mBX_PDB);
            }
        }

        public void UpdateMBX_PDB(MBX_PDB currentMBX_PDB)
        {
            this.ObjectContext.MBX_PDB.AttachAsModified(currentMBX_PDB, this.ChangeSet.GetOriginal(currentMBX_PDB));
        }

        public void DeleteMBX_PDB(MBX_PDB mBX_PDB)
        {
            if ((mBX_PDB.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_PDB, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_PDB.Attach(mBX_PDB);
                this.ObjectContext.MBX_PDB.DeleteObject(mBX_PDB);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_PHASE_PHRASE_ID' query.
        public IQueryable<MBX_PHASE_PHRASE_ID> GetMBX_PHASE_PHRASE_ID()
        {
            return this.ObjectContext.MBX_PHASE_PHRASE_ID;
        }

        public void InsertMBX_PHASE_PHRASE_ID(MBX_PHASE_PHRASE_ID mBX_PHASE_PHRASE_ID)
        {
            if ((mBX_PHASE_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_PHASE_PHRASE_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_PHASE_PHRASE_ID.AddObject(mBX_PHASE_PHRASE_ID);
            }
        }

        public void UpdateMBX_PHASE_PHRASE_ID(MBX_PHASE_PHRASE_ID currentMBX_PHASE_PHRASE_ID)
        {
            this.ObjectContext.MBX_PHASE_PHRASE_ID.AttachAsModified(currentMBX_PHASE_PHRASE_ID, this.ChangeSet.GetOriginal(currentMBX_PHASE_PHRASE_ID));
        }

        public void DeleteMBX_PHASE_PHRASE_ID(MBX_PHASE_PHRASE_ID mBX_PHASE_PHRASE_ID)
        {
            if ((mBX_PHASE_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_PHASE_PHRASE_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_PHASE_PHRASE_ID.Attach(mBX_PHASE_PHRASE_ID);
                this.ObjectContext.MBX_PHASE_PHRASE_ID.DeleteObject(mBX_PHASE_PHRASE_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_REJ_ID' query.
        public IQueryable<MBX_REJ_ID> GetMBX_REJ_ID()
        {
            return this.ObjectContext.MBX_REJ_ID;
        }

        public void InsertMBX_REJ_ID(MBX_REJ_ID mBX_REJ_ID)
        {
            if ((mBX_REJ_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_REJ_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_REJ_ID.AddObject(mBX_REJ_ID);
            }
        }

        public void UpdateMBX_REJ_ID(MBX_REJ_ID currentMBX_REJ_ID)
        {
            this.ObjectContext.MBX_REJ_ID.AttachAsModified(currentMBX_REJ_ID, this.ChangeSet.GetOriginal(currentMBX_REJ_ID));
        }

        public void DeleteMBX_REJ_ID(MBX_REJ_ID mBX_REJ_ID)
        {
            if ((mBX_REJ_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_REJ_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_REJ_ID.Attach(mBX_REJ_ID);
                this.ObjectContext.MBX_REJ_ID.DeleteObject(mBX_REJ_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_REJECT_TYPE' query.
        public IQueryable<MBX_REJECT_TYPE> GetMBX_REJECT_TYPE()
        {
            return this.ObjectContext.MBX_REJECT_TYPE;
        }

        public void InsertMBX_REJECT_TYPE(MBX_REJECT_TYPE mBX_REJECT_TYPE)
        {
            if ((mBX_REJECT_TYPE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_REJECT_TYPE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_REJECT_TYPE.AddObject(mBX_REJECT_TYPE);
            }
        }

        public void UpdateMBX_REJECT_TYPE(MBX_REJECT_TYPE currentMBX_REJECT_TYPE)
        {
            this.ObjectContext.MBX_REJECT_TYPE.AttachAsModified(currentMBX_REJECT_TYPE, this.ChangeSet.GetOriginal(currentMBX_REJECT_TYPE));
        }

        public void DeleteMBX_REJECT_TYPE(MBX_REJECT_TYPE mBX_REJECT_TYPE)
        {
            if ((mBX_REJECT_TYPE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_REJECT_TYPE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_REJECT_TYPE.Attach(mBX_REJECT_TYPE);
                this.ObjectContext.MBX_REJECT_TYPE.DeleteObject(mBX_REJECT_TYPE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_REPAIR_TEXT_ID' query.
        public IQueryable<MBX_REPAIR_TEXT_ID> GetMBX_REPAIR_TEXT_ID()
        {
            return this.ObjectContext.MBX_REPAIR_TEXT_ID;
        }

        public void InsertMBX_REPAIR_TEXT_ID(MBX_REPAIR_TEXT_ID mBX_REPAIR_TEXT_ID)
        {
            if ((mBX_REPAIR_TEXT_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_REPAIR_TEXT_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_REPAIR_TEXT_ID.AddObject(mBX_REPAIR_TEXT_ID);
            }
        }

        public void UpdateMBX_REPAIR_TEXT_ID(MBX_REPAIR_TEXT_ID currentMBX_REPAIR_TEXT_ID)
        {
            this.ObjectContext.MBX_REPAIR_TEXT_ID.AttachAsModified(currentMBX_REPAIR_TEXT_ID, this.ChangeSet.GetOriginal(currentMBX_REPAIR_TEXT_ID));
        }

        public void DeleteMBX_REPAIR_TEXT_ID(MBX_REPAIR_TEXT_ID mBX_REPAIR_TEXT_ID)
        {
            if ((mBX_REPAIR_TEXT_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_REPAIR_TEXT_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_REPAIR_TEXT_ID.Attach(mBX_REPAIR_TEXT_ID);
                this.ObjectContext.MBX_REPAIR_TEXT_ID.DeleteObject(mBX_REPAIR_TEXT_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_SERIAL_RANGE' query.
        public IQueryable<MBX_SERIAL_RANGE> GetMBX_SERIAL_RANGE()
        {
            return this.ObjectContext.MBX_SERIAL_RANGE;
        }

        public void InsertMBX_SERIAL_RANGE(MBX_SERIAL_RANGE mBX_SERIAL_RANGE)
        {
            if ((mBX_SERIAL_RANGE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_SERIAL_RANGE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_SERIAL_RANGE.AddObject(mBX_SERIAL_RANGE);
            }
        }

        public void UpdateMBX_SERIAL_RANGE(MBX_SERIAL_RANGE currentMBX_SERIAL_RANGE)
        {
            this.ObjectContext.MBX_SERIAL_RANGE.AttachAsModified(currentMBX_SERIAL_RANGE, this.ChangeSet.GetOriginal(currentMBX_SERIAL_RANGE));
        }

        public void DeleteMBX_SERIAL_RANGE(MBX_SERIAL_RANGE mBX_SERIAL_RANGE)
        {
            if ((mBX_SERIAL_RANGE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_SERIAL_RANGE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_SERIAL_RANGE.Attach(mBX_SERIAL_RANGE);
                this.ObjectContext.MBX_SERIAL_RANGE.DeleteObject(mBX_SERIAL_RANGE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_SHIFT' query.
        public IQueryable<MBX_SHIFT> GetMBX_SHIFT()
        {
            return this.ObjectContext.MBX_SHIFT;
        }

        public void InsertMBX_SHIFT(MBX_SHIFT mBX_SHIFT)
        {
            if ((mBX_SHIFT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_SHIFT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_SHIFT.AddObject(mBX_SHIFT);
            }
        }

        public void UpdateMBX_SHIFT(MBX_SHIFT currentMBX_SHIFT)
        {
            this.ObjectContext.MBX_SHIFT.AttachAsModified(currentMBX_SHIFT, this.ChangeSet.GetOriginal(currentMBX_SHIFT));
        }

        public void DeleteMBX_SHIFT(MBX_SHIFT mBX_SHIFT)
        {
            if ((mBX_SHIFT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_SHIFT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_SHIFT.Attach(mBX_SHIFT);
                this.ObjectContext.MBX_SHIFT.DeleteObject(mBX_SHIFT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_STAND_CODE' query.
        public IQueryable<MBX_STAND_CODE> GetMBX_STAND_CODE()
        {
            return this.ObjectContext.MBX_STAND_CODE;
        }

        public void InsertMBX_STAND_CODE(MBX_STAND_CODE mBX_STAND_CODE)
        {
            if ((mBX_STAND_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_STAND_CODE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_STAND_CODE.AddObject(mBX_STAND_CODE);
            }
        }

        public void UpdateMBX_STAND_CODE(MBX_STAND_CODE currentMBX_STAND_CODE)
        {
            this.ObjectContext.MBX_STAND_CODE.AttachAsModified(currentMBX_STAND_CODE, this.ChangeSet.GetOriginal(currentMBX_STAND_CODE));
        }

        public void DeleteMBX_STAND_CODE(MBX_STAND_CODE mBX_STAND_CODE)
        {
            if ((mBX_STAND_CODE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_STAND_CODE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_STAND_CODE.Attach(mBX_STAND_CODE);
                this.ObjectContext.MBX_STAND_CODE.DeleteObject(mBX_STAND_CODE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_STAT_PHRASE_ID' query.
        public IQueryable<MBX_STAT_PHRASE_ID> GetMBX_STAT_PHRASE_ID()
        {
            return this.ObjectContext.MBX_STAT_PHRASE_ID;
        }

        public void InsertMBX_STAT_PHRASE_ID(MBX_STAT_PHRASE_ID mBX_STAT_PHRASE_ID)
        {
            if ((mBX_STAT_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_STAT_PHRASE_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_STAT_PHRASE_ID.AddObject(mBX_STAT_PHRASE_ID);
            }
        }

        public void UpdateMBX_STAT_PHRASE_ID(MBX_STAT_PHRASE_ID currentMBX_STAT_PHRASE_ID)
        {
            this.ObjectContext.MBX_STAT_PHRASE_ID.AttachAsModified(currentMBX_STAT_PHRASE_ID, this.ChangeSet.GetOriginal(currentMBX_STAT_PHRASE_ID));
        }

        public void DeleteMBX_STAT_PHRASE_ID(MBX_STAT_PHRASE_ID mBX_STAT_PHRASE_ID)
        {
            if ((mBX_STAT_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_STAT_PHRASE_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_STAT_PHRASE_ID.Attach(mBX_STAT_PHRASE_ID);
                this.ObjectContext.MBX_STAT_PHRASE_ID.DeleteObject(mBX_STAT_PHRASE_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_STEP_PHRASE_ID' query.
        public IQueryable<MBX_STEP_PHRASE_ID> GetMBX_STEP_PHRASE_ID()
        {
            return this.ObjectContext.MBX_STEP_PHRASE_ID;
        }

        public void InsertMBX_STEP_PHRASE_ID(MBX_STEP_PHRASE_ID mBX_STEP_PHRASE_ID)
        {
            if ((mBX_STEP_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_STEP_PHRASE_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_STEP_PHRASE_ID.AddObject(mBX_STEP_PHRASE_ID);
            }
        }

        public void UpdateMBX_STEP_PHRASE_ID(MBX_STEP_PHRASE_ID currentMBX_STEP_PHRASE_ID)
        {
            this.ObjectContext.MBX_STEP_PHRASE_ID.AttachAsModified(currentMBX_STEP_PHRASE_ID, this.ChangeSet.GetOriginal(currentMBX_STEP_PHRASE_ID));
        }

        public void DeleteMBX_STEP_PHRASE_ID(MBX_STEP_PHRASE_ID mBX_STEP_PHRASE_ID)
        {
            if ((mBX_STEP_PHRASE_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_STEP_PHRASE_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_STEP_PHRASE_ID.Attach(mBX_STEP_PHRASE_ID);
                this.ObjectContext.MBX_STEP_PHRASE_ID.DeleteObject(mBX_STEP_PHRASE_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_TEST_STATUS' query.
        public IQueryable<MBX_TEST_STATUS> GetMBX_TEST_STATUS()
        {
            return this.ObjectContext.MBX_TEST_STATUS;
        }

        public void InsertMBX_TEST_STATUS(MBX_TEST_STATUS mBX_TEST_STATUS)
        {
            if ((mBX_TEST_STATUS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TEST_STATUS, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_TEST_STATUS.AddObject(mBX_TEST_STATUS);
            }
        }

        public void UpdateMBX_TEST_STATUS(MBX_TEST_STATUS currentMBX_TEST_STATUS)
        {
            this.ObjectContext.MBX_TEST_STATUS.AttachAsModified(currentMBX_TEST_STATUS, this.ChangeSet.GetOriginal(currentMBX_TEST_STATUS));
        }

        public void DeleteMBX_TEST_STATUS(MBX_TEST_STATUS mBX_TEST_STATUS)
        {
            if ((mBX_TEST_STATUS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TEST_STATUS, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_TEST_STATUS.Attach(mBX_TEST_STATUS);
                this.ObjectContext.MBX_TEST_STATUS.DeleteObject(mBX_TEST_STATUS);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_THREAD_NUM' query.
        public IQueryable<MBX_THREAD_NUM> GetMBX_THREAD_NUM()
        {
            return this.ObjectContext.MBX_THREAD_NUM;
        }

        public void InsertMBX_THREAD_NUM(MBX_THREAD_NUM mBX_THREAD_NUM)
        {
            if ((mBX_THREAD_NUM.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_THREAD_NUM, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_THREAD_NUM.AddObject(mBX_THREAD_NUM);
            }
        }

        public void UpdateMBX_THREAD_NUM(MBX_THREAD_NUM currentMBX_THREAD_NUM)
        {
            this.ObjectContext.MBX_THREAD_NUM.AttachAsModified(currentMBX_THREAD_NUM, this.ChangeSet.GetOriginal(currentMBX_THREAD_NUM));
        }

        public void DeleteMBX_THREAD_NUM(MBX_THREAD_NUM mBX_THREAD_NUM)
        {
            if ((mBX_THREAD_NUM.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_THREAD_NUM, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_THREAD_NUM.Attach(mBX_THREAD_NUM);
                this.ObjectContext.MBX_THREAD_NUM.DeleteObject(mBX_THREAD_NUM);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_TOP' query.
        public IQueryable<MBX_TOP> GetMBX_TOP()
        {
            return this.ObjectContext.MBX_TOP;
        }
        
        public decimal GetNextSequenceValue(string sSequence)
        {
            IList<decimal> sequence;
            string _sSql = "SELECT " + sSequence + ".NEXTVAL FROM DUAL";
            sequence = ObjectContext.ExecuteStoreQuery<decimal>(_sSql).ToList();

            return sequence[0];
        }

        public void InsertMBX_TOP(MBX_TOP mBX_TOP)
        {
            if ( mBX_TOP.MBX_SAKEY == -1 ) mBX_TOP.MBX_SAKEY = (int)this.GetNextSequenceValue("MBX_SAKEY"); // todo: isn't this asynchronous????

            if ((mBX_TOP.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TOP, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_TOP.AddObject(mBX_TOP);
            }
        }

        public void UpdateMBX_TOP(MBX_TOP currentMBX_TOP)
        {
            this.ObjectContext.MBX_TOP.AttachAsModified(currentMBX_TOP, this.ChangeSet.GetOriginal(currentMBX_TOP));
        }

        public void DeleteMBX_TOP(MBX_TOP mBX_TOP)
        {
            if ((mBX_TOP.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TOP, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_TOP.Attach(mBX_TOP);
                this.ObjectContext.MBX_TOP.DeleteObject(mBX_TOP);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_TP_ID' query.
        public IQueryable<MBX_TP_ID> GetMBX_TP_ID()
        {
            return this.ObjectContext.MBX_TP_ID;
        }

        public void InsertMBX_TP_ID(MBX_TP_ID mBX_TP_ID)
        {
            if ((mBX_TP_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TP_ID, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_TP_ID.AddObject(mBX_TP_ID);
            }
        }

        public void UpdateMBX_TP_ID(MBX_TP_ID currentMBX_TP_ID)
        {
            this.ObjectContext.MBX_TP_ID.AttachAsModified(currentMBX_TP_ID, this.ChangeSet.GetOriginal(currentMBX_TP_ID));
        }

        public void DeleteMBX_TP_ID(MBX_TP_ID mBX_TP_ID)
        {
            if ((mBX_TP_ID.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TP_ID, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_TP_ID.Attach(mBX_TP_ID);
                this.ObjectContext.MBX_TP_ID.DeleteObject(mBX_TP_ID);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_TP_QTY' query.
        public IQueryable<MBX_TP_QTY> GetMBX_TP_QTY()
        {
            return this.ObjectContext.MBX_TP_QTY;
        }

        public void InsertMBX_TP_QTY(MBX_TP_QTY mBX_TP_QTY)
        {
            if ((mBX_TP_QTY.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TP_QTY, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_TP_QTY.AddObject(mBX_TP_QTY);
            }
        }

        public void UpdateMBX_TP_QTY(MBX_TP_QTY currentMBX_TP_QTY)
        {
            this.ObjectContext.MBX_TP_QTY.AttachAsModified(currentMBX_TP_QTY, this.ChangeSet.GetOriginal(currentMBX_TP_QTY));
        }

        public void DeleteMBX_TP_QTY(MBX_TP_QTY mBX_TP_QTY)
        {
            if ((mBX_TP_QTY.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TP_QTY, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_TP_QTY.Attach(mBX_TP_QTY);
                this.ObjectContext.MBX_TP_QTY.DeleteObject(mBX_TP_QTY);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MBX_TP_RANGE' query.
        public IQueryable<MBX_TP_RANGE> GetMBX_TP_RANGE()
        {
            return this.ObjectContext.MBX_TP_RANGE;
        }

        public void InsertMBX_TP_RANGE(MBX_TP_RANGE mBX_TP_RANGE)
        {
            if ((mBX_TP_RANGE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TP_RANGE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MBX_TP_RANGE.AddObject(mBX_TP_RANGE);
            }
        }

        public void UpdateMBX_TP_RANGE(MBX_TP_RANGE currentMBX_TP_RANGE)
        {
            this.ObjectContext.MBX_TP_RANGE.AttachAsModified(currentMBX_TP_RANGE, this.ChangeSet.GetOriginal(currentMBX_TP_RANGE));
        }

        public void DeleteMBX_TP_RANGE(MBX_TP_RANGE mBX_TP_RANGE)
        {
            if ((mBX_TP_RANGE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mBX_TP_RANGE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MBX_TP_RANGE.Attach(mBX_TP_RANGE);
                this.ObjectContext.MBX_TP_RANGE.DeleteObject(mBX_TP_RANGE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MODEL_CODE_DEFN' query.
        public IQueryable<MODEL_CODE_DEFN> GetMODEL_CODE_DEFN()
        {
            return this.ObjectContext.MODEL_CODE_DEFN;
        }

        public void InsertMODEL_CODE_DEFN(MODEL_CODE_DEFN mODEL_CODE_DEFN)
        {
            if ((mODEL_CODE_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_CODE_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MODEL_CODE_DEFN.AddObject(mODEL_CODE_DEFN);
            }
        }

        public void UpdateMODEL_CODE_DEFN(MODEL_CODE_DEFN currentMODEL_CODE_DEFN)
        {
            this.ObjectContext.MODEL_CODE_DEFN.AttachAsModified(currentMODEL_CODE_DEFN, this.ChangeSet.GetOriginal(currentMODEL_CODE_DEFN));
        }

        public void DeleteMODEL_CODE_DEFN(MODEL_CODE_DEFN mODEL_CODE_DEFN)
        {
            if ((mODEL_CODE_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_CODE_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MODEL_CODE_DEFN.Attach(mODEL_CODE_DEFN);
                this.ObjectContext.MODEL_CODE_DEFN.DeleteObject(mODEL_CODE_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MODEL_DEFN' query.
        public IQueryable<MODEL_DEFN> GetMODEL_DEFN()
        {
            return this.ObjectContext.MODEL_DEFN;
        }

        public void InsertMODEL_DEFN(MODEL_DEFN mODEL_DEFN)
        {
            if ((mODEL_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MODEL_DEFN.AddObject(mODEL_DEFN);
            }
        }

        public void UpdateMODEL_DEFN(MODEL_DEFN currentMODEL_DEFN)
        {
            this.ObjectContext.MODEL_DEFN.AttachAsModified(currentMODEL_DEFN, this.ChangeSet.GetOriginal(currentMODEL_DEFN));
        }

        public void DeleteMODEL_DEFN(MODEL_DEFN mODEL_DEFN)
        {
            if ((mODEL_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MODEL_DEFN.Attach(mODEL_DEFN);
                this.ObjectContext.MODEL_DEFN.DeleteObject(mODEL_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MODEL_DOWNLOAD_DEFN' query.
        public IQueryable<MODEL_DOWNLOAD_DEFN> GetMODEL_DOWNLOAD_DEFN()
        {
            return this.ObjectContext.MODEL_DOWNLOAD_DEFN;
        }

        public void InsertMODEL_DOWNLOAD_DEFN(MODEL_DOWNLOAD_DEFN mODEL_DOWNLOAD_DEFN)
        {
            if ((mODEL_DOWNLOAD_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_DOWNLOAD_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MODEL_DOWNLOAD_DEFN.AddObject(mODEL_DOWNLOAD_DEFN);
            }
        }

        public void UpdateMODEL_DOWNLOAD_DEFN(MODEL_DOWNLOAD_DEFN currentMODEL_DOWNLOAD_DEFN)
        {
            this.ObjectContext.MODEL_DOWNLOAD_DEFN.AttachAsModified(currentMODEL_DOWNLOAD_DEFN, this.ChangeSet.GetOriginal(currentMODEL_DOWNLOAD_DEFN));
        }

        public void DeleteMODEL_DOWNLOAD_DEFN(MODEL_DOWNLOAD_DEFN mODEL_DOWNLOAD_DEFN)
        {
            if ((mODEL_DOWNLOAD_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_DOWNLOAD_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MODEL_DOWNLOAD_DEFN.Attach(mODEL_DOWNLOAD_DEFN);
                this.ObjectContext.MODEL_DOWNLOAD_DEFN.DeleteObject(mODEL_DOWNLOAD_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MODEL_GROUP_DEFN' query.
        public IQueryable<MODEL_GROUP_DEFN> GetMODEL_GROUP_DEFN()
        {
            return this.ObjectContext.MODEL_GROUP_DEFN;
        }

        public void InsertMODEL_GROUP_DEFN(MODEL_GROUP_DEFN mODEL_GROUP_DEFN)
        {
            if ((mODEL_GROUP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_GROUP_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MODEL_GROUP_DEFN.AddObject(mODEL_GROUP_DEFN);
            }
        }

        public void UpdateMODEL_GROUP_DEFN(MODEL_GROUP_DEFN currentMODEL_GROUP_DEFN)
        {
            this.ObjectContext.MODEL_GROUP_DEFN.AttachAsModified(currentMODEL_GROUP_DEFN, this.ChangeSet.GetOriginal(currentMODEL_GROUP_DEFN));
        }

        public void DeleteMODEL_GROUP_DEFN(MODEL_GROUP_DEFN mODEL_GROUP_DEFN)
        {
            if ((mODEL_GROUP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_GROUP_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MODEL_GROUP_DEFN.Attach(mODEL_GROUP_DEFN);
                this.ObjectContext.MODEL_GROUP_DEFN.DeleteObject(mODEL_GROUP_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MODEL_PSPS_DATA' query.
        public IQueryable<MODEL_PSPS_DATA> GetMODEL_PSPS_DATA()
        {
            return this.ObjectContext.MODEL_PSPS_DATA;
        }

        public void InsertMODEL_PSPS_DATA(MODEL_PSPS_DATA mODEL_PSPS_DATA)
        {
            if ((mODEL_PSPS_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_PSPS_DATA, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MODEL_PSPS_DATA.AddObject(mODEL_PSPS_DATA);
            }
        }

        public void UpdateMODEL_PSPS_DATA(MODEL_PSPS_DATA currentMODEL_PSPS_DATA)
        {
            this.ObjectContext.MODEL_PSPS_DATA.AttachAsModified(currentMODEL_PSPS_DATA, this.ChangeSet.GetOriginal(currentMODEL_PSPS_DATA));
        }

        public void DeleteMODEL_PSPS_DATA(MODEL_PSPS_DATA mODEL_PSPS_DATA)
        {
            if ((mODEL_PSPS_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_PSPS_DATA, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MODEL_PSPS_DATA.Attach(mODEL_PSPS_DATA);
                this.ObjectContext.MODEL_PSPS_DATA.DeleteObject(mODEL_PSPS_DATA);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MODEL_TCU_DEFN' query.
        public IQueryable<MODEL_TCU_DEFN> GetMODEL_TCU_DEFN()
        {
            return this.ObjectContext.MODEL_TCU_DEFN;
        }

        public void InsertMODEL_TCU_DEFN(MODEL_TCU_DEFN mODEL_TCU_DEFN)
        {
            if ((mODEL_TCU_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_TCU_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MODEL_TCU_DEFN.AddObject(mODEL_TCU_DEFN);
            }
        }

        public void UpdateMODEL_TCU_DEFN(MODEL_TCU_DEFN currentMODEL_TCU_DEFN)
        {
            this.ObjectContext.MODEL_TCU_DEFN.AttachAsModified(currentMODEL_TCU_DEFN, this.ChangeSet.GetOriginal(currentMODEL_TCU_DEFN));
        }

        public void DeleteMODEL_TCU_DEFN(MODEL_TCU_DEFN mODEL_TCU_DEFN)
        {
            if ((mODEL_TCU_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mODEL_TCU_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MODEL_TCU_DEFN.Attach(mODEL_TCU_DEFN);
                this.ObjectContext.MODEL_TCU_DEFN.DeleteObject(mODEL_TCU_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'MONTR_PARAM_DEFN' query.
        public IQueryable<MONTR_PARAM_DEFN> GetMONTR_PARAM_DEFN()
        {
            return this.ObjectContext.MONTR_PARAM_DEFN;
        }

        public void InsertMONTR_PARAM_DEFN(MONTR_PARAM_DEFN mONTR_PARAM_DEFN)
        {
            if ((mONTR_PARAM_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mONTR_PARAM_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MONTR_PARAM_DEFN.AddObject(mONTR_PARAM_DEFN);
            }
        }

        public void UpdateMONTR_PARAM_DEFN(MONTR_PARAM_DEFN currentMONTR_PARAM_DEFN)
        {
            this.ObjectContext.MONTR_PARAM_DEFN.AttachAsModified(currentMONTR_PARAM_DEFN, this.ChangeSet.GetOriginal(currentMONTR_PARAM_DEFN));
        }

        public void DeleteMONTR_PARAM_DEFN(MONTR_PARAM_DEFN mONTR_PARAM_DEFN)
        {
            if ((mONTR_PARAM_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mONTR_PARAM_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MONTR_PARAM_DEFN.Attach(mONTR_PARAM_DEFN);
                this.ObjectContext.MONTR_PARAM_DEFN.DeleteObject(mONTR_PARAM_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'NEW_KK_TEST_RESULTS' query.
        public IQueryable<NEW_KK_TEST_RESULTS> GetNEW_KK_TEST_RESULTS()
        {
            return this.ObjectContext.NEW_KK_TEST_RESULTS;
        }

        public void InsertNEW_KK_TEST_RESULTS(NEW_KK_TEST_RESULTS nEW_KK_TEST_RESULTS)
        {
            if ((nEW_KK_TEST_RESULTS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(nEW_KK_TEST_RESULTS, EntityState.Added);
            }
            else
            {
                this.ObjectContext.NEW_KK_TEST_RESULTS.AddObject(nEW_KK_TEST_RESULTS);
            }
        }

        public void UpdateNEW_KK_TEST_RESULTS(NEW_KK_TEST_RESULTS currentNEW_KK_TEST_RESULTS)
        {
            this.ObjectContext.NEW_KK_TEST_RESULTS.AttachAsModified(currentNEW_KK_TEST_RESULTS, this.ChangeSet.GetOriginal(currentNEW_KK_TEST_RESULTS));
        }

        public void DeleteNEW_KK_TEST_RESULTS(NEW_KK_TEST_RESULTS nEW_KK_TEST_RESULTS)
        {
            if ((nEW_KK_TEST_RESULTS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(nEW_KK_TEST_RESULTS, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.NEW_KK_TEST_RESULTS.Attach(nEW_KK_TEST_RESULTS);
                this.ObjectContext.NEW_KK_TEST_RESULTS.DeleteObject(nEW_KK_TEST_RESULTS);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'NEW_TEST_RESULTS' query.
        public IQueryable<NEW_TEST_RESULTS> GetNEW_TEST_RESULTS()
        {
            return this.ObjectContext.NEW_TEST_RESULTS;
        }

        public void InsertNEW_TEST_RESULTS(NEW_TEST_RESULTS nEW_TEST_RESULTS)
        {
            if ((nEW_TEST_RESULTS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(nEW_TEST_RESULTS, EntityState.Added);
            }
            else
            {
                this.ObjectContext.NEW_TEST_RESULTS.AddObject(nEW_TEST_RESULTS);
            }
        }

        public void UpdateNEW_TEST_RESULTS(NEW_TEST_RESULTS currentNEW_TEST_RESULTS)
        {
            this.ObjectContext.NEW_TEST_RESULTS.AttachAsModified(currentNEW_TEST_RESULTS, this.ChangeSet.GetOriginal(currentNEW_TEST_RESULTS));
        }

        public void DeleteNEW_TEST_RESULTS(NEW_TEST_RESULTS nEW_TEST_RESULTS)
        {
            if ((nEW_TEST_RESULTS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(nEW_TEST_RESULTS, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.NEW_TEST_RESULTS.Attach(nEW_TEST_RESULTS);
                this.ObjectContext.NEW_TEST_RESULTS.DeleteObject(nEW_TEST_RESULTS);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PALLET_DATA' query.
        public IQueryable<PALLET_DATA> GetPALLET_DATA()
        {
            return this.ObjectContext.PALLET_DATA;
        }

        public void InsertPALLET_DATA(PALLET_DATA pALLET_DATA)
        {
            if ((pALLET_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pALLET_DATA, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PALLET_DATA.AddObject(pALLET_DATA);
            }
        }

        public void UpdatePALLET_DATA(PALLET_DATA currentPALLET_DATA)
        {
            this.ObjectContext.PALLET_DATA.AttachAsModified(currentPALLET_DATA, this.ChangeSet.GetOriginal(currentPALLET_DATA));
        }

        public void DeletePALLET_DATA(PALLET_DATA pALLET_DATA)
        {
            if ((pALLET_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pALLET_DATA, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PALLET_DATA.Attach(pALLET_DATA);
                this.ObjectContext.PALLET_DATA.DeleteObject(pALLET_DATA);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PALLET_DATA_STAT_DESC' query.
        public IQueryable<PALLET_DATA_STAT_DESC> GetPALLET_DATA_STAT_DESC()
        {
            return this.ObjectContext.PALLET_DATA_STAT_DESC;
        }

        public void InsertPALLET_DATA_STAT_DESC(PALLET_DATA_STAT_DESC pALLET_DATA_STAT_DESC)
        {
            if ((pALLET_DATA_STAT_DESC.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pALLET_DATA_STAT_DESC, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PALLET_DATA_STAT_DESC.AddObject(pALLET_DATA_STAT_DESC);
            }
        }

        public void UpdatePALLET_DATA_STAT_DESC(PALLET_DATA_STAT_DESC currentPALLET_DATA_STAT_DESC)
        {
            this.ObjectContext.PALLET_DATA_STAT_DESC.AttachAsModified(currentPALLET_DATA_STAT_DESC, this.ChangeSet.GetOriginal(currentPALLET_DATA_STAT_DESC));
        }

        public void DeletePALLET_DATA_STAT_DESC(PALLET_DATA_STAT_DESC pALLET_DATA_STAT_DESC)
        {
            if ((pALLET_DATA_STAT_DESC.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pALLET_DATA_STAT_DESC, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PALLET_DATA_STAT_DESC.Attach(pALLET_DATA_STAT_DESC);
                this.ObjectContext.PALLET_DATA_STAT_DESC.DeleteObject(pALLET_DATA_STAT_DESC);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PALLET_DEFN' query.
        public IQueryable<PALLET_DEFN> GetPALLET_DEFN()
        {
            return this.ObjectContext.PALLET_DEFN;
        }

        public void InsertPALLET_DEFN(PALLET_DEFN pALLET_DEFN)
        {
            if ((pALLET_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pALLET_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PALLET_DEFN.AddObject(pALLET_DEFN);
            }
        }

        public void UpdatePALLET_DEFN(PALLET_DEFN currentPALLET_DEFN)
        {
            this.ObjectContext.PALLET_DEFN.AttachAsModified(currentPALLET_DEFN, this.ChangeSet.GetOriginal(currentPALLET_DEFN));
        }

        public void DeletePALLET_DEFN(PALLET_DEFN pALLET_DEFN)
        {
            if ((pALLET_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pALLET_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PALLET_DEFN.Attach(pALLET_DEFN);
                this.ObjectContext.PALLET_DEFN.DeleteObject(pALLET_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PARAM_DEFN' query.
        public IQueryable<PARAM_DEFN> GetPARAM_DEFN()
        {
            return this.ObjectContext.PARAM_DEFN;
        }

        public void InsertPARAM_DEFN(PARAM_DEFN pARAM_DEFN)
        {
            if ((pARAM_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pARAM_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PARAM_DEFN.AddObject(pARAM_DEFN);
            }
        }

        public void UpdatePARAM_DEFN(PARAM_DEFN currentPARAM_DEFN)
        {
            this.ObjectContext.PARAM_DEFN.AttachAsModified(currentPARAM_DEFN, this.ChangeSet.GetOriginal(currentPARAM_DEFN));
        }

        public void DeletePARAM_DEFN(PARAM_DEFN pARAM_DEFN)
        {
            if ((pARAM_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pARAM_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PARAM_DEFN.Attach(pARAM_DEFN);
                this.ObjectContext.PARAM_DEFN.DeleteObject(pARAM_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PARAM_TP_DEFN' query.
        public IQueryable<PARAM_TP_DEFN> GetPARAM_TP_DEFN()
        {
            return this.ObjectContext.PARAM_TP_DEFN;
        }

        public void InsertPARAM_TP_DEFN(PARAM_TP_DEFN pARAM_TP_DEFN)
        {
            if ((pARAM_TP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pARAM_TP_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PARAM_TP_DEFN.AddObject(pARAM_TP_DEFN);
            }
        }

        public void UpdatePARAM_TP_DEFN(PARAM_TP_DEFN currentPARAM_TP_DEFN)
        {
            this.ObjectContext.PARAM_TP_DEFN.AttachAsModified(currentPARAM_TP_DEFN, this.ChangeSet.GetOriginal(currentPARAM_TP_DEFN));
        }

        public void DeletePARAM_TP_DEFN(PARAM_TP_DEFN pARAM_TP_DEFN)
        {
            if ((pARAM_TP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pARAM_TP_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PARAM_TP_DEFN.Attach(pARAM_TP_DEFN);
                this.ObjectContext.PARAM_TP_DEFN.DeleteObject(pARAM_TP_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PARAM_VAL' query.
        public IQueryable<PARAM_VAL> GetPARAM_VAL()
        {
            return this.ObjectContext.PARAM_VAL;
        }

        public void InsertPARAM_VAL(PARAM_VAL pARAM_VAL)
        {
            if ((pARAM_VAL.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pARAM_VAL, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PARAM_VAL.AddObject(pARAM_VAL);
            }
        }

        public void UpdatePARAM_VAL(PARAM_VAL currentPARAM_VAL)
        {
            this.ObjectContext.PARAM_VAL.AttachAsModified(currentPARAM_VAL, this.ChangeSet.GetOriginal(currentPARAM_VAL));
        }

        public void DeletePARAM_VAL(PARAM_VAL pARAM_VAL)
        {
            if ((pARAM_VAL.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pARAM_VAL, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PARAM_VAL.Attach(pARAM_VAL);
                this.ObjectContext.PARAM_VAL.DeleteObject(pARAM_VAL);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PART_COMMENT' query.
        public IQueryable<PART_COMMENT> GetPART_COMMENT()
        {
            return this.ObjectContext.PART_COMMENT;
        }

        public void InsertPART_COMMENT(PART_COMMENT pART_COMMENT)
        {
            if ((pART_COMMENT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pART_COMMENT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PART_COMMENT.AddObject(pART_COMMENT);
            }
        }

        public void UpdatePART_COMMENT(PART_COMMENT currentPART_COMMENT)
        {
            this.ObjectContext.PART_COMMENT.AttachAsModified(currentPART_COMMENT, this.ChangeSet.GetOriginal(currentPART_COMMENT));
        }

        public void DeletePART_COMMENT(PART_COMMENT pART_COMMENT)
        {
            if ((pART_COMMENT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pART_COMMENT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PART_COMMENT.Attach(pART_COMMENT);
                this.ObjectContext.PART_COMMENT.DeleteObject(pART_COMMENT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PHASE_STEP_ORDER' query.
        public IQueryable<PHASE_STEP_ORDER> GetPHASE_STEP_ORDER()
        {
            return this.ObjectContext.PHASE_STEP_ORDER;
        }

        public void InsertPHASE_STEP_ORDER(PHASE_STEP_ORDER pHASE_STEP_ORDER)
        {
            if ((pHASE_STEP_ORDER.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pHASE_STEP_ORDER, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PHASE_STEP_ORDER.AddObject(pHASE_STEP_ORDER);
            }
        }

        public void UpdatePHASE_STEP_ORDER(PHASE_STEP_ORDER currentPHASE_STEP_ORDER)
        {
            this.ObjectContext.PHASE_STEP_ORDER.AttachAsModified(currentPHASE_STEP_ORDER, this.ChangeSet.GetOriginal(currentPHASE_STEP_ORDER));
        }

        public void DeletePHASE_STEP_ORDER(PHASE_STEP_ORDER pHASE_STEP_ORDER)
        {
            if ((pHASE_STEP_ORDER.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pHASE_STEP_ORDER, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PHASE_STEP_ORDER.Attach(pHASE_STEP_ORDER);
                this.ObjectContext.PHASE_STEP_ORDER.DeleteObject(pHASE_STEP_ORDER);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PRODUCT_DATA' query.
        public IQueryable<PRODUCT_DATA> GetPRODUCT_DATA()
        {
            return this.ObjectContext.PRODUCT_DATA;
        }

        public void InsertPRODUCT_DATA(PRODUCT_DATA pRODUCT_DATA)
        {
            if ((pRODUCT_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA.AddObject(pRODUCT_DATA);
            }
        }

        public void UpdatePRODUCT_DATA(PRODUCT_DATA currentPRODUCT_DATA)
        {
            this.ObjectContext.PRODUCT_DATA.AttachAsModified(currentPRODUCT_DATA, this.ChangeSet.GetOriginal(currentPRODUCT_DATA));
        }

        public void DeletePRODUCT_DATA(PRODUCT_DATA pRODUCT_DATA)
        {
            if ((pRODUCT_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA.Attach(pRODUCT_DATA);
                this.ObjectContext.PRODUCT_DATA.DeleteObject(pRODUCT_DATA);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PRODUCT_DATA_COMPONENT' query.
        public IQueryable<PRODUCT_DATA_COMPONENT> GetPRODUCT_DATA_COMPONENT()
        {
            return this.ObjectContext.PRODUCT_DATA_COMPONENT;
        }

        public void InsertPRODUCT_DATA_COMPONENT(PRODUCT_DATA_COMPONENT pRODUCT_DATA_COMPONENT)
        {
            if ((pRODUCT_DATA_COMPONENT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_COMPONENT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_COMPONENT.AddObject(pRODUCT_DATA_COMPONENT);
            }
        }

        public void UpdatePRODUCT_DATA_COMPONENT(PRODUCT_DATA_COMPONENT currentPRODUCT_DATA_COMPONENT)
        {
            this.ObjectContext.PRODUCT_DATA_COMPONENT.AttachAsModified(currentPRODUCT_DATA_COMPONENT, this.ChangeSet.GetOriginal(currentPRODUCT_DATA_COMPONENT));
        }

        public void DeletePRODUCT_DATA_COMPONENT(PRODUCT_DATA_COMPONENT pRODUCT_DATA_COMPONENT)
        {
            if ((pRODUCT_DATA_COMPONENT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_COMPONENT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_COMPONENT.Attach(pRODUCT_DATA_COMPONENT);
                this.ObjectContext.PRODUCT_DATA_COMPONENT.DeleteObject(pRODUCT_DATA_COMPONENT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PRODUCT_DATA_MARRIAGE' query.
        public IQueryable<PRODUCT_DATA_MARRIAGE> GetPRODUCT_DATA_MARRIAGE()
        {
            return this.ObjectContext.PRODUCT_DATA_MARRIAGE;
        }

        public void InsertPRODUCT_DATA_MARRIAGE(PRODUCT_DATA_MARRIAGE pRODUCT_DATA_MARRIAGE)
        {
            if ((pRODUCT_DATA_MARRIAGE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_MARRIAGE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_MARRIAGE.AddObject(pRODUCT_DATA_MARRIAGE);
            }
        }

        public void UpdatePRODUCT_DATA_MARRIAGE(PRODUCT_DATA_MARRIAGE currentPRODUCT_DATA_MARRIAGE)
        {
            this.ObjectContext.PRODUCT_DATA_MARRIAGE.AttachAsModified(currentPRODUCT_DATA_MARRIAGE, this.ChangeSet.GetOriginal(currentPRODUCT_DATA_MARRIAGE));
        }

        public void DeletePRODUCT_DATA_MARRIAGE(PRODUCT_DATA_MARRIAGE pRODUCT_DATA_MARRIAGE)
        {
            if ((pRODUCT_DATA_MARRIAGE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_MARRIAGE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_MARRIAGE.Attach(pRODUCT_DATA_MARRIAGE);
                this.ObjectContext.PRODUCT_DATA_MARRIAGE.DeleteObject(pRODUCT_DATA_MARRIAGE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PRODUCT_DATA_REJ' query.
        public IQueryable<PRODUCT_DATA_REJ> GetPRODUCT_DATA_REJ()
        {
            return this.ObjectContext.PRODUCT_DATA_REJ;
        }

        public void InsertPRODUCT_DATA_REJ(PRODUCT_DATA_REJ pRODUCT_DATA_REJ)
        {
            if ((pRODUCT_DATA_REJ.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_REJ, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_REJ.AddObject(pRODUCT_DATA_REJ);
            }
        }

        public void UpdatePRODUCT_DATA_REJ(PRODUCT_DATA_REJ currentPRODUCT_DATA_REJ)
        {
            this.ObjectContext.PRODUCT_DATA_REJ.AttachAsModified(currentPRODUCT_DATA_REJ, this.ChangeSet.GetOriginal(currentPRODUCT_DATA_REJ));
        }

        public void DeletePRODUCT_DATA_REJ(PRODUCT_DATA_REJ pRODUCT_DATA_REJ)
        {
            if ((pRODUCT_DATA_REJ.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_REJ, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_REJ.Attach(pRODUCT_DATA_REJ);
                this.ObjectContext.PRODUCT_DATA_REJ.DeleteObject(pRODUCT_DATA_REJ);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PRODUCT_DATA_STAT' query.
        public IQueryable<PRODUCT_DATA_STAT> GetPRODUCT_DATA_STAT()
        {
            return this.ObjectContext.PRODUCT_DATA_STAT;
        }

        public void InsertPRODUCT_DATA_STAT(PRODUCT_DATA_STAT pRODUCT_DATA_STAT)
        {
            if ((pRODUCT_DATA_STAT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_STAT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_STAT.AddObject(pRODUCT_DATA_STAT);
            }
        }

        public void UpdatePRODUCT_DATA_STAT(PRODUCT_DATA_STAT currentPRODUCT_DATA_STAT)
        {
            this.ObjectContext.PRODUCT_DATA_STAT.AttachAsModified(currentPRODUCT_DATA_STAT, this.ChangeSet.GetOriginal(currentPRODUCT_DATA_STAT));
        }

        public void DeletePRODUCT_DATA_STAT(PRODUCT_DATA_STAT pRODUCT_DATA_STAT)
        {
            if ((pRODUCT_DATA_STAT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_STAT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_STAT.Attach(pRODUCT_DATA_STAT);
                this.ObjectContext.PRODUCT_DATA_STAT.DeleteObject(pRODUCT_DATA_STAT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PRODUCT_DATA_STAT_DESC' query.
        public IQueryable<PRODUCT_DATA_STAT_DESC> GetPRODUCT_DATA_STAT_DESC()
        {
            return this.ObjectContext.PRODUCT_DATA_STAT_DESC;
        }

        public void InsertPRODUCT_DATA_STAT_DESC(PRODUCT_DATA_STAT_DESC pRODUCT_DATA_STAT_DESC)
        {
            if ((pRODUCT_DATA_STAT_DESC.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_STAT_DESC, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_STAT_DESC.AddObject(pRODUCT_DATA_STAT_DESC);
            }
        }

        public void UpdatePRODUCT_DATA_STAT_DESC(PRODUCT_DATA_STAT_DESC currentPRODUCT_DATA_STAT_DESC)
        {
            this.ObjectContext.PRODUCT_DATA_STAT_DESC.AttachAsModified(currentPRODUCT_DATA_STAT_DESC, this.ChangeSet.GetOriginal(currentPRODUCT_DATA_STAT_DESC));
        }

        public void DeletePRODUCT_DATA_STAT_DESC(PRODUCT_DATA_STAT_DESC pRODUCT_DATA_STAT_DESC)
        {
            if ((pRODUCT_DATA_STAT_DESC.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_STAT_DESC, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_STAT_DESC.Attach(pRODUCT_DATA_STAT_DESC);
                this.ObjectContext.PRODUCT_DATA_STAT_DESC.DeleteObject(pRODUCT_DATA_STAT_DESC);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PRODUCT_DATA_TC' query.
        public IQueryable<PRODUCT_DATA_TC> GetPRODUCT_DATA_TC()
        {
            return this.ObjectContext.PRODUCT_DATA_TC;
        }

        public void InsertPRODUCT_DATA_TC(PRODUCT_DATA_TC pRODUCT_DATA_TC)
        {
            if ((pRODUCT_DATA_TC.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_TC, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_TC.AddObject(pRODUCT_DATA_TC);
            }
        }

        public void UpdatePRODUCT_DATA_TC(PRODUCT_DATA_TC currentPRODUCT_DATA_TC)
        {
            this.ObjectContext.PRODUCT_DATA_TC.AttachAsModified(currentPRODUCT_DATA_TC, this.ChangeSet.GetOriginal(currentPRODUCT_DATA_TC));
        }

        public void DeletePRODUCT_DATA_TC(PRODUCT_DATA_TC pRODUCT_DATA_TC)
        {
            if ((pRODUCT_DATA_TC.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_TC, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_TC.Attach(pRODUCT_DATA_TC);
                this.ObjectContext.PRODUCT_DATA_TC.DeleteObject(pRODUCT_DATA_TC);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'PRODUCT_DATA_VB' query.
        public IQueryable<PRODUCT_DATA_VB> GetPRODUCT_DATA_VB()
        {
            return this.ObjectContext.PRODUCT_DATA_VB;
        }

        public void InsertPRODUCT_DATA_VB(PRODUCT_DATA_VB pRODUCT_DATA_VB)
        {
            if ((pRODUCT_DATA_VB.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_VB, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_VB.AddObject(pRODUCT_DATA_VB);
            }
        }

        public void UpdatePRODUCT_DATA_VB(PRODUCT_DATA_VB currentPRODUCT_DATA_VB)
        {
            this.ObjectContext.PRODUCT_DATA_VB.AttachAsModified(currentPRODUCT_DATA_VB, this.ChangeSet.GetOriginal(currentPRODUCT_DATA_VB));
        }

        public void DeletePRODUCT_DATA_VB(PRODUCT_DATA_VB pRODUCT_DATA_VB)
        {
            if ((pRODUCT_DATA_VB.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(pRODUCT_DATA_VB, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PRODUCT_DATA_VB.Attach(pRODUCT_DATA_VB);
                this.ObjectContext.PRODUCT_DATA_VB.DeleteObject(pRODUCT_DATA_VB);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'QUERY_DEFN' query.
        public IQueryable<QUERY_DEFN> GetQUERY_DEFN()
        {
            return this.ObjectContext.QUERY_DEFN;
        }

        public void InsertQUERY_DEFN(QUERY_DEFN qUERY_DEFN)
        {
            if ((qUERY_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(qUERY_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.QUERY_DEFN.AddObject(qUERY_DEFN);
            }
        }

        public void UpdateQUERY_DEFN(QUERY_DEFN currentQUERY_DEFN)
        {
            this.ObjectContext.QUERY_DEFN.AttachAsModified(currentQUERY_DEFN, this.ChangeSet.GetOriginal(currentQUERY_DEFN));
        }

        public void DeleteQUERY_DEFN(QUERY_DEFN qUERY_DEFN)
        {
            if ((qUERY_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(qUERY_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.QUERY_DEFN.Attach(qUERY_DEFN);
                this.ObjectContext.QUERY_DEFN.DeleteObject(qUERY_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'RAMP_PARAM_DEFN' query.
        public IQueryable<RAMP_PARAM_DEFN> GetRAMP_PARAM_DEFN()
        {
            return this.ObjectContext.RAMP_PARAM_DEFN;
        }

        public void InsertRAMP_PARAM_DEFN(RAMP_PARAM_DEFN rAMP_PARAM_DEFN)
        {
            if ((rAMP_PARAM_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rAMP_PARAM_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.RAMP_PARAM_DEFN.AddObject(rAMP_PARAM_DEFN);
            }
        }

        public void UpdateRAMP_PARAM_DEFN(RAMP_PARAM_DEFN currentRAMP_PARAM_DEFN)
        {
            this.ObjectContext.RAMP_PARAM_DEFN.AttachAsModified(currentRAMP_PARAM_DEFN, this.ChangeSet.GetOriginal(currentRAMP_PARAM_DEFN));
        }

        public void DeleteRAMP_PARAM_DEFN(RAMP_PARAM_DEFN rAMP_PARAM_DEFN)
        {
            if ((rAMP_PARAM_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rAMP_PARAM_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.RAMP_PARAM_DEFN.Attach(rAMP_PARAM_DEFN);
                this.ObjectContext.RAMP_PARAM_DEFN.DeleteObject(rAMP_PARAM_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'REJ_ASSO_TP_DEFN' query.
        public IQueryable<REJ_ASSO_TP_DEFN> GetREJ_ASSO_TP_DEFN()
        {
            return this.ObjectContext.REJ_ASSO_TP_DEFN;
        }

        public void InsertREJ_ASSO_TP_DEFN(REJ_ASSO_TP_DEFN rEJ_ASSO_TP_DEFN)
        {
            if ((rEJ_ASSO_TP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEJ_ASSO_TP_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.REJ_ASSO_TP_DEFN.AddObject(rEJ_ASSO_TP_DEFN);
            }
        }

        public void UpdateREJ_ASSO_TP_DEFN(REJ_ASSO_TP_DEFN currentREJ_ASSO_TP_DEFN)
        {
            this.ObjectContext.REJ_ASSO_TP_DEFN.AttachAsModified(currentREJ_ASSO_TP_DEFN, this.ChangeSet.GetOriginal(currentREJ_ASSO_TP_DEFN));
        }

        public void DeleteREJ_ASSO_TP_DEFN(REJ_ASSO_TP_DEFN rEJ_ASSO_TP_DEFN)
        {
            if ((rEJ_ASSO_TP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEJ_ASSO_TP_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.REJ_ASSO_TP_DEFN.Attach(rEJ_ASSO_TP_DEFN);
                this.ObjectContext.REJ_ASSO_TP_DEFN.DeleteObject(rEJ_ASSO_TP_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'REJ_DEFN' query.
        public IQueryable<REJ_DEFN> GetREJ_DEFN()
        {
            return this.ObjectContext.REJ_DEFN;
        }

        public void InsertREJ_DEFN(REJ_DEFN rEJ_DEFN)
        {
            if ((rEJ_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEJ_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.REJ_DEFN.AddObject(rEJ_DEFN);
            }
        }

        public void UpdateREJ_DEFN(REJ_DEFN currentREJ_DEFN)
        {
            this.ObjectContext.REJ_DEFN.AttachAsModified(currentREJ_DEFN, this.ChangeSet.GetOriginal(currentREJ_DEFN));
        }

        public void DeleteREJ_DEFN(REJ_DEFN rEJ_DEFN)
        {
            if ((rEJ_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEJ_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.REJ_DEFN.Attach(rEJ_DEFN);
                this.ObjectContext.REJ_DEFN.DeleteObject(rEJ_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'REJ_TP_DEFN' query.
        public IQueryable<REJ_TP_DEFN> GetREJ_TP_DEFN()
        {
            return this.ObjectContext.REJ_TP_DEFN;
        }

        public void InsertREJ_TP_DEFN(REJ_TP_DEFN rEJ_TP_DEFN)
        {
            if ((rEJ_TP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEJ_TP_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.REJ_TP_DEFN.AddObject(rEJ_TP_DEFN);
            }
        }

        public void UpdateREJ_TP_DEFN(REJ_TP_DEFN currentREJ_TP_DEFN)
        {
            this.ObjectContext.REJ_TP_DEFN.AttachAsModified(currentREJ_TP_DEFN, this.ChangeSet.GetOriginal(currentREJ_TP_DEFN));
        }

        public void DeleteREJ_TP_DEFN(REJ_TP_DEFN rEJ_TP_DEFN)
        {
            if ((rEJ_TP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEJ_TP_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.REJ_TP_DEFN.Attach(rEJ_TP_DEFN);
                this.ObjectContext.REJ_TP_DEFN.DeleteObject(rEJ_TP_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'REJ_TRIGGER_DEFN' query.
        public IQueryable<REJ_TRIGGER_DEFN> GetREJ_TRIGGER_DEFN()
        {
            return this.ObjectContext.REJ_TRIGGER_DEFN;
        }

        public void InsertREJ_TRIGGER_DEFN(REJ_TRIGGER_DEFN rEJ_TRIGGER_DEFN)
        {
            if ((rEJ_TRIGGER_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEJ_TRIGGER_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.REJ_TRIGGER_DEFN.AddObject(rEJ_TRIGGER_DEFN);
            }
        }

        public void UpdateREJ_TRIGGER_DEFN(REJ_TRIGGER_DEFN currentREJ_TRIGGER_DEFN)
        {
            this.ObjectContext.REJ_TRIGGER_DEFN.AttachAsModified(currentREJ_TRIGGER_DEFN, this.ChangeSet.GetOriginal(currentREJ_TRIGGER_DEFN));
        }

        public void DeleteREJ_TRIGGER_DEFN(REJ_TRIGGER_DEFN rEJ_TRIGGER_DEFN)
        {
            if ((rEJ_TRIGGER_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEJ_TRIGGER_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.REJ_TRIGGER_DEFN.Attach(rEJ_TRIGGER_DEFN);
                this.ObjectContext.REJ_TRIGGER_DEFN.DeleteObject(rEJ_TRIGGER_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'REPAIR_MADE' query.
        public IQueryable<REPAIR_MADE> GetREPAIR_MADE()
        {
            return this.ObjectContext.REPAIR_MADE;
        }

        public void InsertREPAIR_MADE(REPAIR_MADE rEPAIR_MADE)
        {
            if ((rEPAIR_MADE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEPAIR_MADE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.REPAIR_MADE.AddObject(rEPAIR_MADE);
            }
        }

        public void UpdateREPAIR_MADE(REPAIR_MADE currentREPAIR_MADE)
        {
            this.ObjectContext.REPAIR_MADE.AttachAsModified(currentREPAIR_MADE, this.ChangeSet.GetOriginal(currentREPAIR_MADE));
        }

        public void DeleteREPAIR_MADE(REPAIR_MADE rEPAIR_MADE)
        {
            if ((rEPAIR_MADE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEPAIR_MADE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.REPAIR_MADE.Attach(rEPAIR_MADE);
                this.ObjectContext.REPAIR_MADE.DeleteObject(rEPAIR_MADE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'REPAIR_TEXT' query.
        public IQueryable<REPAIR_TEXT> GetREPAIR_TEXT()
        {
            return this.ObjectContext.REPAIR_TEXT;
        }

        public void InsertREPAIR_TEXT(REPAIR_TEXT rEPAIR_TEXT)
        {
            if ((rEPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEPAIR_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.REPAIR_TEXT.AddObject(rEPAIR_TEXT);
            }
        }

        public void UpdateREPAIR_TEXT(REPAIR_TEXT currentREPAIR_TEXT)
        {
            this.ObjectContext.REPAIR_TEXT.AttachAsModified(currentREPAIR_TEXT, this.ChangeSet.GetOriginal(currentREPAIR_TEXT));
        }

        public void DeleteREPAIR_TEXT(REPAIR_TEXT rEPAIR_TEXT)
        {
            if ((rEPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEPAIR_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.REPAIR_TEXT.Attach(rEPAIR_TEXT);
                this.ObjectContext.REPAIR_TEXT.DeleteObject(rEPAIR_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'REPAIR_TREE' query.
        public IQueryable<REPAIR_TREE> GetREPAIR_TREE()
        {
            return this.ObjectContext.REPAIR_TREE;
        }

        public void InsertREPAIR_TREE(REPAIR_TREE rEPAIR_TREE)
        {
            if ((rEPAIR_TREE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEPAIR_TREE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.REPAIR_TREE.AddObject(rEPAIR_TREE);
            }
        }

        public void UpdateREPAIR_TREE(REPAIR_TREE currentREPAIR_TREE)
        {
            this.ObjectContext.REPAIR_TREE.AttachAsModified(currentREPAIR_TREE, this.ChangeSet.GetOriginal(currentREPAIR_TREE));
        }

        public void DeleteREPAIR_TREE(REPAIR_TREE rEPAIR_TREE)
        {
            if ((rEPAIR_TREE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(rEPAIR_TREE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.REPAIR_TREE.Attach(rEPAIR_TREE);
                this.ObjectContext.REPAIR_TREE.DeleteObject(rEPAIR_TREE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'SEQUENCE_DEFN' query.
        public IQueryable<SEQUENCE_DEFN> GetSEQUENCE_DEFN()
        {
            return this.ObjectContext.SEQUENCE_DEFN;
        }

        public void InsertSEQUENCE_DEFN(SEQUENCE_DEFN sEQUENCE_DEFN)
        {
            if ((sEQUENCE_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sEQUENCE_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.SEQUENCE_DEFN.AddObject(sEQUENCE_DEFN);
            }
        }

        public void UpdateSEQUENCE_DEFN(SEQUENCE_DEFN currentSEQUENCE_DEFN)
        {
            this.ObjectContext.SEQUENCE_DEFN.AttachAsModified(currentSEQUENCE_DEFN, this.ChangeSet.GetOriginal(currentSEQUENCE_DEFN));
        }

        public void DeleteSEQUENCE_DEFN(SEQUENCE_DEFN sEQUENCE_DEFN)
        {
            if ((sEQUENCE_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sEQUENCE_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.SEQUENCE_DEFN.Attach(sEQUENCE_DEFN);
                this.ObjectContext.SEQUENCE_DEFN.DeleteObject(sEQUENCE_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'SHIFT_DEFN' query.
        public IQueryable<SHIFT_DEFN> GetSHIFT_DEFN()
        {
            return this.ObjectContext.SHIFT_DEFN;
        }

        public void InsertSHIFT_DEFN(SHIFT_DEFN sHIFT_DEFN)
        {
            if ((sHIFT_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sHIFT_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.SHIFT_DEFN.AddObject(sHIFT_DEFN);
            }
        }

        public void UpdateSHIFT_DEFN(SHIFT_DEFN currentSHIFT_DEFN)
        {
            this.ObjectContext.SHIFT_DEFN.AttachAsModified(currentSHIFT_DEFN, this.ChangeSet.GetOriginal(currentSHIFT_DEFN));
        }

        public void DeleteSHIFT_DEFN(SHIFT_DEFN sHIFT_DEFN)
        {
            if ((sHIFT_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sHIFT_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.SHIFT_DEFN.Attach(sHIFT_DEFN);
                this.ObjectContext.SHIFT_DEFN.DeleteObject(sHIFT_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'STAND_DEFN' query.
        public IQueryable<STAND_DEFN> GetSTAND_DEFN()
        {
            return this.ObjectContext.STAND_DEFN;
        }

        public void InsertSTAND_DEFN(STAND_DEFN sTAND_DEFN)
        {
            if ((sTAND_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sTAND_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.STAND_DEFN.AddObject(sTAND_DEFN);
            }
        }

        public void UpdateSTAND_DEFN(STAND_DEFN currentSTAND_DEFN)
        {
            this.ObjectContext.STAND_DEFN.AttachAsModified(currentSTAND_DEFN, this.ChangeSet.GetOriginal(currentSTAND_DEFN));
        }

        public void DeleteSTAND_DEFN(STAND_DEFN sTAND_DEFN)
        {
            if ((sTAND_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sTAND_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.STAND_DEFN.Attach(sTAND_DEFN);
                this.ObjectContext.STAND_DEFN.DeleteObject(sTAND_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'STAND_TRIGGER_TYPE_DEFN' query.
        public IQueryable<STAND_TRIGGER_TYPE_DEFN> GetSTAND_TRIGGER_TYPE_DEFN()
        {
            return this.ObjectContext.STAND_TRIGGER_TYPE_DEFN;
        }

        public void InsertSTAND_TRIGGER_TYPE_DEFN(STAND_TRIGGER_TYPE_DEFN sTAND_TRIGGER_TYPE_DEFN)
        {
            if ((sTAND_TRIGGER_TYPE_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sTAND_TRIGGER_TYPE_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.STAND_TRIGGER_TYPE_DEFN.AddObject(sTAND_TRIGGER_TYPE_DEFN);
            }
        }

        public void UpdateSTAND_TRIGGER_TYPE_DEFN(STAND_TRIGGER_TYPE_DEFN currentSTAND_TRIGGER_TYPE_DEFN)
        {
            this.ObjectContext.STAND_TRIGGER_TYPE_DEFN.AttachAsModified(currentSTAND_TRIGGER_TYPE_DEFN, this.ChangeSet.GetOriginal(currentSTAND_TRIGGER_TYPE_DEFN));
        }

        public void DeleteSTAND_TRIGGER_TYPE_DEFN(STAND_TRIGGER_TYPE_DEFN sTAND_TRIGGER_TYPE_DEFN)
        {
            if ((sTAND_TRIGGER_TYPE_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sTAND_TRIGGER_TYPE_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.STAND_TRIGGER_TYPE_DEFN.Attach(sTAND_TRIGGER_TYPE_DEFN);
                this.ObjectContext.STAND_TRIGGER_TYPE_DEFN.DeleteObject(sTAND_TRIGGER_TYPE_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'SUGGESTED_TEXT' query.
        public IQueryable<SUGGESTED_TEXT> GetSUGGESTED_TEXT()
        {
            return this.ObjectContext.SUGGESTED_TEXT;
        }

        public void InsertSUGGESTED_TEXT(SUGGESTED_TEXT sUGGESTED_TEXT)
        {
            if ((sUGGESTED_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sUGGESTED_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.SUGGESTED_TEXT.AddObject(sUGGESTED_TEXT);
            }
        }

        public void UpdateSUGGESTED_TEXT(SUGGESTED_TEXT currentSUGGESTED_TEXT)
        {
            this.ObjectContext.SUGGESTED_TEXT.AttachAsModified(currentSUGGESTED_TEXT, this.ChangeSet.GetOriginal(currentSUGGESTED_TEXT));
        }

        public void DeleteSUGGESTED_TEXT(SUGGESTED_TEXT sUGGESTED_TEXT)
        {
            if ((sUGGESTED_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sUGGESTED_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.SUGGESTED_TEXT.Attach(sUGGESTED_TEXT);
                this.ObjectContext.SUGGESTED_TEXT.DeleteObject(sUGGESTED_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'SYS_PARAMS' query.
        public IQueryable<SYS_PARAMS> GetSYS_PARAMS()
        {
            return this.ObjectContext.SYS_PARAMS;
        }

        public void InsertSYS_PARAMS(SYS_PARAMS sYS_PARAMS)
        {
            if ((sYS_PARAMS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYS_PARAMS, EntityState.Added);
            }
            else
            {
                this.ObjectContext.SYS_PARAMS.AddObject(sYS_PARAMS);
            }
        }

        public void UpdateSYS_PARAMS(SYS_PARAMS currentSYS_PARAMS)
        {
            this.ObjectContext.SYS_PARAMS.AttachAsModified(currentSYS_PARAMS, this.ChangeSet.GetOriginal(currentSYS_PARAMS));
        }

        public void DeleteSYS_PARAMS(SYS_PARAMS sYS_PARAMS)
        {
            if ((sYS_PARAMS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYS_PARAMS, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.SYS_PARAMS.Attach(sYS_PARAMS);
                this.ObjectContext.SYS_PARAMS.DeleteObject(sYS_PARAMS);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'SYS_PARAMS_FLOAT' query.
        public IQueryable<SYS_PARAMS_FLOAT> GetSYS_PARAMS_FLOAT()
        {
            return this.ObjectContext.SYS_PARAMS_FLOAT;
        }

        public void InsertSYS_PARAMS_FLOAT(SYS_PARAMS_FLOAT sYS_PARAMS_FLOAT)
        {
            if ((sYS_PARAMS_FLOAT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYS_PARAMS_FLOAT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.SYS_PARAMS_FLOAT.AddObject(sYS_PARAMS_FLOAT);
            }
        }

        public void UpdateSYS_PARAMS_FLOAT(SYS_PARAMS_FLOAT currentSYS_PARAMS_FLOAT)
        {
            this.ObjectContext.SYS_PARAMS_FLOAT.AttachAsModified(currentSYS_PARAMS_FLOAT, this.ChangeSet.GetOriginal(currentSYS_PARAMS_FLOAT));
        }

        public void DeleteSYS_PARAMS_FLOAT(SYS_PARAMS_FLOAT sYS_PARAMS_FLOAT)
        {
            if ((sYS_PARAMS_FLOAT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYS_PARAMS_FLOAT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.SYS_PARAMS_FLOAT.Attach(sYS_PARAMS_FLOAT);
                this.ObjectContext.SYS_PARAMS_FLOAT.DeleteObject(sYS_PARAMS_FLOAT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'SYS_PARAMS_LONG' query.
        public IQueryable<SYS_PARAMS_LONG> GetSYS_PARAMS_LONG()
        {
            return this.ObjectContext.SYS_PARAMS_LONG;
        }

        public void InsertSYS_PARAMS_LONG(SYS_PARAMS_LONG sYS_PARAMS_LONG)
        {
            if ((sYS_PARAMS_LONG.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYS_PARAMS_LONG, EntityState.Added);
            }
            else
            {
                this.ObjectContext.SYS_PARAMS_LONG.AddObject(sYS_PARAMS_LONG);
            }
        }

        public void UpdateSYS_PARAMS_LONG(SYS_PARAMS_LONG currentSYS_PARAMS_LONG)
        {
            this.ObjectContext.SYS_PARAMS_LONG.AttachAsModified(currentSYS_PARAMS_LONG, this.ChangeSet.GetOriginal(currentSYS_PARAMS_LONG));
        }

        public void DeleteSYS_PARAMS_LONG(SYS_PARAMS_LONG sYS_PARAMS_LONG)
        {
            if ((sYS_PARAMS_LONG.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYS_PARAMS_LONG, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.SYS_PARAMS_LONG.Attach(sYS_PARAMS_LONG);
                this.ObjectContext.SYS_PARAMS_LONG.DeleteObject(sYS_PARAMS_LONG);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'SYS_PARAMS_STRING' query.
        public IQueryable<SYS_PARAMS_STRING> GetSYS_PARAMS_STRING()
        {
            return this.ObjectContext.SYS_PARAMS_STRING;
        }

        public void InsertSYS_PARAMS_STRING(SYS_PARAMS_STRING sYS_PARAMS_STRING)
        {
            if ((sYS_PARAMS_STRING.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYS_PARAMS_STRING, EntityState.Added);
            }
            else
            {
                this.ObjectContext.SYS_PARAMS_STRING.AddObject(sYS_PARAMS_STRING);
            }
        }

        public void UpdateSYS_PARAMS_STRING(SYS_PARAMS_STRING currentSYS_PARAMS_STRING)
        {
            this.ObjectContext.SYS_PARAMS_STRING.AttachAsModified(currentSYS_PARAMS_STRING, this.ChangeSet.GetOriginal(currentSYS_PARAMS_STRING));
        }

        public void DeleteSYS_PARAMS_STRING(SYS_PARAMS_STRING sYS_PARAMS_STRING)
        {
            if ((sYS_PARAMS_STRING.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYS_PARAMS_STRING, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.SYS_PARAMS_STRING.Attach(sYS_PARAMS_STRING);
                this.ObjectContext.SYS_PARAMS_STRING.DeleteObject(sYS_PARAMS_STRING);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'SYSTEM_INFO' query.
        public IQueryable<SYSTEM_INFO> GetSYSTEM_INFO()
        {
            return this.ObjectContext.SYSTEM_INFO;
        }

        public void InsertSYSTEM_INFO(SYSTEM_INFO sYSTEM_INFO)
        {
            if ((sYSTEM_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYSTEM_INFO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.SYSTEM_INFO.AddObject(sYSTEM_INFO);
            }
        }

        public void UpdateSYSTEM_INFO(SYSTEM_INFO currentSYSTEM_INFO)
        {
            this.ObjectContext.SYSTEM_INFO.AttachAsModified(currentSYSTEM_INFO, this.ChangeSet.GetOriginal(currentSYSTEM_INFO));
        }

        public void DeleteSYSTEM_INFO(SYSTEM_INFO sYSTEM_INFO)
        {
            if ((sYSTEM_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(sYSTEM_INFO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.SYSTEM_INFO.Attach(sYSTEM_INFO);
                this.ObjectContext.SYSTEM_INFO.DeleteObject(sYSTEM_INFO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'TAG_DEFN' query.
        public IQueryable<TAG_DEFN> GetTAG_DEFN()
        {
            return this.ObjectContext.TAG_DEFN;
        }

        public void InsertTAG_DEFN(TAG_DEFN tAG_DEFN)
        {
            if ((tAG_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tAG_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.TAG_DEFN.AddObject(tAG_DEFN);
            }
        }

        public void UpdateTAG_DEFN(TAG_DEFN currentTAG_DEFN)
        {
            this.ObjectContext.TAG_DEFN.AttachAsModified(currentTAG_DEFN, this.ChangeSet.GetOriginal(currentTAG_DEFN));
        }

        public void DeleteTAG_DEFN(TAG_DEFN tAG_DEFN)
        {
            if ((tAG_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tAG_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.TAG_DEFN.Attach(tAG_DEFN);
                this.ObjectContext.TAG_DEFN.DeleteObject(tAG_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'TCU_DEFN' query.
        public IQueryable<TCU_DEFN> GetTCU_DEFN()
        {
            return this.ObjectContext.TCU_DEFN;
        }

        public void InsertTCU_DEFN(TCU_DEFN tCU_DEFN)
        {
            if ((tCU_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tCU_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.TCU_DEFN.AddObject(tCU_DEFN);
            }
        }

        public void UpdateTCU_DEFN(TCU_DEFN currentTCU_DEFN)
        {
            this.ObjectContext.TCU_DEFN.AttachAsModified(currentTCU_DEFN, this.ChangeSet.GetOriginal(currentTCU_DEFN));
        }

        public void DeleteTCU_DEFN(TCU_DEFN tCU_DEFN)
        {
            if ((tCU_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tCU_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.TCU_DEFN.Attach(tCU_DEFN);
                this.ObjectContext.TCU_DEFN.DeleteObject(tCU_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'TEST_RECORD' query.
        public IQueryable<TEST_RECORD> GetTEST_RECORD()
        {
            return this.ObjectContext.TEST_RECORD;
        }

        public void InsertTEST_RECORD(TEST_RECORD tEST_RECORD)
        {
            if ((tEST_RECORD.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tEST_RECORD, EntityState.Added);
            }
            else
            {
                this.ObjectContext.TEST_RECORD.AddObject(tEST_RECORD);
            }
        }

        public void UpdateTEST_RECORD(TEST_RECORD currentTEST_RECORD)
        {
            this.ObjectContext.TEST_RECORD.AttachAsModified(currentTEST_RECORD, this.ChangeSet.GetOriginal(currentTEST_RECORD));
        }

        public void DeleteTEST_RECORD(TEST_RECORD tEST_RECORD)
        {
            if ((tEST_RECORD.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tEST_RECORD, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.TEST_RECORD.Attach(tEST_RECORD);
                this.ObjectContext.TEST_RECORD.DeleteObject(tEST_RECORD);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'TEST_RECORD_TWO' query.
        public IQueryable<TEST_RECORD_TWO> GetTEST_RECORD_TWO()
        {
            return this.ObjectContext.TEST_RECORD_TWO;
        }

        public void InsertTEST_RECORD_TWO(TEST_RECORD_TWO tEST_RECORD_TWO)
        {
            if ((tEST_RECORD_TWO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tEST_RECORD_TWO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.TEST_RECORD_TWO.AddObject(tEST_RECORD_TWO);
            }
        }

        public void UpdateTEST_RECORD_TWO(TEST_RECORD_TWO currentTEST_RECORD_TWO)
        {
            this.ObjectContext.TEST_RECORD_TWO.AttachAsModified(currentTEST_RECORD_TWO, this.ChangeSet.GetOriginal(currentTEST_RECORD_TWO));
        }

        public void DeleteTEST_RECORD_TWO(TEST_RECORD_TWO tEST_RECORD_TWO)
        {
            if ((tEST_RECORD_TWO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tEST_RECORD_TWO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.TEST_RECORD_TWO.Attach(tEST_RECORD_TWO);
                this.ObjectContext.TEST_RECORD_TWO.DeleteObject(tEST_RECORD_TWO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'TEST_TEXT' query.
        public IQueryable<TEST_TEXT> GetTEST_TEXT()
        {
            return this.ObjectContext.TEST_TEXT;
        }

        public void InsertTEST_TEXT(TEST_TEXT tEST_TEXT)
        {
            if ((tEST_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tEST_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.TEST_TEXT.AddObject(tEST_TEXT);
            }
        }

        public void UpdateTEST_TEXT(TEST_TEXT currentTEST_TEXT)
        {
            this.ObjectContext.TEST_TEXT.AttachAsModified(currentTEST_TEXT, this.ChangeSet.GetOriginal(currentTEST_TEXT));
        }

        public void DeleteTEST_TEXT(TEST_TEXT tEST_TEXT)
        {
            if ((tEST_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tEST_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.TEST_TEXT.Attach(tEST_TEXT);
                this.ObjectContext.TEST_TEXT.DeleteObject(tEST_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'TEXT_DESC' query.
        public IQueryable<TEXT_DESC> GetTEXT_DESC()
        {
            return this.ObjectContext.TEXT_DESC;
        }

        public void InsertTEXT_DESC(TEXT_DESC tEXT_DESC)
        {
            if ((tEXT_DESC.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tEXT_DESC, EntityState.Added);
            }
            else
            {
                this.ObjectContext.TEXT_DESC.AddObject(tEXT_DESC);
            }
        }

        public void UpdateTEXT_DESC(TEXT_DESC currentTEXT_DESC)
        {
            this.ObjectContext.TEXT_DESC.AttachAsModified(currentTEXT_DESC, this.ChangeSet.GetOriginal(currentTEXT_DESC));
        }

        public void DeleteTEXT_DESC(TEXT_DESC tEXT_DESC)
        {
            if ((tEXT_DESC.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tEXT_DESC, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.TEXT_DESC.Attach(tEXT_DESC);
                this.ObjectContext.TEXT_DESC.DeleteObject(tEXT_DESC);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'TP_DATA' query.
        public IQueryable<TP_DATA> GetTP_DATA()
        {
            return this.ObjectContext.TP_DATA;
        }

        public void InsertTP_DATA(TP_DATA tP_DATA)
        {
            if ((tP_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tP_DATA, EntityState.Added);
            }
            else
            {
                this.ObjectContext.TP_DATA.AddObject(tP_DATA);
            }
        }

        public void UpdateTP_DATA(TP_DATA currentTP_DATA)
        {
            this.ObjectContext.TP_DATA.AttachAsModified(currentTP_DATA, this.ChangeSet.GetOriginal(currentTP_DATA));
        }

        public void DeleteTP_DATA(TP_DATA tP_DATA)
        {
            if ((tP_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tP_DATA, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.TP_DATA.Attach(tP_DATA);
                this.ObjectContext.TP_DATA.DeleteObject(tP_DATA);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'TP_DEFN' query.
        public IQueryable<TP_DEFN> GetTP_DEFN()
        {
            return this.ObjectContext.TP_DEFN;
        }

        public void InsertTP_DEFN(TP_DEFN tP_DEFN)
        {
            if ((tP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tP_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.TP_DEFN.AddObject(tP_DEFN);
            }
        }

        public void UpdateTP_DEFN(TP_DEFN currentTP_DEFN)
        {
            this.ObjectContext.TP_DEFN.AttachAsModified(currentTP_DEFN, this.ChangeSet.GetOriginal(currentTP_DEFN));
        }

        public void DeleteTP_DEFN(TP_DEFN tP_DEFN)
        {
            if ((tP_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(tP_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.TP_DEFN.Attach(tP_DEFN);
                this.ObjectContext.TP_DEFN.DeleteObject(tP_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'UNITS_TEXT' query.
        public IQueryable<UNITS_TEXT> GetUNITS_TEXT()
        {
            return this.ObjectContext.UNITS_TEXT;
        }

        public void InsertUNITS_TEXT(UNITS_TEXT uNITS_TEXT)
        {
            if ((uNITS_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(uNITS_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.UNITS_TEXT.AddObject(uNITS_TEXT);
            }
        }

        public void UpdateUNITS_TEXT(UNITS_TEXT currentUNITS_TEXT)
        {
            this.ObjectContext.UNITS_TEXT.AttachAsModified(currentUNITS_TEXT, this.ChangeSet.GetOriginal(currentUNITS_TEXT));
        }

        public void DeleteUNITS_TEXT(UNITS_TEXT uNITS_TEXT)
        {
            if ((uNITS_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(uNITS_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.UNITS_TEXT.Attach(uNITS_TEXT);
                this.ObjectContext.UNITS_TEXT.DeleteObject(uNITS_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VAR_SUM_TEMP' query.
        public IQueryable<VAR_SUM_TEMP> GetVAR_SUM_TEMP()
        {
            return this.ObjectContext.VAR_SUM_TEMP;
        }

        public void InsertVAR_SUM_TEMP(VAR_SUM_TEMP vAR_SUM_TEMP)
        {
            if ((vAR_SUM_TEMP.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vAR_SUM_TEMP, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VAR_SUM_TEMP.AddObject(vAR_SUM_TEMP);
            }
        }

        public void UpdateVAR_SUM_TEMP(VAR_SUM_TEMP currentVAR_SUM_TEMP)
        {
            this.ObjectContext.VAR_SUM_TEMP.AttachAsModified(currentVAR_SUM_TEMP, this.ChangeSet.GetOriginal(currentVAR_SUM_TEMP));
        }

        public void DeleteVAR_SUM_TEMP(VAR_SUM_TEMP vAR_SUM_TEMP)
        {
            if ((vAR_SUM_TEMP.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vAR_SUM_TEMP, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VAR_SUM_TEMP.Attach(vAR_SUM_TEMP);
                this.ObjectContext.VAR_SUM_TEMP.DeleteObject(vAR_SUM_TEMP);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VAR_SUM_TEMP_MAXES' query.
        public IQueryable<VAR_SUM_TEMP_MAXES> GetVAR_SUM_TEMP_MAXES()
        {
            return this.ObjectContext.VAR_SUM_TEMP_MAXES;
        }

        public void InsertVAR_SUM_TEMP_MAXES(VAR_SUM_TEMP_MAXES vAR_SUM_TEMP_MAXES)
        {
            if ((vAR_SUM_TEMP_MAXES.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vAR_SUM_TEMP_MAXES, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VAR_SUM_TEMP_MAXES.AddObject(vAR_SUM_TEMP_MAXES);
            }
        }

        public void UpdateVAR_SUM_TEMP_MAXES(VAR_SUM_TEMP_MAXES currentVAR_SUM_TEMP_MAXES)
        {
            this.ObjectContext.VAR_SUM_TEMP_MAXES.AttachAsModified(currentVAR_SUM_TEMP_MAXES, this.ChangeSet.GetOriginal(currentVAR_SUM_TEMP_MAXES));
        }

        public void DeleteVAR_SUM_TEMP_MAXES(VAR_SUM_TEMP_MAXES vAR_SUM_TEMP_MAXES)
        {
            if ((vAR_SUM_TEMP_MAXES.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vAR_SUM_TEMP_MAXES, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VAR_SUM_TEMP_MAXES.Attach(vAR_SUM_TEMP_MAXES);
                this.ObjectContext.VAR_SUM_TEMP_MAXES.DeleteObject(vAR_SUM_TEMP_MAXES);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VAR_TREND_SUM' query.
        public IQueryable<VAR_TREND_SUM> GetVAR_TREND_SUM()
        {
            return this.ObjectContext.VAR_TREND_SUM;
        }

        public void InsertVAR_TREND_SUM(VAR_TREND_SUM vAR_TREND_SUM)
        {
            if ((vAR_TREND_SUM.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vAR_TREND_SUM, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VAR_TREND_SUM.AddObject(vAR_TREND_SUM);
            }
        }

        public void UpdateVAR_TREND_SUM(VAR_TREND_SUM currentVAR_TREND_SUM)
        {
            this.ObjectContext.VAR_TREND_SUM.AttachAsModified(currentVAR_TREND_SUM, this.ChangeSet.GetOriginal(currentVAR_TREND_SUM));
        }

        public void DeleteVAR_TREND_SUM(VAR_TREND_SUM vAR_TREND_SUM)
        {
            if ((vAR_TREND_SUM.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vAR_TREND_SUM, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VAR_TREND_SUM.Attach(vAR_TREND_SUM);
                this.ObjectContext.VAR_TREND_SUM.DeleteObject(vAR_TREND_SUM);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VAR_TREND_SUM_TEMP' query.
        public IQueryable<VAR_TREND_SUM_TEMP> GetVAR_TREND_SUM_TEMP()
        {
            return this.ObjectContext.VAR_TREND_SUM_TEMP;
        }

        public void InsertVAR_TREND_SUM_TEMP(VAR_TREND_SUM_TEMP vAR_TREND_SUM_TEMP)
        {
            if ((vAR_TREND_SUM_TEMP.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vAR_TREND_SUM_TEMP, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VAR_TREND_SUM_TEMP.AddObject(vAR_TREND_SUM_TEMP);
            }
        }

        public void UpdateVAR_TREND_SUM_TEMP(VAR_TREND_SUM_TEMP currentVAR_TREND_SUM_TEMP)
        {
            this.ObjectContext.VAR_TREND_SUM_TEMP.AttachAsModified(currentVAR_TREND_SUM_TEMP, this.ChangeSet.GetOriginal(currentVAR_TREND_SUM_TEMP));
        }

        public void DeleteVAR_TREND_SUM_TEMP(VAR_TREND_SUM_TEMP vAR_TREND_SUM_TEMP)
        {
            if ((vAR_TREND_SUM_TEMP.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vAR_TREND_SUM_TEMP, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VAR_TREND_SUM_TEMP.Attach(vAR_TREND_SUM_TEMP);
                this.ObjectContext.VAR_TREND_SUM_TEMP.DeleteObject(vAR_TREND_SUM_TEMP);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VB_LEAK_DATA' query.
        public IQueryable<VB_LEAK_DATA> GetVB_LEAK_DATA()
        {
            return this.ObjectContext.VB_LEAK_DATA;
        }

        public void InsertVB_LEAK_DATA(VB_LEAK_DATA vB_LEAK_DATA)
        {
            if ((vB_LEAK_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vB_LEAK_DATA, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VB_LEAK_DATA.AddObject(vB_LEAK_DATA);
            }
        }

        public void UpdateVB_LEAK_DATA(VB_LEAK_DATA currentVB_LEAK_DATA)
        {
            this.ObjectContext.VB_LEAK_DATA.AttachAsModified(currentVB_LEAK_DATA, this.ChangeSet.GetOriginal(currentVB_LEAK_DATA));
        }

        public void DeleteVB_LEAK_DATA(VB_LEAK_DATA vB_LEAK_DATA)
        {
            if ((vB_LEAK_DATA.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vB_LEAK_DATA, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VB_LEAK_DATA.Attach(vB_LEAK_DATA);
                this.ObjectContext.VB_LEAK_DATA.DeleteObject(vB_LEAK_DATA);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VB_MODEL_TABLE_DEFN' query.
        public IQueryable<VB_MODEL_TABLE_DEFN> GetVB_MODEL_TABLE_DEFN()
        {
            return this.ObjectContext.VB_MODEL_TABLE_DEFN;
        }

        public void InsertVB_MODEL_TABLE_DEFN(VB_MODEL_TABLE_DEFN vB_MODEL_TABLE_DEFN)
        {
            if ((vB_MODEL_TABLE_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vB_MODEL_TABLE_DEFN, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VB_MODEL_TABLE_DEFN.AddObject(vB_MODEL_TABLE_DEFN);
            }
        }

        public void UpdateVB_MODEL_TABLE_DEFN(VB_MODEL_TABLE_DEFN currentVB_MODEL_TABLE_DEFN)
        {
            this.ObjectContext.VB_MODEL_TABLE_DEFN.AttachAsModified(currentVB_MODEL_TABLE_DEFN, this.ChangeSet.GetOriginal(currentVB_MODEL_TABLE_DEFN));
        }

        public void DeleteVB_MODEL_TABLE_DEFN(VB_MODEL_TABLE_DEFN vB_MODEL_TABLE_DEFN)
        {
            if ((vB_MODEL_TABLE_DEFN.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vB_MODEL_TABLE_DEFN, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VB_MODEL_TABLE_DEFN.Attach(vB_MODEL_TABLE_DEFN);
                this.ObjectContext.VB_MODEL_TABLE_DEFN.DeleteObject(vB_MODEL_TABLE_DEFN);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_AUDIT_VIA_MBX_TABLE' query.
        public IQueryable<VU_AUDIT_VIA_MBX_TABLE> GetVU_AUDIT_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_AUDIT_VIA_MBX_TABLE;
        }

        public void InsertVU_AUDIT_VIA_MBX_TABLE(VU_AUDIT_VIA_MBX_TABLE vU_AUDIT_VIA_MBX_TABLE)
        {
            if ((vU_AUDIT_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_AUDIT_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_AUDIT_VIA_MBX_TABLE.AddObject(vU_AUDIT_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_AUDIT_VIA_MBX_TABLE(VU_AUDIT_VIA_MBX_TABLE currentVU_AUDIT_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_AUDIT_VIA_MBX_TABLE.AttachAsModified(currentVU_AUDIT_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_AUDIT_VIA_MBX_TABLE));
        }

        public void DeleteVU_AUDIT_VIA_MBX_TABLE(VU_AUDIT_VIA_MBX_TABLE vU_AUDIT_VIA_MBX_TABLE)
        {
            if ((vU_AUDIT_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_AUDIT_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_AUDIT_VIA_MBX_TABLE.Attach(vU_AUDIT_VIA_MBX_TABLE);
                this.ObjectContext.VU_AUDIT_VIA_MBX_TABLE.DeleteObject(vU_AUDIT_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_FLAT_LIMIT' query.
        public IQueryable<VU_FLAT_LIMIT> GetVU_FLAT_LIMIT()
        {
            return this.ObjectContext.VU_FLAT_LIMIT;
        }

        public void InsertVU_FLAT_LIMIT(VU_FLAT_LIMIT vU_FLAT_LIMIT)
        {
            if ((vU_FLAT_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_FLAT_LIMIT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_FLAT_LIMIT.AddObject(vU_FLAT_LIMIT);
            }
        }

        public void UpdateVU_FLAT_LIMIT(VU_FLAT_LIMIT currentVU_FLAT_LIMIT)
        {
            this.ObjectContext.VU_FLAT_LIMIT.AttachAsModified(currentVU_FLAT_LIMIT, this.ChangeSet.GetOriginal(currentVU_FLAT_LIMIT));
        }

        public void DeleteVU_FLAT_LIMIT(VU_FLAT_LIMIT vU_FLAT_LIMIT)
        {
            if ((vU_FLAT_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_FLAT_LIMIT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_FLAT_LIMIT.Attach(vU_FLAT_LIMIT);
                this.ObjectContext.VU_FLAT_LIMIT.DeleteObject(vU_FLAT_LIMIT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_GET_TP_RECALC_TIME' query.
        public IQueryable<VU_GET_TP_RECALC_TIME> GetVU_GET_TP_RECALC_TIME()
        {
            return this.ObjectContext.VU_GET_TP_RECALC_TIME;
        }

        public void InsertVU_GET_TP_RECALC_TIME(VU_GET_TP_RECALC_TIME vU_GET_TP_RECALC_TIME)
        {
            if ((vU_GET_TP_RECALC_TIME.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_GET_TP_RECALC_TIME, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_GET_TP_RECALC_TIME.AddObject(vU_GET_TP_RECALC_TIME);
            }
        }

        public void UpdateVU_GET_TP_RECALC_TIME(VU_GET_TP_RECALC_TIME currentVU_GET_TP_RECALC_TIME)
        {
            this.ObjectContext.VU_GET_TP_RECALC_TIME.AttachAsModified(currentVU_GET_TP_RECALC_TIME, this.ChangeSet.GetOriginal(currentVU_GET_TP_RECALC_TIME));
        }

        public void DeleteVU_GET_TP_RECALC_TIME(VU_GET_TP_RECALC_TIME vU_GET_TP_RECALC_TIME)
        {
            if ((vU_GET_TP_RECALC_TIME.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_GET_TP_RECALC_TIME, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_GET_TP_RECALC_TIME.Attach(vU_GET_TP_RECALC_TIME);
                this.ObjectContext.VU_GET_TP_RECALC_TIME.DeleteObject(vU_GET_TP_RECALC_TIME);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_HIGH_MODEL_LIMIT' query.
        public IQueryable<VU_HIGH_MODEL_LIMIT> GetVU_HIGH_MODEL_LIMIT()
        {
            return this.ObjectContext.VU_HIGH_MODEL_LIMIT;
        }

        public void InsertVU_HIGH_MODEL_LIMIT(VU_HIGH_MODEL_LIMIT vU_HIGH_MODEL_LIMIT)
        {
            if ((vU_HIGH_MODEL_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_HIGH_MODEL_LIMIT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_HIGH_MODEL_LIMIT.AddObject(vU_HIGH_MODEL_LIMIT);
            }
        }

        public void UpdateVU_HIGH_MODEL_LIMIT(VU_HIGH_MODEL_LIMIT currentVU_HIGH_MODEL_LIMIT)
        {
            this.ObjectContext.VU_HIGH_MODEL_LIMIT.AttachAsModified(currentVU_HIGH_MODEL_LIMIT, this.ChangeSet.GetOriginal(currentVU_HIGH_MODEL_LIMIT));
        }

        public void DeleteVU_HIGH_MODEL_LIMIT(VU_HIGH_MODEL_LIMIT vU_HIGH_MODEL_LIMIT)
        {
            if ((vU_HIGH_MODEL_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_HIGH_MODEL_LIMIT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_HIGH_MODEL_LIMIT.Attach(vU_HIGH_MODEL_LIMIT);
                this.ObjectContext.VU_HIGH_MODEL_LIMIT.DeleteObject(vU_HIGH_MODEL_LIMIT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_HIGH_STAND_LIMIT' query.
        public IQueryable<VU_HIGH_STAND_LIMIT> GetVU_HIGH_STAND_LIMIT()
        {
            return this.ObjectContext.VU_HIGH_STAND_LIMIT;
        }

        public void InsertVU_HIGH_STAND_LIMIT(VU_HIGH_STAND_LIMIT vU_HIGH_STAND_LIMIT)
        {
            if ((vU_HIGH_STAND_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_HIGH_STAND_LIMIT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_HIGH_STAND_LIMIT.AddObject(vU_HIGH_STAND_LIMIT);
            }
        }

        public void UpdateVU_HIGH_STAND_LIMIT(VU_HIGH_STAND_LIMIT currentVU_HIGH_STAND_LIMIT)
        {
            this.ObjectContext.VU_HIGH_STAND_LIMIT.AttachAsModified(currentVU_HIGH_STAND_LIMIT, this.ChangeSet.GetOriginal(currentVU_HIGH_STAND_LIMIT));
        }

        public void DeleteVU_HIGH_STAND_LIMIT(VU_HIGH_STAND_LIMIT vU_HIGH_STAND_LIMIT)
        {
            if ((vU_HIGH_STAND_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_HIGH_STAND_LIMIT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_HIGH_STAND_LIMIT.Attach(vU_HIGH_STAND_LIMIT);
                this.ObjectContext.VU_HIGH_STAND_LIMIT.DeleteObject(vU_HIGH_STAND_LIMIT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LEVEL_1_REPAIR_TEXT' query.
        public IQueryable<VU_LEVEL_1_REPAIR_TEXT> GetVU_LEVEL_1_REPAIR_TEXT()
        {
            return this.ObjectContext.VU_LEVEL_1_REPAIR_TEXT;
        }

        public void InsertVU_LEVEL_1_REPAIR_TEXT(VU_LEVEL_1_REPAIR_TEXT vU_LEVEL_1_REPAIR_TEXT)
        {
            if ((vU_LEVEL_1_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LEVEL_1_REPAIR_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LEVEL_1_REPAIR_TEXT.AddObject(vU_LEVEL_1_REPAIR_TEXT);
            }
        }

        public void UpdateVU_LEVEL_1_REPAIR_TEXT(VU_LEVEL_1_REPAIR_TEXT currentVU_LEVEL_1_REPAIR_TEXT)
        {
            this.ObjectContext.VU_LEVEL_1_REPAIR_TEXT.AttachAsModified(currentVU_LEVEL_1_REPAIR_TEXT, this.ChangeSet.GetOriginal(currentVU_LEVEL_1_REPAIR_TEXT));
        }

        public void DeleteVU_LEVEL_1_REPAIR_TEXT(VU_LEVEL_1_REPAIR_TEXT vU_LEVEL_1_REPAIR_TEXT)
        {
            if ((vU_LEVEL_1_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LEVEL_1_REPAIR_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LEVEL_1_REPAIR_TEXT.Attach(vU_LEVEL_1_REPAIR_TEXT);
                this.ObjectContext.VU_LEVEL_1_REPAIR_TEXT.DeleteObject(vU_LEVEL_1_REPAIR_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LEVEL_2_REPAIR_TEXT' query.
        public IQueryable<VU_LEVEL_2_REPAIR_TEXT> GetVU_LEVEL_2_REPAIR_TEXT()
        {
            return this.ObjectContext.VU_LEVEL_2_REPAIR_TEXT;
        }

        public void InsertVU_LEVEL_2_REPAIR_TEXT(VU_LEVEL_2_REPAIR_TEXT vU_LEVEL_2_REPAIR_TEXT)
        {
            if ((vU_LEVEL_2_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LEVEL_2_REPAIR_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LEVEL_2_REPAIR_TEXT.AddObject(vU_LEVEL_2_REPAIR_TEXT);
            }
        }

        public void UpdateVU_LEVEL_2_REPAIR_TEXT(VU_LEVEL_2_REPAIR_TEXT currentVU_LEVEL_2_REPAIR_TEXT)
        {
            this.ObjectContext.VU_LEVEL_2_REPAIR_TEXT.AttachAsModified(currentVU_LEVEL_2_REPAIR_TEXT, this.ChangeSet.GetOriginal(currentVU_LEVEL_2_REPAIR_TEXT));
        }

        public void DeleteVU_LEVEL_2_REPAIR_TEXT(VU_LEVEL_2_REPAIR_TEXT vU_LEVEL_2_REPAIR_TEXT)
        {
            if ((vU_LEVEL_2_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LEVEL_2_REPAIR_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LEVEL_2_REPAIR_TEXT.Attach(vU_LEVEL_2_REPAIR_TEXT);
                this.ObjectContext.VU_LEVEL_2_REPAIR_TEXT.DeleteObject(vU_LEVEL_2_REPAIR_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LEVEL_3_REPAIR_TEXT' query.
        public IQueryable<VU_LEVEL_3_REPAIR_TEXT> GetVU_LEVEL_3_REPAIR_TEXT()
        {
            return this.ObjectContext.VU_LEVEL_3_REPAIR_TEXT;
        }

        public void InsertVU_LEVEL_3_REPAIR_TEXT(VU_LEVEL_3_REPAIR_TEXT vU_LEVEL_3_REPAIR_TEXT)
        {
            if ((vU_LEVEL_3_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LEVEL_3_REPAIR_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LEVEL_3_REPAIR_TEXT.AddObject(vU_LEVEL_3_REPAIR_TEXT);
            }
        }

        public void UpdateVU_LEVEL_3_REPAIR_TEXT(VU_LEVEL_3_REPAIR_TEXT currentVU_LEVEL_3_REPAIR_TEXT)
        {
            this.ObjectContext.VU_LEVEL_3_REPAIR_TEXT.AttachAsModified(currentVU_LEVEL_3_REPAIR_TEXT, this.ChangeSet.GetOriginal(currentVU_LEVEL_3_REPAIR_TEXT));
        }

        public void DeleteVU_LEVEL_3_REPAIR_TEXT(VU_LEVEL_3_REPAIR_TEXT vU_LEVEL_3_REPAIR_TEXT)
        {
            if ((vU_LEVEL_3_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LEVEL_3_REPAIR_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LEVEL_3_REPAIR_TEXT.Attach(vU_LEVEL_3_REPAIR_TEXT);
                this.ObjectContext.VU_LEVEL_3_REPAIR_TEXT.DeleteObject(vU_LEVEL_3_REPAIR_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LEVEL_4_REPAIR_TEXT' query.
        public IQueryable<VU_LEVEL_4_REPAIR_TEXT> GetVU_LEVEL_4_REPAIR_TEXT()
        {
            return this.ObjectContext.VU_LEVEL_4_REPAIR_TEXT;
        }

        public void InsertVU_LEVEL_4_REPAIR_TEXT(VU_LEVEL_4_REPAIR_TEXT vU_LEVEL_4_REPAIR_TEXT)
        {
            if ((vU_LEVEL_4_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LEVEL_4_REPAIR_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LEVEL_4_REPAIR_TEXT.AddObject(vU_LEVEL_4_REPAIR_TEXT);
            }
        }

        public void UpdateVU_LEVEL_4_REPAIR_TEXT(VU_LEVEL_4_REPAIR_TEXT currentVU_LEVEL_4_REPAIR_TEXT)
        {
            this.ObjectContext.VU_LEVEL_4_REPAIR_TEXT.AttachAsModified(currentVU_LEVEL_4_REPAIR_TEXT, this.ChangeSet.GetOriginal(currentVU_LEVEL_4_REPAIR_TEXT));
        }

        public void DeleteVU_LEVEL_4_REPAIR_TEXT(VU_LEVEL_4_REPAIR_TEXT vU_LEVEL_4_REPAIR_TEXT)
        {
            if ((vU_LEVEL_4_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LEVEL_4_REPAIR_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LEVEL_4_REPAIR_TEXT.Attach(vU_LEVEL_4_REPAIR_TEXT);
                this.ObjectContext.VU_LEVEL_4_REPAIR_TEXT.DeleteObject(vU_LEVEL_4_REPAIR_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LIMIT' query.
        public IQueryable<VU_LIMIT> GetVU_LIMIT()
        {
            return this.ObjectContext.VU_LIMIT;
        }

        public void InsertVU_LIMIT(VU_LIMIT vU_LIMIT)
        {
            if ((vU_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LIMIT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LIMIT.AddObject(vU_LIMIT);
            }
        }

        public void UpdateVU_LIMIT(VU_LIMIT currentVU_LIMIT)
        {
            this.ObjectContext.VU_LIMIT.AttachAsModified(currentVU_LIMIT, this.ChangeSet.GetOriginal(currentVU_LIMIT));
        }

        public void DeleteVU_LIMIT(VU_LIMIT vU_LIMIT)
        {
            if ((vU_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LIMIT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LIMIT.Attach(vU_LIMIT);
                this.ObjectContext.VU_LIMIT.DeleteObject(vU_LIMIT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LIMIT_TEXT' query.
        public IQueryable<VU_LIMIT_TEXT> GetVU_LIMIT_TEXT()
        {
            return this.ObjectContext.VU_LIMIT_TEXT;
        }

        public void InsertVU_LIMIT_TEXT(VU_LIMIT_TEXT vU_LIMIT_TEXT)
        {
            if ((vU_LIMIT_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LIMIT_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LIMIT_TEXT.AddObject(vU_LIMIT_TEXT);
            }
        }

        public void UpdateVU_LIMIT_TEXT(VU_LIMIT_TEXT currentVU_LIMIT_TEXT)
        {
            this.ObjectContext.VU_LIMIT_TEXT.AttachAsModified(currentVU_LIMIT_TEXT, this.ChangeSet.GetOriginal(currentVU_LIMIT_TEXT));
        }

        public void DeleteVU_LIMIT_TEXT(VU_LIMIT_TEXT vU_LIMIT_TEXT)
        {
            if ((vU_LIMIT_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LIMIT_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LIMIT_TEXT.Attach(vU_LIMIT_TEXT);
                this.ObjectContext.VU_LIMIT_TEXT.DeleteObject(vU_LIMIT_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LIMIT_TEXT_NEW' query.
        public IQueryable<VU_LIMIT_TEXT_NEW> GetVU_LIMIT_TEXT_NEW()
        {
            return this.ObjectContext.VU_LIMIT_TEXT_NEW;
        }

        public void InsertVU_LIMIT_TEXT_NEW(VU_LIMIT_TEXT_NEW vU_LIMIT_TEXT_NEW)
        {
            if ((vU_LIMIT_TEXT_NEW.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LIMIT_TEXT_NEW, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LIMIT_TEXT_NEW.AddObject(vU_LIMIT_TEXT_NEW);
            }
        }

        public void UpdateVU_LIMIT_TEXT_NEW(VU_LIMIT_TEXT_NEW currentVU_LIMIT_TEXT_NEW)
        {
            this.ObjectContext.VU_LIMIT_TEXT_NEW.AttachAsModified(currentVU_LIMIT_TEXT_NEW, this.ChangeSet.GetOriginal(currentVU_LIMIT_TEXT_NEW));
        }

        public void DeleteVU_LIMIT_TEXT_NEW(VU_LIMIT_TEXT_NEW vU_LIMIT_TEXT_NEW)
        {
            if ((vU_LIMIT_TEXT_NEW.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LIMIT_TEXT_NEW, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LIMIT_TEXT_NEW.Attach(vU_LIMIT_TEXT_NEW);
                this.ObjectContext.VU_LIMIT_TEXT_NEW.DeleteObject(vU_LIMIT_TEXT_NEW);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LOW_MODEL_LIMIT' query.
        public IQueryable<VU_LOW_MODEL_LIMIT> GetVU_LOW_MODEL_LIMIT()
        {
            return this.ObjectContext.VU_LOW_MODEL_LIMIT;
        }

        public void InsertVU_LOW_MODEL_LIMIT(VU_LOW_MODEL_LIMIT vU_LOW_MODEL_LIMIT)
        {
            if ((vU_LOW_MODEL_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LOW_MODEL_LIMIT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LOW_MODEL_LIMIT.AddObject(vU_LOW_MODEL_LIMIT);
            }
        }

        public void UpdateVU_LOW_MODEL_LIMIT(VU_LOW_MODEL_LIMIT currentVU_LOW_MODEL_LIMIT)
        {
            this.ObjectContext.VU_LOW_MODEL_LIMIT.AttachAsModified(currentVU_LOW_MODEL_LIMIT, this.ChangeSet.GetOriginal(currentVU_LOW_MODEL_LIMIT));
        }

        public void DeleteVU_LOW_MODEL_LIMIT(VU_LOW_MODEL_LIMIT vU_LOW_MODEL_LIMIT)
        {
            if ((vU_LOW_MODEL_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LOW_MODEL_LIMIT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LOW_MODEL_LIMIT.Attach(vU_LOW_MODEL_LIMIT);
                this.ObjectContext.VU_LOW_MODEL_LIMIT.DeleteObject(vU_LOW_MODEL_LIMIT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_LOW_STAND_LIMIT' query.
        public IQueryable<VU_LOW_STAND_LIMIT> GetVU_LOW_STAND_LIMIT()
        {
            return this.ObjectContext.VU_LOW_STAND_LIMIT;
        }

        public void InsertVU_LOW_STAND_LIMIT(VU_LOW_STAND_LIMIT vU_LOW_STAND_LIMIT)
        {
            if ((vU_LOW_STAND_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LOW_STAND_LIMIT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_LOW_STAND_LIMIT.AddObject(vU_LOW_STAND_LIMIT);
            }
        }

        public void UpdateVU_LOW_STAND_LIMIT(VU_LOW_STAND_LIMIT currentVU_LOW_STAND_LIMIT)
        {
            this.ObjectContext.VU_LOW_STAND_LIMIT.AttachAsModified(currentVU_LOW_STAND_LIMIT, this.ChangeSet.GetOriginal(currentVU_LOW_STAND_LIMIT));
        }

        public void DeleteVU_LOW_STAND_LIMIT(VU_LOW_STAND_LIMIT vU_LOW_STAND_LIMIT)
        {
            if ((vU_LOW_STAND_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_LOW_STAND_LIMIT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_LOW_STAND_LIMIT.Attach(vU_LOW_STAND_LIMIT);
                this.ObjectContext.VU_LOW_STAND_LIMIT.DeleteObject(vU_LOW_STAND_LIMIT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_MISC_INFO' query.
        public IQueryable<VU_MISC_INFO> GetVU_MISC_INFO()
        {
            return this.ObjectContext.VU_MISC_INFO;
        }

        public void InsertVU_MISC_INFO(VU_MISC_INFO vU_MISC_INFO)
        {
            if ((vU_MISC_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_MISC_INFO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_MISC_INFO.AddObject(vU_MISC_INFO);
            }
        }

        public void UpdateVU_MISC_INFO(VU_MISC_INFO currentVU_MISC_INFO)
        {
            this.ObjectContext.VU_MISC_INFO.AttachAsModified(currentVU_MISC_INFO, this.ChangeSet.GetOriginal(currentVU_MISC_INFO));
        }

        public void DeleteVU_MISC_INFO(VU_MISC_INFO vU_MISC_INFO)
        {
            if ((vU_MISC_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_MISC_INFO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_MISC_INFO.Attach(vU_MISC_INFO);
                this.ObjectContext.VU_MISC_INFO.DeleteObject(vU_MISC_INFO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_ORIGIN_REPAIR_TEXT' query.
        public IQueryable<VU_ORIGIN_REPAIR_TEXT> GetVU_ORIGIN_REPAIR_TEXT()
        {
            return this.ObjectContext.VU_ORIGIN_REPAIR_TEXT;
        }

        public void InsertVU_ORIGIN_REPAIR_TEXT(VU_ORIGIN_REPAIR_TEXT vU_ORIGIN_REPAIR_TEXT)
        {
            if ((vU_ORIGIN_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_ORIGIN_REPAIR_TEXT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_ORIGIN_REPAIR_TEXT.AddObject(vU_ORIGIN_REPAIR_TEXT);
            }
        }

        public void UpdateVU_ORIGIN_REPAIR_TEXT(VU_ORIGIN_REPAIR_TEXT currentVU_ORIGIN_REPAIR_TEXT)
        {
            this.ObjectContext.VU_ORIGIN_REPAIR_TEXT.AttachAsModified(currentVU_ORIGIN_REPAIR_TEXT, this.ChangeSet.GetOriginal(currentVU_ORIGIN_REPAIR_TEXT));
        }

        public void DeleteVU_ORIGIN_REPAIR_TEXT(VU_ORIGIN_REPAIR_TEXT vU_ORIGIN_REPAIR_TEXT)
        {
            if ((vU_ORIGIN_REPAIR_TEXT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_ORIGIN_REPAIR_TEXT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_ORIGIN_REPAIR_TEXT.Attach(vU_ORIGIN_REPAIR_TEXT);
                this.ObjectContext.VU_ORIGIN_REPAIR_TEXT.DeleteObject(vU_ORIGIN_REPAIR_TEXT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PARAM_DEFN_CRUST' query.
        public IQueryable<VU_PARAM_DEFN_CRUST> GetVU_PARAM_DEFN_CRUST()
        {
            return this.ObjectContext.VU_PARAM_DEFN_CRUST;
        }

        public void InsertVU_PARAM_DEFN_CRUST(VU_PARAM_DEFN_CRUST vU_PARAM_DEFN_CRUST)
        {
            if ((vU_PARAM_DEFN_CRUST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAM_DEFN_CRUST, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PARAM_DEFN_CRUST.AddObject(vU_PARAM_DEFN_CRUST);
            }
        }

        public void UpdateVU_PARAM_DEFN_CRUST(VU_PARAM_DEFN_CRUST currentVU_PARAM_DEFN_CRUST)
        {
            this.ObjectContext.VU_PARAM_DEFN_CRUST.AttachAsModified(currentVU_PARAM_DEFN_CRUST, this.ChangeSet.GetOriginal(currentVU_PARAM_DEFN_CRUST));
        }

        public void DeleteVU_PARAM_DEFN_CRUST(VU_PARAM_DEFN_CRUST vU_PARAM_DEFN_CRUST)
        {
            if ((vU_PARAM_DEFN_CRUST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAM_DEFN_CRUST, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PARAM_DEFN_CRUST.Attach(vU_PARAM_DEFN_CRUST);
                this.ObjectContext.VU_PARAM_DEFN_CRUST.DeleteObject(vU_PARAM_DEFN_CRUST);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PARAM_INFO' query.
        public IQueryable<VU_PARAM_INFO> GetVU_PARAM_INFO()
        {
            return this.ObjectContext.VU_PARAM_INFO;
        }

        public void InsertVU_PARAM_INFO(VU_PARAM_INFO vU_PARAM_INFO)
        {
            if ((vU_PARAM_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAM_INFO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PARAM_INFO.AddObject(vU_PARAM_INFO);
            }
        }

        public void UpdateVU_PARAM_INFO(VU_PARAM_INFO currentVU_PARAM_INFO)
        {
            this.ObjectContext.VU_PARAM_INFO.AttachAsModified(currentVU_PARAM_INFO, this.ChangeSet.GetOriginal(currentVU_PARAM_INFO));
        }

        public void DeleteVU_PARAM_INFO(VU_PARAM_INFO vU_PARAM_INFO)
        {
            if ((vU_PARAM_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAM_INFO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PARAM_INFO.Attach(vU_PARAM_INFO);
                this.ObjectContext.VU_PARAM_INFO.DeleteObject(vU_PARAM_INFO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PARAM_VAL_CRUST' query.
        public IQueryable<VU_PARAM_VAL_CRUST> GetVU_PARAM_VAL_CRUST()
        {
            return this.ObjectContext.VU_PARAM_VAL_CRUST;
        }

        public void InsertVU_PARAM_VAL_CRUST(VU_PARAM_VAL_CRUST vU_PARAM_VAL_CRUST)
        {
            if ((vU_PARAM_VAL_CRUST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAM_VAL_CRUST, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PARAM_VAL_CRUST.AddObject(vU_PARAM_VAL_CRUST);
            }
        }

        public void UpdateVU_PARAM_VAL_CRUST(VU_PARAM_VAL_CRUST currentVU_PARAM_VAL_CRUST)
        {
            this.ObjectContext.VU_PARAM_VAL_CRUST.AttachAsModified(currentVU_PARAM_VAL_CRUST, this.ChangeSet.GetOriginal(currentVU_PARAM_VAL_CRUST));
        }

        public void DeleteVU_PARAM_VAL_CRUST(VU_PARAM_VAL_CRUST vU_PARAM_VAL_CRUST)
        {
            if ((vU_PARAM_VAL_CRUST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAM_VAL_CRUST, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PARAM_VAL_CRUST.Attach(vU_PARAM_VAL_CRUST);
                this.ObjectContext.VU_PARAM_VAL_CRUST.DeleteObject(vU_PARAM_VAL_CRUST);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PARAMSHIGH' query.
        public IQueryable<VU_PARAMSHIGH> GetVU_PARAMSHIGH()
        {
            return this.ObjectContext.VU_PARAMSHIGH;
        }

        public void InsertVU_PARAMSHIGH(VU_PARAMSHIGH vU_PARAMSHIGH)
        {
            if ((vU_PARAMSHIGH.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAMSHIGH, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PARAMSHIGH.AddObject(vU_PARAMSHIGH);
            }
        }

        public void UpdateVU_PARAMSHIGH(VU_PARAMSHIGH currentVU_PARAMSHIGH)
        {
            this.ObjectContext.VU_PARAMSHIGH.AttachAsModified(currentVU_PARAMSHIGH, this.ChangeSet.GetOriginal(currentVU_PARAMSHIGH));
        }

        public void DeleteVU_PARAMSHIGH(VU_PARAMSHIGH vU_PARAMSHIGH)
        {
            if ((vU_PARAMSHIGH.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAMSHIGH, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PARAMSHIGH.Attach(vU_PARAMSHIGH);
                this.ObjectContext.VU_PARAMSHIGH.DeleteObject(vU_PARAMSHIGH);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PARAMSLOW' query.
        public IQueryable<VU_PARAMSLOW> GetVU_PARAMSLOW()
        {
            return this.ObjectContext.VU_PARAMSLOW;
        }

        public void InsertVU_PARAMSLOW(VU_PARAMSLOW vU_PARAMSLOW)
        {
            if ((vU_PARAMSLOW.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAMSLOW, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PARAMSLOW.AddObject(vU_PARAMSLOW);
            }
        }

        public void UpdateVU_PARAMSLOW(VU_PARAMSLOW currentVU_PARAMSLOW)
        {
            this.ObjectContext.VU_PARAMSLOW.AttachAsModified(currentVU_PARAMSLOW, this.ChangeSet.GetOriginal(currentVU_PARAMSLOW));
        }

        public void DeleteVU_PARAMSLOW(VU_PARAMSLOW vU_PARAMSLOW)
        {
            if ((vU_PARAMSLOW.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PARAMSLOW, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PARAMSLOW.Attach(vU_PARAMSLOW);
                this.ObjectContext.VU_PARAMSLOW.DeleteObject(vU_PARAMSLOW);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PD_MBX' query.
        public IQueryable<VU_PD_MBX> GetVU_PD_MBX()
        {
            return this.ObjectContext.VU_PD_MBX;
        }

        public void InsertVU_PD_MBX(VU_PD_MBX vU_PD_MBX)
        {
            if ((vU_PD_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PD_MBX, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PD_MBX.AddObject(vU_PD_MBX);
            }
        }

        public void UpdateVU_PD_MBX(VU_PD_MBX currentVU_PD_MBX)
        {
            this.ObjectContext.VU_PD_MBX.AttachAsModified(currentVU_PD_MBX, this.ChangeSet.GetOriginal(currentVU_PD_MBX));
        }

        public void DeleteVU_PD_MBX(VU_PD_MBX vU_PD_MBX)
        {
            if ((vU_PD_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PD_MBX, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PD_MBX.Attach(vU_PD_MBX);
                this.ObjectContext.VU_PD_MBX.DeleteObject(vU_PD_MBX);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PD_STAT_MBX' query.
        public IQueryable<VU_PD_STAT_MBX> GetVU_PD_STAT_MBX()
        {
            return this.ObjectContext.VU_PD_STAT_MBX;
        }

        public void InsertVU_PD_STAT_MBX(VU_PD_STAT_MBX vU_PD_STAT_MBX)
        {
            if ((vU_PD_STAT_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PD_STAT_MBX, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PD_STAT_MBX.AddObject(vU_PD_STAT_MBX);
            }
        }

        public void UpdateVU_PD_STAT_MBX(VU_PD_STAT_MBX currentVU_PD_STAT_MBX)
        {
            this.ObjectContext.VU_PD_STAT_MBX.AttachAsModified(currentVU_PD_STAT_MBX, this.ChangeSet.GetOriginal(currentVU_PD_STAT_MBX));
        }

        public void DeleteVU_PD_STAT_MBX(VU_PD_STAT_MBX vU_PD_STAT_MBX)
        {
            if ((vU_PD_STAT_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PD_STAT_MBX, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PD_STAT_MBX.Attach(vU_PD_STAT_MBX);
                this.ObjectContext.VU_PD_STAT_MBX.DeleteObject(vU_PD_STAT_MBX);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PD_VIA_MBX_TABLE' query.
        public IQueryable<VU_PD_VIA_MBX_TABLE> GetVU_PD_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_PD_VIA_MBX_TABLE;
        }

        public void InsertVU_PD_VIA_MBX_TABLE(VU_PD_VIA_MBX_TABLE vU_PD_VIA_MBX_TABLE)
        {
            if ((vU_PD_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PD_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PD_VIA_MBX_TABLE.AddObject(vU_PD_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_PD_VIA_MBX_TABLE(VU_PD_VIA_MBX_TABLE currentVU_PD_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_PD_VIA_MBX_TABLE.AttachAsModified(currentVU_PD_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_PD_VIA_MBX_TABLE));
        }

        public void DeleteVU_PD_VIA_MBX_TABLE(VU_PD_VIA_MBX_TABLE vU_PD_VIA_MBX_TABLE)
        {
            if ((vU_PD_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PD_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PD_VIA_MBX_TABLE.Attach(vU_PD_VIA_MBX_TABLE);
                this.ObjectContext.VU_PD_VIA_MBX_TABLE.DeleteObject(vU_PD_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PD1_VIA_MBX_TABLE' query.
        public IQueryable<VU_PD1_VIA_MBX_TABLE> GetVU_PD1_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_PD1_VIA_MBX_TABLE;
        }

        public void InsertVU_PD1_VIA_MBX_TABLE(VU_PD1_VIA_MBX_TABLE vU_PD1_VIA_MBX_TABLE)
        {
            if ((vU_PD1_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PD1_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PD1_VIA_MBX_TABLE.AddObject(vU_PD1_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_PD1_VIA_MBX_TABLE(VU_PD1_VIA_MBX_TABLE currentVU_PD1_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_PD1_VIA_MBX_TABLE.AttachAsModified(currentVU_PD1_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_PD1_VIA_MBX_TABLE));
        }

        public void DeleteVU_PD1_VIA_MBX_TABLE(VU_PD1_VIA_MBX_TABLE vU_PD1_VIA_MBX_TABLE)
        {
            if ((vU_PD1_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PD1_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PD1_VIA_MBX_TABLE.Attach(vU_PD1_VIA_MBX_TABLE);
                this.ObjectContext.VU_PD1_VIA_MBX_TABLE.DeleteObject(vU_PD1_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PDR_MODEL_STAND' query.
        public IQueryable<VU_PDR_MODEL_STAND> GetVU_PDR_MODEL_STAND()
        {
            return this.ObjectContext.VU_PDR_MODEL_STAND;
        }

        public void InsertVU_PDR_MODEL_STAND(VU_PDR_MODEL_STAND vU_PDR_MODEL_STAND)
        {
            if ((vU_PDR_MODEL_STAND.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PDR_MODEL_STAND, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PDR_MODEL_STAND.AddObject(vU_PDR_MODEL_STAND);
            }
        }

        public void UpdateVU_PDR_MODEL_STAND(VU_PDR_MODEL_STAND currentVU_PDR_MODEL_STAND)
        {
            this.ObjectContext.VU_PDR_MODEL_STAND.AttachAsModified(currentVU_PDR_MODEL_STAND, this.ChangeSet.GetOriginal(currentVU_PDR_MODEL_STAND));
        }

        public void DeleteVU_PDR_MODEL_STAND(VU_PDR_MODEL_STAND vU_PDR_MODEL_STAND)
        {
            if ((vU_PDR_MODEL_STAND.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PDR_MODEL_STAND, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PDR_MODEL_STAND.Attach(vU_PDR_MODEL_STAND);
                this.ObjectContext.VU_PDR_MODEL_STAND.DeleteObject(vU_PDR_MODEL_STAND);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PDS_MODEL_STAND' query.
        public IQueryable<VU_PDS_MODEL_STAND> GetVU_PDS_MODEL_STAND()
        {
            return this.ObjectContext.VU_PDS_MODEL_STAND;
        }

        public void InsertVU_PDS_MODEL_STAND(VU_PDS_MODEL_STAND vU_PDS_MODEL_STAND)
        {
            if ((vU_PDS_MODEL_STAND.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PDS_MODEL_STAND, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PDS_MODEL_STAND.AddObject(vU_PDS_MODEL_STAND);
            }
        }

        public void UpdateVU_PDS_MODEL_STAND(VU_PDS_MODEL_STAND currentVU_PDS_MODEL_STAND)
        {
            this.ObjectContext.VU_PDS_MODEL_STAND.AttachAsModified(currentVU_PDS_MODEL_STAND, this.ChangeSet.GetOriginal(currentVU_PDS_MODEL_STAND));
        }

        public void DeleteVU_PDS_MODEL_STAND(VU_PDS_MODEL_STAND vU_PDS_MODEL_STAND)
        {
            if ((vU_PDS_MODEL_STAND.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PDS_MODEL_STAND, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PDS_MODEL_STAND.Attach(vU_PDS_MODEL_STAND);
                this.ObjectContext.VU_PDS_MODEL_STAND.DeleteObject(vU_PDS_MODEL_STAND);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_PHASE_INFO' query.
        public IQueryable<VU_PHASE_INFO> GetVU_PHASE_INFO()
        {
            return this.ObjectContext.VU_PHASE_INFO;
        }

        public void InsertVU_PHASE_INFO(VU_PHASE_INFO vU_PHASE_INFO)
        {
            if ((vU_PHASE_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PHASE_INFO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_PHASE_INFO.AddObject(vU_PHASE_INFO);
            }
        }

        public void UpdateVU_PHASE_INFO(VU_PHASE_INFO currentVU_PHASE_INFO)
        {
            this.ObjectContext.VU_PHASE_INFO.AttachAsModified(currentVU_PHASE_INFO, this.ChangeSet.GetOriginal(currentVU_PHASE_INFO));
        }

        public void DeleteVU_PHASE_INFO(VU_PHASE_INFO vU_PHASE_INFO)
        {
            if ((vU_PHASE_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_PHASE_INFO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_PHASE_INFO.Attach(vU_PHASE_INFO);
                this.ObjectContext.VU_PHASE_INFO.DeleteObject(vU_PHASE_INFO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_RD_HIST_MBX' query.
        public IQueryable<VU_RD_HIST_MBX> GetVU_RD_HIST_MBX()
        {
            return this.ObjectContext.VU_RD_HIST_MBX;
        }

        public void InsertVU_RD_HIST_MBX(VU_RD_HIST_MBX vU_RD_HIST_MBX)
        {
            if ((vU_RD_HIST_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RD_HIST_MBX, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_RD_HIST_MBX.AddObject(vU_RD_HIST_MBX);
            }
        }

        public void UpdateVU_RD_HIST_MBX(VU_RD_HIST_MBX currentVU_RD_HIST_MBX)
        {
            this.ObjectContext.VU_RD_HIST_MBX.AttachAsModified(currentVU_RD_HIST_MBX, this.ChangeSet.GetOriginal(currentVU_RD_HIST_MBX));
        }

        public void DeleteVU_RD_HIST_MBX(VU_RD_HIST_MBX vU_RD_HIST_MBX)
        {
            if ((vU_RD_HIST_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RD_HIST_MBX, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_RD_HIST_MBX.Attach(vU_RD_HIST_MBX);
                this.ObjectContext.VU_RD_HIST_MBX.DeleteObject(vU_RD_HIST_MBX);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_RD_MBX' query.
        public IQueryable<VU_RD_MBX> GetVU_RD_MBX()
        {
            return this.ObjectContext.VU_RD_MBX;
        }

        public void InsertVU_RD_MBX(VU_RD_MBX vU_RD_MBX)
        {
            if ((vU_RD_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RD_MBX, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_RD_MBX.AddObject(vU_RD_MBX);
            }
        }

        public void UpdateVU_RD_MBX(VU_RD_MBX currentVU_RD_MBX)
        {
            this.ObjectContext.VU_RD_MBX.AttachAsModified(currentVU_RD_MBX, this.ChangeSet.GetOriginal(currentVU_RD_MBX));
        }

        public void DeleteVU_RD_MBX(VU_RD_MBX vU_RD_MBX)
        {
            if ((vU_RD_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RD_MBX, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_RD_MBX.Attach(vU_RD_MBX);
                this.ObjectContext.VU_RD_MBX.DeleteObject(vU_RD_MBX);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_RECYCLES_PER_TEST' query.
        public IQueryable<VU_RECYCLES_PER_TEST> GetVU_RECYCLES_PER_TEST()
        {
            return this.ObjectContext.VU_RECYCLES_PER_TEST;
        }

        public void InsertVU_RECYCLES_PER_TEST(VU_RECYCLES_PER_TEST vU_RECYCLES_PER_TEST)
        {
            if ((vU_RECYCLES_PER_TEST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RECYCLES_PER_TEST, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_RECYCLES_PER_TEST.AddObject(vU_RECYCLES_PER_TEST);
            }
        }

        public void UpdateVU_RECYCLES_PER_TEST(VU_RECYCLES_PER_TEST currentVU_RECYCLES_PER_TEST)
        {
            this.ObjectContext.VU_RECYCLES_PER_TEST.AttachAsModified(currentVU_RECYCLES_PER_TEST, this.ChangeSet.GetOriginal(currentVU_RECYCLES_PER_TEST));
        }

        public void DeleteVU_RECYCLES_PER_TEST(VU_RECYCLES_PER_TEST vU_RECYCLES_PER_TEST)
        {
            if ((vU_RECYCLES_PER_TEST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RECYCLES_PER_TEST, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_RECYCLES_PER_TEST.Attach(vU_RECYCLES_PER_TEST);
                this.ObjectContext.VU_RECYCLES_PER_TEST.DeleteObject(vU_RECYCLES_PER_TEST);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REJ_ACTION_INFO' query.
        public IQueryable<VU_REJ_ACTION_INFO> GetVU_REJ_ACTION_INFO()
        {
            return this.ObjectContext.VU_REJ_ACTION_INFO;
        }

        public void InsertVU_REJ_ACTION_INFO(VU_REJ_ACTION_INFO vU_REJ_ACTION_INFO)
        {
            if ((vU_REJ_ACTION_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJ_ACTION_INFO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REJ_ACTION_INFO.AddObject(vU_REJ_ACTION_INFO);
            }
        }

        public void UpdateVU_REJ_ACTION_INFO(VU_REJ_ACTION_INFO currentVU_REJ_ACTION_INFO)
        {
            this.ObjectContext.VU_REJ_ACTION_INFO.AttachAsModified(currentVU_REJ_ACTION_INFO, this.ChangeSet.GetOriginal(currentVU_REJ_ACTION_INFO));
        }

        public void DeleteVU_REJ_ACTION_INFO(VU_REJ_ACTION_INFO vU_REJ_ACTION_INFO)
        {
            if ((vU_REJ_ACTION_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJ_ACTION_INFO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REJ_ACTION_INFO.Attach(vU_REJ_ACTION_INFO);
                this.ObjectContext.VU_REJ_ACTION_INFO.DeleteObject(vU_REJ_ACTION_INFO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REJ_ID_VIA_MBX_TABLE' query.
        public IQueryable<VU_REJ_ID_VIA_MBX_TABLE> GetVU_REJ_ID_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_REJ_ID_VIA_MBX_TABLE;
        }

        public void InsertVU_REJ_ID_VIA_MBX_TABLE(VU_REJ_ID_VIA_MBX_TABLE vU_REJ_ID_VIA_MBX_TABLE)
        {
            if ((vU_REJ_ID_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJ_ID_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REJ_ID_VIA_MBX_TABLE.AddObject(vU_REJ_ID_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_REJ_ID_VIA_MBX_TABLE(VU_REJ_ID_VIA_MBX_TABLE currentVU_REJ_ID_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_REJ_ID_VIA_MBX_TABLE.AttachAsModified(currentVU_REJ_ID_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_REJ_ID_VIA_MBX_TABLE));
        }

        public void DeleteVU_REJ_ID_VIA_MBX_TABLE(VU_REJ_ID_VIA_MBX_TABLE vU_REJ_ID_VIA_MBX_TABLE)
        {
            if ((vU_REJ_ID_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJ_ID_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REJ_ID_VIA_MBX_TABLE.Attach(vU_REJ_ID_VIA_MBX_TABLE);
                this.ObjectContext.VU_REJ_ID_VIA_MBX_TABLE.DeleteObject(vU_REJ_ID_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REJ_TYPE_INFO' query.
        public IQueryable<VU_REJ_TYPE_INFO> GetVU_REJ_TYPE_INFO()
        {
            return this.ObjectContext.VU_REJ_TYPE_INFO;
        }

        public void InsertVU_REJ_TYPE_INFO(VU_REJ_TYPE_INFO vU_REJ_TYPE_INFO)
        {
            if ((vU_REJ_TYPE_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJ_TYPE_INFO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REJ_TYPE_INFO.AddObject(vU_REJ_TYPE_INFO);
            }
        }

        public void UpdateVU_REJ_TYPE_INFO(VU_REJ_TYPE_INFO currentVU_REJ_TYPE_INFO)
        {
            this.ObjectContext.VU_REJ_TYPE_INFO.AttachAsModified(currentVU_REJ_TYPE_INFO, this.ChangeSet.GetOriginal(currentVU_REJ_TYPE_INFO));
        }

        public void DeleteVU_REJ_TYPE_INFO(VU_REJ_TYPE_INFO vU_REJ_TYPE_INFO)
        {
            if ((vU_REJ_TYPE_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJ_TYPE_INFO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REJ_TYPE_INFO.Attach(vU_REJ_TYPE_INFO);
                this.ObjectContext.VU_REJ_TYPE_INFO.DeleteObject(vU_REJ_TYPE_INFO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REJECTSHIGH' query.
        public IQueryable<VU_REJECTSHIGH> GetVU_REJECTSHIGH()
        {
            return this.ObjectContext.VU_REJECTSHIGH;
        }

        public void InsertVU_REJECTSHIGH(VU_REJECTSHIGH vU_REJECTSHIGH)
        {
            if ((vU_REJECTSHIGH.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJECTSHIGH, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REJECTSHIGH.AddObject(vU_REJECTSHIGH);
            }
        }

        public void UpdateVU_REJECTSHIGH(VU_REJECTSHIGH currentVU_REJECTSHIGH)
        {
            this.ObjectContext.VU_REJECTSHIGH.AttachAsModified(currentVU_REJECTSHIGH, this.ChangeSet.GetOriginal(currentVU_REJECTSHIGH));
        }

        public void DeleteVU_REJECTSHIGH(VU_REJECTSHIGH vU_REJECTSHIGH)
        {
            if ((vU_REJECTSHIGH.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJECTSHIGH, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REJECTSHIGH.Attach(vU_REJECTSHIGH);
                this.ObjectContext.VU_REJECTSHIGH.DeleteObject(vU_REJECTSHIGH);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REJECTSLOW' query.
        public IQueryable<VU_REJECTSLOW> GetVU_REJECTSLOW()
        {
            return this.ObjectContext.VU_REJECTSLOW;
        }

        public void InsertVU_REJECTSLOW(VU_REJECTSLOW vU_REJECTSLOW)
        {
            if ((vU_REJECTSLOW.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJECTSLOW, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REJECTSLOW.AddObject(vU_REJECTSLOW);
            }
        }

        public void UpdateVU_REJECTSLOW(VU_REJECTSLOW currentVU_REJECTSLOW)
        {
            this.ObjectContext.VU_REJECTSLOW.AttachAsModified(currentVU_REJECTSLOW, this.ChangeSet.GetOriginal(currentVU_REJECTSLOW));
        }

        public void DeleteVU_REJECTSLOW(VU_REJECTSLOW vU_REJECTSLOW)
        {
            if ((vU_REJECTSLOW.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJECTSLOW, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REJECTSLOW.Attach(vU_REJECTSLOW);
                this.ObjectContext.VU_REJECTSLOW.DeleteObject(vU_REJECTSLOW);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REJTPDEFNHIGH' query.
        public IQueryable<VU_REJTPDEFNHIGH> GetVU_REJTPDEFNHIGH()
        {
            return this.ObjectContext.VU_REJTPDEFNHIGH;
        }

        public void InsertVU_REJTPDEFNHIGH(VU_REJTPDEFNHIGH vU_REJTPDEFNHIGH)
        {
            if ((vU_REJTPDEFNHIGH.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJTPDEFNHIGH, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REJTPDEFNHIGH.AddObject(vU_REJTPDEFNHIGH);
            }
        }

        public void UpdateVU_REJTPDEFNHIGH(VU_REJTPDEFNHIGH currentVU_REJTPDEFNHIGH)
        {
            this.ObjectContext.VU_REJTPDEFNHIGH.AttachAsModified(currentVU_REJTPDEFNHIGH, this.ChangeSet.GetOriginal(currentVU_REJTPDEFNHIGH));
        }

        public void DeleteVU_REJTPDEFNHIGH(VU_REJTPDEFNHIGH vU_REJTPDEFNHIGH)
        {
            if ((vU_REJTPDEFNHIGH.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJTPDEFNHIGH, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REJTPDEFNHIGH.Attach(vU_REJTPDEFNHIGH);
                this.ObjectContext.VU_REJTPDEFNHIGH.DeleteObject(vU_REJTPDEFNHIGH);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REJTPDEFNLOW' query.
        public IQueryable<VU_REJTPDEFNLOW> GetVU_REJTPDEFNLOW()
        {
            return this.ObjectContext.VU_REJTPDEFNLOW;
        }

        public void InsertVU_REJTPDEFNLOW(VU_REJTPDEFNLOW vU_REJTPDEFNLOW)
        {
            if ((vU_REJTPDEFNLOW.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJTPDEFNLOW, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REJTPDEFNLOW.AddObject(vU_REJTPDEFNLOW);
            }
        }

        public void UpdateVU_REJTPDEFNLOW(VU_REJTPDEFNLOW currentVU_REJTPDEFNLOW)
        {
            this.ObjectContext.VU_REJTPDEFNLOW.AttachAsModified(currentVU_REJTPDEFNLOW, this.ChangeSet.GetOriginal(currentVU_REJTPDEFNLOW));
        }

        public void DeleteVU_REJTPDEFNLOW(VU_REJTPDEFNLOW vU_REJTPDEFNLOW)
        {
            if ((vU_REJTPDEFNLOW.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REJTPDEFNLOW, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REJTPDEFNLOW.Attach(vU_REJTPDEFNLOW);
                this.ObjectContext.VU_REJTPDEFNLOW.DeleteObject(vU_REJTPDEFNLOW);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REP_EFF_REPAIR_MADE' query.
        public IQueryable<VU_REP_EFF_REPAIR_MADE> GetVU_REP_EFF_REPAIR_MADE()
        {
            return this.ObjectContext.VU_REP_EFF_REPAIR_MADE;
        }

        public void InsertVU_REP_EFF_REPAIR_MADE(VU_REP_EFF_REPAIR_MADE vU_REP_EFF_REPAIR_MADE)
        {
            if ((vU_REP_EFF_REPAIR_MADE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REP_EFF_REPAIR_MADE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REP_EFF_REPAIR_MADE.AddObject(vU_REP_EFF_REPAIR_MADE);
            }
        }

        public void UpdateVU_REP_EFF_REPAIR_MADE(VU_REP_EFF_REPAIR_MADE currentVU_REP_EFF_REPAIR_MADE)
        {
            this.ObjectContext.VU_REP_EFF_REPAIR_MADE.AttachAsModified(currentVU_REP_EFF_REPAIR_MADE, this.ChangeSet.GetOriginal(currentVU_REP_EFF_REPAIR_MADE));
        }

        public void DeleteVU_REP_EFF_REPAIR_MADE(VU_REP_EFF_REPAIR_MADE vU_REP_EFF_REPAIR_MADE)
        {
            if ((vU_REP_EFF_REPAIR_MADE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REP_EFF_REPAIR_MADE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REP_EFF_REPAIR_MADE.Attach(vU_REP_EFF_REPAIR_MADE);
                this.ObjectContext.VU_REP_EFF_REPAIR_MADE.DeleteObject(vU_REP_EFF_REPAIR_MADE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_REP_FLOAT' query.
        public IQueryable<VU_REP_FLOAT> GetVU_REP_FLOAT()
        {
            return this.ObjectContext.VU_REP_FLOAT;
        }

        public void InsertVU_REP_FLOAT(VU_REP_FLOAT vU_REP_FLOAT)
        {
            if ((vU_REP_FLOAT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REP_FLOAT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_REP_FLOAT.AddObject(vU_REP_FLOAT);
            }
        }

        public void UpdateVU_REP_FLOAT(VU_REP_FLOAT currentVU_REP_FLOAT)
        {
            this.ObjectContext.VU_REP_FLOAT.AttachAsModified(currentVU_REP_FLOAT, this.ChangeSet.GetOriginal(currentVU_REP_FLOAT));
        }

        public void DeleteVU_REP_FLOAT(VU_REP_FLOAT vU_REP_FLOAT)
        {
            if ((vU_REP_FLOAT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_REP_FLOAT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_REP_FLOAT.Attach(vU_REP_FLOAT);
                this.ObjectContext.VU_REP_FLOAT.DeleteObject(vU_REP_FLOAT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_RETESTS_PER_TEST' query.
        public IQueryable<VU_RETESTS_PER_TEST> GetVU_RETESTS_PER_TEST()
        {
            return this.ObjectContext.VU_RETESTS_PER_TEST;
        }

        public void InsertVU_RETESTS_PER_TEST(VU_RETESTS_PER_TEST vU_RETESTS_PER_TEST)
        {
            if ((vU_RETESTS_PER_TEST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RETESTS_PER_TEST, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_RETESTS_PER_TEST.AddObject(vU_RETESTS_PER_TEST);
            }
        }

        public void UpdateVU_RETESTS_PER_TEST(VU_RETESTS_PER_TEST currentVU_RETESTS_PER_TEST)
        {
            this.ObjectContext.VU_RETESTS_PER_TEST.AttachAsModified(currentVU_RETESTS_PER_TEST, this.ChangeSet.GetOriginal(currentVU_RETESTS_PER_TEST));
        }

        public void DeleteVU_RETESTS_PER_TEST(VU_RETESTS_PER_TEST vU_RETESTS_PER_TEST)
        {
            if ((vU_RETESTS_PER_TEST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RETESTS_PER_TEST, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_RETESTS_PER_TEST.Attach(vU_RETESTS_PER_TEST);
                this.ObjectContext.VU_RETESTS_PER_TEST.DeleteObject(vU_RETESTS_PER_TEST);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_RM_VIA_MBX_TABLE' query.
        public IQueryable<VU_RM_VIA_MBX_TABLE> GetVU_RM_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_RM_VIA_MBX_TABLE;
        }

        public void InsertVU_RM_VIA_MBX_TABLE(VU_RM_VIA_MBX_TABLE vU_RM_VIA_MBX_TABLE)
        {
            if ((vU_RM_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RM_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_RM_VIA_MBX_TABLE.AddObject(vU_RM_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_RM_VIA_MBX_TABLE(VU_RM_VIA_MBX_TABLE currentVU_RM_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_RM_VIA_MBX_TABLE.AttachAsModified(currentVU_RM_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_RM_VIA_MBX_TABLE));
        }

        public void DeleteVU_RM_VIA_MBX_TABLE(VU_RM_VIA_MBX_TABLE vU_RM_VIA_MBX_TABLE)
        {
            if ((vU_RM_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_RM_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_RM_VIA_MBX_TABLE.Attach(vU_RM_VIA_MBX_TABLE);
                this.ObjectContext.VU_RM_VIA_MBX_TABLE.DeleteObject(vU_RM_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_STAT_INFO' query.
        public IQueryable<VU_STAT_INFO> GetVU_STAT_INFO()
        {
            return this.ObjectContext.VU_STAT_INFO;
        }

        public void InsertVU_STAT_INFO(VU_STAT_INFO vU_STAT_INFO)
        {
            if ((vU_STAT_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_STAT_INFO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_STAT_INFO.AddObject(vU_STAT_INFO);
            }
        }

        public void UpdateVU_STAT_INFO(VU_STAT_INFO currentVU_STAT_INFO)
        {
            this.ObjectContext.VU_STAT_INFO.AttachAsModified(currentVU_STAT_INFO, this.ChangeSet.GetOriginal(currentVU_STAT_INFO));
        }

        public void DeleteVU_STAT_INFO(VU_STAT_INFO vU_STAT_INFO)
        {
            if ((vU_STAT_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_STAT_INFO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_STAT_INFO.Attach(vU_STAT_INFO);
                this.ObjectContext.VU_STAT_INFO.DeleteObject(vU_STAT_INFO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_STEP_INFO' query.
        public IQueryable<VU_STEP_INFO> GetVU_STEP_INFO()
        {
            return this.ObjectContext.VU_STEP_INFO;
        }

        public void InsertVU_STEP_INFO(VU_STEP_INFO vU_STEP_INFO)
        {
            if ((vU_STEP_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_STEP_INFO, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_STEP_INFO.AddObject(vU_STEP_INFO);
            }
        }

        public void UpdateVU_STEP_INFO(VU_STEP_INFO currentVU_STEP_INFO)
        {
            this.ObjectContext.VU_STEP_INFO.AttachAsModified(currentVU_STEP_INFO, this.ChangeSet.GetOriginal(currentVU_STEP_INFO));
        }

        public void DeleteVU_STEP_INFO(VU_STEP_INFO vU_STEP_INFO)
        {
            if ((vU_STEP_INFO.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_STEP_INFO, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_STEP_INFO.Attach(vU_STEP_INFO);
                this.ObjectContext.VU_STEP_INFO.DeleteObject(vU_STEP_INFO);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_SUGGESTED_REPAIR' query.
        public IQueryable<VU_SUGGESTED_REPAIR> GetVU_SUGGESTED_REPAIR()
        {
            return this.ObjectContext.VU_SUGGESTED_REPAIR;
        }

        public void InsertVU_SUGGESTED_REPAIR(VU_SUGGESTED_REPAIR vU_SUGGESTED_REPAIR)
        {
            if ((vU_SUGGESTED_REPAIR.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_SUGGESTED_REPAIR, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_SUGGESTED_REPAIR.AddObject(vU_SUGGESTED_REPAIR);
            }
        }

        public void UpdateVU_SUGGESTED_REPAIR(VU_SUGGESTED_REPAIR currentVU_SUGGESTED_REPAIR)
        {
            this.ObjectContext.VU_SUGGESTED_REPAIR.AttachAsModified(currentVU_SUGGESTED_REPAIR, this.ChangeSet.GetOriginal(currentVU_SUGGESTED_REPAIR));
        }

        public void DeleteVU_SUGGESTED_REPAIR(VU_SUGGESTED_REPAIR vU_SUGGESTED_REPAIR)
        {
            if ((vU_SUGGESTED_REPAIR.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_SUGGESTED_REPAIR, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_SUGGESTED_REPAIR.Attach(vU_SUGGESTED_REPAIR);
                this.ObjectContext.VU_SUGGESTED_REPAIR.DeleteObject(vU_SUGGESTED_REPAIR);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TD_LIMIT' query.
        public IQueryable<VU_TD_LIMIT> GetVU_TD_LIMIT()
        {
            return this.ObjectContext.VU_TD_LIMIT;
        }

        public void InsertVU_TD_LIMIT(VU_TD_LIMIT vU_TD_LIMIT)
        {
            if ((vU_TD_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD_LIMIT, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TD_LIMIT.AddObject(vU_TD_LIMIT);
            }
        }

        public void UpdateVU_TD_LIMIT(VU_TD_LIMIT currentVU_TD_LIMIT)
        {
            this.ObjectContext.VU_TD_LIMIT.AttachAsModified(currentVU_TD_LIMIT, this.ChangeSet.GetOriginal(currentVU_TD_LIMIT));
        }

        public void DeleteVU_TD_LIMIT(VU_TD_LIMIT vU_TD_LIMIT)
        {
            if ((vU_TD_LIMIT.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD_LIMIT, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TD_LIMIT.Attach(vU_TD_LIMIT);
                this.ObjectContext.VU_TD_LIMIT.DeleteObject(vU_TD_LIMIT);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TD_MBX' query.
        public IQueryable<VU_TD_MBX> GetVU_TD_MBX()
        {
            return this.ObjectContext.VU_TD_MBX;
        }

        public void InsertVU_TD_MBX(VU_TD_MBX vU_TD_MBX)
        {
            if ((vU_TD_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD_MBX, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TD_MBX.AddObject(vU_TD_MBX);
            }
        }

        public void UpdateVU_TD_MBX(VU_TD_MBX currentVU_TD_MBX)
        {
            this.ObjectContext.VU_TD_MBX.AttachAsModified(currentVU_TD_MBX, this.ChangeSet.GetOriginal(currentVU_TD_MBX));
        }

        public void DeleteVU_TD_MBX(VU_TD_MBX vU_TD_MBX)
        {
            if ((vU_TD_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD_MBX, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TD_MBX.Attach(vU_TD_MBX);
                this.ObjectContext.VU_TD_MBX.DeleteObject(vU_TD_MBX);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TD_TP_MBX' query.
        public IQueryable<VU_TD_TP_MBX> GetVU_TD_TP_MBX()
        {
            return this.ObjectContext.VU_TD_TP_MBX;
        }

        public void InsertVU_TD_TP_MBX(VU_TD_TP_MBX vU_TD_TP_MBX)
        {
            if ((vU_TD_TP_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD_TP_MBX, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TD_TP_MBX.AddObject(vU_TD_TP_MBX);
            }
        }

        public void UpdateVU_TD_TP_MBX(VU_TD_TP_MBX currentVU_TD_TP_MBX)
        {
            this.ObjectContext.VU_TD_TP_MBX.AttachAsModified(currentVU_TD_TP_MBX, this.ChangeSet.GetOriginal(currentVU_TD_TP_MBX));
        }

        public void DeleteVU_TD_TP_MBX(VU_TD_TP_MBX vU_TD_TP_MBX)
        {
            if ((vU_TD_TP_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD_TP_MBX, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TD_TP_MBX.Attach(vU_TD_TP_MBX);
                this.ObjectContext.VU_TD_TP_MBX.DeleteObject(vU_TD_TP_MBX);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TD1_REJECTS_VIA_MBX_TABLE' query.
        public IQueryable<VU_TD1_REJECTS_VIA_MBX_TABLE> GetVU_TD1_REJECTS_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_TD1_REJECTS_VIA_MBX_TABLE;
        }

        public void InsertVU_TD1_REJECTS_VIA_MBX_TABLE(VU_TD1_REJECTS_VIA_MBX_TABLE vU_TD1_REJECTS_VIA_MBX_TABLE)
        {
            if ((vU_TD1_REJECTS_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD1_REJECTS_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TD1_REJECTS_VIA_MBX_TABLE.AddObject(vU_TD1_REJECTS_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_TD1_REJECTS_VIA_MBX_TABLE(VU_TD1_REJECTS_VIA_MBX_TABLE currentVU_TD1_REJECTS_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_TD1_REJECTS_VIA_MBX_TABLE.AttachAsModified(currentVU_TD1_REJECTS_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_TD1_REJECTS_VIA_MBX_TABLE));
        }

        public void DeleteVU_TD1_REJECTS_VIA_MBX_TABLE(VU_TD1_REJECTS_VIA_MBX_TABLE vU_TD1_REJECTS_VIA_MBX_TABLE)
        {
            if ((vU_TD1_REJECTS_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD1_REJECTS_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TD1_REJECTS_VIA_MBX_TABLE.Attach(vU_TD1_REJECTS_VIA_MBX_TABLE);
                this.ObjectContext.VU_TD1_REJECTS_VIA_MBX_TABLE.DeleteObject(vU_TD1_REJECTS_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TD1_VIA_MBX_TABLE' query.
        public IQueryable<VU_TD1_VIA_MBX_TABLE> GetVU_TD1_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_TD1_VIA_MBX_TABLE;
        }

        public void InsertVU_TD1_VIA_MBX_TABLE(VU_TD1_VIA_MBX_TABLE vU_TD1_VIA_MBX_TABLE)
        {
            if ((vU_TD1_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD1_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TD1_VIA_MBX_TABLE.AddObject(vU_TD1_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_TD1_VIA_MBX_TABLE(VU_TD1_VIA_MBX_TABLE currentVU_TD1_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_TD1_VIA_MBX_TABLE.AttachAsModified(currentVU_TD1_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_TD1_VIA_MBX_TABLE));
        }

        public void DeleteVU_TD1_VIA_MBX_TABLE(VU_TD1_VIA_MBX_TABLE vU_TD1_VIA_MBX_TABLE)
        {
            if ((vU_TD1_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TD1_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TD1_VIA_MBX_TABLE.Attach(vU_TD1_VIA_MBX_TABLE);
                this.ObjectContext.VU_TD1_VIA_MBX_TABLE.DeleteObject(vU_TD1_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TEST_STATUS' query.
        public IQueryable<VU_TEST_STATUS> GetVU_TEST_STATUS()
        {
            return this.ObjectContext.VU_TEST_STATUS;
        }

        public void InsertVU_TEST_STATUS(VU_TEST_STATUS vU_TEST_STATUS)
        {
            if ((vU_TEST_STATUS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS.AddObject(vU_TEST_STATUS);
            }
        }

        public void UpdateVU_TEST_STATUS(VU_TEST_STATUS currentVU_TEST_STATUS)
        {
            this.ObjectContext.VU_TEST_STATUS.AttachAsModified(currentVU_TEST_STATUS, this.ChangeSet.GetOriginal(currentVU_TEST_STATUS));
        }

        public void DeleteVU_TEST_STATUS(VU_TEST_STATUS vU_TEST_STATUS)
        {
            if ((vU_TEST_STATUS.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS.Attach(vU_TEST_STATUS);
                this.ObjectContext.VU_TEST_STATUS.DeleteObject(vU_TEST_STATUS);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TEST_STATUS_BY_STAND' query.
        public IQueryable<VU_TEST_STATUS_BY_STAND> GetVU_TEST_STATUS_BY_STAND()
        {
            return this.ObjectContext.VU_TEST_STATUS_BY_STAND;
        }

        public void InsertVU_TEST_STATUS_BY_STAND(VU_TEST_STATUS_BY_STAND vU_TEST_STATUS_BY_STAND)
        {
            if ((vU_TEST_STATUS_BY_STAND.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS_BY_STAND, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS_BY_STAND.AddObject(vU_TEST_STATUS_BY_STAND);
            }
        }

        public void UpdateVU_TEST_STATUS_BY_STAND(VU_TEST_STATUS_BY_STAND currentVU_TEST_STATUS_BY_STAND)
        {
            this.ObjectContext.VU_TEST_STATUS_BY_STAND.AttachAsModified(currentVU_TEST_STATUS_BY_STAND, this.ChangeSet.GetOriginal(currentVU_TEST_STATUS_BY_STAND));
        }

        public void DeleteVU_TEST_STATUS_BY_STAND(VU_TEST_STATUS_BY_STAND vU_TEST_STATUS_BY_STAND)
        {
            if ((vU_TEST_STATUS_BY_STAND.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS_BY_STAND, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS_BY_STAND.Attach(vU_TEST_STATUS_BY_STAND);
                this.ObjectContext.VU_TEST_STATUS_BY_STAND.DeleteObject(vU_TEST_STATUS_BY_STAND);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TEST_STATUS_MBX' query.
        public IQueryable<VU_TEST_STATUS_MBX> GetVU_TEST_STATUS_MBX()
        {
            return this.ObjectContext.VU_TEST_STATUS_MBX;
        }

        public void InsertVU_TEST_STATUS_MBX(VU_TEST_STATUS_MBX vU_TEST_STATUS_MBX)
        {
            if ((vU_TEST_STATUS_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS_MBX, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS_MBX.AddObject(vU_TEST_STATUS_MBX);
            }
        }

        public void UpdateVU_TEST_STATUS_MBX(VU_TEST_STATUS_MBX currentVU_TEST_STATUS_MBX)
        {
            this.ObjectContext.VU_TEST_STATUS_MBX.AttachAsModified(currentVU_TEST_STATUS_MBX, this.ChangeSet.GetOriginal(currentVU_TEST_STATUS_MBX));
        }

        public void DeleteVU_TEST_STATUS_MBX(VU_TEST_STATUS_MBX vU_TEST_STATUS_MBX)
        {
            if ((vU_TEST_STATUS_MBX.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS_MBX, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS_MBX.Attach(vU_TEST_STATUS_MBX);
                this.ObjectContext.VU_TEST_STATUS_MBX.DeleteObject(vU_TEST_STATUS_MBX);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TEST_STATUS_VIA_DATE' query.
        public IQueryable<VU_TEST_STATUS_VIA_DATE> GetVU_TEST_STATUS_VIA_DATE()
        {
            return this.ObjectContext.VU_TEST_STATUS_VIA_DATE;
        }

        public void InsertVU_TEST_STATUS_VIA_DATE(VU_TEST_STATUS_VIA_DATE vU_TEST_STATUS_VIA_DATE)
        {
            if ((vU_TEST_STATUS_VIA_DATE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS_VIA_DATE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS_VIA_DATE.AddObject(vU_TEST_STATUS_VIA_DATE);
            }
        }

        public void UpdateVU_TEST_STATUS_VIA_DATE(VU_TEST_STATUS_VIA_DATE currentVU_TEST_STATUS_VIA_DATE)
        {
            this.ObjectContext.VU_TEST_STATUS_VIA_DATE.AttachAsModified(currentVU_TEST_STATUS_VIA_DATE, this.ChangeSet.GetOriginal(currentVU_TEST_STATUS_VIA_DATE));
        }

        public void DeleteVU_TEST_STATUS_VIA_DATE(VU_TEST_STATUS_VIA_DATE vU_TEST_STATUS_VIA_DATE)
        {
            if ((vU_TEST_STATUS_VIA_DATE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS_VIA_DATE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS_VIA_DATE.Attach(vU_TEST_STATUS_VIA_DATE);
                this.ObjectContext.VU_TEST_STATUS_VIA_DATE.DeleteObject(vU_TEST_STATUS_VIA_DATE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TEST_STATUS_VIA_MBX_TABLE' query.
        public IQueryable<VU_TEST_STATUS_VIA_MBX_TABLE> GetVU_TEST_STATUS_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_TEST_STATUS_VIA_MBX_TABLE;
        }

        public void InsertVU_TEST_STATUS_VIA_MBX_TABLE(VU_TEST_STATUS_VIA_MBX_TABLE vU_TEST_STATUS_VIA_MBX_TABLE)
        {
            if ((vU_TEST_STATUS_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS_VIA_MBX_TABLE.AddObject(vU_TEST_STATUS_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_TEST_STATUS_VIA_MBX_TABLE(VU_TEST_STATUS_VIA_MBX_TABLE currentVU_TEST_STATUS_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_TEST_STATUS_VIA_MBX_TABLE.AttachAsModified(currentVU_TEST_STATUS_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_TEST_STATUS_VIA_MBX_TABLE));
        }

        public void DeleteVU_TEST_STATUS_VIA_MBX_TABLE(VU_TEST_STATUS_VIA_MBX_TABLE vU_TEST_STATUS_VIA_MBX_TABLE)
        {
            if ((vU_TEST_STATUS_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_STATUS_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TEST_STATUS_VIA_MBX_TABLE.Attach(vU_TEST_STATUS_VIA_MBX_TABLE);
                this.ObjectContext.VU_TEST_STATUS_VIA_MBX_TABLE.DeleteObject(vU_TEST_STATUS_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TEST_TEXT_CRUST' query.
        public IQueryable<VU_TEST_TEXT_CRUST> GetVU_TEST_TEXT_CRUST()
        {
            return this.ObjectContext.VU_TEST_TEXT_CRUST;
        }

        public void InsertVU_TEST_TEXT_CRUST(VU_TEST_TEXT_CRUST vU_TEST_TEXT_CRUST)
        {
            if ((vU_TEST_TEXT_CRUST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_TEXT_CRUST, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TEST_TEXT_CRUST.AddObject(vU_TEST_TEXT_CRUST);
            }
        }

        public void UpdateVU_TEST_TEXT_CRUST(VU_TEST_TEXT_CRUST currentVU_TEST_TEXT_CRUST)
        {
            this.ObjectContext.VU_TEST_TEXT_CRUST.AttachAsModified(currentVU_TEST_TEXT_CRUST, this.ChangeSet.GetOriginal(currentVU_TEST_TEXT_CRUST));
        }

        public void DeleteVU_TEST_TEXT_CRUST(VU_TEST_TEXT_CRUST vU_TEST_TEXT_CRUST)
        {
            if ((vU_TEST_TEXT_CRUST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TEST_TEXT_CRUST, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TEST_TEXT_CRUST.Attach(vU_TEST_TEXT_CRUST);
                this.ObjectContext.VU_TEST_TEXT_CRUST.DeleteObject(vU_TEST_TEXT_CRUST);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TESTPOINTDEFINITIONSEDITOR' query.
        public IQueryable<VU_TESTPOINTDEFINITIONSEDITOR> GetVU_TESTPOINTDEFINITIONSEDITOR()
        {
            return this.ObjectContext.VU_TESTPOINTDEFINITIONSEDITOR;
        }

        public void InsertVU_TESTPOINTDEFINITIONSEDITOR(VU_TESTPOINTDEFINITIONSEDITOR vU_TESTPOINTDEFINITIONSEDITOR)
        {
            if ((vU_TESTPOINTDEFINITIONSEDITOR.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TESTPOINTDEFINITIONSEDITOR, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TESTPOINTDEFINITIONSEDITOR.AddObject(vU_TESTPOINTDEFINITIONSEDITOR);
            }
        }

        public void UpdateVU_TESTPOINTDEFINITIONSEDITOR(VU_TESTPOINTDEFINITIONSEDITOR currentVU_TESTPOINTDEFINITIONSEDITOR)
        {
            this.ObjectContext.VU_TESTPOINTDEFINITIONSEDITOR.AttachAsModified(currentVU_TESTPOINTDEFINITIONSEDITOR, this.ChangeSet.GetOriginal(currentVU_TESTPOINTDEFINITIONSEDITOR));
        }

        public void DeleteVU_TESTPOINTDEFINITIONSEDITOR(VU_TESTPOINTDEFINITIONSEDITOR vU_TESTPOINTDEFINITIONSEDITOR)
        {
            if ((vU_TESTPOINTDEFINITIONSEDITOR.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TESTPOINTDEFINITIONSEDITOR, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TESTPOINTDEFINITIONSEDITOR.Attach(vU_TESTPOINTDEFINITIONSEDITOR);
                this.ObjectContext.VU_TESTPOINTDEFINITIONSEDITOR.DeleteObject(vU_TESTPOINTDEFINITIONSEDITOR);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TOT_REP_VIA_MBX_TABLE' query.
        public IQueryable<VU_TOT_REP_VIA_MBX_TABLE> GetVU_TOT_REP_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_TOT_REP_VIA_MBX_TABLE;
        }

        public void InsertVU_TOT_REP_VIA_MBX_TABLE(VU_TOT_REP_VIA_MBX_TABLE vU_TOT_REP_VIA_MBX_TABLE)
        {
            if ((vU_TOT_REP_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TOT_REP_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TOT_REP_VIA_MBX_TABLE.AddObject(vU_TOT_REP_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_TOT_REP_VIA_MBX_TABLE(VU_TOT_REP_VIA_MBX_TABLE currentVU_TOT_REP_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_TOT_REP_VIA_MBX_TABLE.AttachAsModified(currentVU_TOT_REP_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_TOT_REP_VIA_MBX_TABLE));
        }

        public void DeleteVU_TOT_REP_VIA_MBX_TABLE(VU_TOT_REP_VIA_MBX_TABLE vU_TOT_REP_VIA_MBX_TABLE)
        {
            if ((vU_TOT_REP_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TOT_REP_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TOT_REP_VIA_MBX_TABLE.Attach(vU_TOT_REP_VIA_MBX_TABLE);
                this.ObjectContext.VU_TOT_REP_VIA_MBX_TABLE.DeleteObject(vU_TOT_REP_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TP_DEFN_CRUST' query.
        public IQueryable<VU_TP_DEFN_CRUST> GetVU_TP_DEFN_CRUST()
        {
            return this.ObjectContext.VU_TP_DEFN_CRUST;
        }

        public void InsertVU_TP_DEFN_CRUST(VU_TP_DEFN_CRUST vU_TP_DEFN_CRUST)
        {
            if ((vU_TP_DEFN_CRUST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TP_DEFN_CRUST, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TP_DEFN_CRUST.AddObject(vU_TP_DEFN_CRUST);
            }
        }

        public void UpdateVU_TP_DEFN_CRUST(VU_TP_DEFN_CRUST currentVU_TP_DEFN_CRUST)
        {
            this.ObjectContext.VU_TP_DEFN_CRUST.AttachAsModified(currentVU_TP_DEFN_CRUST, this.ChangeSet.GetOriginal(currentVU_TP_DEFN_CRUST));
        }

        public void DeleteVU_TP_DEFN_CRUST(VU_TP_DEFN_CRUST vU_TP_DEFN_CRUST)
        {
            if ((vU_TP_DEFN_CRUST.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TP_DEFN_CRUST, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TP_DEFN_CRUST.Attach(vU_TP_DEFN_CRUST);
                this.ObjectContext.VU_TP_DEFN_CRUST.DeleteObject(vU_TP_DEFN_CRUST);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_TP_ID_VIA_MBX_TABLE' query.
        public IQueryable<VU_TP_ID_VIA_MBX_TABLE> GetVU_TP_ID_VIA_MBX_TABLE()
        {
            return this.ObjectContext.VU_TP_ID_VIA_MBX_TABLE;
        }

        public void InsertVU_TP_ID_VIA_MBX_TABLE(VU_TP_ID_VIA_MBX_TABLE vU_TP_ID_VIA_MBX_TABLE)
        {
            if ((vU_TP_ID_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TP_ID_VIA_MBX_TABLE, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_TP_ID_VIA_MBX_TABLE.AddObject(vU_TP_ID_VIA_MBX_TABLE);
            }
        }

        public void UpdateVU_TP_ID_VIA_MBX_TABLE(VU_TP_ID_VIA_MBX_TABLE currentVU_TP_ID_VIA_MBX_TABLE)
        {
            this.ObjectContext.VU_TP_ID_VIA_MBX_TABLE.AttachAsModified(currentVU_TP_ID_VIA_MBX_TABLE, this.ChangeSet.GetOriginal(currentVU_TP_ID_VIA_MBX_TABLE));
        }

        public void DeleteVU_TP_ID_VIA_MBX_TABLE(VU_TP_ID_VIA_MBX_TABLE vU_TP_ID_VIA_MBX_TABLE)
        {
            if ((vU_TP_ID_VIA_MBX_TABLE.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_TP_ID_VIA_MBX_TABLE, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_TP_ID_VIA_MBX_TABLE.Attach(vU_TP_ID_VIA_MBX_TABLE);
                this.ObjectContext.VU_TP_ID_VIA_MBX_TABLE.DeleteObject(vU_TP_ID_VIA_MBX_TABLE);
            }
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'VU_VAR_TREND_SUM' query.
        public IQueryable<VU_VAR_TREND_SUM> GetVU_VAR_TREND_SUM()
        {
            return this.ObjectContext.VU_VAR_TREND_SUM;
        }

        public void InsertVU_VAR_TREND_SUM(VU_VAR_TREND_SUM vU_VAR_TREND_SUM)
        {
            if ((vU_VAR_TREND_SUM.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_VAR_TREND_SUM, EntityState.Added);
            }
            else
            {
                this.ObjectContext.VU_VAR_TREND_SUM.AddObject(vU_VAR_TREND_SUM);
            }
        }

        public void UpdateVU_VAR_TREND_SUM(VU_VAR_TREND_SUM currentVU_VAR_TREND_SUM)
        {
            this.ObjectContext.VU_VAR_TREND_SUM.AttachAsModified(currentVU_VAR_TREND_SUM, this.ChangeSet.GetOriginal(currentVU_VAR_TREND_SUM));
        }

        public void DeleteVU_VAR_TREND_SUM(VU_VAR_TREND_SUM vU_VAR_TREND_SUM)
        {
            if ((vU_VAR_TREND_SUM.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(vU_VAR_TREND_SUM, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.VU_VAR_TREND_SUM.Attach(vU_VAR_TREND_SUM);
                this.ObjectContext.VU_VAR_TREND_SUM.DeleteObject(vU_VAR_TREND_SUM);
            }
        }
    }
}


